Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:36 2012
FILE NAME: moist_conv_adjust.f90
PROGRAM NAME: moist_conv_adjust
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   312  opt  (  11): Fused array assignments. :line 312 - 318
   312  vec  (   4): Vectorized array expression.
   323  vec  (   3): Unvectorized loop.
   323  vec  (  13): Overhead of loop division is too large.
   324  opt  (1592): Outer loop unrolled inside inner loop.
   324  vec  (   4): Vectorized array expression.
   324  vec  (   4): Vectorized array expression.
   331  opt  (1592): Outer loop unrolled inside inner loop.
   331  vec  (   4): Vectorized array expression.
   331  vec  (   4): Vectorized array expression.
   333  vec  (   3): Unvectorized loop.
   333  vec  (  13): Overhead of loop division is too large.
   334  opt  (1592): Outer loop unrolled inside inner loop.
   334  vec  (   4): Vectorized array expression.
   334  vec  (   4): Vectorized array expression.
   341  opt  (1592): Outer loop unrolled inside inner loop.
   341  vec  (   4): Vectorized array expression.
   341  vec  (   4): Vectorized array expression.
   347  opt  (1592): Outer loop unrolled inside inner loop.
   347  vec  (   4): Vectorized array expression.
   347  vec  (   4): Vectorized array expression.
   353  opt  (1592): Outer loop unrolled inside inner loop.
   353  vec  (   4): Vectorized array expression.
   353  vec  (   4): Vectorized array expression.
   357  opt  (1017): Subroutine call prevents optimization.
   363  vec  (   1): Vectorized loop.
   503  vec  (   3): Unvectorized loop.
   503  vec  (  13): Overhead of loop division is too large.
   505  opt  (1019): Feedback of scalar value from one loop pass to another.
   505  opt  (1019): Feedback of scalar value from one loop pass to another.
   505  vec  (  21): Unvectorizable dependency.
   516  opt  (  11): Fused array assignments. :line 516 - 581
   516  vec  (   4): Vectorized array expression.
   582  opt  (1592): Outer loop unrolled inside inner loop.
   582  vec  (   4): Vectorized array expression.
   582  vec  (   4): Vectorized array expression.
   583  vec  (   3): Unvectorized loop.
   583  vec  (  13): Overhead of loop division is too large.
   584  opt  (1592): Outer loop unrolled inside inner loop.
   584  vec  (   4): Vectorized array expression.
   584  vec  (   4): Vectorized array expression.
   591  opt  (1592): Outer loop unrolled inside inner loop.
   591  vec  (   4): Vectorized array expression.
   591  vec  (   4): Vectorized array expression.
   628  warn (  82): Name "xyz_ddellwdtccplv" is not used.
   628  warn (  82): Name "tempupplevbefadj" is not used.
   628  warn (  82): Name "templowlevbefadj" is not used.
   628  warn (  82): Name "xy_negddellwdt" is not used.
   628  warn (  82): Name "qvapupplevbefadj" is not used.
   628  warn (  82): Name "qvaplowlevbefadj" is not used.
   709  vec  (   4): Vectorized array expression.
   757  vec  (   4): Vectorized array expression.
   757  vec  (  24): Iteration count is assumed. Iteration count=256
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:36 2012
FILE NAME: moist_conv_adjust.f90
PROGRAM NAME: moist_conv_adjust
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ήĴ
     2  !
     3  != Moist convective adjustment
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA, Yukiko YAMADA
     6  ! Version::   $Id: moist_conv_adjust.f90,v 1.7 2011-12-02 04:06:36 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module moist_conv_adjust
    13    !
    14    != ήĴ
    15    !
    16    != Moist convective adjustment
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! ήĴ᥹ˤ, ٤漾Ĵ.
    21    !
    22    ! Moist convective adjustment was originally proposed by Manabe et al. (1965).
    23    ! But, the algorithm used in this routine seems to be different from that described by
    24    ! Manabe et al. (1965).
    25    !
    26    ! Adjust temperature and specific humidity by
    27    ! convective adjustment scheme.
    28    !
    29    !== Procedures List
    30    !
    31    ! MoistConvAdjust :: ٤漾Ĵ
    32    ! --------------- :: ------------
    33    ! MoistConvAdjust :: Adjust temperature and specific humidity
    34    !
    35    !== NAMELIST
    36    !
    37    ! NAMELIST#moist_conv_adjust_nml
    38    !
    39  
    40    ! ⥸塼 ; USE statements
    41    !
    42  
    43    ! ʻ
    44    ! Grid points settings
    45    !
    46    use gridset, only: imax, & ! ٳʻ.
    47                               ! Number of grid points in longitude
    48      &                jmax, & ! ٳʻ.
    49                               ! Number of grid points in latitude
    50      &                kmax    ! ľؿ.
    51                               ! Number of vertical level
    52  
    53    ! ̷ѥ᥿
    54    ! Kind type parameter
    55    !
    56    use dc_types, only: DP, &      ! ټ¿. Double precision.
    57      &                 STRING     ! ʸ.       Strings.
    58  
    59    ! NAMELIST եϤ˴ؤ桼ƥƥ
    60    ! Utilities for NAMELIST file input
    61    !
    62    use namelist_util, only: MaxNmlArySize
    63                                ! NAMELIST ɤ߹κ祵.
    64                                ! Maximum size of arrays loaded from NAMELIST
    65  
    66    ! å
    67    ! Message output
    68    !
    69    use dc_message, only: MessageNotify
    70  
    71    ! ʸ ; Declaration statements
    72    !
    73    implicit none
    74    private
    75  
    76  !!$  logical, save:: FlagUse
    77  !!$                              ! ѥե饰
    78  !!$                              ! flag for use of this scheme
    79  
    80    ! ³
    81    ! Public procedure
    82    !
    83    public:: MoistConvAdjust
    84    public:: MoistConvAdjustInit
    85  
    86    ! ѿ
    87    ! Public variables
    88    !
    89    logical, save :: moist_conv_adjust_inited = .false.
    90                                ! ե饰.
    91                                ! Initialization flag
    92  
    93    ! ѿ
    94    ! Private variables
    95    !
    96    real(DP), save:: CrtlRH
    97                                ! ׳м.
    98                                ! Critical relative humidity
    99    integer, save:: ItrtMax
   100                                ! ƥ졼.
   101                                ! Number of iteration
   102  
   103    real(DP), save:: AdjustCriterion(1:MaxNmlArySize)
   104                                ! ĴԤ (Ūͥ륮κβٴ)
   105                                ! Criterion of adjustment (temperature difference
   106                                ! equivalent to difference of moist static energy)
   107  
   108    character(*), parameter:: module_name = 'moist_conv_adjust'
   109                                ! ⥸塼̾.
   110                                ! Module name
   111    character(*), parameter:: version = &
   112      & '$Name: dcpam5-20120921 $' // &
   113      & '$Id: moist_conv_adjust.f90,v 1.7 2011-12-02 04:06:36 yot Exp $'
   114                                ! ⥸塼ΥС
   115                                ! Module version
   116  
   117  contains
   118  
   119    !--------------------------------------------------------------------------------------
   120  
   121  !!$  subroutine MoistConvAdjust( &
   122  !!$    & xyz_Temp, xyz_QVap, xy_Rain, &  ! (inout)
   123  !!$    & xyz_DTempDt, xyz_DQVapDt, &     ! (inout)
   124  !!$    & xyz_Press, xyr_Press, &         ! (in)
   125  !!$    & xyz_DQH2OLiqDt &                ! (out)
   126  !!$    & )
   127    subroutine MoistConvAdjust(   &
   128      & xyz_Temp, xyz_QVap,       & ! (inout)
   129      & xyz_DTempDt, xyz_DQVapDt, & ! (inout)
   130      & xyz_Press, xyr_Press,     & ! (in)
   131      & xyz_DQH2OLiqDt            & ! (out)
   132      & )
   133      !
   134      ! ήĴ᥹ˤ, ٤漾Ĵ.
   135      !
   136      ! Adjust temperature and specific humidity by moist convective adjustment
   137      !
   138  
   139      ! ⥸塼 ; USE statements
   140      !
   141  
   142      ! ʪ
   143      ! Physical constants settings
   144      !
   145      use constants, only: &
   146        & Grav, &
   147                                ! $ g $ [m s-2].
   148                                ! ϲ®.
   149                                ! Gravitational acceleration
   150        & GasRDry, &
   151                                ! $ R $ [J kg-1 K-1].
   152                                ! 絤ε.
   153                                ! Gas constant of air
   154        & CpDry, &
   155                                ! $ C_p $ [J kg-1 K-1].
   156                                ! 絤갵Ǯ.
   157                                ! Specific heat of air at constant pressure
   158        & LatentHeat
   159                                ! $ L $ [J kg-1] .
   160                                ! ŷǮ.
   161                                ! Latent heat of condensation
   162  
   163      ! 
   164      ! Time control
   165      !
   166      use timeset, only: &
   167        & DelTime, &            ! $ \Delta t $
   168        & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $.
   169        & TimesetClockStart, TimesetClockStop
   170  
   171      ! ҥȥǡ
   172      ! History data output
   173      !
   174      use gtool_historyauto, only: HistoryAutoPut
   175  
   176      ! ˰漾λ
   177      ! Evaluate saturation specific humidity
   178      !
   179      use saturate, only: xyz_CalcQVapSat, xy_CalcDQVapSatDTemp
   180  
   181  
   182      ! ʸ ; Declaration statements
   183      !
   184      implicit none
   185  
   186      real(DP), intent(inout):: xyz_Temp (0:imax-1, 1:jmax, 1:kmax)
   187                                ! $ T $ .     . Temperature
   188      real(DP), intent(inout):: xyz_QVap (0:imax-1, 1:jmax, 1:kmax)
   189                                ! $ q $ .     漾. Specific humidity
   190  !!$    real(DP), intent(inout):: xy_Rain (0:imax-1, 1:jmax)
   191  !!$                              ! ߿.
   192  !!$                              ! Precipitation
   193      real(DP), intent(inout):: xyz_DTempDt (0:imax-1, 1:jmax, 1:kmax)
   194                                ! ѲΨ.
   195                                ! Temperature tendency
   196      real(DP), intent(inout):: xyz_DQVapDt (0:imax-1, 1:jmax, 1:kmax)
   197                                ! 漾ѲΨ.
   198                                ! Specific humidity tendency
   199  
   200      real(DP), intent(in):: xyz_Press (0:imax-1, 1:jmax, 1:kmax)
   201                                ! $ p $ .  (٥).
   202                                ! Air pressure (full level)
   203      real(DP), intent(in):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
   204                                ! $ \hat{p} $ .  (Ⱦ٥).
   205                                ! Air pressure (half level)
   206      real(DP), intent(out):: xyz_DQH2OLiqDt(0:imax-1, 1:jmax, 1:kmax)
   207  
   208      ! ѿ
   209      ! Work variables
   210      !
   211      real(DP):: xy_RainCumulus (0:imax-1, 1:jmax)
   212                                ! ߿.
   213                                ! Precipitation
   214      real(DP):: xyz_DTempDtCumulus (0:imax-1, 1:jmax, 1:kmax)
   215                                ! ѲΨ.
   216                                ! Temperature tendency
   217      real(DP):: xyz_DQVapDtCumulus (0:imax-1, 1:jmax, 1:kmax)
   218                                ! 漾ѲΨ.
   219                                ! Specific humidity tendency
   220  
   221      real(DP):: xyz_QVapB (0:imax-1, 1:jmax, 1:kmax)
   222                                ! Ĵ漾.
   223                                ! Specific humidity before adjustment
   224      real(DP):: xyz_TempB (0:imax-1, 1:jmax, 1:kmax)
   225                                ! Ĵβ.
   226                                ! Temperature before adjustment
   227      logical:: xy_Adjust (0:imax-1, 1:jmax)
   228                                ! Ĵᤵ줿ݤ?.
   229                                ! Whether it was adjusted this time or not?
   230      logical:: xy_AdjustB (0:imax-1, 1:jmax)
   231                                ! Ĵᤵ줿ݤ?.
   232                                ! Whether it was adjusted last time or not?
   233      real(DP):: xyz_DelPress(0:imax-1, 1:jmax, 1:kmax)
   234                                ! $ \Delta p $
   235                                !
   236      real(DP):: xyz_QVapSat (0:imax-1, 1:jmax, 1:kmax)
   237                                ! ˰漾.
   238                                ! Saturation specific humidity.
   239      real(DP):: xyr_ConvAdjustFactor(0:imax-1, 1:jmax, 0:kmax)
   240                                ! $ \frac{1}{2} \frac{ R }{Cp}
   241                                !   \frac{ p_{k} - p_{k+1} }{ p_{k+1/2} } $
   242  
   243      real(DP):: TempEquivToExcEne
   244                                ! Temperature equivalent to the excess moist static energy
   245                                ! (Moist static energy difference devided by specific heat)
   246  
   247      real(DP):: DelQ
   248      real(DP):: DelTempUppLev
   249                                ! k+1 ܤؤˤĴˤ벹٤Ѳ.
   250                                ! Temperature variation by adjustment at k+1 level
   251      real(DP):: DelTempLowLev
   252                                ! k ܤؤˤĴˤ벹٤Ѳ.
   253                                ! Temperature variation by adjustment at k level
   254      real(DP):: DQVapSatDTempUppLev
   255                                ! $ \DD{q^{*}} (k+1)}{T} $
   256      real(DP):: DQVapSatDTempLowLev
   257                                ! $ \DD{q^{*}} (k)}{T} $
   258      real(DP):: GamUppLev
   259                                ! $ \gamma_{k+1} = \frac{L}{C_p} \DP{q^{*}}{T}_{k+1} $
   260      real(DP):: GamLowLev
   261                                ! $ \gamma_{k}   = \frac{L}{C_p} \DP{q^{*}}{T}_{k} $
   262      logical:: Adjust
   263                                ! ΰˤư٤ǤĴᤵ줿ݤ?.
   264                                ! Whether it was adjusted even once in global
   265                                ! this time or not?
   266  
   267      real(DP):: TempLowLevBefAdj ! Variables for check routine
   268      real(DP):: TempUppLevBefAdj
   269      real(DP):: QVapLowLevBefAdj
   270      real(DP):: QVapUppLevBefAdj
   271  
   272      integer:: i               ! ˲ DO 롼Ѻѿ
   273                                ! Work variables for DO loop in longitude
   274      integer:: j               ! ˲ DO 롼Ѻѿ
   275                                ! Work variables for DO loop in latitude
   276      integer:: k               ! ľ˲ DO 롼Ѻѿ
   277                                ! Work variables for DO loop in vertical direction
   278      integer:: itr             ! ƥ졼˲ DO 롼Ѻѿ
   279                                ! Work variables for DO loop in iteration direction
   280  
   281      real(DP):: xy_DQVapSatDTempUppLev(0:imax-1, 1:jmax)
   282      real(DP):: xy_DQVapSatDTempLowLev(0:imax-1, 1:jmax)
   283  
   284      real(DP):: xyz_RainCumulus (0:imax-1, 1:jmax, 1:kmax)
   285  
   286      real(DP) :: xy_NegDDelLWDt   (0:imax-1, 1:jmax)
   287      real(DP) :: xyz_DDelLWDtCCPLV(0:imax-1, 1:jmax, 1:kmax)
   288  
   289  
   290      ! ¹ʸ ; Executable statement
   291      !
   292  
   293      ! ǧ
   294      ! Initialization check
   295      !
   296      if ( .not. moist_conv_adjust_inited ) then
   297        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   298      end if
   299  
   300  !!$    if ( .not. FlagUse ) return
   301  
   302  
   303      ! ׻ַ¬
   304      ! Start measurement of computation time
   305      !
   306      call TimesetClockStart( module_name )
   307  
   308  
   309      ! Ĵ "QVap", "Temp" ¸
   310      ! Store "QVap", "Temp" before adjustment
   311      !
   312      xyz_QVapB = xyz_QVap
   313      xyz_TempB = xyz_Temp
   314  
   315      ! ˰漾׻
   316      ! Calculate saturation specific humidity
   317      !
   318      xyz_QVapSat = xyz_CalcQVapSat( xyz_Temp, xyz_Press )
   319  
   320      ! Calculate some values used for moist convective adjustment
   321      !
   322  
   323      do k = 1, kmax
   324        xyz_DelPress(:,:,k) = xyr_Press(:,:,k-1) - xyr_Press(:,:,k)
     .           if (jmax .gt. 0) then                                          
     .           J1 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t846 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t848 = 1, imax                                           
     .                 xyz_delpress(t848-1,t846,k) = xyr_press(t848-1,t846,k-1) 
     .       1             - xyr_press(t848-1,t846,k)                           
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t846 = J1 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t848 = 1, imax                                           
     .                 xyz_delpress(t848-1,t846,k) = xyr_press(t848-1,t846,k-1) 
     .       1             - xyr_press(t848-1,t846,k)                           
     .                 xyz_delpress(t848-1,t846+1,k) = xyr_press(t848-1,t846+1,k
     .       1            -1) - xyr_press(t848-1,t846+1,k)                      
     .                 xyz_delpress(t848-1,t846+2,k) = xyr_press(t848-1,t846+2,k
     .       1            -1) - xyr_press(t848-1,t846+2,k)                      
     .                 xyz_delpress(t848-1,t846+3,k) = xyr_press(t848-1,t846+3,k
     .       1            -1) - xyr_press(t848-1,t846+3,k)                      
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   325      end do
   326  
   327      ! \frac{1}{2} \frac{ R }{Cp} \frac{ p_{k} - p_{k+1} }{ p_{k+1/2} }
   328      !
   329      !   The value at k = 0 is not used.
   330      k = 0
   331      xyr_ConvAdjustFactor(:,:,k) = 0.0d0
     .        if (xyr_convadjustfactor.DSC.U2 .gt. 0) then                      
     .           J2 = and(xyr_convadjustfactor.DSC.U2,3)                        
     .  !CDIR    NODEP                                                          
     .           do t856 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t858 = 1, xyr_convadjustfactor.DSC.U1 + 1                
     .                 xyr_convadjustfactor(t858-1,t856,0) =                    
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t856 = J2 + 1, xyr_convadjustfactor.DSC.U2, 4               
     .  !CDIR       NODEP                                                       
     .              do t858 = 1, xyr_convadjustfactor.DSC.U1 + 1                
     .                 xyr_convadjustfactor(t858-1,t856,0) =                    
     .       1            0.0000000000000000e+000                               
     .                 xyr_convadjustfactor(t858-1,t856+1,0) =                  
     .       1            0.0000000000000000e+000                               
     .                 xyr_convadjustfactor(t858-1,t856+2,0) =                  
     .       1            0.0000000000000000e+000                               
     .                 xyr_convadjustfactor(t858-1,t856+3,0) =                  
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   332      !
   333      do k = 1, kmax-1
   334        xyr_ConvAdjustFactor(:,:,k) =                     &
     .        if (jmax .gt. 0) then                                             
     .           J3 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t862 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t864 = 1, imax                                           
     .                 xyr_convadjustfactor(t864-1,t862,k) = gasrdry/cpdry*(    
     .       1            xyz_press(t864-1,t862,k)-xyz_press(t864-1,t862,k+1))/(
     .       2            xyr_press(t864-1,t862,k)*2.00000000000000e+000)       
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t862 = J3 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t864 = 1, imax                                           
     .                 xyr_convadjustfactor(t864-1,t862,k) = (gasrdry/cpdry)*(  
     .       1            xyz_press(t864-1,t862,k)-xyz_press(t864-1,t862,k+1))/(
     .       2            xyr_press(t864-1,t862,k)*2.00000000000000e+000)       
     .                 xyr_convadjustfactor(t864-1,t862+1,k) = (gasrdry/cpdry)*(
     .       1            xyz_press(t864-1,t862+1,k)-xyz_press(t864-1,t862+1,k+1
     .       2            ))/(xyr_press(t864-1,t862+1,k)*2.00000000000000e+000) 
     .                 xyr_convadjustfactor(t864-1,t862+2,k) = (gasrdry/cpdry)*(
     .       1            xyz_press(t864-1,t862+2,k)-xyz_press(t864-1,t862+2,k+1
     .       2            ))/(xyr_press(t864-1,t862+2,k)*2.00000000000000e+000) 
     .                 xyr_convadjustfactor(t864-1,t862+3,k) = (gasrdry/cpdry)*(
     .       1            xyz_press(t864-1,t862+3,k)-xyz_press(t864-1,t862+3,k+1
     .       2            ))/(xyr_press(t864-1,t862+3,k)*2.00000000000000e+000) 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   335          & GasRDry / CpDry                               &
   336          &   * ( xyz_Press(:,:,k) - xyz_Press(:,:,k+1) ) &
   337          &   / xyr_Press(:,:,k) / 2.0_DP
   338      end do
   339      !   The value at k = kmax is not used.
   340      k = kmax
   341      xyr_ConvAdjustFactor(:,:,k) = 0.0d0
     .        if (xyr_convadjustfactor.DSC.U2 .gt. 0) then                      
     .           J4 = and(xyr_convadjustfactor.DSC.U2,3)                        
     .  !CDIR    NODEP                                                          
     .           do t874 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t876 = 1, xyr_convadjustfactor.DSC.U1 + 1                
     .                 xyr_convadjustfactor(t876-1,t874,k) =                    
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t874 = J4 + 1, xyr_convadjustfactor.DSC.U2, 4               
     .  !CDIR       NODEP                                                       
     .              do t876 = 1, xyr_convadjustfactor.DSC.U1 + 1                
     .                 xyr_convadjustfactor(t876-1,t874,k) =                    
     .       1            0.0000000000000000e+000                               
     .                 xyr_convadjustfactor(t876-1,t874+1,k) =                  
     .       1            0.0000000000000000e+000                               
     .                 xyr_convadjustfactor(t876-1,t874+2,k) =                  
     .       1            0.0000000000000000e+000                               
     .                 xyr_convadjustfactor(t876-1,t874+3,k) =                  
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   342  
   343  
   344      ! Ĵ
   345      ! Adjustment
   346      !
   347      xy_AdjustB = .true.
     .        if (xy_adjustb.DSC.U2 .gt. 0) then                                
     .           J5 = and(xy_adjustb.DSC.U2,3)                                  
     .  !CDIR    NODEP                                                          
     .           do t880 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t882 = 1, xy_adjustb.DSC.U1 + 1                          
     .                 xy_adjustb(t882-1,t880) = 1                              
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t880 = J5 + 1, xy_adjustb.DSC.U2, 4                         
     .  !CDIR       NODEP                                                       
     .              do t882 = 1, xy_adjustb.DSC.U1 + 1                          
     .                 xy_adjustb(t882-1,t880) = 1                              
     .                 xy_adjustb(t882-1,t880+1) = 1                            
     .                 xy_adjustb(t882-1,t880+2) = 1                            
     .                 xy_adjustb(t882-1,t880+3) = 1                            
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   348  
   349      ! ֤
   350      ! Iteration
   351      !
   352      do itr = 1, ItrtMax
   353        xy_Adjust = .false.
     .        if (xy_adjust.DSC.U2 .gt. 0) then                                 
     .           J6 = and(xy_adjust.DSC.U2,3)                                   
     .  !CDIR    NODEP                                                          
     .           do t886 = 1, J6                                                
     .  !CDIR       NODEP                                                       
     .              do t888 = 1, xy_adjust.DSC.U1 + 1                           
     .                 xy_adjust(t888-1,t886) = 0                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t886 = J6 + 1, xy_adjust.DSC.U2, 4                          
     .  !CDIR       NODEP                                                       
     .              do t888 = 1, xy_adjust.DSC.U1 + 1                           
     .                 xy_adjust(t888-1,t886) = 0                               
     .                 xy_adjust(t888-1,t886+1) = 0                             
     .                 xy_adjust(t888-1,t886+2) = 0                             
     .                 xy_adjust(t888-1,t886+3) = 0                             
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   354  
   355        do k = 1, kmax-1
   356  
   357          xy_DQVapSatDTempUppLev = &
   358            & xy_CalcDQVapSatDTemp( xyz_Temp(:,:,k+1), xyz_QVapSat(:,:,k+1) )
   359          xy_DQVapSatDTempLowLev = &
   360            & xy_CalcDQVapSatDTemp( xyz_Temp(:,:,k  ), xyz_QVapSat(:,:,k  ) )
   361  
   362          do j = 1, jmax
   363            do i = 0, imax-1
   364              if ( xy_AdjustB(i,j) ) then
   365  
   366                ! Temperature equivalent to the excess moist static energy
   367                ! (Moist static energy difference devided by specific heat)
   368                !
   369                TempEquivToExcEne = &
   370                  &   xyz_Temp(i,j,k) - xyz_Temp(i,j,k+1)                                &
   371                  & + LatentHeat / CpDry * ( xyz_QVapSat(i,j,k) - xyz_QVapSat(i,j,k+1) ) &
   372                  & - xyr_ConvAdjustFactor(i,j,k) * ( xyz_Temp(i,j,k) + xyz_Temp(i,j,k+1) )
   373  
   374                ! Check vertical gradient of moist static energy
   375                !
   376                if ( TempEquivToExcEne > AdjustCriterion(itr) ) then
   377  
   378                  ! Check relative humidity
   379                  !
   380                  if ( ( xyz_QVap(i,j,k+1) / xyz_QVapSat(i,j,k+1) >= CrtlRH ) &
   381                    &  .and.                                                  &
   382                    &  ( xyz_QVap(i,j,k  ) / xyz_QVapSat(i,j,k  ) >= CrtlRH ) &
   383                    &) then
   384  
   385                    DelQ =                                                 &
   386                      &   xyz_DelPress(i,j,k  )                            &
   387                      &     * ( xyz_QVap(i,j,k  ) - xyz_QVapSat(i,j,k  ) ) &
   388                      & + xyz_DelPress(i,j,k+1)                            &
   389                      &     * ( xyz_QVap(i,j,k+1) - xyz_QVapSat(i,j,k+1) )
   390  
   391                    DQVapSatDTempUppLev = xy_DQVapSatDTempUppLev(i,j)
   392                    DQVapSatDTempLowLev = xy_DQVapSatDTempLowLev(i,j)
   393  
   394                    GamUppLev = LatentHeat / CpDry * DQVapSatDTempUppLev
   395                    GamLowLev = LatentHeat / CpDry * DQVapSatDTempLowLev
   396  
   397                    DelTempUppLev =                                                       &
   398                      & (                                                                 &
   399                      &     xyz_DelPress(i,j,k) * ( 1.0d0 + GamLowLev )                   &
   400                      &       * TempEquivToExcEne                                         &
   401                      &   + ( 1.0d0 + GamLowLev - xyr_ConvAdjustFactor(i,j,k) )           &
   402                      &       * LatentHeat / CpDry * DelQ                                 &
   403                      & )                                                                 &
   404                      & / ( xyr_ConvAdjustFactor(i,j,k)                                   &
   405                      &       * ( xyz_DelPress(i,j,k  ) * ( 1.0d0 + GamLowLev )           &
   406                      &         - xyz_DelPress(i,j,k+1) * ( 1.0d0 + GamUppLev ) )         &
   407                      &     + ( 1.0d0 + GamLowLev ) * ( 1.0d0 + GamUppLev )               &
   408                      &       * ( xyz_DelPress(i,j,k) + xyz_DelPress(i,j,k+1) ) )
   409  
   410                    DelTempLowLev =                                                       &
   411                      &   ( LatentHeat / CpDry * DelQ                                     &
   412                      &     - xyz_DelPress(i,j,k+1)                                       &
   413                      &         * ( 1.0d0 + GamUppLev ) * DelTempUppLev )                 &
   414                      & / ( ( 1.0d0 + GamLowLev ) * xyz_DelPress(i,j,k) )
   415  
   416  
   417                    !=========
   418                    ! check routine
   419                    !---------
   420  !!$                  TempLowLevBefAdj = xyz_Temp(i,j,k  )
   421  !!$                  TempUppLevBefAdj = xyz_Temp(i,j,k+1)
   422  !!$                  QVapLowLevBefAdj = xyz_QVap(i,j,k  )
   423  !!$                  QVapUppLevBefAdj = xyz_QVap(i,j,k+1)
   424                    !=========
   425  
   426  
   427                    ! ٤Ĵ
   428                    ! Adjust temperature
   429                    !
   430                    xyz_Temp(i,j,k  ) = xyz_Temp(i,j,k  ) + DelTempLowLev
   431                    xyz_Temp(i,j,k+1) = xyz_Temp(i,j,k+1) + DelTempUppLev
   432  
   433                    ! 漾Ĵ
   434                    ! Adjust specific humidity
   435                    !
   436                    xyz_QVap(i,j,k  ) = &
   437                      &   xyz_QVapSat(i,j,k  ) + DQVapSatDTempLowLev * DelTempLowLev
   438                    xyz_QVap(i,j,k+1) = &
   439                      &   xyz_QVapSat(i,j,k+1) + DQVapSatDTempUppLev * DelTempUppLev
   440  
   441  
   442                    !=========
   443                    ! check routine
   444                    !---------
   445  !!$                  write( 6, * ) '====='
   446  !!$                  write( 6, * ) xyz_Temp(i,j,k), xyz_Temp(i,j,k+1), xyz_QVap(i,j,k), xyz_QVap(i,j,k+1)
   447  !!$                  write( 6, * ) DelTempLowLev, DelTempUppLev
   448  !!$                  write( 6, * ) 'Energy difference before and after adjustment and each energy'
   449  !!$                  write( 6, * ) &
   450  !!$                    &   ( CpDry * TempLowLevBefAdj  + LatentHeat * QVapLowLevBefAdj )  &
   451  !!$                    &     * xyz_DelPress(i,j,k  ) / Grav                               &
   452  !!$                    & + ( CpDry * TempUppLevBefAdj  + LatentHeat * QVapUppLevBefAdj )  &
   453  !!$                    &     * xyz_DelPress(i,j,k+1) / Grav                               &
   454  !!$                    & - ( CpDry * xyz_Temp(i,j,k  ) + LatentHeat * xyz_QVap(i,j,k  ) ) &
   455  !!$                    &     * xyz_DelPress(i,j,k  ) / Grav                               &
   456  !!$                    & - ( CpDry * xyz_Temp(i,j,k+1) + LatentHeat * xyz_QVap(i,j,k+1) ) &
   457  !!$                    &     * xyz_DelPress(i,j,k+1) / Grav,                              &
   458  !!$                    &   ( CpDry * TempLowLevBefAdj  + LatentHeat * QVapLowLevBefAdj )  &
   459  !!$                    &     * xyz_DelPress(i,j,k  ) / Grav,                              &
   460  !!$                    &   ( CpDry * TempUppLevBefAdj  + LatentHeat * QVapUppLevBefAdj )  &
   461  !!$                    &     * xyz_DelPress(i,j,k+1) / Grav,                              &
   462  !!$                    &   ( CpDry * xyz_Temp(i,j,k  ) + LatentHeat * xyz_QVap(i,j,k  ) ) &
   463  !!$                    &     * xyz_DelPress(i,j,k  ) / Grav,                              &
   464  !!$                    &   ( CpDry * xyz_Temp(i,j,k+1) + LatentHeat * xyz_QVap(i,j,k+1) ) &
   465  !!$                    &     * xyz_DelPress(i,j,k+1) / Grav
   466  !!$                  write( 6, * ) 'Difference of moist static energy after adjustment'
   467  !!$                  write( 6, * ) &
   468  !!$                    &   ( CpDry * xyz_Temp(i,j,k  ) + LatentHeat * xyz_QVap(i,j,k  ) )  &
   469  !!$                    & - ( CpDry * xyz_Temp(i,j,k+1) + LatentHeat * xyz_QVap(i,j,k+1) )  &
   470  !!$                    & - CpDry * xyr_ConvAdjustFactor(i,j,k)                             &
   471  !!$                    &   * ( xyz_Temp(i,j,k) + xyz_Temp(i,j,k+1) ),                      &
   472  !!$                    &   ( CpDry * xyz_Temp(i,j,k  ) + LatentHeat * xyz_QVap(i,j,k  ) ), &
   473  !!$                    &   ( CpDry * xyz_Temp(i,j,k+1) + LatentHeat * xyz_QVap(i,j,k+1) ), &
   474  !!$                    & - CpDry * xyr_ConvAdjustFactor(i,j,k)                             &
   475  !!$                    &   * ( xyz_Temp(i,j,k) + xyz_Temp(i,j,k+1) )
   476  !!$                  write( 6, * ) 'Difference of water vapor amount before and after adjustment'
   477  !!$                  write( 6, * ) &
   478  !!$                    & - LatentHeat * ( xyz_QVap(i,j,k  ) - QVapLowLevBefAdj ) &
   479  !!$                    & * xyz_DelPress(i,j,k  ) / Grav,                       &
   480  !!$                    & - LatentHeat * ( xyz_QVap(i,j,k+1) - QVapUppLevBefAdj ) &
   481  !!$                    & * xyz_DelPress(i,j,k+1) / Grav
   482                    !=========
   483  
   484  
   485                    xyz_QVapSat(i,j,k  ) = xyz_QVap(i,j,k  )
   486                    xyz_QVapSat(i,j,k+1) = xyz_QVap(i,j,k+1)
   487  
   488                    ! Ĵᤷݤ?
   489                    ! Whether it was adjusted or not?
   490                    !
   491                    xy_Adjust(i,j) = .true.
   492                  end if
   493  
   494                end if
   495  
   496              end if
   497            end do
     .  !CDIR NODEP                                                             
     .        do i = 1, imax                                                    
     .           if (xy_adjustb(i-1,j) .ne. 0) then                             
     .              tempequivtoexcene = xyz_temp(i-1,j,k) - xyz_temp(i-1,j,k+1) 
     .       1          + latentheat/cpdry*(xyz_qvapsat(i-1,j,k)-xyz_qvapsat(i-1
     .       2         ,j,k+1)) - xyr_convadjustfactor(i-1,j,k)*(xyz_temp(i-1,j,
     .       3         k)+xyz_temp(i-1,j,k+1))                                  
     .              if (tempequivtoexcene .gt. adjustcriterion(itr)) then       
     .                 if (xyz_qvap(i-1,j,k+1)/xyz_qvapsat(i-1,j,k+1).ge.crtlrh 
     .       1             .and. xyz_qvap(i-1,j,k)/xyz_qvapsat(i-1,j,k).ge.     
     .       2            crtlrh) then                                          
     .                    delq = xyz_delpress(i-1,j,k)*(xyz_qvap(i-1,j,k)-      
     .       1               xyz_qvapsat(i-1,j,k)) + xyz_delpress(i-1,j,k+1)*(  
     .       2               xyz_qvap(i-1,j,k+1)-xyz_qvapsat(i-1,j,k+1))        
     .                    gamupplev = (latentheat/cpdry)*xy_dqvapsatdtempupplev(
     .       1               i-1,j)                                             
     .                    gamlowlev = (latentheat/cpdry)*xy_dqvapsatdtemplowlev(
     .       1               i-1,j)                                             
     .                    deltempupplev = ((xyz_delpress(i-1,j,k)*(             
     .       1               1.00000000000000e+000+gamlowlev))*tempequivtoexcene
     .       2               +((1.00000000000000e+000+gamlowlev)-               
     .       3               xyr_convadjustfactor(i-1,j,k))*latentheat/cpdry*   
     .       4               delq)/(xyr_convadjustfactor(i-1,j,k)*((xyz_delpress
     .       5               (i-1,j,k)*(1.00000000000000e+000+gamlowlev))-(     
     .       6               xyz_delpress(i-1,j,k+1)*(1.00000000000000e+000+    
     .       7               gamupplev)))+(1.00000000000000e+000+gamlowlev)*(   
     .       8               1.00000000000000e+000+gamupplev)*(xyz_delpress(i-1,
     .       9               j,k)+xyz_delpress(i-1,j,k+1)))                     
     .                    deltemplowlev = ((latentheat/cpdry)*delq - (          
     .       1               xyz_delpress(i-1,j,k+1)*(1.00000000000000e+000+    
     .       2               gamupplev))*deltempupplev)/(xyz_delpress(i-1,j,k)*(
     .       3               1.00000000000000e+000+gamlowlev))                  
     .                    xyz_temp(i-1,j,k) = xyz_temp(i-1,j,k) + deltemplowlev 
     .                    xyz_temp(i-1,j,k+1) = xyz_temp(i-1,j,k+1) +           
     .       1               deltempupplev                                      
     .                    xyz_qvap(i-1,j,k) = xyz_qvapsat(i-1,j,k) +            
     .       1               xy_dqvapsatdtemplowlev(i-1,j)*deltemplowlev        
     .                    xyz_qvap(i-1,j,k+1) = xyz_qvapsat(i-1,j,k+1) +        
     .       1               xy_dqvapsatdtempupplev(i-1,j)*deltempupplev        
     .                    xyz_qvapsat(i-1,j,k) = xyz_qvap(i-1,j,k)              
     .                    xyz_qvapsat(i-1,j,k+1) = xyz_qvap(i-1,j,k+1)          
     .                    xy_adjust(i-1,j) = 1                                  
     .                 endif                                                    
     .              endif                                                       
     .           endif                                                          
     .        end do                                                            
   498          end do
   499        end do
   500  
   501        Adjust = .false.
   502        do i = 0, imax-1
   503          do j = 1, jmax
   504            xy_AdjustB(i,j) = xy_Adjust(i,j)
   505            Adjust          = Adjust .or. xy_Adjust(i,j)
   506          end do
   507        end do
   508  
   509        if ( .not. Adjust ) exit
   510  
   511      end do
   512  
   513      ! 漾ѲΨ, ѲΨ, ߿̤λ
   514      ! Calculate specific humidity tendency, temperature tendency, precipitation
   515      !
   516      xyz_DQVapDtCumulus = ( xyz_QVap - xyz_QVapB ) / ( 2.0_DP * DelTime )
     .        D1 = 1.D0/(2.00000000000000e+000*deltime)                         
     .        D2 = 1.D0/(2.00000000000000e+000*deltime)                         
     .        D3 = 1.D0/(2.00000000000000e+000*deltime)                         
     .        D4 = 1.D0/grav                                                    
     .  !CDIR NODEP                                                             
     .        do t896 = 1, imax                                                 
     .           xyz_dqvapdtcumulus(t896-1,t894+1,t892+1) = (xyz_qvap(t896-1,   
     .       1      t894+1,t892+1)-xyz_qvapb(t896-1,t894+1,t892+1))*D1          
     .           xyz_dtempdtcumulus(t896-1,t894+1,t892+1) = (xyz_temp(t896-1,   
     .       1      t894+1,t892+1)-xyz_tempb(t896-1,t894+1,t892+1))*D2          
     .           xyz_dtempdt(t896-1,t894+1,t892+1) = xyz_dtempdt(t896-1,t894+1, 
     .       1      t892+1) + xyz_dtempdtcumulus(t896-1,t894+1,t892+1)          
     .           xyz_dqvapdt(t896-1,t894+1,t892+1) = xyz_dqvapdt(t896-1,t894+1, 
     .       1      t892+1) + xyz_dqvapdtcumulus(t896-1,t894+1,t892+1)          
     .           xyz_dqh2oliqdt(t896-1,t894+1,t892+1) = (xyz_qvapb(t896-1,t894+1
     .       1      ,t892+1)-xyz_qvap(t896-1,t894+1,t892+1))*D3                 
     .           xyz_raincumulus(t896-1,t894+1,t892+1) = xyz_dqh2oliqdt(t896-1, 
     .       1      t894+1,t892+1)*xyz_delpress(t896-1,t894+1,t892+1)*D4        
     .        end do                                                            
   517  
   518      xyz_DTempDtCumulus = ( xyz_Temp - xyz_TempB ) / ( 2.0_DP * DelTime )
   519  
   520  
   521  
   522      xyz_DTempDt = xyz_DTempDt + xyz_DTempDtCumulus
   523      xyz_DQVapDt = xyz_DQVapDt + xyz_DQVapDtCumulus
   524  
   525  
   526  
   527      ! OLD CODE TO BE DELETED
   528      !
   529  !!$    xy_RainCumulus = 0.
   530  !!$    do k = 1, kmax
   531  !!$      xy_RainCumulus = xy_RainCumulus &
   532  !!$        & + ( xyz_QVapB(:,:,k) - xyz_QVap(:,:,k) ) &
   533  !!$        &       * xyz_DelPress(:,:,k) / Grav / ( 2.0_DP * DelTime )
   534  !!$    end do
   535  !!$
   536  !!$    xy_RainCumulus = 0.0d0
   537  !!$    do k = kmax, 1, -1
   538  !!$      xy_RainCumulus = xy_RainCumulus                &
   539  !!$        & + xyz_DelPress(:,:,k) / Grav               &
   540  !!$        &   * ( xyz_QVapB(:,:,k) - xyz_QVap(:,:,k) )
   541  !!$    end do
   542  !!$    xy_RainCumulus = xy_RainCumulus / ( 2.0_DP * DelTime )
   543  !!$
   544  !!$    xyz_RainCumulus = ( xyz_QVapB - xyz_QVap ) &
   545  !!$        & * xyz_DelPress / Grav / ( 2.0_DP * DelTime )
   546  !!$    xy_RainCumulus = 0.0d0
   547  !!$    do k = kmax, 1, -1
   548  !!$      xy_RainCumulus = xy_RainCumulus + xyz_RainCumulus(:,:,k)
   549  !!$    end do
   550  
   551  !!$    j = jmax/2+1
   552  !!$    do i = 0, imax-1
   553  !!$      if ( xy_RainCumulus(i,j) /= 0.0d0 ) then
   554  !!$        write( 6, * ) xy_RainCumulus(i,j)
   555  !!$      end if
   556  !!$    end do
   557  
   558  
   559      xyz_DQH2OLiqDt = ( xyz_QVapB - xyz_QVap ) / ( 2.0_DP * DelTime )
   560  
   561  !!$    xyz_RainCumulus = xyz_DQH2OLiqDt * xyz_DelPress / Grav
   562  !!$    xy_RainCumulus = 0.0d0
   563  !!$    do k = kmax, 1, -1
   564  !!$      xy_RainCumulus = xy_RainCumulus + xyz_RainCumulus(:,:,k)
   565  !!$    end do
   566  
   567  
   568  !!$    j = jmax/2+1
   569  !!$    do i = 0, imax-1
   570  !!$      if ( xy_RainCumulus(i,j) /= 0.0d0 ) then
   571  !!$        write( 6, * ) xy_RainCumulus(i,j)
   572  !!$      end if
   573  !!$    end do
   574  !!$    write( 6, * ) '---'
   575  
   576  
   577  !!$    xy_Rain     = xy_Rain     + xy_RainCumulus
   578  
   579  
   580      ! calculation for output (tentative)
   581      xyz_RainCumulus = xyz_DQH2OLiqDt * xyz_DelPress / Grav
   582      xy_RainCumulus = 0.0d0
     .        if (xy_raincumulus.DSC.U2 .gt. 0) then                            
     .           J7 = and(xy_raincumulus.DSC.U2,3)                              
     .  !CDIR    NODEP                                                          
     .           do t952 = 1, J7                                                
     .  !CDIR       NODEP                                                       
     .              do t954 = 1, xy_raincumulus.DSC.U1 + 1                      
     .                 xy_raincumulus(t954-1,t952) = 0.0000000000000000e+000    
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t952 = J7 + 1, xy_raincumulus.DSC.U2, 4                     
     .  !CDIR       NODEP                                                       
     .              do t954 = 1, xy_raincumulus.DSC.U1 + 1                      
     .                 xy_raincumulus(t954-1,t952) = 0.0000000000000000e+000    
     .                 xy_raincumulus(t954-1,t952+1) = 0.0000000000000000e+000  
     .                 xy_raincumulus(t954-1,t952+2) = 0.0000000000000000e+000  
     .                 xy_raincumulus(t954-1,t952+3) = 0.0000000000000000e+000  
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   583      do k = kmax, 1, -1
   584        xy_RainCumulus = xy_RainCumulus + xyz_RainCumulus(:,:,k)
     .        if (xy_raincumulus.DSC.U2 .gt. 0) then                            
     .           J8 = and(xy_raincumulus.DSC.U2,3)                              
     .  !CDIR    NODEP                                                          
     .           do t958 = 1, J8                                                
     .  !CDIR       NODEP                                                       
     .              do t960 = 1, xy_raincumulus.DSC.U1 + 1                      
     .                 xy_raincumulus(t960-1,t958) = xy_raincumulus(t960-1,t958)
     .       1             + xyz_raincumulus(t960-1,t958,k)                     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t958 = J8 + 1, xy_raincumulus.DSC.U2, 4                     
     .  !CDIR       NODEP                                                       
     .              do t960 = 1, xy_raincumulus.DSC.U1 + 1                      
     .                 xy_raincumulus(t960-1,t958) = xy_raincumulus(t960-1,t958)
     .       1             + xyz_raincumulus(t960-1,t958,k)                     
     .                 xy_raincumulus(t960-1,t958+1) = xy_raincumulus(t960-1,   
     .       1            t958+1) + xyz_raincumulus(t960-1,t958+1,k)            
     .                 xy_raincumulus(t960-1,t958+2) = xy_raincumulus(t960-1,   
     .       1            t958+2) + xyz_raincumulus(t960-1,t958+2,k)            
     .                 xy_raincumulus(t960-1,t958+3) = xy_raincumulus(t960-1,   
     .       1            t958+3) + xyz_raincumulus(t960-1,t958+3,k)            
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   585      end do
   586  
   587  
   588      ! ҥȥǡ
   589      ! History data output
   590      !
   591      call HistoryAutoPut( TimeN, 'RainCumulus',    xy_RainCumulus * LatentHeat )
     .        if (xy_raincumulus.DSC.U2 .gt. 0) then                            
     .           J9 = and(xy_raincumulus.DSC.U2,3)                              
     .  !CDIR    NODEP                                                          
     .           do t968 = 1, J9                                                
     .  !CDIR       NODEP                                                       
     .              do t970 = 1, xy_raincumulus.DSC.U1 + 1                      
     .                 %IG0(t970,t968) = xy_raincumulus(t970-1,t968)*latentheat 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t968 = J9 + 1, xy_raincumulus.DSC.U2, 4                     
     .  !CDIR       NODEP                                                       
     .              do t970 = 1, xy_raincumulus.DSC.U1 + 1                      
     .                 %IG0(t970,t968) = xy_raincumulus(t970-1,t968)*latentheat 
     .                 %IG0(t970,t968+1) = xy_raincumulus(t970-1,t968+1)*       
     .       1            latentheat                                            
     .                 %IG0(t970,t968+2) = xy_raincumulus(t970-1,t968+2)*       
     .       1            latentheat                                            
     .                 %IG0(t970,t968+3) = xy_raincumulus(t970-1,t968+3)*       
     .       1            latentheat                                            
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   592      call HistoryAutoPut( TimeN, 'DTempDtCumulus', xyz_DTempDtCumulus )
   593      call HistoryAutoPut( TimeN, 'DQVapDtCumulus', xyz_DQVapDtCumulus )
   594  
   595  
   596  
   597  !!$    if ( present( xyz_DQH2OLiqDt ) ) then
   598  !!$
   599  !!$      xyz_DDelLWDtCCPLV = &
   600  !!$        & + ( xyz_QVapB - xyz_QVap ) &
   601  !!$        &       * xyz_DelPress / Grav / ( 2.0d0 * DelTime )
   602  !!$
   603  !!$      ! Negative cloud production rate is filled with values in lower layers.
   604  !!$      !
   605  !!$      xy_NegDDelLWDt = 0.0d0
   606  !!$      do k = kmax, 1, -1
   607  !!$        do j = 1, jmax
   608  !!$          do i = 0, imax-1
   609  !!$            xyz_DDelLWDtCCPLV(i,j,k) = xyz_DDelLWDtCCPLV(i,j,k) + xy_NegDDelLWDt(i,j)
   610  !!$            if ( xyz_DDelLWDtCCPLV(i,j,k) < 0.0d0 ) then
   611  !!$              xy_NegDDelLWDt(i,j) = xyz_DDelLWDtCCPLV(i,j,k)
   612  !!$              xyz_DDelLWDtCCPLV(i,j,k) = 0.0d0
   613  !!$            end if
   614  !!$          end do
   615  !!$        end do
   616  !!$      end do
   617  !!$
   618  !!$      xyz_DQH2OLiqDt = xyz_DDelLWDtCCPLV / ( xyz_DelPress / Grav )
   619  !!$
   620  !!$    end if
   621  
   622  
   623      ! ׻ַ¬
   624      ! Pause measurement of computation time
   625      !
   626      call TimesetClockStop( module_name )
   627  
   628    end subroutine MoistConvAdjust
   629  
   630    !--------------------------------------------------------------------------------------
   631  
   632    subroutine MoistConvAdjustInit
   633      !
   634      ! moist_conv_adjust ⥸塼νԤޤ.
   635      ! NAMELIST#moist_conv_adjust_nml ɤ߹ߤϤμ³ǹԤޤ.
   636      !
   637      ! "moist_conv_adjust" module is initialized.
   638      ! "NAMELIST#moist_conv_adjust_nml" is loaded in this procedure.
   639      !
   640  
   641      ! ⥸塼 ; USE statements
   642      !
   643  
   644      ! NAMELIST եϤ˴ؤ桼ƥƥ
   645      ! Utilities for NAMELIST file input
   646      !
   647      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   648  
   649      ! ե
   650      ! File I/O support
   651      !
   652      use dc_iounit, only: FileOpen
   653  
   654      ! ̷ѥ᥿
   655      ! Kind type parameter
   656      !
   657      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   658  
   659      ! ʸ
   660      ! Character handling
   661      !
   662      use dc_string, only: StoA
   663  
   664      ! ҥȥǡ
   665      ! History data output
   666      !
   667      use gtool_historyauto, only: HistoryAutoAddVariable
   668  
   669      ! ʸ ; Declaration statements
   670      !
   671      implicit none
   672  
   673      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   674                                ! Unit number for NAMELIST file open
   675      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   676                                ! IOSTAT of NAMELIST read
   677  
   678      ! NAMELIST ѿ
   679      ! NAMELIST group name
   680      !
   681      namelist /moist_conv_adjust_nml/ &
   682        & CrtlRH, ItrtMax, AdjustCriterion !, FlagUse
   683  
   684            ! ǥեͤˤĤƤϽ³ "moist_conv_adjust#CumAdjInit"
   685            ! Υɤ򻲾ȤΤ.
   686            !
   687            ! Refer to source codes in the initialization procedure
   688            ! "moist_conv_adjust#MoistConvAdjustInit" for the default values.
   689            !
   690  
   691      ! ¹ʸ ; Executable statement
   692      !
   693  
   694      if ( moist_conv_adjust_inited ) return
   695  
   696  
   697      ! ǥեͤ
   698      ! Default values settings
   699      !
   700      ! default values used in AGCM5
   701  !!$    CrtlRH  = 0.990_DP
   702  !!$    ItrtMax = 10
   703  !!$    AdjustCriterion(1:ItrtMax) = &
   704  !!$      & (/ 0.01_DP, 0.02_DP, 0.02_DP, 0.05_DP, 0.05_DP, &
   705  !!$      &    0.10_DP, 0.10_DP, 0.20_DP, 0.20_DP, 0.40_DP  /)
   706      !
   707      CrtlRH  = 1.0d0
   708      ItrtMax = 10
   709      AdjustCriterion(1:ItrtMax) = 0.0d0
   710      !
   711  !!$    FlagUse = .true.
   712  
   713      ! NAMELIST ɤ߹
   714      ! NAMELIST is input
   715      !
   716      if ( trim(namelist_filename) /= '' ) then
   717        call FileOpen( unit_nml, &          ! (out)
   718          & namelist_filename, mode = 'r' ) ! (in)
   719  
   720        rewind( unit_nml )
   721        read( unit_nml,                  &  ! (in)
   722          & nml = moist_conv_adjust_nml, &  ! (out)
   723          & iostat = iostat_nml )           ! (out)
   724        close( unit_nml )
   725  
   726        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   727  !!$      if ( iostat_nml == 0 ) write( STDOUT, nml = cumulus_adjust_nml )
   728      end if
   729  
   730      ! ƥ졼, ԰εƸΥå
   731      ! Check number of iteration, admissible error of unstability
   732      !
   733      call NmlutilAryValid( module_name, & ! (in)
   734        & AdjustCriterion, 'AdjustCriterion', &      ! (in)
   735        & ItrtMax,    'ItrtMax' )          ! (in)
   736  
   737  
   738      ! ҥȥǡϤΤΤؤѿϿ
   739      ! Register of variables for history data output
   740      !
   741      call HistoryAutoAddVariable( 'RainCumulus', &
   742        & (/ 'lon ', 'lat ', 'time' /), &
   743        & 'precipitation by cumulus scheme', 'W m-2' )
   744      call HistoryAutoAddVariable( 'DTempDtCumulus', &
   745        & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
   746        & 'cumulus condensation heating', 'K s-1' )
   747      call HistoryAutoAddVariable( 'DQVapDtCumulus', &
   748        & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
   749        & 'cumulus condensation moistening', 'kg kg-1 s-1' )
   750  
   751      !  ; Print
   752      !
   753      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   754  !!$    call MessageNotify( 'M', module_name, '  FlagUse              = %b', l = (/ FlagUse /) )
   755      call MessageNotify( 'M', module_name, '  CrtlRH               = %f', d = (/ CrtlRH /) )
   756      call MessageNotify( 'M', module_name, '  ItrtMax              = %d', i = (/ ItrtMax /) )
   757      call MessageNotify( 'M', module_name, '  AdjustCriterion      = (/ %*r /)', &
   758        & r = real( AdjustCriterion(1:ItrtMax) ), n = (/ ItrtMax /) )
   759      call MessageNotify( 'M', module_name, '' )
   760      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   761  
   762      moist_conv_adjust_inited = .true.
   763  
   764    end subroutine MoistConvAdjustInit
   765  
   766    !--------------------------------------------------------------------------------------
   767  
   768  end module moist_conv_adjust
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:36 2012
FILE NAME: moist_conv_adjust.f90
PROGRAM NAME: moist_conv_adjust
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ήĴ
     2:            !
     3:            != Moist convective adjustment
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA, Yukiko YAMADA
     6:            ! Version::   $Id: moist_conv_adjust.f90,v 1.7 2011-12-02 04:06:36 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module moist_conv_adjust
    13:              !
    14:              != ήĴ
    15:              !
    16:              != Moist convective adjustment
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! ήĴ᥹ˤ, ٤漾Ĵ. 
    21:              !
    22:              ! Moist convective adjustment was originally proposed by Manabe et al. (1965).
    23:              ! But, the algorithm used in this routine seems to be different from that described by 
    24:              ! Manabe et al. (1965). 
    25:              !
    26:              ! Adjust temperature and specific humidity by 
    27:              ! convective adjustment scheme. 
    28:              !
    29:              !== Procedures List
    30:              ! 
    31:              ! MoistConvAdjust :: ٤漾Ĵ
    32:              ! --------------- :: ------------
    33:              ! MoistConvAdjust :: Adjust temperature and specific humidity
    34:              !
    35:              !== NAMELIST
    36:              !
    37:              ! NAMELIST#moist_conv_adjust_nml
    38:              !
    39:            
    40:              ! ⥸塼 ; USE statements
    41:              !
    42:            
    43:              ! ʻ
    44:              ! Grid points settings
    45:              !
    46:              use gridset, only: imax, & ! ٳʻ. 
    47:                                         ! Number of grid points in longitude
    48:                &                jmax, & ! ٳʻ. 
    49:                                         ! Number of grid points in latitude
    50:                &                kmax    ! ľؿ. 
    51:                                         ! Number of vertical level
    52:            
    53:              ! ̷ѥ᥿
    54:              ! Kind type parameter
    55:              !
    56:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    57:                &                 STRING     ! ʸ.       Strings. 
    58:            
    59:              ! NAMELIST եϤ˴ؤ桼ƥƥ
    60:              ! Utilities for NAMELIST file input
    61:              !
    62:              use namelist_util, only: MaxNmlArySize
    63:                                          ! NAMELIST ɤ߹κ祵. 
    64:                                          ! Maximum size of arrays loaded from NAMELIST
    65:            
    66:              ! å
    67:              ! Message output
    68:              !
    69:              use dc_message, only: MessageNotify
    70:            
    71:              ! ʸ ; Declaration statements
    72:              !
    73:              implicit none
    74:              private
    75:            
    76:            !!$  logical, save:: FlagUse
    77:            !!$                              ! ѥե饰
    78:            !!$                              ! flag for use of this scheme
    79:            
    80:              ! ³
    81:              ! Public procedure
    82:              !
    83:              public:: MoistConvAdjust
    84:              public:: MoistConvAdjustInit
    85:            
    86:              ! ѿ
    87:              ! Public variables
    88:              !
    89:              logical, save :: moist_conv_adjust_inited = .false.
    90:                                          ! ե饰. 
    91:                                          ! Initialization flag
    92:            
    93:              ! ѿ
    94:              ! Private variables
    95:              !
    96:              real(DP), save:: CrtlRH
    97:                                          ! ׳м. 
    98:                                          ! Critical relative humidity
    99:              integer, save:: ItrtMax
   100:                                          ! ƥ졼. 
   101:                                          ! Number of iteration
   102:            
   103:              real(DP), save:: AdjustCriterion(1:MaxNmlArySize)
   104:                                          ! ĴԤ (Ūͥ륮κβٴ)
   105:                                          ! Criterion of adjustment (temperature difference 
   106:                                          ! equivalent to difference of moist static energy)
   107:            
   108:              character(*), parameter:: module_name = 'moist_conv_adjust'
   109:                                          ! ⥸塼̾. 
   110:                                          ! Module name
   111:              character(*), parameter:: version = &
   112:                & '$Name: dcpam5-20120921 $' // &
   113:                & '$Id: moist_conv_adjust.f90,v 1.7 2011-12-02 04:06:36 yot Exp $'
   114:                                          ! ⥸塼ΥС
   115:                                          ! Module version
   116:            
   117:            contains
   118:            
   119:              !--------------------------------------------------------------------------------------
   120:            
   121:            !!$  subroutine MoistConvAdjust( &
   122:            !!$    & xyz_Temp, xyz_QVap, xy_Rain, &  ! (inout)
   123:            !!$    & xyz_DTempDt, xyz_DQVapDt, &     ! (inout)
   124:            !!$    & xyz_Press, xyr_Press, &         ! (in)
   125:            !!$    & xyz_DQH2OLiqDt &                ! (out)
   126:            !!$    & )
   127:              subroutine MoistConvAdjust(   &
   128:                & xyz_Temp, xyz_QVap,       & ! (inout)
   129:                & xyz_DTempDt, xyz_DQVapDt, & ! (inout)
   130:                & xyz_Press, xyr_Press,     & ! (in)
   131:                & xyz_DQH2OLiqDt            & ! (out)
   132:                & )
   133:                !
   134:                ! ήĴ᥹ˤ, ٤漾Ĵ. 
   135:                !
   136:                ! Adjust temperature and specific humidity by moist convective adjustment
   137:                !
   138:            
   139:                ! ⥸塼 ; USE statements
   140:                !
   141:            
   142:                ! ʪ
   143:                ! Physical constants settings
   144:                !
   145:                use constants, only: &
   146:                  & Grav, & 
   147:                                          ! $ g $ [m s-2]. 
   148:                                          ! ϲ®. 
   149:                                          ! Gravitational acceleration
   150:                  & GasRDry, &
   151:                                          ! $ R $ [J kg-1 K-1]. 
   152:                                          ! 絤ε. 
   153:                                          ! Gas constant of air
   154:                  & CpDry, &
   155:                                          ! $ C_p $ [J kg-1 K-1]. 
   156:                                          ! 絤갵Ǯ. 
   157:                                          ! Specific heat of air at constant pressure
   158:                  & LatentHeat
   159:                                          ! $ L $ [J kg-1] . 
   160:                                          ! ŷǮ. 
   161:                                          ! Latent heat of condensation
   162:            
   163:                ! 
   164:                ! Time control
   165:                !
   166:                use timeset, only: &
   167:                  & DelTime, &            ! $ \Delta t $
   168:                  & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $. 
   169:                  & TimesetClockStart, TimesetClockStop
   170:            
   171:                ! ҥȥǡ
   172:                ! History data output
   173:                !
   174:                use gtool_historyauto, only: HistoryAutoPut
   175:            
   176:                ! ˰漾λ
   177:                ! Evaluate saturation specific humidity
   178:                !
   179:                use saturate, only: xyz_CalcQVapSat, xy_CalcDQVapSatDTemp
   180:            
   181:            
   182:                ! ʸ ; Declaration statements
   183:                !
   184:                implicit none
   185:            
   186:                real(DP), intent(inout):: xyz_Temp (0:imax-1, 1:jmax, 1:kmax)
   187:                                          ! $ T $ .     . Temperature
   188:                real(DP), intent(inout):: xyz_QVap (0:imax-1, 1:jmax, 1:kmax)
   189:                                          ! $ q $ .     漾. Specific humidity
   190:            !!$    real(DP), intent(inout):: xy_Rain (0:imax-1, 1:jmax)
   191:            !!$                              ! ߿. 
   192:            !!$                              ! Precipitation
   193:                real(DP), intent(inout):: xyz_DTempDt (0:imax-1, 1:jmax, 1:kmax)
   194:                                          ! ѲΨ. 
   195:                                          ! Temperature tendency
   196:                real(DP), intent(inout):: xyz_DQVapDt (0:imax-1, 1:jmax, 1:kmax)
   197:                                          ! 漾ѲΨ. 
   198:                                          ! Specific humidity tendency
   199:            
   200:                real(DP), intent(in):: xyz_Press (0:imax-1, 1:jmax, 1:kmax)
   201:                                          ! $ p $ .  (٥). 
   202:                                          ! Air pressure (full level)
   203:                real(DP), intent(in):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
   204:                                          ! $ \hat{p} $ .  (Ⱦ٥). 
   205:                                          ! Air pressure (half level)
   206:                real(DP), intent(out):: xyz_DQH2OLiqDt(0:imax-1, 1:jmax, 1:kmax)
   207:            
   208:                ! ѿ
   209:                ! Work variables
   210:                !
   211:                real(DP):: xy_RainCumulus (0:imax-1, 1:jmax)
   212:                                          ! ߿. 
   213:                                          ! Precipitation
   214:                real(DP):: xyz_DTempDtCumulus (0:imax-1, 1:jmax, 1:kmax)
   215:                                          ! ѲΨ. 
   216:                                          ! Temperature tendency
   217:                real(DP):: xyz_DQVapDtCumulus (0:imax-1, 1:jmax, 1:kmax)
   218:                                          ! 漾ѲΨ. 
   219:                                          ! Specific humidity tendency
   220:            
   221:                real(DP):: xyz_QVapB (0:imax-1, 1:jmax, 1:kmax)
   222:                                          ! Ĵ漾. 
   223:                                          ! Specific humidity before adjustment
   224:                real(DP):: xyz_TempB (0:imax-1, 1:jmax, 1:kmax)
   225:                                          ! Ĵβ. 
   226:                                          ! Temperature before adjustment
   227:                logical:: xy_Adjust (0:imax-1, 1:jmax)
   228:                                          ! Ĵᤵ줿ݤ?. 
   229:                                          ! Whether it was adjusted this time or not?
   230:                logical:: xy_AdjustB (0:imax-1, 1:jmax)
   231:                                          ! Ĵᤵ줿ݤ?. 
   232:                                          ! Whether it was adjusted last time or not?
   233:                real(DP):: xyz_DelPress(0:imax-1, 1:jmax, 1:kmax)
   234:                                          ! $ \Delta p $
   235:                                          !
   236:                real(DP):: xyz_QVapSat (0:imax-1, 1:jmax, 1:kmax)
   237:                                          ! ˰漾. 
   238:                                          ! Saturation specific humidity. 
   239:                real(DP):: xyr_ConvAdjustFactor(0:imax-1, 1:jmax, 0:kmax)
   240:                                          ! $ \frac{1}{2} \frac{ R }{Cp} 
   241:                                          !   \frac{ p_{k} - p_{k+1} }{ p_{k+1/2} } $
   242:            
   243:                real(DP):: TempEquivToExcEne
   244:                                          ! Temperature equivalent to the excess moist static energy
   245:                                          ! (Moist static energy difference devided by specific heat)
   246:            
   247:                real(DP):: DelQ
   248:                real(DP):: DelTempUppLev
   249:                                          ! k+1 ܤؤˤĴˤ벹٤Ѳ. 
   250:                                          ! Temperature variation by adjustment at k+1 level
   251:                real(DP):: DelTempLowLev
   252:                                          ! k ܤؤˤĴˤ벹٤Ѳ. 
   253:                                          ! Temperature variation by adjustment at k level
   254:                real(DP):: DQVapSatDTempUppLev
   255:                                          ! $ \DD{q^{*}} (k+1)}{T} $
   256:                real(DP):: DQVapSatDTempLowLev
   257:                                          ! $ \DD{q^{*}} (k)}{T} $
   258:                real(DP):: GamUppLev
   259:                                          ! $ \gamma_{k+1} = \frac{L}{C_p} \DP{q^{*}}{T}_{k+1} $
   260:                real(DP):: GamLowLev
   261:                                          ! $ \gamma_{k}   = \frac{L}{C_p} \DP{q^{*}}{T}_{k} $
   262:                logical:: Adjust
   263:                                          ! ΰˤư٤ǤĴᤵ줿ݤ?. 
   264:                                          ! Whether it was adjusted even once in global 
   265:                                          ! this time or not?
   266:            
   267:                real(DP):: TempLowLevBefAdj ! Variables for check routine
   268:                real(DP):: TempUppLevBefAdj
   269:                real(DP):: QVapLowLevBefAdj
   270:                real(DP):: QVapUppLevBefAdj
   271:            
   272:                integer:: i               ! ˲ DO 롼Ѻѿ
   273:                                          ! Work variables for DO loop in longitude
   274:                integer:: j               ! ˲ DO 롼Ѻѿ
   275:                                          ! Work variables for DO loop in latitude
   276:                integer:: k               ! ľ˲ DO 롼Ѻѿ
   277:                                          ! Work variables for DO loop in vertical direction
   278:                integer:: itr             ! ƥ졼˲ DO 롼Ѻѿ
   279:                                          ! Work variables for DO loop in iteration direction
   280:            
   281:                real(DP):: xy_DQVapSatDTempUppLev(0:imax-1, 1:jmax)
   282:                real(DP):: xy_DQVapSatDTempLowLev(0:imax-1, 1:jmax)
   283:            
   284:                real(DP):: xyz_RainCumulus (0:imax-1, 1:jmax, 1:kmax)
   285:            
   286:                real(DP) :: xy_NegDDelLWDt   (0:imax-1, 1:jmax)
   287:                real(DP) :: xyz_DDelLWDtCCPLV(0:imax-1, 1:jmax, 1:kmax)
   288:            
   289:            
   290:                ! ¹ʸ ; Executable statement
   291:                !
   292:            
   293:                ! ǧ
   294:                ! Initialization check
   295:                !
   296:                if ( .not. moist_conv_adjust_inited ) then
   297:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   298:                end if
   299:            
   300:            !!$    if ( .not. FlagUse ) return
   301:            
   302:            
   303:                ! ׻ַ¬
   304:                ! Start measurement of computation time
   305:                !
   306:                call TimesetClockStart( module_name )
   307:            
   308:            
   309:                ! Ĵ "QVap", "Temp" ¸
   310:                ! Store "QVap", "Temp" before adjustment
   311:                !
   312: **V---->       xyz_QVapB = xyz_QVap
   313: |||            xyz_TempB = xyz_Temp
   314: |||        
   315: |||            ! ˰漾׻
   316: |||            ! Calculate saturation specific humidity
   317: |||            !
   318: **V----        xyz_QVapSat = xyz_CalcQVapSat( xyz_Temp, xyz_Press )
   319:            
   320:                ! Calculate some values used for moist convective adjustment
   321:                !
   322:            
   323: +------>       do k = 1, kmax
   324: |+V====          xyz_DelPress(:,:,k) = xyr_Press(:,:,k-1) - xyr_Press(:,:,k)
   325: +------        end do
   326:            
   327:                ! \frac{1}{2} \frac{ R }{Cp} \frac{ p_{k} - p_{k+1} }{ p_{k+1/2} }
   328:                !
   329:                !   The value at k = 0 is not used.
   330:                k = 0
   331: +V=====        xyr_ConvAdjustFactor(:,:,k) = 0.0d0
   332:                !
   333: +------>       do k = 1, kmax-1
   334: |+V====          xyr_ConvAdjustFactor(:,:,k) =                     &
   335: |                  & GasRDry / CpDry                               &
   336: |                  &   * ( xyz_Press(:,:,k) - xyz_Press(:,:,k+1) ) &
   337: |                  &   / xyr_Press(:,:,k) / 2.0_DP
   338: +------        end do
   339:                !   The value at k = kmax is not used.
   340:                k = kmax
   341: +V=====        xyr_ConvAdjustFactor(:,:,k) = 0.0d0
   342:            
   343:            
   344:                ! Ĵ
   345:                ! Adjustment
   346:                !
   347: +V=====        xy_AdjustB = .true.
   348:            
   349:                ! ֤
   350:                ! Iteration
   351:                !
   352: +------>       do itr = 1, ItrtMax
   353: |+V====          xy_Adjust = .false.
   354: |          
   355: |+----->         do k = 1, kmax-1
   356: ||         
   357: ||                 xy_DQVapSatDTempUppLev = &
   358: ||                   & xy_CalcDQVapSatDTemp( xyz_Temp(:,:,k+1), xyz_QVapSat(:,:,k+1) )
   359: ||                 xy_DQVapSatDTempLowLev = &
   360: ||                   & xy_CalcDQVapSatDTemp( xyz_Temp(:,:,k  ), xyz_QVapSat(:,:,k  ) )
   361: ||         
   362: ||+---->           do j = 1, jmax
   363: |||V--->             do i = 0, imax-1
   364: ||||                   if ( xy_AdjustB(i,j) ) then
   365: ||||       
   366: ||||                     ! Temperature equivalent to the excess moist static energy
   367: ||||                     ! (Moist static energy difference devided by specific heat)
   368: ||||                     !
   369: ||||                     TempEquivToExcEne = &
   370: ||||                       &   xyz_Temp(i,j,k) - xyz_Temp(i,j,k+1)                                &
   371: ||||                       & + LatentHeat / CpDry * ( xyz_QVapSat(i,j,k) - xyz_QVapSat(i,j,k+1) ) &
   372: ||||                       & - xyr_ConvAdjustFactor(i,j,k) * ( xyz_Temp(i,j,k) + xyz_Temp(i,j,k+1) )
   373: ||||       
   374: ||||                     ! Check vertical gradient of moist static energy
   375: ||||                     !
   376: ||||                     if ( TempEquivToExcEne > AdjustCriterion(itr) ) then
   377: ||||       
   378: ||||                       ! Check relative humidity
   379: ||||                       !
   380: ||||                       if ( ( xyz_QVap(i,j,k+1) / xyz_QVapSat(i,j,k+1) >= CrtlRH ) &
   381: ||||                         &  .and.                                                  &
   382: ||||                         &  ( xyz_QVap(i,j,k  ) / xyz_QVapSat(i,j,k  ) >= CrtlRH ) &
   383: ||||                         &) then
   384: ||||       
   385: ||||                         DelQ =                                                 &
   386: ||||                           &   xyz_DelPress(i,j,k  )                            &
   387: ||||                           &     * ( xyz_QVap(i,j,k  ) - xyz_QVapSat(i,j,k  ) ) &
   388: ||||                           & + xyz_DelPress(i,j,k+1)                            &
   389: ||||                           &     * ( xyz_QVap(i,j,k+1) - xyz_QVapSat(i,j,k+1) )
   390: ||||       
   391: ||||                         DQVapSatDTempUppLev = xy_DQVapSatDTempUppLev(i,j)
   392: ||||                         DQVapSatDTempLowLev = xy_DQVapSatDTempLowLev(i,j)
   393: ||||       
   394: ||||                         GamUppLev = LatentHeat / CpDry * DQVapSatDTempUppLev
   395: ||||                         GamLowLev = LatentHeat / CpDry * DQVapSatDTempLowLev
   396: ||||       
   397: ||||                         DelTempUppLev =                                                       &
   398: ||||                           & (                                                                 &
   399: ||||                           &     xyz_DelPress(i,j,k) * ( 1.0d0 + GamLowLev )                   &
   400: ||||                           &       * TempEquivToExcEne                                         &
   401: ||||                           &   + ( 1.0d0 + GamLowLev - xyr_ConvAdjustFactor(i,j,k) )           &
   402: ||||                           &       * LatentHeat / CpDry * DelQ                                 &
   403: ||||                           & )                                                                 &
   404: ||||                           & / ( xyr_ConvAdjustFactor(i,j,k)                                   &
   405: ||||                           &       * ( xyz_DelPress(i,j,k  ) * ( 1.0d0 + GamLowLev )           &
   406: ||||                           &         - xyz_DelPress(i,j,k+1) * ( 1.0d0 + GamUppLev ) )         &
   407: ||||                           &     + ( 1.0d0 + GamLowLev ) * ( 1.0d0 + GamUppLev )               &
   408: ||||                           &       * ( xyz_DelPress(i,j,k) + xyz_DelPress(i,j,k+1) ) )
   409: ||||       
   410: ||||                         DelTempLowLev =                                                       &
   411: ||||                           &   ( LatentHeat / CpDry * DelQ                                     &
   412: ||||                           &     - xyz_DelPress(i,j,k+1)                                       &
   413: ||||                           &         * ( 1.0d0 + GamUppLev ) * DelTempUppLev )                 &
   414: ||||                           & / ( ( 1.0d0 + GamLowLev ) * xyz_DelPress(i,j,k) )
   415: ||||       
   416: ||||       
   417: ||||                         !=========
   418: ||||                         ! check routine
   419: ||||                         !---------
   420: ||||       !!$                  TempLowLevBefAdj = xyz_Temp(i,j,k  )
   421: ||||       !!$                  TempUppLevBefAdj = xyz_Temp(i,j,k+1)
   422: ||||       !!$                  QVapLowLevBefAdj = xyz_QVap(i,j,k  )
   423: ||||       !!$                  QVapUppLevBefAdj = xyz_QVap(i,j,k+1)
   424: ||||                         !=========
   425: ||||       
   426: ||||       
   427: ||||                         ! ٤Ĵ
   428: ||||                         ! Adjust temperature
   429: ||||                         !
   430: ||||                         xyz_Temp(i,j,k  ) = xyz_Temp(i,j,k  ) + DelTempLowLev
   431: ||||                         xyz_Temp(i,j,k+1) = xyz_Temp(i,j,k+1) + DelTempUppLev
   432: ||||       
   433: ||||                         ! 漾Ĵ
   434: ||||                         ! Adjust specific humidity
   435: ||||                         !
   436: ||||                         xyz_QVap(i,j,k  ) = &
   437: ||||                           &   xyz_QVapSat(i,j,k  ) + DQVapSatDTempLowLev * DelTempLowLev
   438: ||||                         xyz_QVap(i,j,k+1) = &
   439: ||||                           &   xyz_QVapSat(i,j,k+1) + DQVapSatDTempUppLev * DelTempUppLev
   440: ||||       
   441: ||||       
   442: ||||                         !=========
   443: ||||                         ! check routine
   444: ||||                         !---------
   445: ||||       !!$                  write( 6, * ) '====='
   446: ||||       !!$                  write( 6, * ) xyz_Temp(i,j,k), xyz_Temp(i,j,k+1), xyz_QVap(i,j,k), xyz_QVap(i,j,k+1)
   447: ||||       !!$                  write( 6, * ) DelTempLowLev, DelTempUppLev
   448: ||||       !!$                  write( 6, * ) 'Energy difference before and after adjustment and each energy'
   449: ||||       !!$                  write( 6, * ) &
   450: ||||       !!$                    &   ( CpDry * TempLowLevBefAdj  + LatentHeat * QVapLowLevBefAdj )  &
   451: ||||       !!$                    &     * xyz_DelPress(i,j,k  ) / Grav                               &
   452: ||||       !!$                    & + ( CpDry * TempUppLevBefAdj  + LatentHeat * QVapUppLevBefAdj )  &
   453: ||||       !!$                    &     * xyz_DelPress(i,j,k+1) / Grav                               &
   454: ||||       !!$                    & - ( CpDry * xyz_Temp(i,j,k  ) + LatentHeat * xyz_QVap(i,j,k  ) ) &
   455: ||||       !!$                    &     * xyz_DelPress(i,j,k  ) / Grav                               &
   456: ||||       !!$                    & - ( CpDry * xyz_Temp(i,j,k+1) + LatentHeat * xyz_QVap(i,j,k+1) ) &
   457: ||||       !!$                    &     * xyz_DelPress(i,j,k+1) / Grav,                              &
   458: ||||       !!$                    &   ( CpDry * TempLowLevBefAdj  + LatentHeat * QVapLowLevBefAdj )  &
   459: ||||       !!$                    &     * xyz_DelPress(i,j,k  ) / Grav,                              &
   460: ||||       !!$                    &   ( CpDry * TempUppLevBefAdj  + LatentHeat * QVapUppLevBefAdj )  &
   461: ||||       !!$                    &     * xyz_DelPress(i,j,k+1) / Grav,                              &
   462: ||||       !!$                    &   ( CpDry * xyz_Temp(i,j,k  ) + LatentHeat * xyz_QVap(i,j,k  ) ) &
   463: ||||       !!$                    &     * xyz_DelPress(i,j,k  ) / Grav,                              &
   464: ||||       !!$                    &   ( CpDry * xyz_Temp(i,j,k+1) + LatentHeat * xyz_QVap(i,j,k+1) ) &
   465: ||||       !!$                    &     * xyz_DelPress(i,j,k+1) / Grav
   466: ||||       !!$                  write( 6, * ) 'Difference of moist static energy after adjustment'
   467: ||||       !!$                  write( 6, * ) &
   468: ||||       !!$                    &   ( CpDry * xyz_Temp(i,j,k  ) + LatentHeat * xyz_QVap(i,j,k  ) )  &
   469: ||||       !!$                    & - ( CpDry * xyz_Temp(i,j,k+1) + LatentHeat * xyz_QVap(i,j,k+1) )  &
   470: ||||       !!$                    & - CpDry * xyr_ConvAdjustFactor(i,j,k)                             &
   471: ||||       !!$                    &   * ( xyz_Temp(i,j,k) + xyz_Temp(i,j,k+1) ),                      &
   472: ||||       !!$                    &   ( CpDry * xyz_Temp(i,j,k  ) + LatentHeat * xyz_QVap(i,j,k  ) ), &
   473: ||||       !!$                    &   ( CpDry * xyz_Temp(i,j,k+1) + LatentHeat * xyz_QVap(i,j,k+1) ), &
   474: ||||       !!$                    & - CpDry * xyr_ConvAdjustFactor(i,j,k)                             &
   475: ||||       !!$                    &   * ( xyz_Temp(i,j,k) + xyz_Temp(i,j,k+1) )
   476: ||||       !!$                  write( 6, * ) 'Difference of water vapor amount before and after adjustment'
   477: ||||       !!$                  write( 6, * ) &
   478: ||||       !!$                    & - LatentHeat * ( xyz_QVap(i,j,k  ) - QVapLowLevBefAdj ) &
   479: ||||       !!$                    & * xyz_DelPress(i,j,k  ) / Grav,                       &
   480: ||||       !!$                    & - LatentHeat * ( xyz_QVap(i,j,k+1) - QVapUppLevBefAdj ) &
   481: ||||       !!$                    & * xyz_DelPress(i,j,k+1) / Grav
   482: ||||                         !=========
   483: ||||       
   484: ||||       
   485: ||||                         xyz_QVapSat(i,j,k  ) = xyz_QVap(i,j,k  )
   486: ||||                         xyz_QVapSat(i,j,k+1) = xyz_QVap(i,j,k+1)
   487: ||||       
   488: ||||                         ! Ĵᤷݤ?
   489: ||||                         ! Whether it was adjusted or not?
   490: ||||                         !
   491: ||||                         xy_Adjust(i,j) = .true.
   492: ||||                       end if
   493: ||||       
   494: ||||                     end if
   495: ||||       
   496: ||||                   end if
   497: |||V---              end do
   498: ||+----            end do
   499: |+-----          end do
   500: |          
   501: |                Adjust = .false.
   502: |+----->         do i = 0, imax-1
   503: ||+---->           do j = 1, jmax
   504: |||                  xy_AdjustB(i,j) = xy_Adjust(i,j)
   505: |||                  Adjust          = Adjust .or. xy_Adjust(i,j)
   506: ||+----            end do
   507: |+-----          end do
   508: |          
   509: |                if ( .not. Adjust ) exit
   510: |          
   511: +------        end do
   512:            
   513:                ! 漾ѲΨ, ѲΨ, ߿̤λ
   514:                ! Calculate specific humidity tendency, temperature tendency, precipitation
   515:                !
   516: **V---->       xyz_DQVapDtCumulus = ( xyz_QVap - xyz_QVapB ) / ( 2.0_DP * DelTime )
   517: |||        
   518: |||            xyz_DTempDtCumulus = ( xyz_Temp - xyz_TempB ) / ( 2.0_DP * DelTime )
   519: |||        
   520: |||        
   521: |||        
   522: |||            xyz_DTempDt = xyz_DTempDt + xyz_DTempDtCumulus
   523: |||            xyz_DQVapDt = xyz_DQVapDt + xyz_DQVapDtCumulus
   524: |||        
   525: |||        
   526: |||        
   527: |||            ! OLD CODE TO BE DELETED
   528: |||            !
   529: |||        !!$    xy_RainCumulus = 0.
   530: |||        !!$    do k = 1, kmax
   531: |||        !!$      xy_RainCumulus = xy_RainCumulus &
   532: |||        !!$        & + ( xyz_QVapB(:,:,k) - xyz_QVap(:,:,k) ) &
   533: |||        !!$        &       * xyz_DelPress(:,:,k) / Grav / ( 2.0_DP * DelTime )
   534: |||        !!$    end do
   535: |||        !!$
   536: |||        !!$    xy_RainCumulus = 0.0d0
   537: |||        !!$    do k = kmax, 1, -1
   538: |||        !!$      xy_RainCumulus = xy_RainCumulus                &
   539: |||        !!$        & + xyz_DelPress(:,:,k) / Grav               &
   540: |||        !!$        &   * ( xyz_QVapB(:,:,k) - xyz_QVap(:,:,k) )
   541: |||        !!$    end do
   542: |||        !!$    xy_RainCumulus = xy_RainCumulus / ( 2.0_DP * DelTime )
   543: |||        !!$
   544: |||        !!$    xyz_RainCumulus = ( xyz_QVapB - xyz_QVap ) &
   545: |||        !!$        & * xyz_DelPress / Grav / ( 2.0_DP * DelTime )
   546: |||        !!$    xy_RainCumulus = 0.0d0
   547: |||        !!$    do k = kmax, 1, -1
   548: |||        !!$      xy_RainCumulus = xy_RainCumulus + xyz_RainCumulus(:,:,k)
   549: |||        !!$    end do
   550: |||        
   551: |||        !!$    j = jmax/2+1
   552: |||        !!$    do i = 0, imax-1
   553: |||        !!$      if ( xy_RainCumulus(i,j) /= 0.0d0 ) then
   554: |||        !!$        write( 6, * ) xy_RainCumulus(i,j)
   555: |||        !!$      end if
   556: |||        !!$    end do
   557: |||        
   558: |||        
   559: |||            xyz_DQH2OLiqDt = ( xyz_QVapB - xyz_QVap ) / ( 2.0_DP * DelTime )
   560: |||        
   561: |||        !!$    xyz_RainCumulus = xyz_DQH2OLiqDt * xyz_DelPress / Grav
   562: |||        !!$    xy_RainCumulus = 0.0d0
   563: |||        !!$    do k = kmax, 1, -1
   564: |||        !!$      xy_RainCumulus = xy_RainCumulus + xyz_RainCumulus(:,:,k)
   565: |||        !!$    end do
   566: |||        
   567: |||        
   568: |||        !!$    j = jmax/2+1
   569: |||        !!$    do i = 0, imax-1
   570: |||        !!$      if ( xy_RainCumulus(i,j) /= 0.0d0 ) then
   571: |||        !!$        write( 6, * ) xy_RainCumulus(i,j)
   572: |||        !!$      end if
   573: |||        !!$    end do
   574: |||        !!$    write( 6, * ) '---'
   575: |||        
   576: |||        
   577: |||        !!$    xy_Rain     = xy_Rain     + xy_RainCumulus
   578: |||        
   579: |||        
   580: |||            ! calculation for output (tentative)
   581: **V----        xyz_RainCumulus = xyz_DQH2OLiqDt * xyz_DelPress / Grav
   582: +V=====        xy_RainCumulus = 0.0d0
   583: +------>       do k = kmax, 1, -1
   584: |+V====          xy_RainCumulus = xy_RainCumulus + xyz_RainCumulus(:,:,k)
   585: +------        end do
   586:            
   587:            
   588:                ! ҥȥǡ
   589:                ! History data output
   590:                !
   591: +V=====        call HistoryAutoPut( TimeN, 'RainCumulus',    xy_RainCumulus * LatentHeat )
   592:                call HistoryAutoPut( TimeN, 'DTempDtCumulus', xyz_DTempDtCumulus )
   593:                call HistoryAutoPut( TimeN, 'DQVapDtCumulus', xyz_DQVapDtCumulus )
   594:            
   595:            
   596:            
   597:            !!$    if ( present( xyz_DQH2OLiqDt ) ) then
   598:            !!$
   599:            !!$      xyz_DDelLWDtCCPLV = &
   600:            !!$        & + ( xyz_QVapB - xyz_QVap ) &
   601:            !!$        &       * xyz_DelPress / Grav / ( 2.0d0 * DelTime )
   602:            !!$
   603:            !!$      ! Negative cloud production rate is filled with values in lower layers.
   604:            !!$      !
   605:            !!$      xy_NegDDelLWDt = 0.0d0
   606:            !!$      do k = kmax, 1, -1
   607:            !!$        do j = 1, jmax
   608:            !!$          do i = 0, imax-1
   609:            !!$            xyz_DDelLWDtCCPLV(i,j,k) = xyz_DDelLWDtCCPLV(i,j,k) + xy_NegDDelLWDt(i,j)
   610:            !!$            if ( xyz_DDelLWDtCCPLV(i,j,k) < 0.0d0 ) then
   611:            !!$              xy_NegDDelLWDt(i,j) = xyz_DDelLWDtCCPLV(i,j,k) 
   612:            !!$              xyz_DDelLWDtCCPLV(i,j,k) = 0.0d0
   613:            !!$            end if
   614:            !!$          end do
   615:            !!$        end do
   616:            !!$      end do
   617:            !!$
   618:            !!$      xyz_DQH2OLiqDt = xyz_DDelLWDtCCPLV / ( xyz_DelPress / Grav )
   619:            !!$
   620:            !!$    end if
   621:            
   622:            
   623:                ! ׻ַ¬
   624:                ! Pause measurement of computation time
   625:                !
   626:                call TimesetClockStop( module_name )
   627:            
   628:              end subroutine MoistConvAdjust
   629:            
   630:              !--------------------------------------------------------------------------------------
   631:            
   632:              subroutine MoistConvAdjustInit
   633:                !
   634:                ! moist_conv_adjust ⥸塼νԤޤ. 
   635:                ! NAMELIST#moist_conv_adjust_nml ɤ߹ߤϤμ³ǹԤޤ. 
   636:                !
   637:                ! "moist_conv_adjust" module is initialized. 
   638:                ! "NAMELIST#moist_conv_adjust_nml" is loaded in this procedure. 
   639:                !
   640:            
   641:                ! ⥸塼 ; USE statements
   642:                !
   643:            
   644:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   645:                ! Utilities for NAMELIST file input
   646:                !
   647:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   648:            
   649:                ! ե
   650:                ! File I/O support
   651:                !
   652:                use dc_iounit, only: FileOpen
   653:            
   654:                ! ̷ѥ᥿
   655:                ! Kind type parameter
   656:                !
   657:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   658:            
   659:                ! ʸ
   660:                ! Character handling
   661:                !
   662:                use dc_string, only: StoA
   663:            
   664:                ! ҥȥǡ
   665:                ! History data output
   666:                !
   667:                use gtool_historyauto, only: HistoryAutoAddVariable
   668:            
   669:                ! ʸ ; Declaration statements
   670:                !
   671:                implicit none
   672:            
   673:                integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   674:                                          ! Unit number for NAMELIST file open
   675:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   676:                                          ! IOSTAT of NAMELIST read
   677:            
   678:                ! NAMELIST ѿ
   679:                ! NAMELIST group name
   680:                !
   681:                namelist /moist_conv_adjust_nml/ &
   682:                  & CrtlRH, ItrtMax, AdjustCriterion !, FlagUse
   683:            
   684:                      ! ǥեͤˤĤƤϽ³ "moist_conv_adjust#CumAdjInit" 
   685:                      ! Υɤ򻲾ȤΤ. 
   686:                      !
   687:                      ! Refer to source codes in the initialization procedure
   688:                      ! "moist_conv_adjust#MoistConvAdjustInit" for the default values. 
   689:                      !
   690:            
   691:                ! ¹ʸ ; Executable statement
   692:                !
   693:            
   694:                if ( moist_conv_adjust_inited ) return
   695:            
   696:            
   697:                ! ǥեͤ
   698:                ! Default values settings
   699:                !
   700:                ! default values used in AGCM5
   701:            !!$    CrtlRH  = 0.990_DP
   702:            !!$    ItrtMax = 10
   703:            !!$    AdjustCriterion(1:ItrtMax) = &
   704:            !!$      & (/ 0.01_DP, 0.02_DP, 0.02_DP, 0.05_DP, 0.05_DP, &
   705:            !!$      &    0.10_DP, 0.10_DP, 0.20_DP, 0.20_DP, 0.40_DP  /)
   706:                !
   707:                CrtlRH  = 1.0d0
   708:                ItrtMax = 10
   709: V======        AdjustCriterion(1:ItrtMax) = 0.0d0
   710:                !
   711:            !!$    FlagUse = .true.
   712:            
   713:                ! NAMELIST ɤ߹
   714:                ! NAMELIST is input
   715:                !
   716:                if ( trim(namelist_filename) /= '' ) then
   717:                  call FileOpen( unit_nml, &          ! (out)
   718:                    & namelist_filename, mode = 'r' ) ! (in)
   719:            
   720:                  rewind( unit_nml )
   721:                  read( unit_nml,                  &  ! (in)
   722:                    & nml = moist_conv_adjust_nml, &  ! (out)
   723:                    & iostat = iostat_nml )           ! (out)
   724:                  close( unit_nml )
   725:            
   726:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   727:            !!$      if ( iostat_nml == 0 ) write( STDOUT, nml = cumulus_adjust_nml )
   728:                end if
   729:            
   730:                ! ƥ졼, ԰εƸΥå
   731:                ! Check number of iteration, admissible error of unstability
   732:                !
   733:                call NmlutilAryValid( module_name, & ! (in)
   734:                  & AdjustCriterion, 'AdjustCriterion', &      ! (in)
   735:                  & ItrtMax,    'ItrtMax' )          ! (in)
   736:            
   737:            
   738:                ! ҥȥǡϤΤΤؤѿϿ
   739:                ! Register of variables for history data output
   740:                !
   741:                call HistoryAutoAddVariable( 'RainCumulus', &
   742:                  & (/ 'lon ', 'lat ', 'time' /), &
   743:                  & 'precipitation by cumulus scheme', 'W m-2' )
   744:                call HistoryAutoAddVariable( 'DTempDtCumulus', &
   745:                  & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
   746:                  & 'cumulus condensation heating', 'K s-1' )
   747:                call HistoryAutoAddVariable( 'DQVapDtCumulus', &
   748:                  & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
   749:                  & 'cumulus condensation moistening', 'kg kg-1 s-1' )
   750:            
   751:                !  ; Print
   752:                !
   753:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   754:            !!$    call MessageNotify( 'M', module_name, '  FlagUse              = %b', l = (/ FlagUse /) )
   755:                call MessageNotify( 'M', module_name, '  CrtlRH               = %f', d = (/ CrtlRH /) )
   756:                call MessageNotify( 'M', module_name, '  ItrtMax              = %d', i = (/ ItrtMax /) )
   757: V======        call MessageNotify( 'M', module_name, '  AdjustCriterion      = (/ %*r /)', &
   758:                  & r = real( AdjustCriterion(1:ItrtMax) ), n = (/ ItrtMax /) )
   759:                call MessageNotify( 'M', module_name, '' )
   760:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   761:            
   762:                moist_conv_adjust_inited = .true.
   763:            
   764:              end subroutine MoistConvAdjustInit
   765:            
   766:              !--------------------------------------------------------------------------------------
   767:            
   768:            end module moist_conv_adjust
