Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:07 2012
FILE NAME: dynamics_physicsonly.f90
PROGRAM NAME: dynamics_physicsonly
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   189  opt  (1593): Loop nest collapsed into one loop.
   189  vec  (   4): Vectorized array expression.
   190  opt  (  11): Fused array assignments. :line 190 - 192
   190  opt  (1593): Loop nest collapsed into one loop.
   190  vec  (   4): Vectorized array expression.
   193  opt  (1593): Loop nest collapsed into one loop.
   193  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:07 2012
FILE NAME: dynamics_physicsonly.f90
PROGRAM NAME: dynamics_physicsonly
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ʪΤߤη׻Τϳز
     2  !
     3  != A dynamics for calculation with physical processes only
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: dynamics_physicsonly.f90,v 1.3 2011-07-08 03:55:18 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008-2009. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module dynamics_physicsonly
    13    !
    14    != ʪΤߤη׻Τϳز
    15    !
    16    != A dynamics for calculation with physical processes only
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    !== Procedures List
    21    !
    22    !== NAMELIST
    23    !
    24    !
    25  
    26    ! ⥸塼 ; USE statements
    27    !
    28  
    29    ! ʻ
    30    ! Grid points settings
    31    !
    32    use gridset, only: imax, & ! ٳʻ.
    33                               ! Number of grid points in longitude
    34      &                jmax, & ! ٳʻ.
    35                               ! Number of grid points in latitude
    36      &                kmax    ! ľؿ.
    37                               ! Number of vertical level
    38    ! ˴ؤ
    39    ! Settings of array for atmospheric composition
    40    !
    41    use composition, only: &
    42      &                    ncmax
    43                                ! ʬο
    44                                ! Number of composition
    45  
    46    ! ̷ѥ᥿
    47    ! Kind type parameter
    48    !
    49    use dc_types, only: DP, &      ! ټ¿. Double precision.
    50      &                 STRING     ! ʸ.       Strings.
    51  
    52    ! å
    53    ! Message output
    54    !
    55    use dc_message, only: MessageNotify
    56  
    57    ! ʸ ; Declaration statements
    58    !
    59    implicit none
    60    private
    61  
    62    ! ³
    63    ! Public procedure
    64    !
    65    public :: DynamicsPhysicsOnly
    66    public :: DynamicsPhysicsOnlyInit
    67  
    68    ! ѿ
    69    ! Public variables
    70    !
    71  
    72    ! ѿ
    73    ! Private variables
    74    !
    75    logical, save :: dynamics_physicsonly_inited = .false.
    76                                ! ե饰.
    77                                ! Initialization flag
    78  
    79  
    80    character(*), parameter:: module_name = 'dynamics_physicsonly'
    81                                ! ⥸塼̾.
    82                                ! Module name
    83    character(*), parameter:: version = &
    84      & '$Name: dcpam5-20120921 $' // &
    85      & '$Id: dynamics_physicsonly.f90,v 1.3 2011-07-08 03:55:18 yot Exp $'
    86                                ! ⥸塼ΥС
    87                                ! Module version
    88  
    89    ! INTERFACE ʸ ; INTERFACE statements
    90    !
    91  
    92  contains
    93  
    94    subroutine DynamicsPhysicsOnly(                                &
    95      & xyz_DUDtPhy, xyz_DVDtPhy, xyz_DTempDtPhy, xyzf_DQMixDtPhy, & ! (in)
    96      & xy_PsB, xyz_UB, xyz_VB, xyz_TempB, xyzf_QMixB,             & ! (in)
    97      & xy_PsA, xyz_UA, xyz_VA, xyz_TempA, xyzf_QMixA              & ! (out)
    98      & )
    99  
   100      ! ⥸塼 ; USE statements
   101      !
   102  
   103      ! 
   104      ! Time control
   105      !
   106      use timeset, only: &
   107        & DelTime, &            ! $ \Delta t $ [s]
   108        & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $.
   109        & TimesetClockStart, TimesetClockStop
   110  
   111      ! ǥХåѥ桼ƥƥ
   112      ! Utilities for debug
   113      !
   114      use dc_trace, only: DbgMessage, BeginSub, EndSub
   115  
   116      ! ʸ ; Declaration statements
   117      !
   118      implicit none
   119  
   120      real(DP), intent(in):: xyz_DUDtPhy    (0:imax-1, 1:jmax, 1:kmax)
   121                                ! $ \left(\DP{u}{t}\right)^{phy} $ .
   122                                ! Ϲ (ʪ) ˤ®Ѳ.
   123                                ! Eastward wind tendency by external force terms (physical processes)
   124      real(DP), intent(in):: xyz_DVDtPhy    (0:imax-1, 1:jmax, 1:kmax)
   125                                ! $ \left(\DP{v}{t}\right)^{phy} $ .
   126                                ! Ϲ (ʪ) ˤ®Ѳ.
   127                                ! Northward wind tendency by external force terms (physicalprocesses)
   128      real(DP), intent(in):: xyz_DTempDtPhy (0:imax-1, 1:jmax, 1:kmax)
   129                                ! $ \left(\DP{T}{t}\right)^{phy} $ .
   130                                ! Ϲ (ʪ) ˤ벹Ѳ.
   131                                ! Temperature tendency by external force terms (physical processes)
   132      real(DP), intent(in):: xyzf_DQMixDtPhy (0:imax-1, 1:jmax, 1:kmax, 1:ncmax)
   133                                ! $ \left(\DP{q}{t}\right)^{phy} $ .
   134                                ! Ϲ (ʪ) ˤ漾Ѳ.
   135                                ! Temperature tendency by external force terms (physical processes)
   136      real(DP), intent(in ):: xy_PsB(0:imax-1, 1:jmax)
   137                                ! $ p_s $ . ɽ̵ (Ⱦ٥).
   138                                ! Surface pressure (half level)
   139      real(DP), intent(in ):: xyz_UB(0:imax-1, 1:jmax, 1:kmax)
   140                                ! $ u $ . ®. Eastward wind
   141      real(DP), intent(in ):: xyz_VB(0:imax-1, 1:jmax, 1:kmax)
   142                                ! $ v $ . ®. Northward wind
   143      real(DP), intent(in ):: xyz_TempB(0:imax-1, 1:jmax, 1:kmax)
   144                                ! $ T $ .  (٥).
   145                                ! Temperature (full level)
   146      real(DP), intent(in ):: xyzf_QMixB(0:imax-1, 1:jmax, 1:kmax, 1:ncmax)
   147                                ! $ q $ .     漾. Specific humidity
   148      real(DP), intent(out):: xy_PsA(0:imax-1, 1:jmax)
   149                                ! $ p_s $ . ɽ̵ (Ⱦ٥).
   150                                ! Surface pressure (half level)
   151      real(DP), intent(out):: xyz_UA(0:imax-1, 1:jmax, 1:kmax)
   152                                ! $ u $ . ®. Eastward wind
   153      real(DP), intent(out):: xyz_VA(0:imax-1, 1:jmax, 1:kmax)
   154                                ! $ v $ . ®. Northward wind
   155      real(DP), intent(out):: xyz_TempA(0:imax-1, 1:jmax, 1:kmax)
   156                                ! $ T $ .  (٥).
   157                                ! Temperature (full level)
   158      real(DP), intent(out):: xyzf_QMixA(0:imax-1, 1:jmax, 1:kmax, 1:ncmax)
   159                                ! $ q $ .     漾. Specific humidity
   160  
   161  
   162      ! ѿ
   163      ! Work variables
   164      !
   165  
   166  !!$    integer:: i               ! ˲ DO 롼Ѻѿ
   167  !!$                              ! Work variables for DO loop in longitude
   168  !!$    integer:: j               ! ˲ DO 롼Ѻѿ
   169  !!$                              ! Work variables for DO loop in latitude
   170  !!$    integer:: k
   171  
   172      ! ¹ʸ ; Executable statement
   173      !
   174  
   175      ! ǧ
   176      ! Initialization check
   177      !
   178      if ( .not. dynamics_physicsonly_inited ) then
   179        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   180      end if
   181  
   182  
   183      ! ׻ַ¬
   184      ! Start measurement of computation time
   185      !
   186      call TimesetClockStart( module_name )
   187  
   188  
   189      xy_PsA     = xy_PsB
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t231 = 1, jmax*imax                                            
     .           xy_psa(t231-1,1) = xy_psb(t231-1,1)                            
     .        end do                                                            
   190      xyz_UA     = xyz_UB     + xyz_DUDtPhy     * 2.0d0 * DelTime
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t239 = 1, kmax*jmax*imax                                       
     .           xyz_ua(t239-1,1,1) = xyz_ub(t239-1,1,1) + (                    
     .       1      2.00000000000000e+000*deltime)*xyz_dudtphy(t239-1,1,1)      
     .           xyz_va(t239-1,1,1) = xyz_vb(t239-1,1,1) + (                    
     .       1      2.00000000000000e+000*deltime)*xyz_dvdtphy(t239-1,1,1)      
     .           xyz_tempa(t239-1,1,1) = xyz_tempb(t239-1,1,1) + (              
     .       1      2.00000000000000e+000*deltime)*xyz_dtempdtphy(t239-1,1,1)   
     .        end do                                                            
   191      xyz_VA     = xyz_VB     + xyz_DVDtPhy     * 2.0d0 * DelTime
   192      xyz_TempA  = xyz_TempB  + xyz_DTempDtPhy  * 2.0d0 * DelTime
   193      xyzf_QMixA = xyzf_QMixB + xyzf_DQMixDtPhy * 2.0d0 * DelTime
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t272 = 1, ncmax*kmax*jmax*imax                                 
     .           xyzf_qmixa(t272-1,1,1,1) = xyzf_qmixb(t272-1,1,1,1) +          
     .       1      xyzf_dqmixdtphy(t272-1,1,1,1)*2.00000000000000e+000*deltime 
     .        end do                                                            
   194  
   195  
   196    end subroutine DynamicsPhysicsOnly
   197  
   198    !-------------------------------------------------------------------
   199  
   200    subroutine DynamicsPhysicsOnlyInit
   201  
   202      ! ⥸塼 ; USE statements
   203      !
   204  
   205  
   206      ! ʸ ; Declaration statements
   207      !
   208      implicit none
   209  
   210  !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   211  !!$                              ! Unit number for NAMELIST file open
   212  !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   213  !!$                              ! IOSTAT of NAMELIST read
   214  
   215      ! NAMELIST ѿ
   216      ! NAMELIST group name
   217      !
   218  !!$    namelist /surface_flux_bulk_nml/ &
   219  !!$      & VelMinForRi, VelMinForVel, VelMinForTemp, VelMinForQVap, &
   220  !!$      & VelMaxForVel, VelMaxForTemp, VelMaxForQVap, &
   221  !!$!
   222  !!$      & Neutral, ConstBulkCoef, &
   223  !!$      & VelBulkCoefMin, TempBulkCoefMin, QVapBulkCoefMin, &
   224  !!$      & VelBulkCoefMax, TempBulkCoefMax, QVapBulkCoefMax
   225  !!$          !
   226  !!$          ! ǥեͤˤĤƤϽ³ "surface_flux_bulk#SurfFluxInit"
   227  !!$          ! Υɤ򻲾ȤΤ.
   228  !!$          !
   229  !!$          ! Refer to source codes in the initialization procedure
   230  !!$          ! "surface_flux_bulk#SurfFluxInit" for the default values.
   231  !!$          !
   232  
   233      ! ¹ʸ ; Executable statement
   234      !
   235  
   236      if ( dynamics_physicsonly_inited ) return
   237  
   238  
   239      ! ǥեͤ
   240      ! Default values settings
   241      !
   242  
   243  
   244  
   245      ! NAMELIST ɤ߹
   246      ! NAMELIST is input
   247      !
   248  !!$    if ( trim(namelist_filename) /= '' ) then
   249  !!$      call FileOpen( unit_nml, &          ! (out)
   250  !!$        & namelist_filename, mode = 'r' ) ! (in)
   251  !!$
   252  !!$      rewind( unit_nml )
   253  !!$      read( unit_nml, &                ! (in)
   254  !!$        & nml = surface_flux_bulk_nml, &  ! (out)
   255  !!$        & iostat = iostat_nml )        ! (out)
   256  !!$      close( unit_nml )
   257  !!$
   258  !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   259  !!$    end if
   260  !!$
   261  !!$    ! ҥȥǡϤΤΤؤѿϿ
   262  !!$    ! Register of variables for history data output
   263  !!$    !
   264  !!$    call HistoryAutoAddVariable( 'TauX', &
   265  !!$      & (/ 'lon ', 'lat ', 'time' /), &
   266  !!$      & 'surface stress(x)  ', 'N m-2' )
   267  !!$
   268  !!$    call HistoryAutoAddVariable( 'TauY', &
   269  !!$      & (/ 'lon ', 'lat ', 'time' /), &
   270  !!$      & 'surface stress(y)  ', 'N m-2' )
   271  !!$
   272  !!$    call HistoryAutoAddVariable( 'Sens', &
   273  !!$      & (/ 'lon ', 'lat ', 'time' /), &
   274  !!$      & 'sensible heat flux', 'W m-2' )
   275  !!$
   276  !!$    call HistoryAutoAddVariable( 'EVap', &
   277  !!$      & (/ 'lon ', 'lat ', 'time' /), &
   278  !!$      & 'latent heat flux  ', 'W m-2' )
   279  !!$
   280  !!$    !  ; Print
   281  !!$    !
   282  !!$    call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   283  !!$
   284  !!$    call MessageNotify( 'M', module_name, '  VelMinForRi   = %f', d = (/ VelMinForRi   /) )
   285  !!$    call MessageNotify( 'M', module_name, '  VelMinForVel  = %f', d = (/ VelMinForVel  /) )
   286  !!$    call MessageNotify( 'M', module_name, '  VelMinForTemp = %f', d = (/ VelMinForTemp /) )
   287  !!$    call MessageNotify( 'M', module_name, '  VelMinForQVap = %f', d = (/ VelMinForQVap /) )
   288  !!$    call MessageNotify( 'M', module_name, '  VelMaxForVel  = %f', d = (/ VelMaxForVel  /) )
   289  !!$    call MessageNotify( 'M', module_name, '  VelMaxForTemp = %f', d = (/ VelMaxForTemp /) )
   290  !!$    call MessageNotify( 'M', module_name, '  VelMaxForQVap = %f', d = (/ VelMaxForQVap /) )
   291  !!$
   292  !!$    call MessageNotify( 'M', module_name, 'Bulk coefficients:' )
   293  !!$    call MessageNotify( 'M', module_name, '  Neutral         = %b', l = (/ Neutral          /) )
   294  !!$    call MessageNotify( 'M', module_name, '  ConstBulkCoef   = %f', d = (/ ConstBulkCoef   /) )
   295  !!$    call MessageNotify( 'M', module_name, '  VelBulkCoefMin  = %f', d = (/ VelBulkCoefMin  /) )
   296  !!$    call MessageNotify( 'M', module_name, '  TempBulkCoefMin = %f', d = (/ TempBulkCoefMin /) )
   297  !!$    call MessageNotify( 'M', module_name, '  QVapBulkCoefMin = %f', d = (/ QVapBulkCoefMin /) )
   298  !!$    call MessageNotify( 'M', module_name, '  VelBulkCoefMax  = %f', d = (/ VelBulkCoefMax  /) )
   299  !!$    call MessageNotify( 'M', module_name, '  TempBulkCoefMax = %f', d = (/ TempBulkCoefMax /) )
   300  !!$    call MessageNotify( 'M', module_name, '  QVapBulkCoefMax = %f', d = (/ QVapBulkCoefMax /) )
   301  !!$    call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   302  
   303      dynamics_physicsonly_inited = .true.
   304  
   305    end subroutine DynamicsPhysicsOnlyInit
   306  
   307    !--------------------------------------------------------------------------------------
   308  
   309  end module dynamics_physicsonly
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:07 2012
FILE NAME: dynamics_physicsonly.f90
PROGRAM NAME: dynamics_physicsonly
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ʪΤߤη׻Τϳز
     2:            !
     3:            != A dynamics for calculation with physical processes only
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: dynamics_physicsonly.f90,v 1.3 2011-07-08 03:55:18 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008-2009. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module dynamics_physicsonly
    13:              !
    14:              != ʪΤߤη׻Τϳز
    15:              !
    16:              != A dynamics for calculation with physical processes only
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              !== Procedures List
    21:              !
    22:              !== NAMELIST
    23:              !
    24:              !
    25:            
    26:              ! ⥸塼 ; USE statements
    27:              !
    28:            
    29:              ! ʻ
    30:              ! Grid points settings
    31:              !
    32:              use gridset, only: imax, & ! ٳʻ. 
    33:                                         ! Number of grid points in longitude
    34:                &                jmax, & ! ٳʻ. 
    35:                                         ! Number of grid points in latitude
    36:                &                kmax    ! ľؿ. 
    37:                                         ! Number of vertical level
    38:              ! ˴ؤ
    39:              ! Settings of array for atmospheric composition
    40:              !
    41:              use composition, only: &
    42:                &                    ncmax
    43:                                          ! ʬο
    44:                                          ! Number of composition
    45:            
    46:              ! ̷ѥ᥿
    47:              ! Kind type parameter
    48:              !
    49:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    50:                &                 STRING     ! ʸ.       Strings. 
    51:            
    52:              ! å
    53:              ! Message output
    54:              !
    55:              use dc_message, only: MessageNotify
    56:            
    57:              ! ʸ ; Declaration statements
    58:              !
    59:              implicit none
    60:              private
    61:            
    62:              ! ³
    63:              ! Public procedure
    64:              !
    65:              public :: DynamicsPhysicsOnly
    66:              public :: DynamicsPhysicsOnlyInit
    67:            
    68:              ! ѿ
    69:              ! Public variables
    70:              !
    71:            
    72:              ! ѿ
    73:              ! Private variables
    74:              !
    75:              logical, save :: dynamics_physicsonly_inited = .false.
    76:                                          ! ե饰. 
    77:                                          ! Initialization flag
    78:            
    79:            
    80:              character(*), parameter:: module_name = 'dynamics_physicsonly'
    81:                                          ! ⥸塼̾. 
    82:                                          ! Module name
    83:              character(*), parameter:: version = &
    84:                & '$Name: dcpam5-20120921 $' // &
    85:                & '$Id: dynamics_physicsonly.f90,v 1.3 2011-07-08 03:55:18 yot Exp $'
    86:                                          ! ⥸塼ΥС
    87:                                          ! Module version
    88:            
    89:              ! INTERFACE ʸ ; INTERFACE statements
    90:              !
    91:            
    92:            contains
    93:            
    94:              subroutine DynamicsPhysicsOnly(                                &
    95:                & xyz_DUDtPhy, xyz_DVDtPhy, xyz_DTempDtPhy, xyzf_DQMixDtPhy, & ! (in)
    96:                & xy_PsB, xyz_UB, xyz_VB, xyz_TempB, xyzf_QMixB,             & ! (in)
    97:                & xy_PsA, xyz_UA, xyz_VA, xyz_TempA, xyzf_QMixA              & ! (out)
    98:                & )
    99:            
   100:                ! ⥸塼 ; USE statements
   101:                !
   102:            
   103:                ! 
   104:                ! Time control
   105:                !
   106:                use timeset, only: &
   107:                  & DelTime, &            ! $ \Delta t $ [s]
   108:                  & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $. 
   109:                  & TimesetClockStart, TimesetClockStop
   110:            
   111:                ! ǥХåѥ桼ƥƥ
   112:                ! Utilities for debug
   113:                !
   114:                use dc_trace, only: DbgMessage, BeginSub, EndSub
   115:            
   116:                ! ʸ ; Declaration statements
   117:                !
   118:                implicit none
   119:            
   120:                real(DP), intent(in):: xyz_DUDtPhy    (0:imax-1, 1:jmax, 1:kmax)
   121:                                          ! $ \left(\DP{u}{t}\right)^{phy} $ .
   122:                                          ! Ϲ (ʪ) ˤ®Ѳ.
   123:                                          ! Eastward wind tendency by external force terms (physical processes)
   124:                real(DP), intent(in):: xyz_DVDtPhy    (0:imax-1, 1:jmax, 1:kmax)
   125:                                          ! $ \left(\DP{v}{t}\right)^{phy} $ .
   126:                                          ! Ϲ (ʪ) ˤ®Ѳ.
   127:                                          ! Northward wind tendency by external force terms (physicalprocesses)
   128:                real(DP), intent(in):: xyz_DTempDtPhy (0:imax-1, 1:jmax, 1:kmax)
   129:                                          ! $ \left(\DP{T}{t}\right)^{phy} $ .
   130:                                          ! Ϲ (ʪ) ˤ벹Ѳ.
   131:                                          ! Temperature tendency by external force terms (physical processes)
   132:                real(DP), intent(in):: xyzf_DQMixDtPhy (0:imax-1, 1:jmax, 1:kmax, 1:ncmax)
   133:                                          ! $ \left(\DP{q}{t}\right)^{phy} $ .
   134:                                          ! Ϲ (ʪ) ˤ漾Ѳ.
   135:                                          ! Temperature tendency by external force terms (physical processes)
   136:                real(DP), intent(in ):: xy_PsB(0:imax-1, 1:jmax)
   137:                                          ! $ p_s $ . ɽ̵ (Ⱦ٥). 
   138:                                          ! Surface pressure (half level)
   139:                real(DP), intent(in ):: xyz_UB(0:imax-1, 1:jmax, 1:kmax)
   140:                                          ! $ u $ . ®. Eastward wind
   141:                real(DP), intent(in ):: xyz_VB(0:imax-1, 1:jmax, 1:kmax)
   142:                                          ! $ v $ . ®. Northward wind
   143:                real(DP), intent(in ):: xyz_TempB(0:imax-1, 1:jmax, 1:kmax)
   144:                                          ! $ T $ .  (٥). 
   145:                                          ! Temperature (full level)
   146:                real(DP), intent(in ):: xyzf_QMixB(0:imax-1, 1:jmax, 1:kmax, 1:ncmax)
   147:                                          ! $ q $ .     漾. Specific humidity
   148:                real(DP), intent(out):: xy_PsA(0:imax-1, 1:jmax)
   149:                                          ! $ p_s $ . ɽ̵ (Ⱦ٥). 
   150:                                          ! Surface pressure (half level)
   151:                real(DP), intent(out):: xyz_UA(0:imax-1, 1:jmax, 1:kmax)
   152:                                          ! $ u $ . ®. Eastward wind
   153:                real(DP), intent(out):: xyz_VA(0:imax-1, 1:jmax, 1:kmax)
   154:                                          ! $ v $ . ®. Northward wind
   155:                real(DP), intent(out):: xyz_TempA(0:imax-1, 1:jmax, 1:kmax)
   156:                                          ! $ T $ .  (٥). 
   157:                                          ! Temperature (full level)
   158:                real(DP), intent(out):: xyzf_QMixA(0:imax-1, 1:jmax, 1:kmax, 1:ncmax)
   159:                                          ! $ q $ .     漾. Specific humidity
   160:            
   161:            
   162:                ! ѿ
   163:                ! Work variables
   164:                !
   165:            
   166:            !!$    integer:: i               ! ˲ DO 롼Ѻѿ
   167:            !!$                              ! Work variables for DO loop in longitude
   168:            !!$    integer:: j               ! ˲ DO 롼Ѻѿ
   169:            !!$                              ! Work variables for DO loop in latitude
   170:            !!$    integer:: k
   171:            
   172:                ! ¹ʸ ; Executable statement
   173:                !
   174:            
   175:                ! ǧ
   176:                ! Initialization check
   177:                !
   178:                if ( .not. dynamics_physicsonly_inited ) then
   179:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   180:                end if
   181:            
   182:            
   183:                ! ׻ַ¬
   184:                ! Start measurement of computation time
   185:                !
   186:                call TimesetClockStart( module_name )
   187:            
   188:            
   189: W*=====        xy_PsA     = xy_PsB
   190: **W---->       xyz_UA     = xyz_UB     + xyz_DUDtPhy     * 2.0d0 * DelTime
   191: |||            xyz_VA     = xyz_VB     + xyz_DVDtPhy     * 2.0d0 * DelTime
   192: **W----        xyz_TempA  = xyz_TempB  + xyz_DTempDtPhy  * 2.0d0 * DelTime
   193: W***===        xyzf_QMixA = xyzf_QMixB + xyzf_DQMixDtPhy * 2.0d0 * DelTime
   194:            
   195:            
   196:              end subroutine DynamicsPhysicsOnly
   197:            
   198:              !-------------------------------------------------------------------
   199:            
   200:              subroutine DynamicsPhysicsOnlyInit
   201:            
   202:                ! ⥸塼 ; USE statements
   203:                !
   204:            
   205:            
   206:                ! ʸ ; Declaration statements
   207:                !
   208:                implicit none
   209:            
   210:            !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   211:            !!$                              ! Unit number for NAMELIST file open
   212:            !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   213:            !!$                              ! IOSTAT of NAMELIST read
   214:            
   215:                ! NAMELIST ѿ
   216:                ! NAMELIST group name
   217:                !
   218:            !!$    namelist /surface_flux_bulk_nml/ &
   219:            !!$      & VelMinForRi, VelMinForVel, VelMinForTemp, VelMinForQVap, &
   220:            !!$      & VelMaxForVel, VelMaxForTemp, VelMaxForQVap, &
   221:            !!$! 
   222:            !!$      & Neutral, ConstBulkCoef, &
   223:            !!$      & VelBulkCoefMin, TempBulkCoefMin, QVapBulkCoefMin, &
   224:            !!$      & VelBulkCoefMax, TempBulkCoefMax, QVapBulkCoefMax
   225:            !!$          !
   226:            !!$          ! ǥեͤˤĤƤϽ³ "surface_flux_bulk#SurfFluxInit" 
   227:            !!$          ! Υɤ򻲾ȤΤ. 
   228:            !!$          !
   229:            !!$          ! Refer to source codes in the initialization procedure
   230:            !!$          ! "surface_flux_bulk#SurfFluxInit" for the default values. 
   231:            !!$          !
   232:            
   233:                ! ¹ʸ ; Executable statement
   234:                !
   235:            
   236:                if ( dynamics_physicsonly_inited ) return
   237:            
   238:            
   239:                ! ǥեͤ
   240:                ! Default values settings
   241:                !
   242:            
   243:            
   244:            
   245:                ! NAMELIST ɤ߹
   246:                ! NAMELIST is input
   247:                !
   248:            !!$    if ( trim(namelist_filename) /= '' ) then
   249:            !!$      call FileOpen( unit_nml, &          ! (out)
   250:            !!$        & namelist_filename, mode = 'r' ) ! (in)
   251:            !!$
   252:            !!$      rewind( unit_nml )
   253:            !!$      read( unit_nml, &                ! (in)
   254:            !!$        & nml = surface_flux_bulk_nml, &  ! (out)
   255:            !!$        & iostat = iostat_nml )        ! (out)
   256:            !!$      close( unit_nml )
   257:            !!$
   258:            !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   259:            !!$    end if
   260:            !!$
   261:            !!$    ! ҥȥǡϤΤΤؤѿϿ
   262:            !!$    ! Register of variables for history data output
   263:            !!$    !
   264:            !!$    call HistoryAutoAddVariable( 'TauX', &
   265:            !!$      & (/ 'lon ', 'lat ', 'time' /), &
   266:            !!$      & 'surface stress(x)  ', 'N m-2' )
   267:            !!$
   268:            !!$    call HistoryAutoAddVariable( 'TauY', &
   269:            !!$      & (/ 'lon ', 'lat ', 'time' /), &
   270:            !!$      & 'surface stress(y)  ', 'N m-2' )
   271:            !!$
   272:            !!$    call HistoryAutoAddVariable( 'Sens', &
   273:            !!$      & (/ 'lon ', 'lat ', 'time' /), &
   274:            !!$      & 'sensible heat flux', 'W m-2' )
   275:            !!$
   276:            !!$    call HistoryAutoAddVariable( 'EVap', &
   277:            !!$      & (/ 'lon ', 'lat ', 'time' /), &
   278:            !!$      & 'latent heat flux  ', 'W m-2' )
   279:            !!$
   280:            !!$    !  ; Print
   281:            !!$    !
   282:            !!$    call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   283:            !!$
   284:            !!$    call MessageNotify( 'M', module_name, '  VelMinForRi   = %f', d = (/ VelMinForRi   /) )
   285:            !!$    call MessageNotify( 'M', module_name, '  VelMinForVel  = %f', d = (/ VelMinForVel  /) )
   286:            !!$    call MessageNotify( 'M', module_name, '  VelMinForTemp = %f', d = (/ VelMinForTemp /) )
   287:            !!$    call MessageNotify( 'M', module_name, '  VelMinForQVap = %f', d = (/ VelMinForQVap /) )
   288:            !!$    call MessageNotify( 'M', module_name, '  VelMaxForVel  = %f', d = (/ VelMaxForVel  /) )
   289:            !!$    call MessageNotify( 'M', module_name, '  VelMaxForTemp = %f', d = (/ VelMaxForTemp /) )
   290:            !!$    call MessageNotify( 'M', module_name, '  VelMaxForQVap = %f', d = (/ VelMaxForQVap /) )
   291:            !!$
   292:            !!$    call MessageNotify( 'M', module_name, 'Bulk coefficients:' )
   293:            !!$    call MessageNotify( 'M', module_name, '  Neutral         = %b', l = (/ Neutral          /) )
   294:            !!$    call MessageNotify( 'M', module_name, '  ConstBulkCoef   = %f', d = (/ ConstBulkCoef   /) )
   295:            !!$    call MessageNotify( 'M', module_name, '  VelBulkCoefMin  = %f', d = (/ VelBulkCoefMin  /) )
   296:            !!$    call MessageNotify( 'M', module_name, '  TempBulkCoefMin = %f', d = (/ TempBulkCoefMin /) )
   297:            !!$    call MessageNotify( 'M', module_name, '  QVapBulkCoefMin = %f', d = (/ QVapBulkCoefMin /) )
   298:            !!$    call MessageNotify( 'M', module_name, '  VelBulkCoefMax  = %f', d = (/ VelBulkCoefMax  /) )
   299:            !!$    call MessageNotify( 'M', module_name, '  TempBulkCoefMax = %f', d = (/ TempBulkCoefMax /) )
   300:            !!$    call MessageNotify( 'M', module_name, '  QVapBulkCoefMax = %f', d = (/ QVapBulkCoefMax /) )
   301:            !!$    call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   302:            
   303:                dynamics_physicsonly_inited = .true.
   304:            
   305:              end subroutine DynamicsPhysicsOnlyInit
   306:            
   307:              !--------------------------------------------------------------------------------------
   308:            
   309:            end module dynamics_physicsonly
