Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:19:37 2012
FILE NAME: i.netcdf_wrapper.F90
PROGRAM NAME: netcdf_wrapper
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != NetCDF Υåѡץ
     2  !
     3  != NetCDF wrapper
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: netcdf_wrapper.F90,v 1.3 2011-09-10 18:23:29 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module netcdf_wrapper
    13    !
    14    != NetCDF Υåѡץ
    15    !
    16    != NetCDF wrapper
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! gtool ǰʤʬ򥫥С NetCDF Υåѡץ.
    21    !
    22    ! The wrapper routines in this module treat NetCDF input/output that are not
    23    ! covered by gtool.
    24    !
    25    !== Procedures List
    26    !
    27    ! NWInqDimLen :: Ĺ䤤碌
    28    ! ----------- :: ------------
    29    ! NWInqDimLen :: Inquire length of a dimension
    30    !
    31    !== NAMELIST
    32    !
    33    ! NAMELIST#radiation_DennouAGCM_nml
    34    !
    35  
    36    ! ⥸塼 ; USE statements
    37    !
    38  
    39    ! ̷ѥ᥿
    40    ! Kind type parameter
    41    !
    42    use dc_types, only: DP, &      ! ټ¿. Double precision.
    43      &                 STRING     ! ʸ.       Strings.
    44  
    45    ! å
    46    ! Message output
    47    !
    48    use dc_message, only: MessageNotify
    49  
    50    ! NetCDF
    51    !
    52    use netcdf
    53  
    54    implicit none
    55  
    56    private
    57  
    58  
    59    public :: NWInqDimLen
    60    public :: NWGetAtt
    61    public :: NWPresentAVarInFile
    62  
    63  
    64    interface NWGetAtt
    65      module procedure NWGetAttChar, NWGetAttInteger
    66    end interface
    67  
    68  
    69    character(*), parameter:: module_name = 'netcdf_wrapper'
    70                                ! ⥸塼̾.
    71                                ! Module name
    72    character(*), parameter:: version = &
    73      & '$Name: dcpam5-20120921 $' // &
    74      & '$Id: netcdf_wrapper.F90,v 1.3 2011-09-10 18:23:29 yot Exp $'
    75                                ! ⥸塼ΥС
    76                                ! Module version
    77  
    78    !--------------------------------------------------------------------------
    79  
    80  contains
    81  
    82    !--------------------------------------------------------------------------
    83  
    84    subroutine NWInqDimLen( &
    85      & ncfn,    & ! (in )
    86      & dimname, & ! (in )
    87      & len      & ! (out)
    88      & )
    89      !
    90      ! Ĺ䤤碌ޤ.
    91      !
    92      ! Inquire length of a dimension.
    93      !
    94  
    95      character(*), intent(in ) :: ncfn
    96                                    ! NetCDF filename
    97      character(*), intent(in ) :: dimname
    98                                    ! Dimension name
    99      integer     , intent(out) :: len
   100                                    ! Length of a dimension
   101  
   102  
   103      !
   104      ! Local variables
   105      !
   106      character(STRING) :: mode
   107      integer           :: ncid
   108      integer           :: dimid
   109      integer           :: status
   110      character(STRING) :: err_mes
   111  
   112  
   113      err_mes = "In NWInqDimLen"
   114  
   115      mode = "read"
   116      call NWOpen( NWMkNCFN(ncfn), mode, ncid )
   117  
   118      status = NF90_inq_dimid( ncid, dimname, dimid )
   119      call NWHandleErr( status, err_mes )
   120  
   121      status = NF90_Inquire_Dimension( ncid, dimid, len = len )
   122      call NWHandleErr( status, err_mes )
   123  
   124      call NWClose( ncid )
   125  
   126  
   127    end subroutine NWInqDimLen
   128  
   129    !--------------------------------------------------------------------------
   130  
   131    subroutine NWGetAttChar( ncfn, varname, attname, att )
   132  
   133      character(*), intent(in ) :: ncfn
   134                                    ! NetCDF filename
   135      character(*), intent(in ) :: varname
   136                                    ! Variable name
   137      character(*), intent(in ) :: attname
   138                                    ! Attribute name
   139      character(*), intent(out) :: att
   140                                    ! Attribute
   141  
   142  
   143      ! Local variables
   144      !
   145      character(STRING) :: mode
   146      integer           :: ncid
   147      integer           :: varid
   148      integer           :: status
   149      character(STRING) :: err_mes
   150  
   151  
   152      err_mes = "In NWGetAttChar"
   153      err_mes = trim( err_mes ) &
   154        // ', Var: ' // trim( varname ) // ', Att: ' // trim( attname )
   155  
   156      mode = "read"
   157      call NWOpen( NWMkNCFN(ncfn), mode, ncid )
   158  
   159      if ( ( varname == 'global' ) .or. ( varname == 'GLOBAL' ) ) then
   160        varid = NF90_GLOBAL
   161      else
   162        status = nf90_inq_varid( ncid, varname, varid )
   163        call NWHandleErr( status, err_mes )
   164      end if
   165  
   166      status = nf90_get_att( ncid, varid, attname, att )
   167      call NWHandleErr( status, err_mes )
   168  
   169      call NWClose( ncid )
   170  
   171    end subroutine NWGetAttChar
   172  
   173    !--------------------------------------------------------------------------
   174  
   175    subroutine NWGetAttInteger( ncfn, varname, attname, att )
   176  
   177      character(*), intent(in ) :: ncfn
   178                                    ! NetCDF filename
   179      character(*), intent(in ) :: varname
   180                                    ! Variable name
   181      character(*), intent(in ) :: attname
   182                                    ! Attribute name
   183      integer     , intent(out) :: att
   184                                    ! Attribute
   185  
   186  
   187      ! Local variables
   188      !
   189      character(STRING) :: mode
   190      integer           :: ncid
   191      integer           :: varid
   192      integer           :: status
   193      character(STRING) :: err_mes
   194  
   195  
   196      err_mes = "In NWGetAttInteger"
   197      err_mes = trim( err_mes ) &
   198        // ', Var: ' // trim( varname ) // ', Att: ' // trim( attname )
   199  
   200      mode = "read"
   201      call NWOpen( NWMkNCFN(ncfn), mode, ncid )
   202  
   203      if ( ( varname == 'global' ) .or. ( varname == 'GLOBAL' ) ) then
   204        varid = NF90_GLOBAL
   205      else
   206        status = nf90_inq_varid( ncid, varname, varid )
   207        call NWHandleErr( status, err_mes )
   208      end if
   209  
   210      status = nf90_get_att( ncid, varid, attname, att )
   211      call NWHandleErr( status, err_mes )
   212  
   213      call NWClose( ncid )
   214  
   215    end subroutine NWGetAttInteger
   216  
   217    !--------------------------------------------------------------------------
   218  
   219    function NWPresentAVarInFile( ncfn, varname ) result( Flag )
   220  
   221      character(*), intent(in ) :: ncfn
   222                                    ! NetCDF filename
   223      character(*), intent(in ) :: varname
   224                                    ! Variable name
   225  
   226      logical                   :: Flag
   227  
   228      ! Local variables
   229      !
   230      character(STRING) :: mode
   231      integer           :: ncid
   232      integer           :: varid
   233      integer           :: status
   234      character(STRING) :: err_mes
   235  
   236  
   237      err_mes = "In NWChkAVarInFile"
   238      err_mes = trim( err_mes ) // ', Var: ' // trim( varname )
   239  
   240      mode = "read"
   241      call NWOpen( NWMkNCFN(ncfn), mode, ncid )
   242  
   243      status = nf90_inq_varid( ncid, varname, varid )
   244      if( status == nf90_noerr ) then
   245        Flag = .true.
   246      else
   247        Flag = .false.
   248        call MessageNotify( 'M', module_name, &
   249          & 'Variable, %c, cannot be found in file, %c.', &
   250          & c1 = trim(varname), c2 = trim(NWMkNCFN(ncfn)) &
   251          & )
   252      end if
   253  
   254      call NWClose( ncid )
   255  
   256    end function NWPresentAVarInFile
   257  
   258    !--------------------------------------------------------------------------
   259    ! Routines below are internal ones.
   260    !--------------------------------------------------------------------------
   261  
   262    character(STRING) function NWMkNCFN( ncfn_in ) result( ncfn_out )
   263  
   264      ! MPI wrapper
   265      !
   266      use mpi_wrapper, only : myrank
   267  
   268      character(*), intent(in ) :: ncfn_in
   269                                    ! NetCDF filename
   270  
   271  
   272  
   273      ncfn_out = ncfn_in
   274  
   275  
   276    end function NWMkNCFN
   277  
   278    !--------------------------------------------------------------------------
   279  
   280    subroutine NWHandleErr( &
   281      & status, &
   282      & err_mes &
   283      & )
   284  
   285      integer     , intent(in)           :: status
   286      character(*), intent(in), optional :: err_mes
   287  
   288  
   289      if( status .ne. nf90_noerr ) then
   290        if( present( err_mes ) ) print *, trim( err_mes )
   291        print *, trim( nf90_strerror( status ) )
   292        stop "STOP"
   293      end if
   294  
   295  
   296    end subroutine NWHandleErr
   297  
   298    !--------------------------------------------------------------------------
   299  
   300    subroutine NWOpen( &
   301      & path, &
   302      & mode, &
   303      & ncid &
   304      & )
   305  
   306      character(*), intent(in ) :: path
   307      character(*), intent(in ) :: mode
   308      integer     , intent(out) :: ncid
   309  
   310  
   311      ! Local variables
   312      !
   313      integer           :: cmode, omode
   314      integer           :: status
   315      character(STRING) :: err_mes
   316  
   317  
   318      err_mes = "In NWOpen"
   319      err_mes = trim( err_mes ) // ', path: ' // trim( path ) &
   320        // ', mode: ' // trim( mode )
   321  
   322  
   323      if( ( mode .eq. "new" ) .or. ( mode .eq. "NEW" ) ) then
   324  
   325        cmode = NF90_CLOBBER
   326        status = nf90_create( path, cmode, ncid )
   327        call NWHandleErr( status, err_mes )
   328  
   329      else
   330  
   331        if( ( mode .eq. "read" ) .or. ( mode .eq. "READ" ) ) then
   332          omode = NF90_NOWRITE
   333        else if( ( mode .eq. "write" ) .or. ( mode .eq. "WRITE" ) ) then
   334          omode = NF90_WRITE
   335        else
   336          write( 6, * ) "Inproper argument, mode"
   337          write( 6, * ) "Argument mode should be either of words below."
   338          write( 6, * ) " 'new', 'NEW', 'read', 'READ', 'write', or 'WRITE'"
   339          stop
   340        end if
   341  
   342        status = nf90_open( path, omode, ncid )
   343        call NWHandleErr( status, err_mes )
   344  
   345      end if
   346  
   347  
   348    end subroutine NWOpen
   349  
   350    !--------------------------------------------------------------------------
   351  
   352    subroutine NWClose( &
   353      & ncid &
   354      & )
   355  
   356      integer, intent(in) :: ncid
   357  
   358  
   359      ! Local variables
   360      !
   361      integer           :: status
   362      character(STRING) :: err_mes
   363  
   364  
   365      err_mes = "In NWClose"
   366  
   367  
   368      status = nf90_close( ncid )
   369      call NWHandleErr( status, err_mes )
   370  
   371    end subroutine NWClose
   372  
   373    !--------------------------------------------------------------------------
   374  
   375    subroutine NWReDef( &
   376      & ncid &
   377      & )
   378  
   379      integer, intent(in) :: ncid
   380  
   381  
   382      ! Local variables
   383      !
   384      integer           :: status
   385      character(STRING) :: err_mes
   386  
   387  
   388      err_mes = "In NWReDef"
   389  
   390  
   391      status = nf90_redef( ncid )
   392      if( ( status .ne. nf90_noerr ) .and. ( status .ne. nf90_eindefine ) ) &
   393        call NWHandleErr( status, err_mes )
   394  
   395  
   396    end subroutine NWReDef
   397  
   398    !--------------------------------------------------------------------------
   399  
   400    subroutine NWEndDef( &
   401      & ncid &
   402      & )
   403  
   404      integer, intent(in) :: ncid
   405  
   406  
   407      ! Local variables
   408      !
   409      integer           :: status
   410      character(STRING) :: err_mes
   411  
   412  
   413      err_mes = "In NWEndDef"
   414  
   415  
   416      status = nf90_enddef( ncid )
   417      if( ( status .ne. nf90_noerr ) .and. ( status .ne. nf90_enotindefine ) ) &
   418        call NWHandleErr( status, err_mes )
   419  
   420  
   421    end subroutine NWEndDef
   422  
   423    !--------------------------------------------------------------------------
   424  
   425  end module netcdf_wrapper
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:19:37 2012
FILE NAME: i.netcdf_wrapper.F90
PROGRAM NAME: netcdf_wrapper
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != NetCDF Υåѡץ
     2:            !
     3:            != NetCDF wrapper
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: netcdf_wrapper.F90,v 1.3 2011-09-10 18:23:29 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module netcdf_wrapper
    13:              !
    14:              != NetCDF Υåѡץ
    15:              !
    16:              != NetCDF wrapper
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! gtool ǰʤʬ򥫥С NetCDF Υåѡץ. 
    21:              !
    22:              ! The wrapper routines in this module treat NetCDF input/output that are not 
    23:              ! covered by gtool.
    24:              !
    25:              !== Procedures List
    26:              !
    27:              ! NWInqDimLen :: Ĺ䤤碌
    28:              ! ----------- :: ------------
    29:              ! NWInqDimLen :: Inquire length of a dimension
    30:              !
    31:              !== NAMELIST
    32:              !
    33:              ! NAMELIST#radiation_DennouAGCM_nml
    34:              !
    35:            
    36:              ! ⥸塼 ; USE statements
    37:              !
    38:            
    39:              ! ̷ѥ᥿
    40:              ! Kind type parameter
    41:              !
    42:              use dc_types, only: DP, &      ! ټ¿. Double precision.
    43:                &                 STRING     ! ʸ.       Strings.
    44:            
    45:              ! å
    46:              ! Message output
    47:              !
    48:              use dc_message, only: MessageNotify
    49:            
    50:              ! NetCDF
    51:              !
    52:              use netcdf
    53:            
    54:              implicit none
    55:            
    56:              private
    57:            
    58:            
    59:              public :: NWInqDimLen
    60:              public :: NWGetAtt
    61:              public :: NWPresentAVarInFile
    62:            
    63:            
    64:              interface NWGetAtt
    65:                module procedure NWGetAttChar, NWGetAttInteger
    66:              end interface
    67:            
    68:            
    69:              character(*), parameter:: module_name = 'netcdf_wrapper'
    70:                                          ! ⥸塼̾. 
    71:                                          ! Module name
    72:              character(*), parameter:: version = &
    73:                & '$Name: dcpam5-20120921 $' // &
    74:                & '$Id: netcdf_wrapper.F90,v 1.3 2011-09-10 18:23:29 yot Exp $'
    75:                                          ! ⥸塼ΥС
    76:                                          ! Module version
    77:            
    78:              !--------------------------------------------------------------------------
    79:            
    80:            contains
    81:            
    82:              !--------------------------------------------------------------------------
    83:            
    84:              subroutine NWInqDimLen( &
    85:                & ncfn,    & ! (in )
    86:                & dimname, & ! (in )
    87:                & len      & ! (out)
    88:                & )
    89:                !
    90:                ! Ĺ䤤碌ޤ. 
    91:                !
    92:                ! Inquire length of a dimension. 
    93:                !
    94:            
    95:                character(*), intent(in ) :: ncfn
    96:                                              ! NetCDF filename
    97:                character(*), intent(in ) :: dimname
    98:                                              ! Dimension name
    99:                integer     , intent(out) :: len
   100:                                              ! Length of a dimension
   101:            
   102:            
   103:                !
   104:                ! Local variables
   105:                !
   106:                character(STRING) :: mode
   107:                integer           :: ncid
   108:                integer           :: dimid
   109:                integer           :: status
   110:                character(STRING) :: err_mes
   111:            
   112:            
   113:                err_mes = "In NWInqDimLen"
   114:            
   115:                mode = "read"
   116:                call NWOpen( NWMkNCFN(ncfn), mode, ncid )
   117:            
   118:                status = NF90_inq_dimid( ncid, dimname, dimid )
   119:                call NWHandleErr( status, err_mes )
   120:            
   121:                status = NF90_Inquire_Dimension( ncid, dimid, len = len )
   122:                call NWHandleErr( status, err_mes )
   123:            
   124:                call NWClose( ncid )
   125:            
   126:            
   127:              end subroutine NWInqDimLen
   128:            
   129:              !--------------------------------------------------------------------------
   130:            
   131:              subroutine NWGetAttChar( ncfn, varname, attname, att )
   132:            
   133:                character(*), intent(in ) :: ncfn
   134:                                              ! NetCDF filename
   135:                character(*), intent(in ) :: varname
   136:                                              ! Variable name
   137:                character(*), intent(in ) :: attname
   138:                                              ! Attribute name
   139:                character(*), intent(out) :: att
   140:                                              ! Attribute
   141:            
   142:            
   143:                ! Local variables
   144:                !
   145:                character(STRING) :: mode
   146:                integer           :: ncid
   147:                integer           :: varid
   148:                integer           :: status
   149:                character(STRING) :: err_mes
   150:            
   151:            
   152:                err_mes = "In NWGetAttChar"
   153:                err_mes = trim( err_mes ) &
   154:                  // ', Var: ' // trim( varname ) // ', Att: ' // trim( attname )
   155:            
   156:                mode = "read"
   157:                call NWOpen( NWMkNCFN(ncfn), mode, ncid )
   158:            
   159:                if ( ( varname == 'global' ) .or. ( varname == 'GLOBAL' ) ) then
   160:                  varid = NF90_GLOBAL
   161:                else
   162:                  status = nf90_inq_varid( ncid, varname, varid )
   163:                  call NWHandleErr( status, err_mes )
   164:                end if
   165:            
   166:                status = nf90_get_att( ncid, varid, attname, att )
   167:                call NWHandleErr( status, err_mes )
   168:            
   169:                call NWClose( ncid )
   170:            
   171:              end subroutine NWGetAttChar
   172:            
   173:              !--------------------------------------------------------------------------
   174:            
   175:              subroutine NWGetAttInteger( ncfn, varname, attname, att )
   176:            
   177:                character(*), intent(in ) :: ncfn
   178:                                              ! NetCDF filename
   179:                character(*), intent(in ) :: varname
   180:                                              ! Variable name
   181:                character(*), intent(in ) :: attname
   182:                                              ! Attribute name
   183:                integer     , intent(out) :: att
   184:                                              ! Attribute
   185:            
   186:            
   187:                ! Local variables
   188:                !
   189:                character(STRING) :: mode
   190:                integer           :: ncid
   191:                integer           :: varid
   192:                integer           :: status
   193:                character(STRING) :: err_mes
   194:            
   195:            
   196:                err_mes = "In NWGetAttInteger"
   197:                err_mes = trim( err_mes ) &
   198:                  // ', Var: ' // trim( varname ) // ', Att: ' // trim( attname )
   199:            
   200:                mode = "read"
   201:                call NWOpen( NWMkNCFN(ncfn), mode, ncid )
   202:            
   203:                if ( ( varname == 'global' ) .or. ( varname == 'GLOBAL' ) ) then
   204:                  varid = NF90_GLOBAL
   205:                else
   206:                  status = nf90_inq_varid( ncid, varname, varid )
   207:                  call NWHandleErr( status, err_mes )
   208:                end if
   209:            
   210:                status = nf90_get_att( ncid, varid, attname, att )
   211:                call NWHandleErr( status, err_mes )
   212:            
   213:                call NWClose( ncid )
   214:            
   215:              end subroutine NWGetAttInteger
   216:            
   217:              !--------------------------------------------------------------------------
   218:            
   219:              function NWPresentAVarInFile( ncfn, varname ) result( Flag )
   220:            
   221:                character(*), intent(in ) :: ncfn
   222:                                              ! NetCDF filename
   223:                character(*), intent(in ) :: varname
   224:                                              ! Variable name
   225:            
   226:                logical                   :: Flag
   227:            
   228:                ! Local variables
   229:                !
   230:                character(STRING) :: mode
   231:                integer           :: ncid
   232:                integer           :: varid
   233:                integer           :: status
   234:                character(STRING) :: err_mes
   235:            
   236:            
   237:                err_mes = "In NWChkAVarInFile"
   238:                err_mes = trim( err_mes ) // ', Var: ' // trim( varname )
   239:            
   240:                mode = "read"
   241:                call NWOpen( NWMkNCFN(ncfn), mode, ncid )
   242:            
   243:                status = nf90_inq_varid( ncid, varname, varid )
   244:                if( status == nf90_noerr ) then
   245:                  Flag = .true.
   246:                else
   247:                  Flag = .false.
   248:                  call MessageNotify( 'M', module_name, &
   249:                    & 'Variable, %c, cannot be found in file, %c.', &
   250:                    & c1 = trim(varname), c2 = trim(NWMkNCFN(ncfn)) &
   251:                    & )
   252:                end if
   253:            
   254:                call NWClose( ncid )
   255:            
   256:              end function NWPresentAVarInFile
   257:            
   258:              !--------------------------------------------------------------------------
   259:              ! Routines below are internal ones.
   260:              !--------------------------------------------------------------------------
   261:            
   262:              character(STRING) function NWMkNCFN( ncfn_in ) result( ncfn_out )
   263:            
   264:                ! MPI wrapper
   265:                !
   266:                use mpi_wrapper, only : myrank
   267:            
   268:                character(*), intent(in ) :: ncfn_in
   269:                                              ! NetCDF filename
   270:            
   271:            
   272:            
   273:                ncfn_out = ncfn_in
   274:            
   275:            
   276:              end function NWMkNCFN
   277:            
   278:              !--------------------------------------------------------------------------
   279:            
   280:              subroutine NWHandleErr( &
   281:                & status, &
   282:                & err_mes &
   283:                & )
   284:            
   285:                integer     , intent(in)           :: status
   286:                character(*), intent(in), optional :: err_mes
   287:            
   288:            
   289:                if( status .ne. nf90_noerr ) then
   290:                  if( present( err_mes ) ) print *, trim( err_mes )
   291:                  print *, trim( nf90_strerror( status ) )
   292:                  stop "STOP"
   293:                end if
   294:            
   295:            
   296:              end subroutine NWHandleErr
   297:            
   298:              !--------------------------------------------------------------------------
   299:            
   300:              subroutine NWOpen( &
   301:                & path, &
   302:                & mode, &
   303:                & ncid &
   304:                & )
   305:            
   306:                character(*), intent(in ) :: path
   307:                character(*), intent(in ) :: mode
   308:                integer     , intent(out) :: ncid
   309:            
   310:            
   311:                ! Local variables
   312:                !
   313:                integer           :: cmode, omode
   314:                integer           :: status
   315:                character(STRING) :: err_mes
   316:            
   317:            
   318:                err_mes = "In NWOpen"
   319:                err_mes = trim( err_mes ) // ', path: ' // trim( path ) &
   320:                  // ', mode: ' // trim( mode )
   321:            
   322:            
   323:                if( ( mode .eq. "new" ) .or. ( mode .eq. "NEW" ) ) then
   324:            
   325:                  cmode = NF90_CLOBBER
   326:                  status = nf90_create( path, cmode, ncid )
   327:                  call NWHandleErr( status, err_mes )
   328:            
   329:                else
   330:            
   331:                  if( ( mode .eq. "read" ) .or. ( mode .eq. "READ" ) ) then
   332:                    omode = NF90_NOWRITE
   333:                  else if( ( mode .eq. "write" ) .or. ( mode .eq. "WRITE" ) ) then
   334:                    omode = NF90_WRITE
   335:                  else
   336:                    write( 6, * ) "Inproper argument, mode"
   337:                    write( 6, * ) "Argument mode should be either of words below."
   338:                    write( 6, * ) " 'new', 'NEW', 'read', 'READ', 'write', or 'WRITE'"
   339:                    stop
   340:                  end if
   341:            
   342:                  status = nf90_open( path, omode, ncid )
   343:                  call NWHandleErr( status, err_mes )
   344:            
   345:                end if
   346:            
   347:            
   348:              end subroutine NWOpen
   349:            
   350:              !--------------------------------------------------------------------------
   351:            
   352:              subroutine NWClose( &
   353:                & ncid &
   354:                & )
   355:            
   356:                integer, intent(in) :: ncid
   357:            
   358:            
   359:                ! Local variables
   360:                !
   361:                integer           :: status
   362:                character(STRING) :: err_mes
   363:            
   364:            
   365:                err_mes = "In NWClose"
   366:            
   367:            
   368:                status = nf90_close( ncid )
   369:                call NWHandleErr( status, err_mes )
   370:            
   371:              end subroutine NWClose
   372:            
   373:              !--------------------------------------------------------------------------
   374:            
   375:              subroutine NWReDef( &
   376:                & ncid &
   377:                & )
   378:            
   379:                integer, intent(in) :: ncid
   380:            
   381:            
   382:                ! Local variables
   383:                !
   384:                integer           :: status
   385:                character(STRING) :: err_mes
   386:            
   387:            
   388:                err_mes = "In NWReDef"
   389:            
   390:            
   391:                status = nf90_redef( ncid )
   392:                if( ( status .ne. nf90_noerr ) .and. ( status .ne. nf90_eindefine ) ) &
   393:                  call NWHandleErr( status, err_mes )
   394:            
   395:            
   396:              end subroutine NWReDef
   397:            
   398:              !--------------------------------------------------------------------------
   399:            
   400:              subroutine NWEndDef( &
   401:                & ncid &
   402:                & )
   403:            
   404:                integer, intent(in) :: ncid
   405:            
   406:            
   407:                ! Local variables
   408:                !
   409:                integer           :: status
   410:                character(STRING) :: err_mes
   411:            
   412:            
   413:                err_mes = "In NWEndDef"
   414:            
   415:            
   416:                status = nf90_enddef( ncid )
   417:                if( ( status .ne. nf90_noerr ) .and. ( status .ne. nf90_enotindefine ) ) &
   418:                  call NWHandleErr( status, err_mes )
   419:            
   420:            
   421:              end subroutine NWEndDef
   422:            
   423:              !--------------------------------------------------------------------------
   424:            
   425:            end module netcdf_wrapper
