Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:52:04 2012
FILE NAME: lscond_LL91.f90
PROGRAM NAME: lscond_ll91
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   286  opt  (  11): Fused array assignments. :line 286 - 311
   286  vec  (   4): Vectorized array expression.
   312  opt  (1772): Loop nest fused with following nest(s).
   314  vec  (   1): Vectorized loop.
   359  opt  (1017): Subroutine call prevents optimization.
   364  vec  (   1): Vectorized loop.
   419  opt  (  11): Fused array assignments. :line 419 - 463
   419  vec  (   4): Vectorized array expression.
   467  opt  (1592): Outer loop unrolled inside inner loop.
   467  vec  (   4): Vectorized array expression.
   467  vec  (   4): Vectorized array expression.
   468  vec  (   3): Unvectorized loop.
   468  vec  (  13): Overhead of loop division is too large.
   469  opt  (1592): Outer loop unrolled inside inner loop.
   469  vec  (   4): Vectorized array expression.
   469  vec  (   4): Vectorized array expression.
   476  opt  (1592): Outer loop unrolled inside inner loop.
   476  vec  (   4): Vectorized array expression.
   476  vec  (   4): Vectorized array expression.
   487  warn (  82): Name "xyz_rainlsc" is not used.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:52:04 2012
FILE NAME: lscond_LL91.f90
PROGRAM NAME: lscond_ll91
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != 絬϶ŷ (ήŷ) (Le Treut and Li, 1991)
     2  !
     3  != Large scale condensation (non-convective condensation) (Le Treut and Li, 1991)
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: lscond_LL91.f90,v 1.2 2011-12-02 04:07:03 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module lscond_LL91
    13    !
    14    != 絬϶ŷ (ήŷ)
    15    !
    16    != Large scale condensation (non-convective condensation)
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! 絬϶ŷˤäƲ٤漾Ĵᤷޤ.
    21    !
    22    ! Adjust temperature and specific humidity by
    23    ! a large scale condensation process.
    24    !
    25    !== References
    26    !
    27    !  Le Treut, H., and Z.-X. Li,
    28    !    Sensitivity of an atmospheric general circulation model to prescribed SST changes:
    29    !    feedback effects associated with the simulation of cloud optical properties,
    30    !    Clim. Dyn., 5, 175-187, 1991.
    31    !
    32    !  Manabe, S., J. Smagorinsky, R. F. Strickler,
    33    !    Simulated climatology of a general circulation model with a hydrologic cycle,
    34    !    Mon. Wea. Rev., 93, 769-798, 1965.
    35    !
    36    !== Procedures List
    37    !
    38    ! LScaleCondLL91     :: ٤漾Ĵ
    39    ! LScaleCondLL91Init :: 
    40    ! -----------------  :: ------------
    41    ! LScaleCondLL91     :: Adjust temperature and specific humidity
    42    ! LScaleCondLL91Init :: Initialization
    43    !
    44    !== NAMELIST
    45    !
    46    ! NAMELIST#lscond_nml
    47    !
    48  
    49    ! ⥸塼 ; USE statements
    50    !
    51  
    52    ! ʻ
    53    ! Grid points settings
    54    !
    55    use gridset, only: imax, & ! ٳʻ.
    56                               ! Number of grid points in longitude
    57      &                jmax, & ! ٳʻ.
    58                               ! Number of grid points in latitude
    59      &                kmax    ! ľؿ.
    60                               ! Number of vertical level
    61  
    62    ! ̷ѥ᥿
    63    ! Kind type parameter
    64    !
    65    use dc_types, only: DP, &      ! ټ¿. Double precision.
    66      &                 STRING     ! ʸ.       Strings.
    67  
    68    ! å
    69    ! Message output
    70    !
    71    use dc_message, only: MessageNotify
    72  
    73    ! ʸ ; Declaration statements
    74    !
    75    implicit none
    76    private
    77  
    78    ! ³
    79    ! Public procedure
    80    !
    81    public:: LScaleCondLL91
    82    public:: LScaleCondLL91Init
    83  
    84    ! ѿ
    85    ! Public variables
    86    !
    87  
    88    ! ѿ
    89    ! Private variables
    90    !
    91    logical, save :: lscond_LL91_inited = .false.
    92                                ! ե饰.
    93                                ! Initialization flag
    94  
    95    real(DP), save :: Gamma
    96                                !
    97                                ! Subgrid scale variation of specific humidity
    98                                ! expressed as fraction of specific humidity
    99  !!$  real(DP), save:: CrtlRH
   100  !!$                              ! ׳м.
   101  !!$                              ! Critical relative humidity
   102    integer, save :: ItrtMax
   103                                ! ƥ졼.
   104                                ! Number of iteration
   105  !!$  logical, save :: FlagUse
   106  !!$                              ! ѥե饰
   107  !!$                              ! flag for use of this scheme
   108  
   109    character(*), parameter:: module_name = 'lscond_LL91'
   110                                ! ⥸塼̾.
   111                                ! Module name
   112    character(*), parameter:: version = &
   113      & '$Name: dcpam5-20120921 $' // &
   114      & '$Id: lscond_LL91.f90,v 1.2 2011-12-02 04:07:03 yot Exp $'
   115                                ! ⥸塼ΥС
   116                                ! Module version
   117  
   118  contains
   119  
   120    !--------------------------------------------------------------------------------------
   121  
   122    subroutine LScaleCondLL91(       &
   123      & xyz_Temp, xyz_QVap,          &  ! (inout)
   124      & xyz_DTempDt, xyz_DQVapDt,    &  ! (inout)
   125      & xyz_Press, xyr_Press,        &  ! (in)
   126      & xyz_DQH2OLiqDt               &  ! (out)
   127      & )
   128      !
   129      ! 絬϶ŷ륹ˤ, ٤漾Ĵᤷޤ.
   130      !
   131      ! Adjust temperature and specific humidity by
   132      ! large scale condensation scheme.
   133      !
   134  
   135      ! ⥸塼 ; USE statements
   136      !
   137  
   138      ! ʪ
   139      ! Physical constants settings
   140      !
   141      use constants, only: &
   142        & Grav, &
   143                                ! $ g $ [m s-2].
   144                                ! ϲ®.
   145                                ! Gravitational acceleration
   146        & CpDry, &
   147                                ! $ C_p $ [J kg-1 K-1].
   148                                ! 絤갵Ǯ.
   149                                ! Specific heat of air at constant pressure
   150        & LatentHeat
   151                                ! $ L $ [J kg-1] .
   152                                ! ŷǮ.
   153                                ! Latent heat of condensation
   154  
   155      ! 
   156      ! Time control
   157      !
   158      use timeset, only: &
   159        & DelTime, &            ! $ \Delta t $
   160        & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $.
   161        & TimesetClockStart, TimesetClockStop
   162  
   163      ! ҥȥǡ
   164      ! History data output
   165      !
   166      use gtool_historyauto, only: HistoryAutoPut
   167  
   168      ! ˰漾λ
   169      ! Evaluate saturation specific humidity
   170      !
   171      use saturate, only: xyz_CalcQVapSat, xyz_CalcDQVapSatDTemp
   172  
   173  
   174      ! ʸ ; Declaration statements
   175      !
   176      implicit none
   177  
   178      real(DP), intent(inout):: xyz_Temp (0:imax-1, 1:jmax, 1:kmax)
   179                                ! $ T $ .     . Temperature
   180      real(DP), intent(inout):: xyz_QVap (0:imax-1, 1:jmax, 1:kmax)
   181                                ! $ q $ .     漾. Specific humidity
   182      real(DP), intent(inout):: xyz_DTempDt (0:imax-1, 1:jmax, 1:kmax)
   183                                ! ѲΨ.
   184                                ! Temperature tendency
   185      real(DP), intent(inout):: xyz_DQVapDt (0:imax-1, 1:jmax, 1:kmax)
   186                                ! 漾ѲΨ.
   187                                ! Specific humidity tendency
   188      real(DP), intent(in):: xyz_Press (0:imax-1, 1:jmax, 1:kmax)
   189                                ! $ p $ .  (٥).
   190                                ! Air pressure (full level)
   191      real(DP), intent(in):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
   192                                ! $ \hat{p} $ .  (Ⱦ٥).
   193                                ! Air pressure (half level)
   194      real(DP), intent(out) :: xyz_DQH2OLiqDt(0:imax-1,1:jmax,1:kmax)
   195  
   196  
   197      ! ѿ
   198      ! Work variables
   199      !
   200      real(DP) :: xyz_CldFrac   (0:imax-1, 1:jmax, 1:kmax)
   201                                !
   202                                ! Cloud fraction
   203      real(DP) :: xyz_QVapHalRan(0:imax-1, 1:jmax, 1:kmax)
   204                                !
   205                                ! Half range of specific humidity
   206      real(DP) :: xyz_QVapCler  (0:imax-1, 1:jmax, 1:kmax)
   207                                !
   208                                ! Specific humidity in clear region
   209      real(DP) :: xyz_QVapCldy  (0:imax-1, 1:jmax, 1:kmax)
   210                                !
   211                                ! Specific humidity in cloudy region
   212      real(DP) :: xyz_TempCler  (0:imax-1, 1:jmax, 1:kmax)
   213                                !
   214                                ! Temperature in clear region
   215      real(DP) :: xyz_TempCldy  (0:imax-1, 1:jmax, 1:kmax)
   216                                !
   217                                ! Temperature in cloudy region
   218  
   219      real(DP) :: xy_RainLsc (0:imax-1, 1:jmax)
   220                                ! ߿.
   221                                ! Precipitation
   222      real(DP) :: xyz_DTempDtLsc (0:imax-1, 1:jmax, 1:kmax)
   223                                ! ѲΨ.
   224                                ! Temperature tendency
   225      real(DP) :: xyz_DQVapDtLsc (0:imax-1, 1:jmax, 1:kmax)
   226                                ! 漾ѲΨ.
   227                                ! Specific humidity tendency
   228  
   229      real(DP) :: xyz_QVapB (0:imax-1, 1:jmax, 1:kmax)
   230                                ! Ĵ漾.
   231                                ! Specific humidity before adjust.
   232      real(DP) :: xyz_TempB (0:imax-1, 1:jmax, 1:kmax)
   233                                ! Ĵβ.
   234                                ! Temperature before adjust.
   235                                !
   236      real(DP) :: xyz_QVapSat      (0:imax-1, 1:jmax, 1:kmax)
   237                                ! ˰漾.
   238                                ! Saturation specific humidity.
   239      real(DP) :: xyz_DQVapSatDTemp(0:imax-1, 1:jmax, 1:kmax)
   240                                ! $ \DD{q_{\rm{sat}}}{T} $
   241      real(DP) :: DelTemp
   242                                ! Ĵˤ벹Ѳ.
   243                                ! Temperature variation by adjustment
   244  
   245      integer :: i              ! ˲ DO 롼Ѻѿ
   246                                ! Work variables for DO loop in longitude
   247      integer :: j              ! ˲ DO 롼Ѻѿ
   248                                ! Work variables for DO loop in latitude
   249      integer :: k              ! ľ˲ DO 롼Ѻѿ
   250                                ! Work variables for DO loop in vertical direction
   251      integer :: itr            ! ƥ졼˲ DO 롼Ѻѿ
   252                                ! Work variables for DO loop in iteration direction
   253  
   254      real(DP) :: xyz_RainLSC(0:imax-1, 1:jmax, 1:kmax)
   255  
   256      logical  :: xyz_FlagSaturated(0:imax-1, 1:jmax, 1:kmax)
   257  
   258      ! Variables for debug
   259  !!$    real(DP) :: TempBefAdj
   260  !!$    real(DP) :: QVapBefAdj
   261  
   262  
   263      ! ¹ʸ ; Executable statement
   264      !
   265  
   266      ! ǧ
   267      ! Initialization check
   268      !
   269      if ( .not. lscond_LL91_inited ) then
   270        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   271      end if
   272  
   273  !!$    if ( .not. FlagUse ) return
   274  
   275  
   276      ! ׻ַ¬
   277      ! Start measurement of computation time
   278      !
   279      call TimesetClockStart( module_name )
   280  
   281  
   282  
   283      ! Ĵ "QVap", "Temp" ¸
   284      ! Store "QVap", "Temp" before adjustment
   285      !
   286      xyz_QVapB  = xyz_QVap
   287      xyz_TempB  = xyz_Temp
   288  
   289  
   290      ! Ĵ
   291      ! Adjustment
   292      !
   293  
   294      ! ˰漾׻
   295      ! Calculate saturation specific humidity
   296      !
   297      xyz_QVapSat = xyz_CalcQVapSat( xyz_Temp, xyz_Press )
   298  
   299  
   300      ! Preparation for temperature in clear and cloudy regions
   301      !
   302      xyz_TempCler = xyz_Temp
   303      xyz_TempCldy = xyz_Temp
   304  
   305      ! Calculation of cloud fraction, specific humidities in clear and cloudy regions
   306      !
   307      xyz_QVapHalRan = Gamma * xyz_QVap
   308      xyz_CldFrac  = ( xyz_QVap + xyz_QVapHalRan - xyz_QVapSat ) &
   309        & / ( 2.0_DP * xyz_QVapHalRan + 1.0d-100 )
   310      xyz_QVapCler = ( xyz_QVapSat + xyz_QVap - xyz_QVapHalRan ) / 2.0_DP
   311      xyz_QVapCldy = ( xyz_QVapSat + xyz_QVap + xyz_QVapHalRan ) / 2.0_DP
   312      do k = 1, kmax
   313        do j = 1, jmax
   314          do i = 0, imax-1
   315            if ( xyz_CldFrac(i,j,k) >= 1.0_DP ) then
   316              xyz_QVapCler(i,j,k) = 0.0_DP
   317              xyz_QVapCldy(i,j,k) = xyz_QVap(i,j,k)
   318            else if ( xyz_CldFrac(i,j,k) <= 0.0_DP ) then
   319              xyz_QVapCler(i,j,k) = xyz_QVap(i,j,k)
   320              xyz_QVapCldy(i,j,k) = 0.0_DP
   321            end if
   322          end do
   323        end do
   324      end do
   325      do k = 1, kmax
   326        do j = 1, jmax
   327          do i = 0, imax-1
   328            if ( xyz_CldFrac(i,j,k) > 1.0_DP ) then
   329              xyz_CldFrac(i,j,k) = 1.0_DP
   330            else if ( xyz_CldFrac(i,j,k) < 0.0_DP ) then
   331              xyz_CldFrac(i,j,k) = 0.0_DP
   332            end if
   333          end do
   334        end do
   335      end do
   336  
   337  
   338      do k = 1, kmax
   339        do j = 1, jmax
   340          do i = 0, imax-1
   341  
   342  !!$          if ( ( xyz_QVap(i,j,k) / xyz_QVapSat(i,j,k) ) >= CrtlRH ) then
   343            if ( xyz_CldFrac(i,j,k) > 0.0_DP ) then
   344              xyz_FlagSaturated(i,j,k) = .true.
   345            else
   346              xyz_FlagSaturated(i,j,k) = .false.
   347            end if
   348  
   349          end do
   350        end do
   351      end do
     .        do k = 1, kmax                                                    
     .           do j = 1, jmax                                                 
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xyz_cldfrac(i-1,j,k) .ge. 1.00000000000000e+000) then
     .                    xyz_qvapcler(i-1,j,k) = 0.0000000000000000e+000       
     .                    xyz_qvapcldy(i-1,j,k) = xyz_qvap(i-1,j,k)             
     .                 else                                                     
     .                    if (xyz_cldfrac(i-1,j,k) .le. 0.0000000000000000e+000 
     .       1               ) then                                             
     .                       xyz_qvapcler(i-1,j,k) = xyz_qvap(i-1,j,k)          
     .                       xyz_qvapcldy(i-1,j,k) = 0.0000000000000000e+000    
     .                    endif                                                 
     .                 endif                                                    
     .                 if (xyz_cldfrac(i-1,j,k) .gt. 1.00000000000000e+000) then
     .                    xyz_cldfrac(i-1,j,k) = 1.00000000000000e+000          
     .                 else                                                     
     .                    if (xyz_cldfrac(i-1,j,k) .lt. 0.0000000000000000e+000 
     .       1               ) then                                             
     .                       xyz_cldfrac(i-1,j,k) = 0.0000000000000000e+000     
     .                    endif                                                 
     .                 endif                                                    
     .                 if (xyz_cldfrac(i-1,j,k) .gt. 0.0000000000000000e+000)   
     .       1            then                                                  
     .                    xyz_flagsaturated(i-1,j,k) = 1                        
     .                 else                                                     
     .                    xyz_flagsaturated(i-1,j,k) = 0                        
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .        end do                                                            
   352  
   353  
   354      do itr = 1, ItrtMax
   355  
   356        ! ˰漾׻
   357        ! Calculate saturation specific humidity
   358        !
   359        xyz_QVapSat       = xyz_CalcQVapSat      ( xyz_TempCldy, xyz_Press   )
   360        xyz_DQVapSatDTemp = xyz_CalcDQVapSatDTemp( xyz_TempCldy, xyz_QVapSat )
   361  
   362        do k = 1, kmax
   363          do j = 1, jmax
   364            do i = 0, imax-1
   365  
   366              ! ˰¤Ƥ, ٤漾Ѳ׻
   367              ! Calculate tendency of temperature and humidity
   368              ! if moist is saturation.
   369              !
   370              if ( xyz_FlagSaturated(i,j,k) ) then
   371  
   372                ! ٤Ѳʬ˥塼ȥˡǵ
   373                ! Calculate variation of temperature
   374                !
   375                DelTemp = &
   376                  & LatentHeat * ( xyz_QVapCldy(i,j,k) - xyz_QVapSat(i,j,k) ) &
   377                  &    / ( CpDry + LatentHeat * xyz_DQVapSatDTemp(i,j,k) )
   378  
   379  
   380                !=========
   381                ! check routine
   382                !---------
   383  !!$              TempBefAdj = xyz_TempCldy(i,j,k)
   384  !!$              QVapBefAdj = xyz_QVapCldy(i,j,k)
   385                !=========
   386  
   387                ! ٤漾Ĵ
   388                ! Adjust temperature and specific humidity
   389                !
   390                xyz_TempCldy(i,j,k) = xyz_TempCldy(i,j,k) &
   391                  & + DelTemp
   392                xyz_QVapCldy(i,j,k) = xyz_QVapSat(i,j,k)  &
   393                  & + xyz_DQVapSatDTemp(i,j,k) * DelTemp
   394  
   395                !=========
   396                ! check routine
   397                !---------
   398  !!$              write( 6, * ) '====='
   399  !!$              write( 6, * ) 'Energy difference before and after adjustment and each energy', xyz_CldFrac(i,j,k)
   400  !!$              write( 6, * ) &
   401  !!$                & (     CpDry*TempBefAdj          + LatentHeat*QVapBefAdj              &
   402  !!$                &   - ( CpDry*xyz_TempCldy(i,j,k) + LatentHeat*xyz_QVapCldy(i,j,k) ) ) &
   403  !!$                & /(    CpDry*TempBefAdj          + LatentHeat*QVapBefAdj ),           &
   404  !!$                &     CpDry*TempBefAdj          + LatentHeat*QVapBefAdj,               &
   405  !!$                &   ( CpDry*xyz_TempCldy(i,j,k) + LatentHeat*xyz_QVapCldy(i,j,k) )
   406                !=========
   407  
   408  
   409              end if
   410  
   411            end do
     .  !CDIR NODEP                                                             
     .        do i = 1, imax                                                    
     .           if (xyz_flagsaturated(i-1,j,k) .ne. 0) then                    
     .              deltemp = latentheat*(xyz_qvapcldy(i-1,j,k)-xyz_qvapsat(i-1,
     .       1         j,k))/(cpdry + latentheat*xyz_dqvapsatdtemp(i-1,j,k))    
     .              xyz_tempcldy(i-1,j,k) = xyz_tempcldy(i-1,j,k) + deltemp     
     .              xyz_qvapcldy(i-1,j,k) = xyz_qvapsat(i-1,j,k) +              
     .       1         xyz_dqvapsatdtemp(i-1,j,k)*deltemp                       
     .           endif                                                          
     .        end do                                                            
   412          end do
   413        end do
   414  
   415      end do
   416  
   417      ! Calculation of temperature and specific humidity averaged over a grid
   418      !
   419      xyz_Temp = xyz_CldFrac * xyz_TempCldy + ( 1.0_DP - xyz_CldFrac ) * xyz_TempCler
     .        D3 = 1.D0/(2.00000000000000e+000*deltime)                         
     .        D4 = 1.D0/(2.00000000000000e+000*deltime)                         
     .  !CDIR NODEP                                                             
     .        do t807 = 1, xyz_cldfrac.DSC.U1 + 1                               
     .           xyz_temp(t807-1,t805+1,t803+1) = xyz_cldfrac(t807-1,t805+1,t803
     .       1      +1)*xyz_tempcldy(t807-1,t805+1,t803+1) + (                  
     .       2      1.00000000000000e+000 - xyz_cldfrac(t807-1,t805+1,t803+1))* 
     .       3      xyz_tempcler(t807-1,t805+1,t803+1)                          
     .           xyz_qvap(t807-1,t805+1,t803+1) = xyz_cldfrac(t807-1,t805+1,t803
     .       1      +1)*xyz_qvapcldy(t807-1,t805+1,t803+1) + (                  
     .       2      1.00000000000000e+000 - xyz_cldfrac(t807-1,t805+1,t803+1))* 
     .       3      xyz_qvapcler(t807-1,t805+1,t803+1)                          
     .           xyz_dqvapdtlsc(t807-1,t805+1,t803+1) = (xyz_qvap(t807-1,t805+1,
     .       1      t803+1)-xyz_qvapb(t807-1,t805+1,t803+1))*D3                 
     .           xyz_dtempdtlsc(t807-1,t805+1,t803+1) = (xyz_temp(t807-1,t805+1,
     .       1      t803+1)-xyz_tempb(t807-1,t805+1,t803+1))*D4                 
     .           xyz_dtempdt(t807-1,t805+1,t803+1) = xyz_dtempdt(t807-1,t805+1, 
     .       1      t803+1) + xyz_dtempdtlsc(t807-1,t805+1,t803+1)              
     .           xyz_dqvapdt(t807-1,t805+1,t803+1) = xyz_dqvapdt(t807-1,t805+1, 
     .       1      t803+1) + xyz_dqvapdtlsc(t807-1,t805+1,t803+1)              
     .           xyz_dqh2oliqdt(t807-1,t805+1,t803+1) = -xyz_dqvapdtlsc(t807-1, 
     .       1      t805+1,t803+1)                                              
     .        end do                                                            
   420      xyz_QVap = xyz_CldFrac * xyz_QVapCldy + ( 1.0_DP - xyz_CldFrac ) * xyz_QVapCler
   421  
   422  
   423      ! 漾ѲΨ, ѲΨ, ߿̤λ
   424      ! Calculate specific humidity tendency, temperature tendency,
   425      ! precipitation
   426      !
   427      xyz_DQVapDtLsc = ( xyz_QVap - xyz_QVapB ) / ( 2.0_DP * DelTime )
   428      xyz_DTempDtLsc = ( xyz_Temp - xyz_TempB ) / ( 2.0_DP * DelTime )
   429  
   430      xyz_DTempDt = xyz_DTempDt + xyz_DTempDtLsc
   431      xyz_DQVapDt = xyz_DQVapDt + xyz_DQVapDtLsc
   432  
   433  
   434  !!$    xy_RainLsc     = 0.0d0
   435  !!$    do k = kmax, 1, -1
   436  !!$      xy_RainLsc = xy_RainLsc                                     &
   437  !!$        & + ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav      &
   438  !!$        & * ( xyz_QVapB(:,:,k  ) - xyz_QVap (:,:,k) )
   439  !!$    end do
   440  !!$    xy_RainLsc = xy_RainLsc / ( 2.0_DP * DelTime )
   441  
   442  
   443  !!$    i = 0
   444  !!$    j = jmax/2+1
   445  !!$    write( 6, * ) xy_RainLsc(i,j)
   446  
   447  
   448  !!$    xyz_DQH2OLiqDt = - xyz_DQVapDtLsc
   449  !!$    xy_RainLsc     = 0.0d0
   450  !!$    do k = kmax, 1, -1
   451  !!$      xy_RainLsc = xy_RainLsc                                     &
   452  !!$        & + xyz_DQH2OLiqDt(:,:,k) * ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav
   453  !!$    end do
   454  
   455  !!$    i = 0
   456  !!$    j = jmax/2+1
   457  !!$    write( 6, * ) xy_RainLsc(i,j)
   458  !!$    write( 6, * ) '---'
   459  
   460  !!$    xy_Rain     = xy_Rain     + xy_RainLsc
   461  
   462  
   463      xyz_DQH2OLiqDt = - xyz_DQVapDtLsc
   464  
   465  
   466      ! calculation for output
   467      xy_RainLsc     = 0.0d0
     .        if (xy_rainlsc.DSC.U2 .gt. 0) then                                
     .           J1 = and(xy_rainlsc.DSC.U2,3)                                  
     .  !CDIR    NODEP                                                          
     .           do t881 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t883 = 1, xy_rainlsc.DSC.U1 + 1                          
     .                 xy_rainlsc(t883-1,t881) = 0.0000000000000000e+000        
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t881 = J1 + 1, xy_rainlsc.DSC.U2, 4                         
     .  !CDIR       NODEP                                                       
     .              do t883 = 1, xy_rainlsc.DSC.U1 + 1                          
     .                 xy_rainlsc(t883-1,t881) = 0.0000000000000000e+000        
     .                 xy_rainlsc(t883-1,t881+1) = 0.0000000000000000e+000      
     .                 xy_rainlsc(t883-1,t881+2) = 0.0000000000000000e+000      
     .                 xy_rainlsc(t883-1,t881+3) = 0.0000000000000000e+000      
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   468      do k = kmax, 1, -1
   469        xy_RainLsc = xy_RainLsc                                     &
     .        if (xy_rainlsc.DSC.U2 .gt. 0) then                                
     .           J2 = and(xy_rainlsc.DSC.U2,3)                                  
     .  !CDIR    NODEP                                                          
     .           do t887 = 1, J2                                                
     .              D5 = 1.D0/grav                                              
     .  !CDIR       NODEP                                                       
     .              do t889 = 1, xy_rainlsc.DSC.U1 + 1                          
     .                 xy_rainlsc(t889-1,t887) = xy_rainlsc(t889-1,t887) +      
     .       1            xyz_dqh2oliqdt(t889-1,t887,k)*(xyr_press(t889-1,t887,k
     .       2            -1)-xyr_press(t889-1,t887,k))*D5                      
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t887 = J2 + 1, xy_rainlsc.DSC.U2, 4                         
     .              D6 = 1.D0/grav                                              
     .              D7 = 1.D0/grav                                              
     .              D8 = 1.D0/grav                                              
     .              D9 = 1.D0/grav                                              
     .  !CDIR       NODEP                                                       
     .              do t889 = 1, xy_rainlsc.DSC.U1 + 1                          
     .                 xy_rainlsc(t889-1,t887) = xy_rainlsc(t889-1,t887) +      
     .       1            xyz_dqh2oliqdt(t889-1,t887,k)*(xyr_press(t889-1,t887,k
     .       2            -1)-xyr_press(t889-1,t887,k))*D6                      
     .                 xy_rainlsc(t889-1,t887+1) = xy_rainlsc(t889-1,t887+1) +  
     .       1            xyz_dqh2oliqdt(t889-1,t887+1,k)*(xyr_press(t889-1,t887
     .       2            +1,k-1)-xyr_press(t889-1,t887+1,k))*D7                
     .                 xy_rainlsc(t889-1,t887+2) = xy_rainlsc(t889-1,t887+2) +  
     .       1            xyz_dqh2oliqdt(t889-1,t887+2,k)*(xyr_press(t889-1,t887
     .       2            +2,k-1)-xyr_press(t889-1,t887+2,k))*D8                
     .                 xy_rainlsc(t889-1,t887+3) = xy_rainlsc(t889-1,t887+3) +  
     .       1            xyz_dqh2oliqdt(t889-1,t887+3,k)*(xyr_press(t889-1,t887
     .       2            +3,k-1)-xyr_press(t889-1,t887+3,k))*D9                
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   470          & + xyz_DQH2OLiqDt(:,:,k) * ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav
   471      end do
   472  
   473      ! ҥȥǡ
   474      ! History data output
   475      !
   476      call HistoryAutoPut( TimeN, 'RainLsc',    xy_RainLsc * LatentHeat )
     .        if (xy_rainlsc.DSC.U2 .gt. 0) then                                
     .           J3 = and(xy_rainlsc.DSC.U2,3)                                  
     .  !CDIR    NODEP                                                          
     .           do t901 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t903 = 1, xy_rainlsc.DSC.U1 + 1                          
     .                 %IG0(t903,t901) = xy_rainlsc(t903-1,t901)*latentheat     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t901 = J3 + 1, xy_rainlsc.DSC.U2, 4                         
     .  !CDIR       NODEP                                                       
     .              do t903 = 1, xy_rainlsc.DSC.U1 + 1                          
     .                 %IG0(t903,t901) = xy_rainlsc(t903-1,t901)*latentheat     
     .                 %IG0(t903,t901+1) = xy_rainlsc(t903-1,t901+1)*latentheat 
     .                 %IG0(t903,t901+2) = xy_rainlsc(t903-1,t901+2)*latentheat 
     .                 %IG0(t903,t901+3) = xy_rainlsc(t903-1,t901+3)*latentheat 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   477      call HistoryAutoPut( TimeN, 'DTempDtLsc', xyz_DTempDtLsc )
   478      call HistoryAutoPut( TimeN, 'DQVapDtLsc', xyz_DQVapDtLsc )
   479  
   480  
   481  
   482      ! ׻ַ¬
   483      ! Pause measurement of computation time
   484      !
   485      call TimesetClockStop( module_name )
   486  
   487    end subroutine LScaleCondLL91
   488  
   489    !--------------------------------------------------------------------------------------
   490  
   491    subroutine LScaleCondLL91Init
   492      !
   493      ! lscond ⥸塼νԤޤ.
   494      ! NAMELIST#lscond_nml ɤ߹ߤϤμ³ǹԤޤ.
   495      !
   496      ! "lscond" module is initialized.
   497      ! "NAMELIST#lscond_nml" is loaded in this procedure.
   498      !
   499  
   500      ! ⥸塼 ; USE statements
   501      !
   502  
   503      ! NAMELIST եϤ˴ؤ桼ƥƥ
   504      ! Utilities for NAMELIST file input
   505      !
   506      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   507  
   508      ! ե
   509      ! File I/O support
   510      !
   511      use dc_iounit, only: FileOpen
   512  
   513      ! ̷ѥ᥿
   514      ! Kind type parameter
   515      !
   516      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   517  
   518      ! ʸ
   519      ! Character handling
   520      !
   521      use dc_string, only: StoA
   522  
   523      ! ҥȥǡ
   524      ! History data output
   525      !
   526      use gtool_historyauto, only: HistoryAutoAddVariable
   527  
   528      ! ʸ ; Declaration statements
   529      !
   530      implicit none
   531  
   532      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   533                                ! Unit number for NAMELIST file open
   534      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   535                                ! IOSTAT of NAMELIST read
   536  
   537      ! NAMELIST ѿ
   538      ! NAMELIST group name
   539      !
   540      namelist /lscond_nml/ &
   541  !!$      & CrtlRH, ItrtMax, FlagUse
   542        & Gamma, ItrtMax !, FlagUse
   543            !
   544            ! ǥեͤˤĤƤϽ³ "lscond#LSCondInit"
   545            ! Υɤ򻲾ȤΤ.
   546            !
   547            ! Refer to source codes in the initialization procedure
   548            ! "lscond#LSCondInit" for the default values.
   549            !
   550  
   551      ! ¹ʸ ; Executable statement
   552      !
   553  
   554      if ( lscond_LL91_inited ) return
   555  
   556  
   557      ! ǥեͤ
   558      ! Default values settings
   559      !
   560  !!$    CrtlRH  = 1.0_DP
   561      Gamma   = 0.2_DP
   562      !  This value is from Le Treut and Li (1991).
   563      ItrtMax = 3
   564  !!$    FlagUse = .true.
   565  
   566      ! NAMELIST ɤ߹
   567      ! NAMELIST is input
   568      !
   569      if ( trim(namelist_filename) /= '' ) then
   570        call FileOpen( unit_nml, &          ! (out)
   571          & namelist_filename, mode = 'r' ) ! (in)
   572  
   573        rewind( unit_nml )
   574        read( unit_nml, &         ! (in)
   575          & nml = lscond_nml, &   ! (out)
   576          & iostat = iostat_nml ) ! (out)
   577        close( unit_nml )
   578  
   579        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   580        if ( iostat_nml == 0 ) write( STDOUT, nml = lscond_nml )
   581      end if
   582  
   583      ! ҥȥǡϤΤΤؤѿϿ
   584      ! Register of variables for history data output
   585      !
   586      call HistoryAutoAddVariable( 'RainLsc', &
   587        & (/ 'lon ', 'lat ', 'time' /), &
   588        & 'precipitation by large scale condensation', 'W m-2' )
   589      call HistoryAutoAddVariable( 'DTempDtLsc', &
   590        & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
   591        & 'large-scale condensation heating', 'K s-1' )
   592      call HistoryAutoAddVariable( 'DQVapDtLsc', &
   593        & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
   594        & 'large-scale condensation moistening', 'kg kg-1 s-1' )
   595  
   596      !  ; Print
   597      !
   598      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   599  !!$    call MessageNotify( 'M', module_name, '  FlagUse = %b', l = (/ FlagUse /) )
   600  !!$    call MessageNotify( 'M', module_name, '  CrtlRH  = %f', d = (/ CrtlRH /) )
   601      call MessageNotify( 'M', module_name, '  Gamma   = %f', d = (/ Gamma /) )
   602      call MessageNotify( 'M', module_name, '  ItrtMax = %d', i = (/ ItrtMax /) )
   603      call MessageNotify( 'M', module_name, '' )
   604      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   605  
   606      lscond_LL91_inited = .true.
   607  
   608    end subroutine LScaleCondLL91Init
   609  
   610    !--------------------------------------------------------------------------------------
   611  
   612  end module lscond_LL91
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:52:04 2012
FILE NAME: lscond_LL91.f90
PROGRAM NAME: lscond_ll91
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != 絬϶ŷ (ήŷ) (Le Treut and Li, 1991)
     2:            !
     3:            != Large scale condensation (non-convective condensation) (Le Treut and Li, 1991)
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: lscond_LL91.f90,v 1.2 2011-12-02 04:07:03 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module lscond_LL91
    13:              !
    14:              != 絬϶ŷ (ήŷ)
    15:              !
    16:              != Large scale condensation (non-convective condensation)
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! 絬϶ŷˤäƲ٤漾Ĵᤷޤ. 
    21:              !
    22:              ! Adjust temperature and specific humidity by 
    23:              ! a large scale condensation process.
    24:              !
    25:              !== References
    26:              !
    27:              !  Le Treut, H., and Z.-X. Li,
    28:              !    Sensitivity of an atmospheric general circulation model to prescribed SST changes:
    29:              !    feedback effects associated with the simulation of cloud optical properties, 
    30:              !    Clim. Dyn., 5, 175-187, 1991.
    31:              !
    32:              !  Manabe, S., J. Smagorinsky, R. F. Strickler, 
    33:              !    Simulated climatology of a general circulation model with a hydrologic cycle,
    34:              !    Mon. Wea. Rev., 93, 769-798, 1965.
    35:              !
    36:              !== Procedures List
    37:              ! 
    38:              ! LScaleCondLL91     :: ٤漾Ĵ
    39:              ! LScaleCondLL91Init :: 
    40:              ! -----------------  :: ------------
    41:              ! LScaleCondLL91     :: Adjust temperature and specific humidity
    42:              ! LScaleCondLL91Init :: Initialization
    43:              !
    44:              !== NAMELIST
    45:              !
    46:              ! NAMELIST#lscond_nml
    47:              !
    48:            
    49:              ! ⥸塼 ; USE statements
    50:              !
    51:            
    52:              ! ʻ
    53:              ! Grid points settings
    54:              !
    55:              use gridset, only: imax, & ! ٳʻ. 
    56:                                         ! Number of grid points in longitude
    57:                &                jmax, & ! ٳʻ. 
    58:                                         ! Number of grid points in latitude
    59:                &                kmax    ! ľؿ. 
    60:                                         ! Number of vertical level
    61:            
    62:              ! ̷ѥ᥿
    63:              ! Kind type parameter
    64:              !
    65:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    66:                &                 STRING     ! ʸ.       Strings. 
    67:            
    68:              ! å
    69:              ! Message output
    70:              !
    71:              use dc_message, only: MessageNotify
    72:            
    73:              ! ʸ ; Declaration statements
    74:              !
    75:              implicit none
    76:              private
    77:            
    78:              ! ³
    79:              ! Public procedure
    80:              !
    81:              public:: LScaleCondLL91
    82:              public:: LScaleCondLL91Init
    83:            
    84:              ! ѿ
    85:              ! Public variables
    86:              !
    87:            
    88:              ! ѿ
    89:              ! Private variables
    90:              !
    91:              logical, save :: lscond_LL91_inited = .false.
    92:                                          ! ե饰. 
    93:                                          ! Initialization flag
    94:            
    95:              real(DP), save :: Gamma
    96:                                          !
    97:                                          ! Subgrid scale variation of specific humidity 
    98:                                          ! expressed as fraction of specific humidity
    99:            !!$  real(DP), save:: CrtlRH
   100:            !!$                              ! ׳м. 
   101:            !!$                              ! Critical relative humidity
   102:              integer, save :: ItrtMax
   103:                                          ! ƥ졼. 
   104:                                          ! Number of iteration
   105:            !!$  logical, save :: FlagUse
   106:            !!$                              ! ѥե饰
   107:            !!$                              ! flag for use of this scheme
   108:            
   109:              character(*), parameter:: module_name = 'lscond_LL91'
   110:                                          ! ⥸塼̾. 
   111:                                          ! Module name
   112:              character(*), parameter:: version = &
   113:                & '$Name: dcpam5-20120921 $' // &
   114:                & '$Id: lscond_LL91.f90,v 1.2 2011-12-02 04:07:03 yot Exp $'
   115:                                          ! ⥸塼ΥС
   116:                                          ! Module version
   117:            
   118:            contains
   119:            
   120:              !--------------------------------------------------------------------------------------
   121:            
   122:              subroutine LScaleCondLL91(       &
   123:                & xyz_Temp, xyz_QVap,          &  ! (inout)
   124:                & xyz_DTempDt, xyz_DQVapDt,    &  ! (inout)
   125:                & xyz_Press, xyr_Press,        &  ! (in)
   126:                & xyz_DQH2OLiqDt               &  ! (out)
   127:                & )
   128:                !
   129:                ! 絬϶ŷ륹ˤ, ٤漾Ĵᤷޤ. 
   130:                !
   131:                ! Adjust temperature and specific humidity by 
   132:                ! large scale condensation scheme. 
   133:                !
   134:            
   135:                ! ⥸塼 ; USE statements
   136:                !
   137:            
   138:                ! ʪ
   139:                ! Physical constants settings
   140:                !
   141:                use constants, only: &
   142:                  & Grav, & 
   143:                                          ! $ g $ [m s-2]. 
   144:                                          ! ϲ®. 
   145:                                          ! Gravitational acceleration
   146:                  & CpDry, &
   147:                                          ! $ C_p $ [J kg-1 K-1]. 
   148:                                          ! 絤갵Ǯ. 
   149:                                          ! Specific heat of air at constant pressure
   150:                  & LatentHeat
   151:                                          ! $ L $ [J kg-1] . 
   152:                                          ! ŷǮ. 
   153:                                          ! Latent heat of condensation
   154:            
   155:                ! 
   156:                ! Time control
   157:                !
   158:                use timeset, only: &
   159:                  & DelTime, &            ! $ \Delta t $
   160:                  & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $. 
   161:                  & TimesetClockStart, TimesetClockStop
   162:            
   163:                ! ҥȥǡ
   164:                ! History data output
   165:                !
   166:                use gtool_historyauto, only: HistoryAutoPut
   167:            
   168:                ! ˰漾λ
   169:                ! Evaluate saturation specific humidity
   170:                !
   171:                use saturate, only: xyz_CalcQVapSat, xyz_CalcDQVapSatDTemp
   172:            
   173:            
   174:                ! ʸ ; Declaration statements
   175:                !
   176:                implicit none
   177:            
   178:                real(DP), intent(inout):: xyz_Temp (0:imax-1, 1:jmax, 1:kmax)
   179:                                          ! $ T $ .     . Temperature
   180:                real(DP), intent(inout):: xyz_QVap (0:imax-1, 1:jmax, 1:kmax)
   181:                                          ! $ q $ .     漾. Specific humidity
   182:                real(DP), intent(inout):: xyz_DTempDt (0:imax-1, 1:jmax, 1:kmax)
   183:                                          ! ѲΨ. 
   184:                                          ! Temperature tendency
   185:                real(DP), intent(inout):: xyz_DQVapDt (0:imax-1, 1:jmax, 1:kmax)
   186:                                          ! 漾ѲΨ. 
   187:                                          ! Specific humidity tendency
   188:                real(DP), intent(in):: xyz_Press (0:imax-1, 1:jmax, 1:kmax)
   189:                                          ! $ p $ .  (٥). 
   190:                                          ! Air pressure (full level)
   191:                real(DP), intent(in):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
   192:                                          ! $ \hat{p} $ .  (Ⱦ٥). 
   193:                                          ! Air pressure (half level)
   194:                real(DP), intent(out) :: xyz_DQH2OLiqDt(0:imax-1,1:jmax,1:kmax)
   195:            
   196:            
   197:                ! ѿ
   198:                ! Work variables
   199:                !
   200:                real(DP) :: xyz_CldFrac   (0:imax-1, 1:jmax, 1:kmax)
   201:                                          !
   202:                                          ! Cloud fraction
   203:                real(DP) :: xyz_QVapHalRan(0:imax-1, 1:jmax, 1:kmax)
   204:                                          !
   205:                                          ! Half range of specific humidity
   206:                real(DP) :: xyz_QVapCler  (0:imax-1, 1:jmax, 1:kmax)
   207:                                          !
   208:                                          ! Specific humidity in clear region
   209:                real(DP) :: xyz_QVapCldy  (0:imax-1, 1:jmax, 1:kmax)
   210:                                          !
   211:                                          ! Specific humidity in cloudy region
   212:                real(DP) :: xyz_TempCler  (0:imax-1, 1:jmax, 1:kmax)
   213:                                          !
   214:                                          ! Temperature in clear region
   215:                real(DP) :: xyz_TempCldy  (0:imax-1, 1:jmax, 1:kmax)
   216:                                          !
   217:                                          ! Temperature in cloudy region
   218:            
   219:                real(DP) :: xy_RainLsc (0:imax-1, 1:jmax)
   220:                                          ! ߿. 
   221:                                          ! Precipitation
   222:                real(DP) :: xyz_DTempDtLsc (0:imax-1, 1:jmax, 1:kmax)
   223:                                          ! ѲΨ. 
   224:                                          ! Temperature tendency
   225:                real(DP) :: xyz_DQVapDtLsc (0:imax-1, 1:jmax, 1:kmax)
   226:                                          ! 漾ѲΨ. 
   227:                                          ! Specific humidity tendency
   228:            
   229:                real(DP) :: xyz_QVapB (0:imax-1, 1:jmax, 1:kmax)
   230:                                          ! Ĵ漾. 
   231:                                          ! Specific humidity before adjust. 
   232:                real(DP) :: xyz_TempB (0:imax-1, 1:jmax, 1:kmax)
   233:                                          ! Ĵβ. 
   234:                                          ! Temperature before adjust. 
   235:                                          !
   236:                real(DP) :: xyz_QVapSat      (0:imax-1, 1:jmax, 1:kmax)
   237:                                          ! ˰漾. 
   238:                                          ! Saturation specific humidity. 
   239:                real(DP) :: xyz_DQVapSatDTemp(0:imax-1, 1:jmax, 1:kmax)
   240:                                          ! $ \DD{q_{\rm{sat}}}{T} $
   241:                real(DP) :: DelTemp
   242:                                          ! Ĵˤ벹Ѳ. 
   243:                                          ! Temperature variation by adjustment
   244:            
   245:                integer :: i              ! ˲ DO 롼Ѻѿ
   246:                                          ! Work variables for DO loop in longitude
   247:                integer :: j              ! ˲ DO 롼Ѻѿ
   248:                                          ! Work variables for DO loop in latitude
   249:                integer :: k              ! ľ˲ DO 롼Ѻѿ
   250:                                          ! Work variables for DO loop in vertical direction
   251:                integer :: itr            ! ƥ졼˲ DO 롼Ѻѿ
   252:                                          ! Work variables for DO loop in iteration direction
   253:            
   254:                real(DP) :: xyz_RainLSC(0:imax-1, 1:jmax, 1:kmax)
   255:            
   256:                logical  :: xyz_FlagSaturated(0:imax-1, 1:jmax, 1:kmax)
   257:            
   258:                ! Variables for debug
   259:            !!$    real(DP) :: TempBefAdj
   260:            !!$    real(DP) :: QVapBefAdj
   261:            
   262:            
   263:                ! ¹ʸ ; Executable statement
   264:                !
   265:            
   266:                ! ǧ
   267:                ! Initialization check
   268:                !
   269:                if ( .not. lscond_LL91_inited ) then
   270:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   271:                end if
   272:            
   273:            !!$    if ( .not. FlagUse ) return
   274:            
   275:            
   276:                ! ׻ַ¬
   277:                ! Start measurement of computation time
   278:                !
   279:                call TimesetClockStart( module_name )
   280:            
   281:            
   282:            
   283:                ! Ĵ "QVap", "Temp" ¸
   284:                ! Store "QVap", "Temp" before adjustment
   285:                !
   286: **V---->       xyz_QVapB  = xyz_QVap
   287: |||            xyz_TempB  = xyz_Temp
   288: |||        
   289: |||        
   290: |||            ! Ĵ
   291: |||            ! Adjustment
   292: |||            !
   293: |||        
   294: |||            ! ˰漾׻
   295: |||            ! Calculate saturation specific humidity 
   296: |||            !
   297: |||            xyz_QVapSat = xyz_CalcQVapSat( xyz_Temp, xyz_Press )
   298: |||        
   299: |||        
   300: |||            ! Preparation for temperature in clear and cloudy regions
   301: |||            !
   302: |||            xyz_TempCler = xyz_Temp
   303: |||            xyz_TempCldy = xyz_Temp
   304: |||        
   305: |||            ! Calculation of cloud fraction, specific humidities in clear and cloudy regions
   306: |||            !
   307: |||            xyz_QVapHalRan = Gamma * xyz_QVap
   308: |||            xyz_CldFrac  = ( xyz_QVap + xyz_QVapHalRan - xyz_QVapSat ) &
   309: |||              & / ( 2.0_DP * xyz_QVapHalRan + 1.0d-100 )
   310: |||            xyz_QVapCler = ( xyz_QVapSat + xyz_QVap - xyz_QVapHalRan ) / 2.0_DP
   311: **V----        xyz_QVapCldy = ( xyz_QVapSat + xyz_QVap + xyz_QVapHalRan ) / 2.0_DP
   312: +------>       do k = 1, kmax
   313: |+----->         do j = 1, jmax
   314: ||V---->           do i = 0, imax-1
   315: |||                  if ( xyz_CldFrac(i,j,k) >= 1.0_DP ) then
   316: |||                    xyz_QVapCler(i,j,k) = 0.0_DP
   317: |||                    xyz_QVapCldy(i,j,k) = xyz_QVap(i,j,k)
   318: |||                  else if ( xyz_CldFrac(i,j,k) <= 0.0_DP ) then
   319: |||                    xyz_QVapCler(i,j,k) = xyz_QVap(i,j,k)
   320: |||                    xyz_QVapCldy(i,j,k) = 0.0_DP
   321: |||                  end if
   322: |||                end do
   323: |||              end do
   324: |||            end do
   325: |||            do k = 1, kmax
   326: |||              do j = 1, jmax
   327: |||                do i = 0, imax-1
   328: |||                  if ( xyz_CldFrac(i,j,k) > 1.0_DP ) then
   329: |||                    xyz_CldFrac(i,j,k) = 1.0_DP
   330: |||                  else if ( xyz_CldFrac(i,j,k) < 0.0_DP ) then
   331: |||                    xyz_CldFrac(i,j,k) = 0.0_DP
   332: |||                  end if
   333: |||                end do
   334: |||              end do
   335: |||            end do
   336: |||        
   337: |||        
   338: |||            do k = 1, kmax
   339: |||              do j = 1, jmax
   340: |||                do i = 0, imax-1
   341: |||        
   342: |||        !!$          if ( ( xyz_QVap(i,j,k) / xyz_QVapSat(i,j,k) ) >= CrtlRH ) then
   343: |||                  if ( xyz_CldFrac(i,j,k) > 0.0_DP ) then
   344: |||                    xyz_FlagSaturated(i,j,k) = .true.
   345: |||                  else
   346: |||                    xyz_FlagSaturated(i,j,k) = .false.
   347: |||                  end if
   348: |||        
   349: ||V----            end do
   350: |+-----          end do
   351: +------        end do
   352:            
   353:            
   354: +------>       do itr = 1, ItrtMax
   355: |          
   356: |                ! ˰漾׻
   357: |                ! Calculate saturation specific humidity
   358: |                !
   359: |                xyz_QVapSat       = xyz_CalcQVapSat      ( xyz_TempCldy, xyz_Press   )
   360: |                xyz_DQVapSatDTemp = xyz_CalcDQVapSatDTemp( xyz_TempCldy, xyz_QVapSat )
   361: |          
   362: |+----->         do k = 1, kmax
   363: ||+---->           do j = 1, jmax
   364: |||V--->             do i = 0, imax-1
   365: ||||       
   366: ||||                   ! ˰¤Ƥ, ٤漾Ѳ׻
   367: ||||                   ! Calculate tendency of temperature and humidity 
   368: ||||                   ! if moist is saturation. 
   369: ||||                   !
   370: ||||                   if ( xyz_FlagSaturated(i,j,k) ) then
   371: ||||       
   372: ||||                     ! ٤Ѳʬ˥塼ȥˡǵ
   373: ||||                     ! Calculate variation of temperature
   374: ||||                     !
   375: ||||                     DelTemp = &
   376: ||||                       & LatentHeat * ( xyz_QVapCldy(i,j,k) - xyz_QVapSat(i,j,k) ) &
   377: ||||                       &    / ( CpDry + LatentHeat * xyz_DQVapSatDTemp(i,j,k) )
   378: ||||       
   379: ||||       
   380: ||||                     !=========
   381: ||||                     ! check routine
   382: ||||                     !---------
   383: ||||       !!$              TempBefAdj = xyz_TempCldy(i,j,k)
   384: ||||       !!$              QVapBefAdj = xyz_QVapCldy(i,j,k)
   385: ||||                     !=========
   386: ||||       
   387: ||||                     ! ٤漾Ĵ
   388: ||||                     ! Adjust temperature and specific humidity
   389: ||||                     !
   390: ||||                     xyz_TempCldy(i,j,k) = xyz_TempCldy(i,j,k) &
   391: ||||                       & + DelTemp
   392: ||||                     xyz_QVapCldy(i,j,k) = xyz_QVapSat(i,j,k)  &
   393: ||||                       & + xyz_DQVapSatDTemp(i,j,k) * DelTemp
   394: ||||       
   395: ||||                     !=========
   396: ||||                     ! check routine
   397: ||||                     !---------
   398: ||||       !!$              write( 6, * ) '====='
   399: ||||       !!$              write( 6, * ) 'Energy difference before and after adjustment and each energy', xyz_CldFrac(i,j,k)
   400: ||||       !!$              write( 6, * ) &
   401: ||||       !!$                & (     CpDry*TempBefAdj          + LatentHeat*QVapBefAdj              &
   402: ||||       !!$                &   - ( CpDry*xyz_TempCldy(i,j,k) + LatentHeat*xyz_QVapCldy(i,j,k) ) ) &
   403: ||||       !!$                & /(    CpDry*TempBefAdj          + LatentHeat*QVapBefAdj ),           &
   404: ||||       !!$                &     CpDry*TempBefAdj          + LatentHeat*QVapBefAdj,               &
   405: ||||       !!$                &   ( CpDry*xyz_TempCldy(i,j,k) + LatentHeat*xyz_QVapCldy(i,j,k) )
   406: ||||                     !=========
   407: ||||       
   408: ||||       
   409: ||||                   end if
   410: ||||       
   411: |||V---              end do
   412: ||+----            end do
   413: |+-----          end do
   414: |          
   415: +------        end do
   416:            
   417:                ! Calculation of temperature and specific humidity averaged over a grid
   418:                !
   419: **V---->       xyz_Temp = xyz_CldFrac * xyz_TempCldy + ( 1.0_DP - xyz_CldFrac ) * xyz_TempCler
   420: |||            xyz_QVap = xyz_CldFrac * xyz_QVapCldy + ( 1.0_DP - xyz_CldFrac ) * xyz_QVapCler
   421: |||        
   422: |||        
   423: |||            ! 漾ѲΨ, ѲΨ, ߿̤λ
   424: |||            ! Calculate specific humidity tendency, temperature tendency, 
   425: |||            ! precipitation
   426: |||            !
   427: |||            xyz_DQVapDtLsc = ( xyz_QVap - xyz_QVapB ) / ( 2.0_DP * DelTime )
   428: |||            xyz_DTempDtLsc = ( xyz_Temp - xyz_TempB ) / ( 2.0_DP * DelTime )
   429: |||        
   430: |||            xyz_DTempDt = xyz_DTempDt + xyz_DTempDtLsc
   431: |||            xyz_DQVapDt = xyz_DQVapDt + xyz_DQVapDtLsc
   432: |||        
   433: |||        
   434: |||        !!$    xy_RainLsc     = 0.0d0
   435: |||        !!$    do k = kmax, 1, -1
   436: |||        !!$      xy_RainLsc = xy_RainLsc                                     &
   437: |||        !!$        & + ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav      &
   438: |||        !!$        & * ( xyz_QVapB(:,:,k  ) - xyz_QVap (:,:,k) )
   439: |||        !!$    end do
   440: |||        !!$    xy_RainLsc = xy_RainLsc / ( 2.0_DP * DelTime )
   441: |||        
   442: |||        
   443: |||        !!$    i = 0
   444: |||        !!$    j = jmax/2+1
   445: |||        !!$    write( 6, * ) xy_RainLsc(i,j)
   446: |||        
   447: |||        
   448: |||        !!$    xyz_DQH2OLiqDt = - xyz_DQVapDtLsc
   449: |||        !!$    xy_RainLsc     = 0.0d0
   450: |||        !!$    do k = kmax, 1, -1
   451: |||        !!$      xy_RainLsc = xy_RainLsc                                     &
   452: |||        !!$        & + xyz_DQH2OLiqDt(:,:,k) * ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav
   453: |||        !!$    end do
   454: |||        
   455: |||        !!$    i = 0
   456: |||        !!$    j = jmax/2+1
   457: |||        !!$    write( 6, * ) xy_RainLsc(i,j)
   458: |||        !!$    write( 6, * ) '---'
   459: |||        
   460: |||        !!$    xy_Rain     = xy_Rain     + xy_RainLsc
   461: |||        
   462: |||        
   463: **V----        xyz_DQH2OLiqDt = - xyz_DQVapDtLsc
   464:            
   465:            
   466:                ! calculation for output
   467: +V=====        xy_RainLsc     = 0.0d0
   468: +------>       do k = kmax, 1, -1
   469: |+V====          xy_RainLsc = xy_RainLsc                                     &
   470: |                  & + xyz_DQH2OLiqDt(:,:,k) * ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav
   471: +------        end do
   472:            
   473:                ! ҥȥǡ
   474:                ! History data output
   475:                !
   476: +V=====        call HistoryAutoPut( TimeN, 'RainLsc',    xy_RainLsc * LatentHeat )
   477:                call HistoryAutoPut( TimeN, 'DTempDtLsc', xyz_DTempDtLsc )
   478:                call HistoryAutoPut( TimeN, 'DQVapDtLsc', xyz_DQVapDtLsc )
   479:            
   480:            
   481:            
   482:                ! ׻ַ¬
   483:                ! Pause measurement of computation time
   484:                !
   485:                call TimesetClockStop( module_name )
   486:            
   487:              end subroutine LScaleCondLL91
   488:            
   489:              !--------------------------------------------------------------------------------------
   490:            
   491:              subroutine LScaleCondLL91Init
   492:                !
   493:                ! lscond ⥸塼νԤޤ. 
   494:                ! NAMELIST#lscond_nml ɤ߹ߤϤμ³ǹԤޤ. 
   495:                !
   496:                ! "lscond" module is initialized. 
   497:                ! "NAMELIST#lscond_nml" is loaded in this procedure. 
   498:                !
   499:            
   500:                ! ⥸塼 ; USE statements
   501:                !
   502:            
   503:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   504:                ! Utilities for NAMELIST file input
   505:                !
   506:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   507:            
   508:                ! ե
   509:                ! File I/O support
   510:                !
   511:                use dc_iounit, only: FileOpen
   512:            
   513:                ! ̷ѥ᥿
   514:                ! Kind type parameter
   515:                !
   516:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   517:            
   518:                ! ʸ
   519:                ! Character handling
   520:                !
   521:                use dc_string, only: StoA
   522:            
   523:                ! ҥȥǡ
   524:                ! History data output
   525:                !
   526:                use gtool_historyauto, only: HistoryAutoAddVariable
   527:            
   528:                ! ʸ ; Declaration statements
   529:                !
   530:                implicit none
   531:            
   532:                integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   533:                                          ! Unit number for NAMELIST file open
   534:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   535:                                          ! IOSTAT of NAMELIST read
   536:            
   537:                ! NAMELIST ѿ
   538:                ! NAMELIST group name
   539:                !
   540:                namelist /lscond_nml/ &
   541:            !!$      & CrtlRH, ItrtMax, FlagUse
   542:                  & Gamma, ItrtMax !, FlagUse
   543:                      !
   544:                      ! ǥեͤˤĤƤϽ³ "lscond#LSCondInit" 
   545:                      ! Υɤ򻲾ȤΤ. 
   546:                      !
   547:                      ! Refer to source codes in the initialization procedure
   548:                      ! "lscond#LSCondInit" for the default values. 
   549:                      !
   550:            
   551:                ! ¹ʸ ; Executable statement
   552:                !
   553:            
   554:                if ( lscond_LL91_inited ) return
   555:            
   556:            
   557:                ! ǥեͤ
   558:                ! Default values settings
   559:                !
   560:            !!$    CrtlRH  = 1.0_DP
   561:                Gamma   = 0.2_DP
   562:                !  This value is from Le Treut and Li (1991). 
   563:                ItrtMax = 3
   564:            !!$    FlagUse = .true.
   565:            
   566:                ! NAMELIST ɤ߹
   567:                ! NAMELIST is input
   568:                !
   569:                if ( trim(namelist_filename) /= '' ) then
   570:                  call FileOpen( unit_nml, &          ! (out)
   571:                    & namelist_filename, mode = 'r' ) ! (in)
   572:            
   573:                  rewind( unit_nml )
   574:                  read( unit_nml, &         ! (in)
   575:                    & nml = lscond_nml, &   ! (out)
   576:                    & iostat = iostat_nml ) ! (out)
   577:                  close( unit_nml )
   578:            
   579:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   580:                  if ( iostat_nml == 0 ) write( STDOUT, nml = lscond_nml )
   581:                end if
   582:            
   583:                ! ҥȥǡϤΤΤؤѿϿ
   584:                ! Register of variables for history data output
   585:                !
   586:                call HistoryAutoAddVariable( 'RainLsc', &
   587:                  & (/ 'lon ', 'lat ', 'time' /), &
   588:                  & 'precipitation by large scale condensation', 'W m-2' )
   589:                call HistoryAutoAddVariable( 'DTempDtLsc', &
   590:                  & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
   591:                  & 'large-scale condensation heating', 'K s-1' )
   592:                call HistoryAutoAddVariable( 'DQVapDtLsc', &
   593:                  & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
   594:                  & 'large-scale condensation moistening', 'kg kg-1 s-1' )
   595:            
   596:                !  ; Print
   597:                !
   598:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   599:            !!$    call MessageNotify( 'M', module_name, '  FlagUse = %b', l = (/ FlagUse /) )
   600:            !!$    call MessageNotify( 'M', module_name, '  CrtlRH  = %f', d = (/ CrtlRH /) )
   601:                call MessageNotify( 'M', module_name, '  Gamma   = %f', d = (/ Gamma /) )
   602:                call MessageNotify( 'M', module_name, '  ItrtMax = %d', i = (/ ItrtMax /) )
   603:                call MessageNotify( 'M', module_name, '' )
   604:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   605:            
   606:                lscond_LL91_inited = .true.
   607:            
   608:              end subroutine LScaleCondLL91Init
   609:            
   610:              !--------------------------------------------------------------------------------------
   611:            
   612:            end module lscond_LL91
