Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:52:56 2012
FILE NAME: sst_data.f90
PROGRAM NAME: sst_data
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ɽ̥ǡץ
     2  !
     3  != dcpam main program for generation of surface data
     4  !
     5  ! Authors::   Yasuhiro Morikawa, Yoshiyuki O. Takahashi
     6  ! Version::   $Id: sst_data.f90,v 1.6 2012-09-17 10:59:31 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  program sst_data
    13    !
    14    ! <b>Note that Japanese and English are described in parallel.</b>
    15    !
    16    ! ɽ̥ǡեޤ.
    17    !
    18    ! Surface data file is created.
    19    !
    20  
    21    ! ⥸塼 ; USE statements
    22    !
    23  
    24    ! ɽ̥ǡ
    25    ! Prepare surface data
    26    !
    27    use surface_data, only: SetSurfData
    28  
    29    ! ɽ̲٥ꥹȥǡ
    30    ! Restart data of surface temperature input/output
    31    !
    32    use restart_surftemp_io, only: RestartSurfTempOutput
    33  
    34    ! ̷ѥ᥿
    35    ! Kind type parameter
    36    !
    37    use dc_types, only: DP, &      ! ټ¿. Double precision.
    38      &                 STRING, &  ! ʸ.       Strings.
    39      &                 TOKEN      ! .   Keywords.
    40  
    41    ! ʸ ; Declaration statements
    42    !
    43    implicit none
    44  
    45    ! ѿ
    46    ! Variables
    47    !
    48    real(DP), allocatable:: xy_SurfTemp (:,:)
    49                                ! ɽ̲.
    50                                ! Surface temperature
    51  
    52    ! ѿ
    53    ! Work variables
    54    !
    55  
    56    ! ¹ʸ ; Executable statement
    57    !
    58  
    59    ! ץν (֥롼)
    60    ! Initialization for the main program (Internal subroutine)
    61    !
    62    call MainInit
    63  
    64    ! ɽ̥ǡκ
    65    ! Generate surface data
    66    !
    67    call SetSurfData( xy_SurfTemp = xy_SurfTemp )  ! (out) optional
    68  
    69    ! ɽ̲٥ꥹȥǡ
    70    ! Restart data of surface temperature output
    71    !
    72    call RestartSurfTempOutput( &
    73      & xy_SurfTemp  )             ! (in)
    74  
    75    ! ץνλ (֥롼)
    76    ! Termination for the main program (Internal subroutine)
    77    !
    78    call MainTerminate
    79  
    80  contains
    81  
    82    !-------------------------------------------------------------------
    83  
    84    subroutine MainInit
    85      !
    86      ! ץν³.
    87      !
    88      ! Initialization procedure for the main program.
    89      !
    90  
    91      ! MPI
    92      !
    93      use mpi_wrapper, only : MPIWrapperInit
    94  
    95      use dc_message, only: MessageNotify
    96  
    97      ! ޥɥ饤
    98      ! Command line option parser
    99      !
   100      use option_parser, only: OptParseInit
   101  
   102      ! NAMELIST եϤ˴ؤ桼ƥƥ
   103      ! Utilities for NAMELIST file input
   104      !
   105      use namelist_util, only: NmlutilInit
   106  
   107      ! 
   108      ! Time control
   109      !
   110      use timeset, only: TimesetInit
   111                                ! ƥå $ t $ λ. Time of step $ t $.
   112  
   113      ! ϥեδܾ
   114      ! Management basic information for output files
   115      !
   116      use fileset, only: FilesetInit
   117  
   118      ! ʻ
   119      ! Grid points settings
   120      !
   121      use gridset, only: GridsetInit, &
   122        &                imax, & ! ٳʻ.
   123                                 ! Number of grid points in longitude
   124        &                jmax    ! ٳʻ.
   125                                 ! Number of grid points in latitude
   126  
   127      ! ʪ
   128      ! Physical constants settings
   129      !
   130      use constants, only: ConstantsInit
   131  
   132      ! ɸǡ
   133      ! Axes data settings
   134      !
   135      use axesset, only: AxessetInit
   136  
   137      ! ɽ̲٥ꥹȥǡ
   138      ! Restart data of surface temperature input/output
   139      !
   140      use restart_surftemp_io, only: RestartSurfTempInit, RestartSurfTempOpen, RestartSurfTempGet
   141  
   142      ! ɽ̥ǡ
   143      ! Prepare surface data
   144      !
   145      use surface_data, only : SurfDataInit
   146  
   147  
   148      ! ʸ ; Declaration statements
   149      !
   150      implicit none
   151      character(*), parameter:: prog_name = 'sst_data'
   152                                ! ץ̾.
   153                                ! Main program name
   154      character(*), parameter:: version = &
   155        & '$Name: dcpam5-20120921 $' // &
   156        & '$Id: sst_data.f90,v 1.6 2012-09-17 10:59:31 yot Exp $'
   157                                ! ץΥС
   158                                ! Main program version
   159      character(STRING)      :: namelist_filename
   160                                ! NAMELIST ե̾.
   161                                ! NAMELIST file name
   162  
   163      character(STRING):: brief
   164                                ! ¹ԥեδʷ
   165                                ! Brief account of executable file
   166  
   167      ! ¹ʸ ; Executable statement
   168      !
   169  
   170      ! Initialize MPI
   171      !
   172      call MPIWrapperInit
   173  
   174      brief = 'SST data generation'
   175      call MessageNotify( 'M', prog_name, 'Run: %c', c1 = trim(brief) )
   176      call MessageNotify( 'M', prog_name, '-- version = %c', c1 = trim(version) )
   177  
   178      ! ޥɥ饤
   179      ! Command line option parser
   180      !
   181      call OptParseInit(       &
   182        & namelist_filename,   & ! (out)
   183        & prog_name,           & ! (in )
   184        & brief                & ! (in )
   185        & )
   186  
   187      ! NAMELIST ե̾
   188      ! Input NAMELIST file name
   189      !
   190      call NmlutilInit( &
   191        & namelist_filename  & ! (in)
   192        & )
   193  
   194      ! 
   195      ! Time control
   196      !
   197      call TimesetInit
   198  
   199      ! ϥեδܾ
   200      ! Management basic information for output files
   201      !
   202      call FilesetInit
   203  
   204      ! ʻ
   205      ! Grid points settings
   206      !
   207      call GridsetInit
   208  
   209      ! ʪ
   210      ! Physical constants settings
   211      !
   212      call ConstantsInit
   213  
   214      ! ɸǡ
   215      ! Axes data settings
   216      !
   217      call AxessetInit
   218  
   219      ! ɽ̥ǡ
   220      ! Prepare surface data
   221      !
   222      call SurfDataInit
   223  
   224      ! ɽ̲ѿγ
   225      ! Allocation of a variable of surface temperature
   226      !
   227      allocate( xy_SurfTemp (0:imax-1, 1:jmax) )
   228  
   229      ! ɽ̲٥ꥹȥǡեν
   230      ! Initialization of restart data file of surface temperature
   231      !
   232      call RestartSurfTempInit
   233      call RestartSurfTempOpen( flag_init_data = .true. ) ! (in) optional
   234  
   235    end subroutine MainInit
   236  
   237    !-------------------------------------------------------------------
   238  
   239    subroutine MainTerminate
   240      !
   241      ! ץνλ³.
   242      !
   243      ! Termination procedure for the main program.
   244      !
   245  
   246      ! MPI
   247      !
   248      use mpi_wrapper, only : MPIWrapperFinalize
   249  
   250      ! 
   251      ! Time control
   252      !
   253      use timeset, only: TimesetClose
   254  
   255      ! ɽ̲٥ꥹȥǡ
   256      ! Restart data of surface temperature input/output
   257      !
   258      use restart_surftemp_io, only: RestartSurfTempClose
   259  
   260      ! ҥȥǡ
   261      ! History data output
   262      !
   263      use history_file_io, only: HistoryFileClose
   264  
   265      ! ʸ ; Declaration statements
   266      !
   267      implicit none
   268  
   269      ! ¹ʸ ; Executable statement
   270      !
   271  
   272      ! ɽ̲٥ꥹȥǡե륯
   273      ! Close restart data file of surface temperature
   274      !
   275      call RestartSurfTempClose
   276  
   277      ! λ
   278      ! Termination of time control
   279      !
   280      call TimesetClose
   281  
   282      ! ɽ̲ѿγղ
   283      ! Deallocation of a variable of surface temperature
   284      !
   285      deallocate( xy_SurfTemp )
   286  
   287      ! Finalize MPI
   288      !
   289      call MPIWrapperFinalize
   290  
   291    end subroutine MainTerminate
   292  
   293  end program sst_data
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:52:56 2012
FILE NAME: sst_data.f90
PROGRAM NAME: sst_data
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ɽ̥ǡץ
     2:            !
     3:            != dcpam main program for generation of surface data
     4:            !
     5:            ! Authors::   Yasuhiro Morikawa, Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: sst_data.f90,v 1.6 2012-09-17 10:59:31 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            program sst_data
    13:              !
    14:              ! <b>Note that Japanese and English are described in parallel.</b>
    15:              !
    16:              ! ɽ̥ǡեޤ. 
    17:              !
    18:              ! Surface data file is created. 
    19:              !
    20:            
    21:              ! ⥸塼 ; USE statements
    22:              !
    23:            
    24:              ! ɽ̥ǡ
    25:              ! Prepare surface data
    26:              !
    27:              use surface_data, only: SetSurfData
    28:            
    29:              ! ɽ̲٥ꥹȥǡ
    30:              ! Restart data of surface temperature input/output
    31:              !
    32:              use restart_surftemp_io, only: RestartSurfTempOutput
    33:            
    34:              ! ̷ѥ᥿
    35:              ! Kind type parameter
    36:              !
    37:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    38:                &                 STRING, &  ! ʸ.       Strings. 
    39:                &                 TOKEN      ! .   Keywords. 
    40:            
    41:              ! ʸ ; Declaration statements
    42:              !
    43:              implicit none
    44:            
    45:              ! ѿ
    46:              ! Variables
    47:              !
    48:              real(DP), allocatable:: xy_SurfTemp (:,:)
    49:                                          ! ɽ̲. 
    50:                                          ! Surface temperature
    51:            
    52:              ! ѿ
    53:              ! Work variables
    54:              !
    55:            
    56:              ! ¹ʸ ; Executable statement
    57:              !
    58:            
    59:              ! ץν (֥롼)
    60:              ! Initialization for the main program (Internal subroutine)
    61:              !
    62:              call MainInit
    63:            
    64:              ! ɽ̥ǡκ
    65:              ! Generate surface data
    66:              !
    67:              call SetSurfData( xy_SurfTemp = xy_SurfTemp )  ! (out) optional
    68:            
    69:              ! ɽ̲٥ꥹȥǡ
    70:              ! Restart data of surface temperature output
    71:              !
    72:              call RestartSurfTempOutput( &
    73:                & xy_SurfTemp  )             ! (in)
    74:            
    75:              ! ץνλ (֥롼)
    76:              ! Termination for the main program (Internal subroutine)
    77:              !
    78:              call MainTerminate
    79:            
    80:            contains
    81:            
    82:              !-------------------------------------------------------------------
    83:            
    84:              subroutine MainInit
    85:                !
    86:                ! ץν³. 
    87:                !
    88:                ! Initialization procedure for the main program. 
    89:                !
    90:            
    91:                ! MPI
    92:                !
    93:                use mpi_wrapper, only : MPIWrapperInit
    94:            
    95:                use dc_message, only: MessageNotify
    96:            
    97:                ! ޥɥ饤
    98:                ! Command line option parser
    99:                !
   100:                use option_parser, only: OptParseInit
   101:            
   102:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   103:                ! Utilities for NAMELIST file input
   104:                !
   105:                use namelist_util, only: NmlutilInit
   106:            
   107:                ! 
   108:                ! Time control
   109:                !
   110:                use timeset, only: TimesetInit
   111:                                          ! ƥå $ t $ λ. Time of step $ t $. 
   112:            
   113:                ! ϥեδܾ
   114:                ! Management basic information for output files
   115:                ! 
   116:                use fileset, only: FilesetInit
   117:            
   118:                ! ʻ
   119:                ! Grid points settings
   120:                !
   121:                use gridset, only: GridsetInit, &
   122:                  &                imax, & ! ٳʻ. 
   123:                                           ! Number of grid points in longitude
   124:                  &                jmax    ! ٳʻ. 
   125:                                           ! Number of grid points in latitude
   126:            
   127:                ! ʪ
   128:                ! Physical constants settings
   129:                !
   130:                use constants, only: ConstantsInit
   131:            
   132:                ! ɸǡ
   133:                ! Axes data settings
   134:                !
   135:                use axesset, only: AxessetInit
   136:            
   137:                ! ɽ̲٥ꥹȥǡ
   138:                ! Restart data of surface temperature input/output
   139:                !
   140:                use restart_surftemp_io, only: RestartSurfTempInit, RestartSurfTempOpen, RestartSurfTempGet
   141:            
   142:                ! ɽ̥ǡ
   143:                ! Prepare surface data
   144:                !
   145:                use surface_data, only : SurfDataInit
   146:            
   147:            
   148:                ! ʸ ; Declaration statements
   149:                !
   150:                implicit none
   151:                character(*), parameter:: prog_name = 'sst_data'
   152:                                          ! ץ̾. 
   153:                                          ! Main program name
   154:                character(*), parameter:: version = &
   155:                  & '$Name: dcpam5-20120921 $' // &
   156:                  & '$Id: sst_data.f90,v 1.6 2012-09-17 10:59:31 yot Exp $'
   157:                                          ! ץΥС
   158:                                          ! Main program version
   159:                character(STRING)      :: namelist_filename
   160:                                          ! NAMELIST ե̾. 
   161:                                          ! NAMELIST file name
   162:            
   163:                character(STRING):: brief
   164:                                          ! ¹ԥեδʷ
   165:                                          ! Brief account of executable file
   166:            
   167:                ! ¹ʸ ; Executable statement
   168:                !
   169:            
   170:                ! Initialize MPI
   171:                !
   172:                call MPIWrapperInit
   173:            
   174:                brief = 'SST data generation'
   175:                call MessageNotify( 'M', prog_name, 'Run: %c', c1 = trim(brief) )
   176:                call MessageNotify( 'M', prog_name, '-- version = %c', c1 = trim(version) )
   177:            
   178:                ! ޥɥ饤
   179:                ! Command line option parser
   180:                !
   181:                call OptParseInit(       &
   182:                  & namelist_filename,   & ! (out)
   183:                  & prog_name,           & ! (in )
   184:                  & brief                & ! (in )
   185:                  & )
   186:            
   187:                ! NAMELIST ե̾
   188:                ! Input NAMELIST file name
   189:                !
   190:                call NmlutilInit( &
   191:                  & namelist_filename  & ! (in)
   192:                  & )
   193:            
   194:                ! 
   195:                ! Time control
   196:                !
   197:                call TimesetInit
   198:            
   199:                ! ϥեδܾ
   200:                ! Management basic information for output files
   201:                ! 
   202:                call FilesetInit
   203:            
   204:                ! ʻ
   205:                ! Grid points settings
   206:                !
   207:                call GridsetInit
   208:            
   209:                ! ʪ
   210:                ! Physical constants settings
   211:                !
   212:                call ConstantsInit
   213:            
   214:                ! ɸǡ
   215:                ! Axes data settings
   216:                !
   217:                call AxessetInit
   218:            
   219:                ! ɽ̥ǡ
   220:                ! Prepare surface data
   221:                !
   222:                call SurfDataInit
   223:            
   224:                ! ɽ̲ѿγ
   225:                ! Allocation of a variable of surface temperature
   226:                !
   227:                allocate( xy_SurfTemp (0:imax-1, 1:jmax) )
   228:            
   229:                ! ɽ̲٥ꥹȥǡեν
   230:                ! Initialization of restart data file of surface temperature
   231:                !
   232:                call RestartSurfTempInit
   233:                call RestartSurfTempOpen( flag_init_data = .true. ) ! (in) optional
   234:            
   235:              end subroutine MainInit
   236:            
   237:              !-------------------------------------------------------------------
   238:            
   239:              subroutine MainTerminate
   240:                !
   241:                ! ץνλ³. 
   242:                !
   243:                ! Termination procedure for the main program. 
   244:                !
   245:            
   246:                ! MPI
   247:                !
   248:                use mpi_wrapper, only : MPIWrapperFinalize
   249:            
   250:                ! 
   251:                ! Time control
   252:                !
   253:                use timeset, only: TimesetClose
   254:            
   255:                ! ɽ̲٥ꥹȥǡ
   256:                ! Restart data of surface temperature input/output
   257:                !
   258:                use restart_surftemp_io, only: RestartSurfTempClose
   259:            
   260:                ! ҥȥǡ
   261:                ! History data output
   262:                !
   263:                use history_file_io, only: HistoryFileClose
   264:            
   265:                ! ʸ ; Declaration statements
   266:                !
   267:                implicit none
   268:            
   269:                ! ¹ʸ ; Executable statement
   270:                !
   271:            
   272:                ! ɽ̲٥ꥹȥǡե륯
   273:                ! Close restart data file of surface temperature
   274:                !
   275:                call RestartSurfTempClose
   276:            
   277:                ! λ
   278:                ! Termination of time control
   279:                !
   280:                call TimesetClose
   281:            
   282:                ! ɽ̲ѿγղ
   283:                ! Deallocation of a variable of surface temperature
   284:                !
   285:                deallocate( xy_SurfTemp )
   286:            
   287:                ! Finalize MPI
   288:                !
   289:                call MPIWrapperFinalize
   290:            
   291:              end subroutine MainTerminate
   292:            
   293:            end program sst_data
