Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:31 2012
FILE NAME: set_1d_profile.f90
PROGRAM NAME: set_1d_profile
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   145  vec  (   4): Vectorized array expression.
   152  opt  (1593): Loop nest collapsed into one loop.
   152  vec  (   4): Vectorized array expression.
   181  opt  (1593): Loop nest collapsed into one loop.
   181  vec  (   4): Vectorized array expression.
   207  opt  (1593): Loop nest collapsed into one loop.
   207  vec  (   4): Vectorized array expression.
   238  vec  (   4): Vectorized array expression.
   246  opt  (1593): Loop nest collapsed into one loop.
   246  vec  (   4): Vectorized array expression.
   317  vec  (   1): Vectorized loop.
   318  opt  (1084): Branch out of the loop inhibits optimization.
   318  vec  (  26): Macro operation Search.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:31 2012
FILE NAME: set_1d_profile.f90
PROGRAM NAME: set_1d_profile
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ե뤫 1 ץեɤꤹ.
     2  !
     3  != read 1-D profile from a file and set it
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: set_1d_profile.f90,v 1.4 2011-07-16 19:52:49 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module set_1d_profile
    13  
    14    !
    15    != ե뤫 1 ץեɤꤹ.
    16    !
    17    != read 1-D profile from a file and set it
    18    !
    19    ! <b>Note that Japanese and English are described in parallel.</b>
    20    !
    21  
    22    !== References
    23    !
    24  !!$  !  Chou, M.-D.,
    25  !!$  !    Atmospheric solar heating rate in the water vapor bands,
    26  !!$  !    J. Climate Appl. Meteor., 25, 1532-1542, 1986.
    27    !
    28    !== Procedures List
    29    !
    30  !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    31  !!$  ! RadiationDTempDt        :: ͥեåˤ벹Ѳη׻
    32  !!$  ! RadiationFluxOutput     :: ͥեåν
    33  !!$  ! RadiationFinalize       :: λ (⥸塼ѿγդ)
    34  !!$  ! ------------            :: ------------
    35  !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    36  !!$  ! RadiationDTempDt        :: Calculate temperature tendency with radiation flux
    37  !!$  ! RadiationFluxOutput     :: Output radiation fluxes
    38  !!$  ! RadiationFinalize       :: Termination (deallocate variables in this module)
    39    !
    40    !== NAMELIST
    41    !
    42    ! NAMELIST#set_1d_profile_nml
    43    !
    44  
    45    ! USE statements
    46    !
    47  
    48    !
    49    ! Kind type parameter
    50    !
    51    use dc_types, only: DP, &      ! Double precision.
    52      &                 STRING, &  ! Strings.
    53      &                 TOKEN      ! Keywords.
    54  
    55    ! å
    56    ! Message output
    57    !
    58    use dc_message, only: MessageNotify
    59  
    60    ! ʻ
    61    ! Grid points settings
    62    !
    63    use gridset, only: imax, & ! ٳʻ.
    64                               ! Number of grid points in longitude
    65      &                jmax, & ! ٳʻ.
    66                               ! Number of grid points in latitude
    67      &                kmax    ! ľؿ.
    68                               ! Number of vertical level
    69  
    70    implicit none
    71  
    72    private
    73  
    74  
    75    character(len=STRING), save :: InFileName
    76  
    77    integer              , save :: Inkmax
    78    real(DP), allocatable, save :: a_InPress(:)
    79    real(DP), allocatable, save :: a_InTemp (:)
    80    real(DP), allocatable, save :: a_InQH2O (:)
    81    real(DP), allocatable, save :: a_InQO3  (:)
    82  
    83  
    84    ! ѿ
    85    ! Public variables
    86    !
    87    logical, save :: set_1d_profile_inited = .false.
    88                                ! ե饰.
    89                                ! Initialization flag
    90  
    91    public :: Set1DProfileAtm
    92    public :: Set1DProfilePs
    93    public :: Set1DProfileSurfTemp
    94    public :: Set1DProfileO3
    95    public :: Set1DProfileInit
    96  
    97    character(*), parameter:: module_name = 'set_1d_profile'
    98                                ! ⥸塼̾.
    99                                ! Module name
   100    character(*), parameter:: version = &
   101      & '$Name: dcpam5-20120921 $' // &
   102      & '$Id: set_1d_profile.f90,v 1.4 2011-07-16 19:52:49 yot Exp $'
   103                                ! ⥸塼ΥС
   104                                ! Module version
   105  
   106  
   107    !--------------------------------------------------------------------------------------
   108  
   109  contains
   110  
   111    !--------------------------------------------------------------------------------------
   112  
   113    subroutine Set1DProfileAtm(      &
   114      & xyz_Press,                   &
   115      & xyz_Temp, xyz_QVap           &
   116      & )
   117  
   118      real(DP), intent(in ) :: xyz_Press(0:imax-1,1:jmax,1:kmax)
   119      real(DP), intent(out) :: xyz_Temp (0:imax-1,1:jmax,1:kmax)
   120      real(DP), intent(out) :: xyz_QVap (0:imax-1,1:jmax,1:kmax)
   121  
   122  
   123      !
   124      ! local variables
   125      !
   126      real(DP), allocatable :: a_InLogQH2O(:)
   127  
   128  
   129      ! ǧ
   130      ! Initialization check
   131      !
   132      if ( .not. set_1d_profile_inited ) then
   133        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   134      end if
   135  
   136  
   137      call Set1DProfileInterpolate(       &
   138        & Inkmax, a_InPress, a_InTemp,    &
   139        & xyz_Press,                      &
   140        & xyz_Temp                        &
   141        & )
   142  
   143  
   144      allocate( a_InLogQH2O( Inkmax ) )
   145      a_InLogQH2O = log( a_InQH2O )
   146  
   147      call Set1DProfileInterpolate(       &
   148        & Inkmax, a_InPress, a_InLogQH2O, &
   149        & xyz_Press,                      &
   150        & xyz_QVap                        &
   151        & )
   152      xyz_QVap(:,:,:) = exp( xyz_QVap(:,:,:) )
     .  !CDIR    NODEP                                                          
     .  !CDIR NOASSUME                                                          
     .        do t96 = 1, kmax*jmax*imax                                        
     .           xyz_qvap(t96-1,1,1) = dexp(xyz_qvap(t96-1,1,1))                
     .        end do                                                            
   153  
   154      deallocate( a_InLogQH2O )
   155  
   156  
   157  
   158    end subroutine Set1DProfileAtm
   159  
   160    !--------------------------------------------------------------------------------------
   161  
   162    subroutine Set1DProfilePs( &
   163      & xy_Ps &
   164      & )
   165  
   166      real(DP), intent(out) :: xy_Ps(0:imax-1,1:jmax)
   167  
   168  
   169      !
   170      ! local variables
   171      !
   172  
   173      ! ǧ
   174      ! Initialization check
   175      !
   176      if ( .not. set_1d_profile_inited ) then
   177        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   178      end if
   179  
   180  
   181      xy_Ps = a_InPress(1)
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t27 = 1, jmax*imax                                             
     .           xy_ps(t27-1,1) = a_inpress(1)                                  
     .        end do                                                            
   182  
   183  
   184    end subroutine Set1DProfilePs
   185  
   186    !--------------------------------------------------------------------------------------
   187  
   188    subroutine Set1DProfileSurfTemp( &
   189      & xy_SurfTemp &
   190      & )
   191  
   192      real(DP), intent(out) :: xy_SurfTemp(0:imax-1,1:jmax)
   193  
   194  
   195      !
   196      ! local variables
   197      !
   198  
   199      ! ǧ
   200      ! Initialization check
   201      !
   202      if ( .not. set_1d_profile_inited ) then
   203        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   204      end if
   205  
   206  
   207      xy_SurfTemp = a_InTemp(1)
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t27 = 1, jmax*imax                                             
     .           xy_surftemp(t27-1,1) = a_intemp(1)                             
     .        end do                                                            
   208  
   209  
   210    end subroutine Set1DProfileSurfTemp
   211  
   212    !--------------------------------------------------------------------------------------
   213  
   214    subroutine Set1DProfileO3( &
   215      & xyz_Press,             & ! (in )
   216      & xyz_QO3                & ! (out)
   217      & )
   218  
   219      real(DP), intent(in ) :: xyz_Press(0:imax-1,1:jmax,1:kmax)
   220      real(DP), intent(out) :: xyz_QO3  (0:imax-1,1:jmax,1:kmax)
   221  
   222  
   223      !
   224      ! local variables
   225      !
   226      real(DP), allocatable :: a_InLogQO3(:)
   227  
   228  
   229      ! ǧ
   230      ! Initialization check
   231      !
   232      if ( .not. set_1d_profile_inited ) then
   233        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   234      end if
   235  
   236  
   237      allocate( a_InLogQO3( Inkmax ) )
   238      a_InLogQO3 = log( a_InQO3 )
   239  
   240      call Set1DProfileInterpolate(       &
   241        & Inkmax, a_InPress, a_InLogQO3,  &
   242        & xyz_Press,                      &
   243        & xyz_QO3                         &
   244        & )
   245  
   246      xyz_QO3(:,:,:) = exp( xyz_QO3(:,:,:) )
     .  !CDIR    NODEP                                                          
     .  !CDIR NOASSUME                                                          
     .        do t73 = 1, kmax*jmax*imax                                        
     .           xyz_qo3(t73-1,1,1) = dexp(xyz_qo3(t73-1,1,1))                  
     .        end do                                                            
   247  
   248      deallocate( a_InLogQO3 )
   249  
   250  
   251    end subroutine Set1DProfileO3
   252  
   253    !--------------------------------------------------------------------------------------
   254  
   255    subroutine Set1DProfileInterpolate( &
   256      & NLev, a_Press, a_Array,         &
   257      & xyz_Press,                      &
   258      & xyz_Array                       &
   259      & )
   260  
   261      integer , intent(in ) :: NLev
   262      real(DP), intent(in ) :: a_Press  (1:NLev)
   263      real(DP), intent(in ) :: a_Array  (1:NLev)
   264      real(DP), intent(in ) :: xyz_Press(0:imax-1,1:jmax,1:kmax)
   265      real(DP), intent(out) :: xyz_Array(0:imax-1,1:jmax,1:kmax)
   266  
   267  
   268      !
   269      ! local variables
   270      !
   271      integer :: i
   272      integer :: j
   273      integer :: k
   274      integer :: kk
   275  
   276  
   277      ! ǧ
   278      ! Initialization check
   279      !
   280      if ( .not. set_1d_profile_inited ) then
   281        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   282      end if
   283  
   284  
   285      ! Old code to be deleted
   286  
   287  !!$    do k = 1, kmax
   288  !!$      if( xyz_Press(0,1,k) <= a_Press(NLev) ) then
   289  !!$        xyz_Array(0,1,k) = a_Array(NLev)
   290  !!$      else
   291  !!$        search_loop : do kk = 2, Inkmax
   292  !!$          if( a_Press( kk ) < xyz_Press(0,1,k) ) exit search_loop
   293  !!$        end do search_loop
   294  !!$        if( kk > NLev ) &
   295  !!$          stop 'Unexpected error in setting temperature profile'
   296  !!$        xyz_Array(0,1,k) =                                  &
   297  !!$          &   ( a_Array( kk ) - a_Array( kk-1 ) )           &
   298  !!$          & / ( log( a_Press( kk )    / a_Press( kk-1 ) ) ) &
   299  !!$          & * ( log( xyz_Press(0,1,k) / a_Press( kk-1 ) ) ) &
   300  !!$          & + a_Array( kk-1 )
   301  !!$      end if
   302  !!$    end do
   303  !!$
   304  !!$    do k = 1, kmax
   305  !!$      xyz_Array(:,:,k) = xyz_Array(0,1,k)
   306  !!$    end do
   307  
   308  
   309  
   310      do k = 1, kmax
   311        do j = 1, jmax
   312          do i = 0, imax-1
   313  
   314            if( xyz_Press(i,j,k) <= a_Press(NLev) ) then
   315              xyz_Array(i,j,k) = a_Array(NLev)
   316            else
   317              search_loop : do kk = 2, Inkmax
   318                if( a_Press( kk ) < xyz_Press(i,j,k) ) exit search_loop
   319              end do search_loop
   320              if( kk > NLev ) &
   321                stop 'Unexpected error in setting temperature profile'
   322              xyz_Array(i,j,k) =                                  &
   323                &   ( a_Array( kk ) - a_Array( kk-1 ) )           &
   324                & / ( log( a_Press( kk )    / a_Press( kk-1 ) ) ) &
   325                & * ( log( xyz_Press(i,j,k) / a_Press( kk-1 ) ) ) &
   326                & + a_Array( kk-1 )
   327            end if
   328  
   329          end do
   330        end do
   331      end do
   332  
   333  
   334    end subroutine Set1DProfileInterpolate
   335  
   336    !--------------------------------------------------------------------------------------
   337  
   338    subroutine Set1DProfileInit
   339  
   340      ! ե
   341      ! File I/O support
   342      !
   343      use dc_iounit, only: FileOpen
   344  
   345      ! gtool ǡ
   346      ! Gtool data input
   347      !
   348      use gtool_history, only: HistoryGet, HistoryGetAttr
   349  
   350      ! NetCDF Υåѡץ
   351      ! NetCDF wrapper
   352      !
   353      use netcdf_wrapper, only : NWInqDimLen
   354  
   355      ! NAMELIST եϤ˴ؤ桼ƥƥ
   356      ! Utilities for NAMELIST file input
   357      !
   358      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   359  
   360  
   361      ! ʸ ; Declaration statements
   362      !
   363  
   364      logical :: flag_mpi_init
   365  
   366      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   367                                ! Unit number for NAMELIST file open
   368      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   369                                ! IOSTAT of NAMELIST read
   370  
   371      ! NAMELIST ѿ
   372      ! NAMELIST group name
   373      !
   374      namelist /set_1d_profile_nml/ &
   375        & InFileName
   376            !
   377            ! ǥեͤˤĤƤϽ³ "set_1d_profile#Set1DProfileInit"
   378            ! Υɤ򻲾ȤΤ.
   379            !
   380            ! Refer to source codes in the initialization procedure
   381            ! "set_1d_profile#Set1DProfileInit" for the default values.
   382            !
   383  
   384      if ( set_1d_profile_inited ) return
   385  
   386  
   387      ! ǥեͤ
   388      ! Default values settings
   389      !
   390  !!$    InFileName = 'data.nc'
   391      InFileName = ''
   392  
   393      ! NAMELIST ɤ߹
   394      ! NAMELIST is input
   395      !
   396      if ( trim(namelist_filename) /= '' ) then
   397        call FileOpen( unit_nml, &          ! (out)
   398          & namelist_filename, mode = 'r' ) ! (in)
   399  
   400        rewind( unit_nml )
   401        read( unit_nml,                     & ! (in)
   402          & nml = set_1d_profile_nml,       & ! (out)
   403          & iostat = iostat_nml )             ! (out)
   404        close( unit_nml )
   405  
   406        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   407      end if
   408  
   409  
   410      if ( InFileName /= '' ) then
   411  
   412        call NWInqDimLen( &
   413          & InFileName,    & ! (in )
   414          & 'plev',        & ! (in )
   415          & Inkmax         & ! (out)
   416          & )
   417  
   418        allocate( a_InPress( Inkmax ) )
   419        allocate( a_InTemp ( Inkmax ) )
   420        allocate( a_InQH2O ( Inkmax ) )
   421        allocate( a_InQO3  ( Inkmax ) )
   422  
   423  
   424        flag_mpi_init = .true.
   425  
   426        call HistoryGet(                   &
   427          & InFileName, 'plev',            & ! (in)
   428          & a_InPress,                     & ! (out)
   429          & flag_mpi_split = flag_mpi_init & ! (in) optional
   430          & )
   431  
   432        call HistoryGet(                   &
   433          & InFileName, 'Temp',            & ! (in)
   434          & a_InTemp,                      & ! (out)
   435          & flag_mpi_split = flag_mpi_init & ! (in) optional
   436          & )
   437  
   438        call HistoryGet(                   &
   439          & InFileName, 'QH2O',            & ! (in)
   440          & a_InQH2O,                      & ! (out)
   441          & flag_mpi_split = flag_mpi_init & ! (in) optional
   442          & )
   443  
   444        call HistoryGet(                   &
   445          & InFileName, 'QO3',             & ! (in)
   446          & a_InQO3,                       & ! (out)
   447          & flag_mpi_split = flag_mpi_init & ! (in) optional
   448          & )
   449  
   450      end if
   451  
   452  
   453      !  ; Print
   454      !
   455      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   456      call MessageNotify( 'M', module_name, 'InFileName = %c', c1 = trim(InFileName) )
   457      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   458  
   459  
   460      set_1d_profile_inited = .true.
   461  
   462  
   463    end subroutine Set1DProfileInit
   464  
   465    !--------------------------------------------------------------------------------------
   466  
   467  end module set_1d_profile
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:31 2012
FILE NAME: set_1d_profile.f90
PROGRAM NAME: set_1d_profile
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ե뤫 1 ץեɤꤹ. 
     2:            !
     3:            != read 1-D profile from a file and set it 
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: set_1d_profile.f90,v 1.4 2011-07-16 19:52:49 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module set_1d_profile
    13:            
    14:              !
    15:              != ե뤫 1 ץեɤꤹ. 
    16:              !
    17:              != read 1-D profile from a file and set it 
    18:              !
    19:              ! <b>Note that Japanese and English are described in parallel.</b>
    20:              !
    21:            
    22:              !== References
    23:              !
    24:            !!$  !  Chou, M.-D.,
    25:            !!$  !    Atmospheric solar heating rate in the water vapor bands,
    26:            !!$  !    J. Climate Appl. Meteor., 25, 1532-1542, 1986.
    27:              !
    28:              !== Procedures List
    29:              !
    30:            !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    31:            !!$  ! RadiationDTempDt        :: ͥեåˤ벹Ѳη׻
    32:            !!$  ! RadiationFluxOutput     :: ͥեåν
    33:            !!$  ! RadiationFinalize       :: λ (⥸塼ѿγդ)
    34:            !!$  ! ------------            :: ------------
    35:            !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    36:            !!$  ! RadiationDTempDt        :: Calculate temperature tendency with radiation flux
    37:            !!$  ! RadiationFluxOutput     :: Output radiation fluxes
    38:            !!$  ! RadiationFinalize       :: Termination (deallocate variables in this module)
    39:              !
    40:              !== NAMELIST
    41:              !
    42:              ! NAMELIST#set_1d_profile_nml
    43:              !
    44:            
    45:              ! USE statements
    46:              !
    47:            
    48:              !
    49:              ! Kind type parameter
    50:              !
    51:              use dc_types, only: DP, &      ! Double precision.
    52:                &                 STRING, &  ! Strings.
    53:                &                 TOKEN      ! Keywords.
    54:            
    55:              ! å
    56:              ! Message output
    57:              !
    58:              use dc_message, only: MessageNotify
    59:            
    60:              ! ʻ
    61:              ! Grid points settings
    62:              !
    63:              use gridset, only: imax, & ! ٳʻ.
    64:                                         ! Number of grid points in longitude
    65:                &                jmax, & ! ٳʻ.
    66:                                         ! Number of grid points in latitude
    67:                &                kmax    ! ľؿ.
    68:                                         ! Number of vertical level
    69:            
    70:              implicit none
    71:            
    72:              private
    73:            
    74:            
    75:              character(len=STRING), save :: InFileName
    76:            
    77:              integer              , save :: Inkmax
    78:              real(DP), allocatable, save :: a_InPress(:)
    79:              real(DP), allocatable, save :: a_InTemp (:)
    80:              real(DP), allocatable, save :: a_InQH2O (:)
    81:              real(DP), allocatable, save :: a_InQO3  (:)
    82:            
    83:            
    84:              ! ѿ
    85:              ! Public variables
    86:              !
    87:              logical, save :: set_1d_profile_inited = .false.
    88:                                          ! ե饰.
    89:                                          ! Initialization flag
    90:            
    91:              public :: Set1DProfileAtm
    92:              public :: Set1DProfilePs
    93:              public :: Set1DProfileSurfTemp
    94:              public :: Set1DProfileO3
    95:              public :: Set1DProfileInit
    96:            
    97:              character(*), parameter:: module_name = 'set_1d_profile'
    98:                                          ! ⥸塼̾.
    99:                                          ! Module name
   100:              character(*), parameter:: version = &
   101:                & '$Name: dcpam5-20120921 $' // &
   102:                & '$Id: set_1d_profile.f90,v 1.4 2011-07-16 19:52:49 yot Exp $'
   103:                                          ! ⥸塼ΥС
   104:                                          ! Module version
   105:            
   106:            
   107:              !--------------------------------------------------------------------------------------
   108:            
   109:            contains
   110:            
   111:              !--------------------------------------------------------------------------------------
   112:            
   113:              subroutine Set1DProfileAtm(      &
   114:                & xyz_Press,                   &
   115:                & xyz_Temp, xyz_QVap           &
   116:                & )
   117:            
   118:                real(DP), intent(in ) :: xyz_Press(0:imax-1,1:jmax,1:kmax)
   119:                real(DP), intent(out) :: xyz_Temp (0:imax-1,1:jmax,1:kmax)
   120:                real(DP), intent(out) :: xyz_QVap (0:imax-1,1:jmax,1:kmax)
   121:            
   122:            
   123:                !
   124:                ! local variables
   125:                !
   126:                real(DP), allocatable :: a_InLogQH2O(:)
   127:            
   128:            
   129:                ! ǧ
   130:                ! Initialization check
   131:                !
   132:                if ( .not. set_1d_profile_inited ) then
   133:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   134:                end if
   135:            
   136:            
   137:                call Set1DProfileInterpolate(       &
   138:                  & Inkmax, a_InPress, a_InTemp,    &
   139:                  & xyz_Press,                      &
   140:                  & xyz_Temp                        &
   141:                  & )
   142:            
   143:            
   144:                allocate( a_InLogQH2O( Inkmax ) )
   145: V======        a_InLogQH2O = log( a_InQH2O )
   146:            
   147:                call Set1DProfileInterpolate(       &
   148:                  & Inkmax, a_InPress, a_InLogQH2O, &
   149:                  & xyz_Press,                      &
   150:                  & xyz_QVap                        &
   151:                  & )
   152: WWW====        xyz_QVap(:,:,:) = exp( xyz_QVap(:,:,:) )
   153:            
   154:                deallocate( a_InLogQH2O )
   155:            
   156:            
   157:            
   158:              end subroutine Set1DProfileAtm
   159:            
   160:              !--------------------------------------------------------------------------------------
   161:            
   162:              subroutine Set1DProfilePs( &
   163:                & xy_Ps &
   164:                & )
   165:            
   166:                real(DP), intent(out) :: xy_Ps(0:imax-1,1:jmax)
   167:            
   168:            
   169:                !
   170:                ! local variables
   171:                !
   172:            
   173:                ! ǧ
   174:                ! Initialization check
   175:                !
   176:                if ( .not. set_1d_profile_inited ) then
   177:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   178:                end if
   179:            
   180:            
   181: ++=====        xy_Ps = a_InPress(1)
   182:            
   183:            
   184:              end subroutine Set1DProfilePs
   185:            
   186:              !--------------------------------------------------------------------------------------
   187:            
   188:              subroutine Set1DProfileSurfTemp( &
   189:                & xy_SurfTemp &
   190:                & )
   191:            
   192:                real(DP), intent(out) :: xy_SurfTemp(0:imax-1,1:jmax)
   193:            
   194:            
   195:                !
   196:                ! local variables
   197:                !
   198:            
   199:                ! ǧ
   200:                ! Initialization check
   201:                !
   202:                if ( .not. set_1d_profile_inited ) then
   203:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   204:                end if
   205:            
   206:            
   207: ++=====        xy_SurfTemp = a_InTemp(1)
   208:            
   209:            
   210:              end subroutine Set1DProfileSurfTemp
   211:            
   212:              !--------------------------------------------------------------------------------------
   213:            
   214:              subroutine Set1DProfileO3( &
   215:                & xyz_Press,             & ! (in )
   216:                & xyz_QO3                & ! (out)
   217:                & )
   218:            
   219:                real(DP), intent(in ) :: xyz_Press(0:imax-1,1:jmax,1:kmax)
   220:                real(DP), intent(out) :: xyz_QO3  (0:imax-1,1:jmax,1:kmax)
   221:            
   222:            
   223:                !
   224:                ! local variables
   225:                !
   226:                real(DP), allocatable :: a_InLogQO3(:)
   227:            
   228:            
   229:                ! ǧ
   230:                ! Initialization check
   231:                !
   232:                if ( .not. set_1d_profile_inited ) then
   233:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   234:                end if
   235:            
   236:            
   237:                allocate( a_InLogQO3( Inkmax ) )
   238: V======        a_InLogQO3 = log( a_InQO3 )
   239:            
   240:                call Set1DProfileInterpolate(       &
   241:                  & Inkmax, a_InPress, a_InLogQO3,  &
   242:                  & xyz_Press,                      &
   243:                  & xyz_QO3                         &
   244:                  & )
   245:            
   246: W**====        xyz_QO3(:,:,:) = exp( xyz_QO3(:,:,:) )
   247:            
   248:                deallocate( a_InLogQO3 )
   249:            
   250:            
   251:              end subroutine Set1DProfileO3
   252:            
   253:              !--------------------------------------------------------------------------------------
   254:            
   255:              subroutine Set1DProfileInterpolate( &
   256:                & NLev, a_Press, a_Array,         &
   257:                & xyz_Press,                      &
   258:                & xyz_Array                       &
   259:                & )
   260:            
   261:                integer , intent(in ) :: NLev
   262:                real(DP), intent(in ) :: a_Press  (1:NLev)
   263:                real(DP), intent(in ) :: a_Array  (1:NLev)
   264:                real(DP), intent(in ) :: xyz_Press(0:imax-1,1:jmax,1:kmax)
   265:                real(DP), intent(out) :: xyz_Array(0:imax-1,1:jmax,1:kmax)
   266:            
   267:            
   268:                !
   269:                ! local variables
   270:                !
   271:                integer :: i
   272:                integer :: j
   273:                integer :: k
   274:                integer :: kk
   275:            
   276:            
   277:                ! ǧ
   278:                ! Initialization check
   279:                !
   280:                if ( .not. set_1d_profile_inited ) then
   281:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   282:                end if
   283:            
   284:            
   285:                ! Old code to be deleted
   286:            
   287:            !!$    do k = 1, kmax
   288:            !!$      if( xyz_Press(0,1,k) <= a_Press(NLev) ) then
   289:            !!$        xyz_Array(0,1,k) = a_Array(NLev)
   290:            !!$      else
   291:            !!$        search_loop : do kk = 2, Inkmax
   292:            !!$          if( a_Press( kk ) < xyz_Press(0,1,k) ) exit search_loop
   293:            !!$        end do search_loop
   294:            !!$        if( kk > NLev ) &
   295:            !!$          stop 'Unexpected error in setting temperature profile'
   296:            !!$        xyz_Array(0,1,k) =                                  &
   297:            !!$          &   ( a_Array( kk ) - a_Array( kk-1 ) )           &
   298:            !!$          & / ( log( a_Press( kk )    / a_Press( kk-1 ) ) ) &
   299:            !!$          & * ( log( xyz_Press(0,1,k) / a_Press( kk-1 ) ) ) &
   300:            !!$          & + a_Array( kk-1 )
   301:            !!$      end if
   302:            !!$    end do
   303:            !!$
   304:            !!$    do k = 1, kmax
   305:            !!$      xyz_Array(:,:,k) = xyz_Array(0,1,k)
   306:            !!$    end do
   307:            
   308:            
   309:            
   310: +------>       do k = 1, kmax
   311: |+----->         do j = 1, jmax
   312: ||+---->           do i = 0, imax-1
   313: |||        
   314: |||                  if( xyz_Press(i,j,k) <= a_Press(NLev) ) then
   315: |||                    xyz_Array(i,j,k) = a_Array(NLev)
   316: |||                  else
   317: |||V--->               search_loop : do kk = 2, Inkmax
   318: ||||                     if( a_Press( kk ) < xyz_Press(i,j,k) ) exit search_loop
   319: |||V---                end do search_loop
   320: |||                    if( kk > NLev ) &
   321: |||                      stop 'Unexpected error in setting temperature profile'
   322: |||                    xyz_Array(i,j,k) =                                  &
   323: |||                      &   ( a_Array( kk ) - a_Array( kk-1 ) )           &
   324: |||                      & / ( log( a_Press( kk )    / a_Press( kk-1 ) ) ) &
   325: |||                      & * ( log( xyz_Press(i,j,k) / a_Press( kk-1 ) ) ) &
   326: |||                      & + a_Array( kk-1 )
   327: |||                  end if
   328: |||        
   329: ||+----            end do
   330: |+-----          end do
   331: +------        end do
   332:            
   333:            
   334:              end subroutine Set1DProfileInterpolate
   335:            
   336:              !--------------------------------------------------------------------------------------
   337:            
   338:              subroutine Set1DProfileInit
   339:            
   340:                ! ե
   341:                ! File I/O support
   342:                !
   343:                use dc_iounit, only: FileOpen
   344:            
   345:                ! gtool ǡ
   346:                ! Gtool data input
   347:                !
   348:                use gtool_history, only: HistoryGet, HistoryGetAttr
   349:            
   350:                ! NetCDF Υåѡץ
   351:                ! NetCDF wrapper
   352:                !
   353:                use netcdf_wrapper, only : NWInqDimLen
   354:            
   355:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   356:                ! Utilities for NAMELIST file input
   357:                !
   358:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   359:            
   360:            
   361:                ! ʸ ; Declaration statements
   362:                !
   363:            
   364:                logical :: flag_mpi_init
   365:            
   366:                integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   367:                                          ! Unit number for NAMELIST file open
   368:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   369:                                          ! IOSTAT of NAMELIST read
   370:            
   371:                ! NAMELIST ѿ
   372:                ! NAMELIST group name
   373:                !
   374:                namelist /set_1d_profile_nml/ &
   375:                  & InFileName
   376:                      !
   377:                      ! ǥեͤˤĤƤϽ³ "set_1d_profile#Set1DProfileInit"
   378:                      ! Υɤ򻲾ȤΤ.
   379:                      !
   380:                      ! Refer to source codes in the initialization procedure
   381:                      ! "set_1d_profile#Set1DProfileInit" for the default values.
   382:                      !
   383:            
   384:                if ( set_1d_profile_inited ) return
   385:            
   386:            
   387:                ! ǥեͤ
   388:                ! Default values settings
   389:                !
   390:            !!$    InFileName = 'data.nc'
   391:                InFileName = ''
   392:            
   393:                ! NAMELIST ɤ߹
   394:                ! NAMELIST is input
   395:                !
   396:                if ( trim(namelist_filename) /= '' ) then
   397:                  call FileOpen( unit_nml, &          ! (out)
   398:                    & namelist_filename, mode = 'r' ) ! (in)
   399:            
   400:                  rewind( unit_nml )
   401:                  read( unit_nml,                     & ! (in)
   402:                    & nml = set_1d_profile_nml,       & ! (out)
   403:                    & iostat = iostat_nml )             ! (out)
   404:                  close( unit_nml )
   405:            
   406:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   407:                end if
   408:            
   409:            
   410:                if ( InFileName /= '' ) then
   411:            
   412:                  call NWInqDimLen( &
   413:                    & InFileName,    & ! (in )
   414:                    & 'plev',        & ! (in )
   415:                    & Inkmax         & ! (out)
   416:                    & )
   417:            
   418:                  allocate( a_InPress( Inkmax ) )
   419:                  allocate( a_InTemp ( Inkmax ) )
   420:                  allocate( a_InQH2O ( Inkmax ) )
   421:                  allocate( a_InQO3  ( Inkmax ) )
   422:            
   423:            
   424:                  flag_mpi_init = .true.
   425:            
   426:                  call HistoryGet(                   &
   427:                    & InFileName, 'plev',            & ! (in)
   428:                    & a_InPress,                     & ! (out)
   429:                    & flag_mpi_split = flag_mpi_init & ! (in) optional
   430:                    & )
   431:            
   432:                  call HistoryGet(                   &
   433:                    & InFileName, 'Temp',            & ! (in)
   434:                    & a_InTemp,                      & ! (out)
   435:                    & flag_mpi_split = flag_mpi_init & ! (in) optional
   436:                    & )
   437:            
   438:                  call HistoryGet(                   &
   439:                    & InFileName, 'QH2O',            & ! (in)
   440:                    & a_InQH2O,                      & ! (out)
   441:                    & flag_mpi_split = flag_mpi_init & ! (in) optional
   442:                    & )
   443:            
   444:                  call HistoryGet(                   &
   445:                    & InFileName, 'QO3',             & ! (in)
   446:                    & a_InQO3,                       & ! (out)
   447:                    & flag_mpi_split = flag_mpi_init & ! (in) optional
   448:                    & )
   449:            
   450:                end if
   451:            
   452:            
   453:                !  ; Print
   454:                !
   455:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   456:                call MessageNotify( 'M', module_name, 'InFileName = %c', c1 = trim(InFileName) )
   457:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   458:            
   459:            
   460:                set_1d_profile_inited = .true.
   461:            
   462:            
   463:              end subroutine Set1DProfileInit
   464:            
   465:              !--------------------------------------------------------------------------------------
   466:            
   467:            end module set_1d_profile
