Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:00 2012
FILE NAME: rad_Mars_NIR.f90
PROGRAM NAME: rad_mars_nir
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   218  opt  (1592): Outer loop unrolled inside inner loop.
   218  vec  (   4): Vectorized array expression.
   218  vec  (   4): Vectorized array expression.
   224  vec  (   1): Vectorized loop.
   229  vec  (   1): Vectorized loop.
   240  opt  (1592): Outer loop unrolled inside inner loop.
   240  vec  (   4): Vectorized array expression.
   240  vec  (   4): Vectorized array expression.
   308  opt  (1592): Outer loop unrolled inside inner loop.
   308  vec  (   4): Vectorized array expression.
   308  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:00 2012
FILE NAME: rad_Mars_NIR.f90
PROGRAM NAME: rad_mars_nir
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ׻ѶֳǮΨ׻
     2  !
     3  != Calculation of near infrared heating rate in the case of Mars
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: rad_Mars_NIR.f90,v 1.3 2012-09-17 10:59:31 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module rad_Mars_NIR
    13    !
    14    != ׻ѶֳǮΨ׻
    15    !
    16    != Calculation of near infrared heating rate in the case of Mars
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    !== Procedures List
    21    !
    22  !!$  ! DryConvAdjust :: ήĴ
    23  !!$  ! ------------  :: ------------
    24  !!$  ! DryConvAdjust :: Dry convective adjustment
    25    !
    26    !== NAMELIST
    27    !
    28    ! NAMELIST#rad_M_NIR_nml
    29    !
    30  
    31    ! ⥸塼 ; USE statements
    32    !
    33  
    34    ! ʻ
    35    ! Grid points settings
    36    !
    37    use gridset, only: imax, & ! ٳʻ.
    38                               ! Number of grid points in longitude
    39      &                jmax, & ! ٳʻ.
    40                               ! Number of grid points in latitude
    41      &                kmax    ! ľؿ.
    42                               ! Number of vertical level
    43  
    44    ! ̷ѥ᥿
    45    ! Kind type parameter
    46    !
    47    use dc_types, only: DP, &      ! ټ¿. Double precision.
    48      &                 STRING     ! ʸ.       Strings.
    49  
    50    ! NAMELIST եϤ˴ؤ桼ƥƥ
    51    ! Utilities for NAMELIST file input
    52    !
    53    use namelist_util, only: MaxNmlArySize
    54                                ! NAMELIST ɤ߹κ祵.
    55                                ! Maximum size of arrays loaded from NAMELIST
    56  
    57    ! å
    58    ! Message output
    59    !
    60    use dc_message, only: MessageNotify
    61  
    62    ! ʸ ; Declaration statements
    63    !
    64    implicit none
    65    private
    66  
    67    ! ³
    68    ! Public procedure
    69    !
    70    public :: RadMarsNIRInit
    71    public :: RadMarsNIR
    72    public :: RadMarsNIRINOUT
    73  
    74    ! ѿ
    75    ! Public variables
    76    !
    77    logical, save, public:: rad_Mars_NIR_inited = .false.
    78                                ! ե饰.
    79                                ! Initialization flag
    80  
    81    ! ѿ
    82    ! Private variables
    83    !
    84    logical, save:: FlagUse
    85                                ! ѥե饰
    86                                ! flag for use of this scheme
    87  
    88    character(*), parameter:: module_name = 'rad_Mars_NIR'
    89                                ! ⥸塼̾.
    90                                ! Module name
    91    character(*), parameter:: version = &
    92      & '$Name: dcpam5-20120921 $' // &
    93      & '$Id: rad_Mars_NIR.f90,v 1.3 2012-09-17 10:59:31 yot Exp $'
    94                                ! ⥸塼ΥС
    95                                ! Module version
    96  
    97  contains
    98  
    99    subroutine RadMarsNIR(         &
   100      & xyz_Press,                 &  ! (in)
   101      & xyz_DTempDt                &  ! (out)
   102      & )
   103      !
   104      ! ׻ѶֳǮΨ׻
   105      !
   106      ! Calculation of near infrared heating rate in the case of Mars
   107      !
   108      ! Calculation schume of solar nir infrared heating rate follows
   109      ! that shown in Forget et al., 1999
   110  
   111  
   112      ! ⥸塼 ; USE statements
   113      !
   114  
   115      ! 
   116      ! Time control
   117      !
   118      use timeset, only: &
   119        & DelTime, &            ! $ \Delta t $
   120        & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $.
   121        & TimesetClockStart, TimesetClockStop
   122  
   123      ! ҥȥǡ
   124      ! History data output
   125      !
   126      use gtool_historyauto, only: HistoryAutoPut
   127  
   128      ! դӻμ갷
   129      ! Date and time handler
   130      !
   131      use dc_calendar, only: DCCalInquire
   132  
   133      ! ʪ
   134      ! Physical and mathematical constants settings
   135      !
   136      use constants0, only: &
   137        & PI                    ! $ \pi $ .
   138                                ! ߼Ψ.  Circular constant
   139  
   140      ! û ()
   141      ! Short wave (insolation) incoming
   142      !
   143      use rad_short_income, only : RadShortIncome
   144  
   145  
   146      ! ʸ ; Declaration statements
   147      !
   148      implicit none
   149  
   150      real(DP), intent(in ):: xyz_Press  (0:imax-1, 1:jmax, 1:kmax)
   151                                ! $ p $ .  (٥).
   152                                ! Air pressure (full level)
   153      real(DP), intent(out):: xyz_DTempDt(0:imax-1, 1:jmax, 1:kmax)
   154                                ! ѲΨ.
   155                                ! Temperature tendency
   156  
   157      ! ѿ
   158      ! Work variables
   159      !
   160      real(DP) :: qnir0
   161      real(DP) :: RefPress
   162      real(DP) :: NLTEPress
   163  
   164      integer  :: hour_in_day
   165      integer  :: min_in_hour
   166      real(DP) :: sec_in_min
   167  
   168      real(DP) :: DistFromStarScld
   169      real(DP) :: DiurnalMeanFactor
   170      real(DP) :: xy_CosZet  (0:imax-1, 1:jmax)
   171      real(DP) :: xy_CosZetSq(0:imax-1, 1:jmax)
   172  
   173      real(DP) :: MuFac
   174  
   175      integer:: i               ! ˲ DO 롼Ѻѿ
   176                                ! Work variables for DO loop in longitude
   177      integer:: j               ! ˲ DO 롼Ѻѿ
   178                                ! Work variables for DO loop in latitude
   179      integer:: k               ! ľ˲ DO 롼Ѻѿ
   180                                ! Work variables for DO loop in vertical direction
   181  
   182      ! ¹ʸ ; Executable statement
   183      !
   184  
   185      ! ׻ַ¬
   186      ! Start measurement of computation time
   187      !
   188      call TimesetClockStart( module_name )
   189  
   190      ! 
   191      ! Initialization
   192      !
   193      if ( .not. rad_Mars_NIR_inited ) then
   194        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   195      end if
   196  
   197  
   198      call DCCalInquire( &
   199        & hour_in_day      = hour_in_day  , &     ! (out)
   200        & min_in_hour      = min_in_hour  , &     ! (out)
   201        & sec_in_min       = sec_in_min     &     ! (out)
   202        & )
   203  
   204      ! constants
   205      !
   206      qnir0     = 1.3_DP / ( hour_in_day * min_in_hour * sec_in_min )
   207      RefPress  = 700.0_DP
   208      NLTEPress = 0.0075_DP
   209  
   210  
   211      call RadShortIncome( &
   212        & DistFromStarScld   = DistFromStarScld,   & ! (out) optional
   213        & xy_CosZet          = xy_CosZet,          & ! (out) optional
   214        & DiurnalMeanFactor  = DiurnalMeanFactor,  & ! (out) optional
   215        & FlagOutput         = .false.             & ! (in)  optional
   216        & )
   217  
   218      xy_CosZetSq = xy_CosZet**2
     .        if (xy_coszet.DSC.U2 .gt. 0) then                                 
     .           J1 = and(xy_coszet.DSC.U2,3)                                   
     .  !CDIR    NODEP                                                          
     .           do t162 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t164 = 1, xy_coszet.DSC.U1 + 1                           
     .                 xy_coszetsq(t164-1,t162) = xy_coszet(t164-1,t162)**2     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t162 = J1 + 1, xy_coszet.DSC.U2, 4                          
     .  !CDIR       NODEP                                                       
     .              do t164 = 1, xy_coszet.DSC.U1 + 1                           
     .                 xy_coszetsq(t164-1,t162) = xy_coszet(t164-1,t162)**2     
     .                 xy_coszetsq(t164-1,t162+1) = xy_coszet(t164-1,t162+1)**2 
     .                 xy_coszetsq(t164-1,t162+2) = xy_coszet(t164-1,t162+2)**2 
     .                 xy_coszetsq(t164-1,t162+3) = xy_coszet(t164-1,t162+3)**2 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   219  
   220      do j = 1, jmax
   221        do i = 0, imax-1
   222  
   223          if( xy_CosZet(i,j) < 0.0_DP ) then
   224            do k = 1, kmax
   225              xyz_DTempDt(i,j,k) = 0.0_DP
   226            end do
     .  !CDIR NODEP                                                             
     .        do k = 1, kmax                                                    
     .           xyz_dtempdt(i,j,k) = 0.0000000000000000e+000                   
     .        end do                                                            
     .        go to 10015                                                       
   227          else
   228            MuFac = sqrt( ( 1224.0_DP * xy_CosZetSq(i,j) + 1.0d0 ) / 1225.0_DP )
   229            do k = 1, kmax
   230              xyz_DTempDt(i,j,k) = &
   231                & qnir0 / DistFromStarScld**2 &
   232                & * sqrt( RefPress / xyz_Press(i,j,k) * MuFac ) &
   233                & / ( 1.0d0 + NLTEPress / xyz_Press(i,j,k) )
   234            end do
     .  !CDIR NODEP                                                             
     .        do k = 1, kmax                                                    
     .           xyz_dtempdt(i,j,k) = qnir0/distfromstarscld**2*dsqrt(refpress/ 
     .       1      xyz_press(i,j,k)*mufac)/(1.00000000000000e+000 + nltepress/ 
     .       2      xyz_press(i,j,k))                                           
     .        end do                                                            
   235          end if
   236  
   237        end do
   238      end do
   239  
   240      xyz_DTempDt = xyz_DTempDt * DiurnalMeanFactor
     .        if (xyz_dtempdt.DSC.U2 .gt. 0) then                               
     .           J2 = and(xyz_dtempdt.DSC.U2,3)                                 
     .  !CDIR    NODEP                                                          
     .           do t172 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t174 = 1, xyz_dtempdt.DSC.U1 + 1                         
     .                 xyz_dtempdt(t174-1,t172,t170+1) = xyz_dtempdt(t174-1,t172
     .       1            ,t170+1)*diurnalmeanfactor                            
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t172 = J2 + 1, xyz_dtempdt.DSC.U2, 4                        
     .  !CDIR       NODEP                                                       
     .              do t174 = 1, xyz_dtempdt.DSC.U1 + 1                         
     .                 xyz_dtempdt(t174-1,t172,t170+1) = xyz_dtempdt(t174-1,t172
     .       1            ,t170+1)*diurnalmeanfactor                            
     .                 xyz_dtempdt(t174-1,t172+1,t170+1) = xyz_dtempdt(t174-1,  
     .       1            t172+1,t170+1)*diurnalmeanfactor                      
     .                 xyz_dtempdt(t174-1,t172+2,t170+1) = xyz_dtempdt(t174-1,  
     .       1            t172+2,t170+1)*diurnalmeanfactor                      
     .                 xyz_dtempdt(t174-1,t172+3,t170+1) = xyz_dtempdt(t174-1,  
     .       1            t172+3,t170+1)*diurnalmeanfactor                      
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   241  
   242  
   243      ! ҥȥǡ
   244      ! History data output
   245      !
   246      call HistoryAutoPut( TimeN, 'DTempDtMNIR', xyz_DTempDt )
   247  
   248  
   249      ! ׻ַ¬
   250      ! Pause measurement of computation time
   251      !
   252      call TimesetClockStop( module_name )
   253  
   254    end subroutine RadMarsNIR
   255  
   256    !-------------------------------------------------------------------
   257  
   258    subroutine RadMarsNIRINOUT(  &
   259      & xyz_Press,                 &  ! (in   )
   260      & xyz_DTempDt                &  ! (inout)
   261      & )
   262      !
   263      ! ׻ѶֳǮΨ׻
   264      !
   265      ! Calculation of near infrared heating rate in the case of Mars
   266      !
   267      ! Calculation schume of solar nir infrared heating rate follows
   268      ! that shown in Forget et al., 1999
   269  
   270  
   271      ! ⥸塼 ; USE statements
   272      !
   273  
   274  
   275      ! ʸ ; Declaration statements
   276      !
   277      implicit none
   278  
   279      real(DP), intent(in   ):: xyz_Press (0:imax-1, 1:jmax, 1:kmax)
   280                                ! $ p $ .  (٥).
   281                                ! Air pressure (full level)
   282      real(DP), intent(inout):: xyz_DTempDt(0:imax-1, 1:jmax, 1:kmax)
   283                                ! ѲΨ.
   284                                ! Temperature tendency
   285  
   286      ! ѿ
   287      ! Work variables
   288      !
   289      real(DP) :: xyz_DTempDtLocal(0:imax-1, 1:jmax, 1:kmax)
   290  
   291      ! ¹ʸ ; Executable statement
   292      !
   293  
   294  
   295      ! 
   296      ! Initialization
   297      !
   298      if ( .not. rad_Mars_NIR_inited ) then
   299        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   300      end if
   301  
   302  
   303      call RadMarsNIR(         &
   304        & xyz_Press,           &  ! (in )
   305        & xyz_DTempDtLocal     &  ! (out)
   306        & )
   307  
   308      xyz_DTempDt = xyz_DTempDt + xyz_DTempDtLocal
     .        if (jmax .gt. 0) then                                             
     .           J1 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t57 = 1, J1                                                 
     .  !CDIR       NODEP                                                       
     .              do t59 = 1, imax                                            
     .                 xyz_dtempdt(t59-1,t57,t55+1) = xyz_dtempdt(t59-1,t57,t55+
     .       1            1) + xyz_dtempdtlocal(t59-1,t57,t55+1)                
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t57 = J1 + 1, jmax, 4                                       
     .  !CDIR       NODEP                                                       
     .              do t59 = 1, imax                                            
     .                 xyz_dtempdt(t59-1,t57,t55+1) = xyz_dtempdt(t59-1,t57,t55+
     .       1            1) + xyz_dtempdtlocal(t59-1,t57,t55+1)                
     .                 xyz_dtempdt(t59-1,t57+1,t55+1) = xyz_dtempdt(t59-1,t57+1,
     .       1            t55+1) + xyz_dtempdtlocal(t59-1,t57+1,t55+1)          
     .                 xyz_dtempdt(t59-1,t57+2,t55+1) = xyz_dtempdt(t59-1,t57+2,
     .       1            t55+1) + xyz_dtempdtlocal(t59-1,t57+2,t55+1)          
     .                 xyz_dtempdt(t59-1,t57+3,t55+1) = xyz_dtempdt(t59-1,t57+3,
     .       1            t55+1) + xyz_dtempdtlocal(t59-1,t57+3,t55+1)          
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   309  
   310  
   311    end subroutine RadMarsNIRINOUT
   312  
   313    !-------------------------------------------------------------------
   314  
   315    subroutine RadMarsNIRInit
   316      !
   317      ! rad_Mars_NIR ⥸塼νԤޤ.
   318      ! NAMELIST#rad_Mars_NIR_nml ɤ߹ߤϤμ³ǹԤޤ.
   319      !
   320      ! "rad_Mars_NIR" module is initialized.
   321      ! "NAMELIST#rad_Mars_NIR_nml" is loaded in this procedure.
   322      !
   323  
   324      ! ⥸塼 ; USE statements
   325      !
   326  
   327      ! NAMELIST եϤ˴ؤ桼ƥƥ
   328      ! Utilities for NAMELIST file input
   329      !
   330      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   331  
   332      ! ե
   333      ! File I/O support
   334      !
   335      use dc_iounit, only: FileOpen
   336  
   337      ! ̷ѥ᥿
   338      ! Kind type parameter
   339      !
   340      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   341  
   342      ! ʸ
   343      ! Character handling
   344      !
   345      use dc_string, only: StoA
   346  
   347      ! ҥȥǡ
   348      ! History data output
   349      !
   350      use gtool_historyauto, only: HistoryAutoAddVariable
   351  
   352      ! û ()
   353      ! Short wave (insolation) incoming
   354      !
   355      use rad_short_income, only : RadShortIncomeInit
   356  
   357      ! ʸ ; Declaration statements
   358      !
   359      implicit none
   360  
   361      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   362                                ! Unit number for NAMELIST file open
   363      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   364                                ! IOSTAT of NAMELIST read
   365  
   366      ! NAMELIST ѿ
   367      ! NAMELIST group name
   368      !
   369      namelist /rad_Mars_NIR_nml/ &
   370        & FlagUse
   371  
   372            ! ǥեͤˤĤƤϽ³ "dry_conv_adjust#DryConvAdjustInit"
   373            ! Υɤ򻲾ȤΤ.
   374            !
   375            ! Refer to source codes in the initialization procedure
   376            ! "dry_conv_adjust#DryConvAdjustInit" for the default values.
   377            !
   378  
   379      ! ¹ʸ ; Executable statement
   380      !
   381  
   382      if ( rad_Mars_NIR_inited ) return
   383  
   384      ! ǥեͤ
   385      ! Default values settings
   386      !
   387      FlagUse = .true.
   388  
   389      ! NAMELIST ɤ߹
   390      ! NAMELIST is input
   391      !
   392      if ( trim(namelist_filename) /= '' ) then
   393        call FileOpen( unit_nml, &          ! (out)
   394          & namelist_filename, mode = 'r' ) ! (in)
   395  
   396        rewind( unit_nml )
   397        read( unit_nml,                &  ! (in)
   398          & nml = rad_Mars_NIR_nml,    &  ! (out)
   399          & iostat = iostat_nml )         ! (out)
   400        close( unit_nml )
   401  
   402        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   403      end if
   404  
   405  
   406      ! ҥȥǡϤΤΤؤѿϿ
   407      ! Register of variables for history data output
   408      !
   409      call HistoryAutoAddVariable( 'DTempDtMNIR', &
   410        & (/ 'lon ', 'lat ', 'sig ', 'time' /),      &
   411        & 'near infrared heating rate', 'K s-1' )
   412  
   413  
   414  
   415      ! Initialization of modules used in this module
   416      !
   417  
   418      ! û ()
   419      ! Short wave (insolation) incoming
   420      !
   421      call RadShortIncomeInit
   422  
   423  
   424  
   425      !  ; Print
   426      !
   427      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   428      call MessageNotify( 'M', module_name, '  FlagUse    = %b', l = (/ FlagUse /) )
   429      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   430  
   431      rad_Mars_NIR_inited = .true.
   432  
   433    end subroutine RadMarsNIRInit
   434  
   435    !-------------------------------------------------------------------
   436  
   437  end module rad_Mars_NIR
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:00 2012
FILE NAME: rad_Mars_NIR.f90
PROGRAM NAME: rad_mars_nir
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ׻ѶֳǮΨ׻
     2:            !
     3:            != Calculation of near infrared heating rate in the case of Mars
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: rad_Mars_NIR.f90,v 1.3 2012-09-17 10:59:31 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module rad_Mars_NIR
    13:              !
    14:              != ׻ѶֳǮΨ׻
    15:              !
    16:              != Calculation of near infrared heating rate in the case of Mars
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              !== Procedures List
    21:              !
    22:            !!$  ! DryConvAdjust :: ήĴ
    23:            !!$  ! ------------  :: ------------
    24:            !!$  ! DryConvAdjust :: Dry convective adjustment
    25:              !
    26:              !== NAMELIST
    27:              !
    28:              ! NAMELIST#rad_M_NIR_nml
    29:              !
    30:            
    31:              ! ⥸塼 ; USE statements
    32:              !
    33:            
    34:              ! ʻ
    35:              ! Grid points settings
    36:              !
    37:              use gridset, only: imax, & ! ٳʻ. 
    38:                                         ! Number of grid points in longitude
    39:                &                jmax, & ! ٳʻ. 
    40:                                         ! Number of grid points in latitude
    41:                &                kmax    ! ľؿ. 
    42:                                         ! Number of vertical level
    43:            
    44:              ! ̷ѥ᥿
    45:              ! Kind type parameter
    46:              !
    47:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    48:                &                 STRING     ! ʸ.       Strings. 
    49:            
    50:              ! NAMELIST եϤ˴ؤ桼ƥƥ
    51:              ! Utilities for NAMELIST file input
    52:              !
    53:              use namelist_util, only: MaxNmlArySize
    54:                                          ! NAMELIST ɤ߹κ祵. 
    55:                                          ! Maximum size of arrays loaded from NAMELIST
    56:            
    57:              ! å
    58:              ! Message output
    59:              !
    60:              use dc_message, only: MessageNotify
    61:            
    62:              ! ʸ ; Declaration statements
    63:              !
    64:              implicit none
    65:              private
    66:            
    67:              ! ³
    68:              ! Public procedure
    69:              !
    70:              public :: RadMarsNIRInit
    71:              public :: RadMarsNIR
    72:              public :: RadMarsNIRINOUT
    73:            
    74:              ! ѿ
    75:              ! Public variables
    76:              !
    77:              logical, save, public:: rad_Mars_NIR_inited = .false.
    78:                                          ! ե饰. 
    79:                                          ! Initialization flag
    80:            
    81:              ! ѿ
    82:              ! Private variables
    83:              !
    84:              logical, save:: FlagUse
    85:                                          ! ѥե饰
    86:                                          ! flag for use of this scheme
    87:            
    88:              character(*), parameter:: module_name = 'rad_Mars_NIR'
    89:                                          ! ⥸塼̾. 
    90:                                          ! Module name
    91:              character(*), parameter:: version = &
    92:                & '$Name: dcpam5-20120921 $' // &
    93:                & '$Id: rad_Mars_NIR.f90,v 1.3 2012-09-17 10:59:31 yot Exp $'
    94:                                          ! ⥸塼ΥС
    95:                                          ! Module version
    96:            
    97:            contains
    98:            
    99:              subroutine RadMarsNIR(         &
   100:                & xyz_Press,                 &  ! (in)
   101:                & xyz_DTempDt                &  ! (out)
   102:                & )
   103:                !
   104:                ! ׻ѶֳǮΨ׻
   105:                !
   106:                ! Calculation of near infrared heating rate in the case of Mars
   107:                !
   108:                ! Calculation schume of solar nir infrared heating rate follows
   109:                ! that shown in Forget et al., 1999
   110:            
   111:            
   112:                ! ⥸塼 ; USE statements
   113:                !
   114:            
   115:                ! 
   116:                ! Time control
   117:                !
   118:                use timeset, only: &
   119:                  & DelTime, &            ! $ \Delta t $
   120:                  & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $. 
   121:                  & TimesetClockStart, TimesetClockStop
   122:            
   123:                ! ҥȥǡ
   124:                ! History data output
   125:                !
   126:                use gtool_historyauto, only: HistoryAutoPut
   127:            
   128:                ! դӻμ갷
   129:                ! Date and time handler
   130:                !
   131:                use dc_calendar, only: DCCalInquire
   132:            
   133:                ! ʪ
   134:                ! Physical and mathematical constants settings
   135:                !
   136:                use constants0, only: &
   137:                  & PI                    ! $ \pi $ .
   138:                                          ! ߼Ψ.  Circular constant
   139:            
   140:                ! û ()
   141:                ! Short wave (insolation) incoming
   142:                !
   143:                use rad_short_income, only : RadShortIncome
   144:            
   145:            
   146:                ! ʸ ; Declaration statements
   147:                !
   148:                implicit none
   149:            
   150:                real(DP), intent(in ):: xyz_Press  (0:imax-1, 1:jmax, 1:kmax)
   151:                                          ! $ p $ .  (٥). 
   152:                                          ! Air pressure (full level)
   153:                real(DP), intent(out):: xyz_DTempDt(0:imax-1, 1:jmax, 1:kmax)
   154:                                          ! ѲΨ. 
   155:                                          ! Temperature tendency
   156:            
   157:                ! ѿ
   158:                ! Work variables
   159:                !
   160:                real(DP) :: qnir0
   161:                real(DP) :: RefPress
   162:                real(DP) :: NLTEPress
   163:            
   164:                integer  :: hour_in_day
   165:                integer  :: min_in_hour
   166:                real(DP) :: sec_in_min
   167:            
   168:                real(DP) :: DistFromStarScld
   169:                real(DP) :: DiurnalMeanFactor
   170:                real(DP) :: xy_CosZet  (0:imax-1, 1:jmax)
   171:                real(DP) :: xy_CosZetSq(0:imax-1, 1:jmax)
   172:            
   173:                real(DP) :: MuFac
   174:            
   175:                integer:: i               ! ˲ DO 롼Ѻѿ
   176:                                          ! Work variables for DO loop in longitude
   177:                integer:: j               ! ˲ DO 롼Ѻѿ
   178:                                          ! Work variables for DO loop in latitude
   179:                integer:: k               ! ľ˲ DO 롼Ѻѿ
   180:                                          ! Work variables for DO loop in vertical direction
   181:            
   182:                ! ¹ʸ ; Executable statement
   183:                !
   184:            
   185:                ! ׻ַ¬
   186:                ! Start measurement of computation time
   187:                !
   188:                call TimesetClockStart( module_name )
   189:            
   190:                ! 
   191:                ! Initialization
   192:                !
   193:                if ( .not. rad_Mars_NIR_inited ) then
   194:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   195:                end if
   196:            
   197:            
   198:                call DCCalInquire( &
   199:                  & hour_in_day      = hour_in_day  , &     ! (out)
   200:                  & min_in_hour      = min_in_hour  , &     ! (out)
   201:                  & sec_in_min       = sec_in_min     &     ! (out)
   202:                  & )
   203:            
   204:                ! constants
   205:                !
   206:                qnir0     = 1.3_DP / ( hour_in_day * min_in_hour * sec_in_min )
   207:                RefPress  = 700.0_DP
   208:                NLTEPress = 0.0075_DP
   209:            
   210:            
   211:                call RadShortIncome( &
   212:                  & DistFromStarScld   = DistFromStarScld,   & ! (out) optional
   213:                  & xy_CosZet          = xy_CosZet,          & ! (out) optional
   214:                  & DiurnalMeanFactor  = DiurnalMeanFactor,  & ! (out) optional
   215:                  & FlagOutput         = .false.             & ! (in)  optional
   216:                  & )
   217:            
   218: +V=====        xy_CosZetSq = xy_CosZet**2
   219:            
   220: +------>       do j = 1, jmax
   221: |+----->         do i = 0, imax-1
   222: ||         
   223: ||                 if( xy_CosZet(i,j) < 0.0_DP ) then
   224: ||V---->             do k = 1, kmax
   225: |||                    xyz_DTempDt(i,j,k) = 0.0_DP
   226: ||V----              end do
   227: ||                 else
   228: ||                   MuFac = sqrt( ( 1224.0_DP * xy_CosZetSq(i,j) + 1.0d0 ) / 1225.0_DP )
   229: ||V---->             do k = 1, kmax
   230: |||                    xyz_DTempDt(i,j,k) = &
   231: |||                      & qnir0 / DistFromStarScld**2 &
   232: |||                      & * sqrt( RefPress / xyz_Press(i,j,k) * MuFac ) &
   233: |||                      & / ( 1.0d0 + NLTEPress / xyz_Press(i,j,k) )
   234: ||V----              end do
   235: ||                 end if
   236: ||         
   237: |+-----          end do
   238: +------        end do
   239:            
   240: ++V====        xyz_DTempDt = xyz_DTempDt * DiurnalMeanFactor
   241:            
   242:            
   243:                ! ҥȥǡ
   244:                ! History data output
   245:                !
   246:                call HistoryAutoPut( TimeN, 'DTempDtMNIR', xyz_DTempDt )
   247:            
   248:            
   249:                ! ׻ַ¬
   250:                ! Pause measurement of computation time
   251:                !
   252:                call TimesetClockStop( module_name )
   253:            
   254:              end subroutine RadMarsNIR
   255:            
   256:              !-------------------------------------------------------------------
   257:            
   258:              subroutine RadMarsNIRINOUT(  &
   259:                & xyz_Press,                 &  ! (in   )
   260:                & xyz_DTempDt                &  ! (inout)
   261:                & )
   262:                !
   263:                ! ׻ѶֳǮΨ׻
   264:                !
   265:                ! Calculation of near infrared heating rate in the case of Mars
   266:                !
   267:                ! Calculation schume of solar nir infrared heating rate follows
   268:                ! that shown in Forget et al., 1999
   269:            
   270:            
   271:                ! ⥸塼 ; USE statements
   272:                !
   273:            
   274:            
   275:                ! ʸ ; Declaration statements
   276:                !
   277:                implicit none
   278:            
   279:                real(DP), intent(in   ):: xyz_Press (0:imax-1, 1:jmax, 1:kmax)
   280:                                          ! $ p $ .  (٥). 
   281:                                          ! Air pressure (full level)
   282:                real(DP), intent(inout):: xyz_DTempDt(0:imax-1, 1:jmax, 1:kmax)
   283:                                          ! ѲΨ. 
   284:                                          ! Temperature tendency
   285:            
   286:                ! ѿ
   287:                ! Work variables
   288:                !
   289:                real(DP) :: xyz_DTempDtLocal(0:imax-1, 1:jmax, 1:kmax)
   290:            
   291:                ! ¹ʸ ; Executable statement
   292:                !
   293:            
   294:            
   295:                ! 
   296:                ! Initialization
   297:                !
   298:                if ( .not. rad_Mars_NIR_inited ) then
   299:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   300:                end if
   301:            
   302:            
   303:                call RadMarsNIR(         &
   304:                  & xyz_Press,           &  ! (in )
   305:                  & xyz_DTempDtLocal     &  ! (out)
   306:                  & )
   307:            
   308: ++V====        xyz_DTempDt = xyz_DTempDt + xyz_DTempDtLocal
   309:            
   310:            
   311:              end subroutine RadMarsNIRINOUT
   312:            
   313:              !-------------------------------------------------------------------
   314:            
   315:              subroutine RadMarsNIRInit
   316:                !
   317:                ! rad_Mars_NIR ⥸塼νԤޤ. 
   318:                ! NAMELIST#rad_Mars_NIR_nml ɤ߹ߤϤμ³ǹԤޤ. 
   319:                !
   320:                ! "rad_Mars_NIR" module is initialized. 
   321:                ! "NAMELIST#rad_Mars_NIR_nml" is loaded in this procedure. 
   322:                !
   323:            
   324:                ! ⥸塼 ; USE statements
   325:                !
   326:            
   327:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   328:                ! Utilities for NAMELIST file input
   329:                !
   330:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   331:            
   332:                ! ե
   333:                ! File I/O support
   334:                !
   335:                use dc_iounit, only: FileOpen
   336:            
   337:                ! ̷ѥ᥿
   338:                ! Kind type parameter
   339:                !
   340:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   341:            
   342:                ! ʸ
   343:                ! Character handling
   344:                !
   345:                use dc_string, only: StoA
   346:            
   347:                ! ҥȥǡ
   348:                ! History data output
   349:                !
   350:                use gtool_historyauto, only: HistoryAutoAddVariable
   351:            
   352:                ! û ()
   353:                ! Short wave (insolation) incoming
   354:                !
   355:                use rad_short_income, only : RadShortIncomeInit
   356:            
   357:                ! ʸ ; Declaration statements
   358:                !
   359:                implicit none
   360:            
   361:                integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   362:                                          ! Unit number for NAMELIST file open
   363:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   364:                                          ! IOSTAT of NAMELIST read
   365:            
   366:                ! NAMELIST ѿ
   367:                ! NAMELIST group name
   368:                !
   369:                namelist /rad_Mars_NIR_nml/ &
   370:                  & FlagUse
   371:            
   372:                      ! ǥեͤˤĤƤϽ³ "dry_conv_adjust#DryConvAdjustInit" 
   373:                      ! Υɤ򻲾ȤΤ. 
   374:                      !
   375:                      ! Refer to source codes in the initialization procedure
   376:                      ! "dry_conv_adjust#DryConvAdjustInit" for the default values. 
   377:                      !
   378:            
   379:                ! ¹ʸ ; Executable statement
   380:                !
   381:            
   382:                if ( rad_Mars_NIR_inited ) return
   383:            
   384:                ! ǥեͤ
   385:                ! Default values settings
   386:                !
   387:                FlagUse = .true.
   388:            
   389:                ! NAMELIST ɤ߹
   390:                ! NAMELIST is input
   391:                !
   392:                if ( trim(namelist_filename) /= '' ) then
   393:                  call FileOpen( unit_nml, &          ! (out)
   394:                    & namelist_filename, mode = 'r' ) ! (in)
   395:            
   396:                  rewind( unit_nml )
   397:                  read( unit_nml,                &  ! (in)
   398:                    & nml = rad_Mars_NIR_nml,    &  ! (out)
   399:                    & iostat = iostat_nml )         ! (out)
   400:                  close( unit_nml )
   401:            
   402:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   403:                end if
   404:            
   405:            
   406:                ! ҥȥǡϤΤΤؤѿϿ
   407:                ! Register of variables for history data output
   408:                !
   409:                call HistoryAutoAddVariable( 'DTempDtMNIR', &
   410:                  & (/ 'lon ', 'lat ', 'sig ', 'time' /),      &
   411:                  & 'near infrared heating rate', 'K s-1' )
   412:            
   413:            
   414:            
   415:                ! Initialization of modules used in this module
   416:                !
   417:            
   418:                ! û ()
   419:                ! Short wave (insolation) incoming
   420:                !
   421:                call RadShortIncomeInit
   422:            
   423:            
   424:            
   425:                !  ; Print
   426:                !
   427:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   428:                call MessageNotify( 'M', module_name, '  FlagUse    = %b', l = (/ FlagUse /) )
   429:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   430:            
   431:                rad_Mars_NIR_inited = .true.
   432:            
   433:              end subroutine RadMarsNIRInit
   434:            
   435:              !-------------------------------------------------------------------
   436:            
   437:            end module rad_Mars_NIR
