Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:10 2012
FILE NAME: rad_short_income.f90
PROGRAM NAME: rad_short_income
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   310  opt  (1395): Inner loop stripped and strip loop moved outside outer loop.
   311  vec  (   1): Vectorized loop.
   362  opt  (1395): Inner loop stripped and strip loop moved outside outer loop.
   363  vec  (   1): Vectorized loop.
   406  vec  (   1): Vectorized loop.
   425  opt  (1592): Outer loop unrolled inside inner loop.
   425  vec  (   4): Vectorized array expression.
   425  vec  (   4): Vectorized array expression.
   428  opt  (1592): Outer loop unrolled inside inner loop.
   428  vec  (   4): Vectorized array expression.
   428  vec  (   4): Vectorized array expression.
   534  vec  (   4): Vectorized array expression.
   534  vec  (  26): Macro operation Sum/InnerProd.
   549  vec  (   3): Unvectorized loop.
   549  vec  (   8): Unvectorizable loop structure.
   552  opt  (1084): Branch out of the loop inhibits optimization.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:10 2012
FILE NAME: rad_short_income.f90
PROGRAM NAME: rad_short_income
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != û ()
     2  !
     3  != Short wave (insolation) incoming
     4  !
     5  ! Authors::   Satoshi NODA, Yasuhiro MORIKAWA, Yukiko YAMADA, Yoshiyuki O. TAKAHASHI
     6  ! Version::   $Id: rad_short_income.f90,v 1.5 2012-02-01 05:19:53 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module rad_short_income
    13    !
    14    != û ()
    15    !
    16    != Short wave (insolation) incoming
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! û () ׻ޤ.
    21    !
    22    ! Calculate short wave (insolation) incoming radiation.
    23    !
    24    !== Procedures List
    25    !
    26    ! ShortIncoming      :: û () η׻
    27    ! ------------       :: ------------
    28    ! ShortIncoming      :: Calculate short wave (insolation) incoming radiation.
    29    !
    30    !== NAMELIST
    31    !
    32    ! NAMELIST#rad_short_income_nml
    33    !
    34  
    35    ! ⥸塼 ; USE statements
    36    !
    37  
    38    ! ̷ѥ᥿
    39    ! Kind type parameter
    40    !
    41    use dc_types, only: DP, &      ! ټ¿. Double precision.
    42      &                 STRING, &  ! ʸ.       Strings.
    43      &                 TOKEN      ! .   Keywords.
    44  
    45    ! å
    46    ! Message output
    47    !
    48    use dc_message, only: MessageNotify
    49  
    50    ! ʪ
    51    ! Physical and mathematical constants settings
    52    !
    53    use constants0, only: &
    54      & PI                    ! $ \pi $.
    55                              ! ߼Ψ. Circular constant
    56  
    57    ! ʻ
    58    ! Grid points settings
    59    !
    60    use gridset, only: imax, & ! ٳʻ.
    61                               ! Number of grid points in longitude
    62      &                jmax, & ! ٳʻ.
    63                               ! Number of grid points in latitude
    64      &                kmax    ! ľؿ.
    65                               ! Number of vertical level
    66  
    67    ! 
    68    ! Time control
    69    !
    70    use timeset, only: &
    71      & TimeN,                & !
    72      & InitialDate             ! ׻.
    73                                ! Start date of calculation
    74  
    75    ! ɸǡ
    76    ! Axes data settings
    77    !
    78    use axesset, only: &
    79      & y_Lat,   & ! $ \varphi $ [rad.] . . Latitude
    80      & x_Lon      ! $ \lambda $ [rad.] . . Longitude
    81  
    82  
    83    ! ʸ ; Declaration statements
    84    !
    85    implicit none
    86    private
    87  
    88    ! ³
    89    ! Public procedure
    90    !
    91    public:: RadShortIncome
    92    public:: RadShortIncomeInit
    93  
    94    ! ѿ
    95    ! Public variables
    96    !
    97    logical, save :: rad_short_income_inited = .false.
    98                                ! ե饰.
    99                                ! Initialization flag.
   100  
   101  
   102    ! ѿ
   103    ! Private variables
   104    !
   105  
   106    logical,  save:: FlagAnnualMean
   107                                ! ǯʿͥե饰.
   108                                ! Flag for annual mean incoming radiation.
   109    logical,  save:: FlagDiurnalMean
   110                                ! ʿͥե饰.
   111                                ! Flag for diurnal mean incoming radiation.
   112    logical,  save:: FlagPerpetual
   113                                ! Ѳʤͥե饰.
   114                                ! Flag for perpetual incoming radiation.
   115  
   116    real(DP), save :: PerpSinDel
   117                                ! sine of declination angle for perpetual experiments
   118    real(DP), save :: PerpDistFromStarScld
   119                                ! distance between a planet and a central star for
   120                                ! perpetual experiment
   121  
   122  
   123    ! NOTE:
   124    !   Distance between the central star and the planet, and the declination can be
   125    !   determined by specifying following three parameters:
   126    !     PerLonFromVE     : the longitude of the perihelion measured from the vernal
   127    !                        equinox,
   128    !     LonFromVEAtEpoch : the longitude of the planet at epoch,
   129    !     epoch            : date or time.
   130    !
   131    real(DP), save:: PerLonFromVE
   132                                ! ʬ¬äη () (degree)
   133                                ! Longitude of the perihelion from vernal equinox (degree)
   134    real(DP), save:: LonFromVEAtEpoch
   135                                ! ˤη () (degree)
   136                                ! Longitude of the planet at epoch (degree)
   137    real(DP), save:: TimeAtEpoch
   138                                ! ˤ (sec)
   139                                ! Time at epoch (sec)
   140  
   141    real(DP), save:: EpsOrb
   142                                ! ƻг.
   143                                ! Inclination of equator to orbit.
   144    real(DP), save:: Eccentricity
   145                                ! ΥΨ.
   146                                ! Eccentricity.
   147  
   148    integer,  save:: MaxItrEccAnomaly
   149                                ! ΥѤ׻κ緫֤.
   150                                ! Maximum iteration number of times
   151                                ! to calculate eccentric anomaly.
   152    real(DP), save:: ThreEccAnomalyError
   153                                ! ΥѤ׻θεƤ.
   154                                ! Threshold of error
   155                                ! to calculate eccentric anomaly.
   156  
   157    real(DP), save:: IncomAIns
   158                                ! $ A_{ins} $ . ǯʿͤη.
   159                                ! Coefficient of annual mean incoming radiation.
   160    real(DP), save:: IncomBIns
   161                                ! $ B_{ins} $ . ǯʿͤη. AIns Ʊ.
   162                                ! Coefficient of annual mean incoming radiation.
   163                                ! Same as "AIns".
   164    real(DP), save:: IncomAZet
   165                                ! $ A_{\zeta} $ . ǯʿͳѤη. AIns Ʊ.
   166                                ! Coefficient of annual mean incoming radiation.
   167                                ! Same as "AIns".
   168    real(DP), save:: IncomBZet
   169                                ! $ B_{\zeta} $ . ǯʿͳѤη. AIns Ʊ.
   170                                ! Coefficient of annual mean incoming radiation.
   171                                ! Same as "AIns".
   172  
   173  
   174    real(DP), allocatable, save:: xy_InAngle (:,:)
   175                                ! sec (ͳ).
   176                                ! sec (angle of incidence)
   177  
   178    logical:: FlagRadSynchronous
   179                                ! ƱžͤΥե饰
   180                                ! Flag for synchronous rotation
   181  
   182    character(*), parameter:: module_name = 'rad_short_income'
   183                                ! ⥸塼̾.
   184                                ! Module name
   185    character(*), parameter:: version = &
   186      & '$Name: dcpam5-20120921 $' // &
   187      & '$Id: rad_short_income.f90,v 1.5 2012-02-01 05:19:53 yot Exp $'
   188                                ! ⥸塼ΥС
   189                                ! Module version
   190  
   191  contains
   192  
   193    !--------------------------------------------------------------------------------------
   194  
   195    subroutine RadShortIncome(                    &
   196      & xy_InAngle, DistFromStarScld, xy_CosZet,  & ! (out) optional
   197      & DiurnalMeanFactor, PlanetLonFromVE,       & ! (out) optional
   198      & FlagOutput                                & ! (in)  optional
   199      & )
   200      !
   201      ! û () ׻ޤ.
   202      !
   203      ! Calculate short wave (insolation) incoming radiation.
   204      !
   205  
   206      ! ⥸塼 ; USE statements
   207      !
   208  
   209      ! դӻμ갷
   210      ! Date and time handler
   211      !
   212      use dc_calendar, only: DCCalInquire, DCCalDateEvalSecOfDay
   213  
   214      ! ҥȥǡ
   215      ! History data output
   216      !
   217      use gtool_historyauto, only: HistoryAutoPut
   218  
   219  
   220      ! ʸ ; Declaration statements
   221      !
   222      implicit none
   223      real(DP), intent(out), optional :: xy_InAngle (0:imax-1, 1:jmax)
   224                                ! sec ( ͳ ).
   225                                ! sec ( Incident angle )
   226      real(DP), intent(out), optional :: DistFromStarScld
   227                                ! ƻĹȾ¤ǥ󥰤εΥ
   228                                ! Distance from the star scaled
   229                                ! by semimajor axis of the planet's orbit
   230      real(DP), intent(out), optional :: xy_CosZet(0:imax-1, 1:jmax)
   231                                ! cos( ͳ )
   232                                ! cos( Incident angle )
   233      real(DP), intent(out), optional :: DiurnalMeanFactor
   234      real(DP), intent(out), optional :: PlanetLonFromVE
   235                                ! 濴濴Ȥɸˤʬ¬äη
   236                                ! Longitude of the planet measured from the vernal equinox
   237                                ! in the coordinate that the central star is located on
   238                                ! the origin.
   239      logical , intent(in ), optional :: FlagOutput
   240  
   241  
   242      ! ѿ
   243      ! Work variables
   244      !
   245      integer:: i                ! ˲ DO 롼Ѻѿ
   246                                 ! Work variables for DO loop in longitude
   247      integer:: j                ! ˲ DO 롼Ѻѿ
   248                                 ! Work variables for DO loop in latitude
   249      real(DP):: SinDel          ! ְ
   250                                 ! Declination
   251      real(DP):: CosZet          ! ͳ
   252                                 ! Incidence angle
   253      real(DP):: AngleMaxLon     ! ͤȤʤ
   254  
   255      real(DP):: HourAngle       ! 
   256                                 ! Hour angle
   257      real(DP):: ClockByDay      ! ɽ (0.0 - 1.0)
   258                                 ! Clock expressed by day (0.0 - 1.0)
   259  
   260  
   261      real(DP) :: xy_InAngleLV       (0:imax-1, 1:jmax)
   262                                 ! sec ( ͳ ).
   263                                 ! sec ( Incident angle )
   264                                 ! (local variable)
   265      real(DP) :: DistFromStarScldLV
   266                                 ! Distance between the central star and the planet
   267                                 ! (local variable)
   268      real(DP) :: xy_CosZetLV        (0:imax-1, 1:jmax)
   269                                 ! cos( ͳ )
   270                                 ! cos( Incident angle )
   271                                 ! (local variable)
   272      real(DP) :: PlanetLonFromVELV
   273  
   274      integer         :: hour_in_a_day, min_in_a_hour
   275      real(DP)        :: sec_in_a_min, sec_in_a_day
   276  
   277  
   278      ! ¹ʸ ; Executable statement
   279      !
   280  
   281      ! ǧ
   282      ! Initialization check
   283      !
   284      if ( .not. rad_short_income_inited ) then
   285        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   286      end if
   287  
   288  
   289      ! Set flag for diurnally averaged insolation : This is temporary one.
   290      !
   291      if ( present( DiurnalMeanFactor ) ) then
   292        if ( ( .not. FlagAnnualMean ) .and. FlagDiurnalMean ) then
   293          DiurnalMeanFactor = 1.0_DP / PI
   294        else
   295          DiurnalMeanFactor = 1.0_DP
   296        end if
   297      end if
   298  
   299  
   300      ! ƱžͤΥե饰
   301      ! Flag for synchronous rotation
   302      if ( .not. FlagRadSynchronous ) then
   303  
   304        ! ǯ, ʿͤη׻
   305        ! Calculate annual mean, daily mean insolation
   306        !
   307  
   308        if ( FlagAnnualMean .and. FlagDiurnalMean ) then
   309  
   310          do i = 0, imax - 1
   311            do j = 1, jmax
   312              xy_CosZetLV(i,j) = IncomAIns + IncomBIns * cos( y_Lat(j) )**2
   313  
   314              if ( xy_CosZetLV(i,j) > 0.0_DP ) then
   315                xy_InAngleLV(i,j) = 1.0_DP / xy_CosZetLV(i,j)
   316              else
   317                xy_InAngleLV(i,j) = 0.
   318              end if
   319  
   320            end do
   321          end do
     .  !CDIR NOASSUME                                                          
     .        do j1 = 0, jmax - 1, maxvl()                                      
     .           j2 = min0(jmax - j1,maxvl())                                   
     .           do i = 1, imax                                                 
     .  !CDIR       NODEP                                                       
     .              do j = 1, j2                                                
     .                 xy_coszetlv(i-1,j1+j) = incomains + incombins*dcos(y_lat(
     .       1            j1+j))**2                                             
     .                 if (xy_coszetlv(i-1,j1+j) .gt. 0.0000000000000000e+000)  
     .       1            then                                                  
     .                    xy_inanglelv(i-1,j1+j) = 1.00000000000000e+000/       
     .       1               xy_coszetlv(i-1,j1+j)                              
     .                 else                                                     
     .                    xy_inanglelv(i-1,j1+j) = 0.0000000000000000e+000      
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .        end do                                                            
   322  
   323          DistFromStarScldLV = 1.0_DP
   324          SinDel             = 0.0_DP
   325          PlanetLonFromVELV  = 0.0_DP
   326  
   327        else if ( .not. FlagAnnualMean ) then
   328  
   329          ! Set sine of declination and distance between a planet and a central star
   330          ! scaled with semi-major axis
   331          !
   332          if ( FlagPerpetual ) then
   333            SinDel             = PerpSinDel
   334            DistFromStarScldLV = PerpDistFromStarScld
   335          else
   336            call ShortIncomCalcOrbParam(                       &
   337              & SinDel, DistFromStarScldLV, PlanetLonFromVELV  & ! (out) optional
   338              & )
   339            if ( present( PlanetLonFromVE ) ) PlanetLonFromVE = PlanetLonFromVELV
   340          end if
   341  
   342  
   343          call DCCalInquire( &
   344            & hour_in_day      = hour_in_a_day,     & ! (out)
   345            & min_in_hour      = min_in_a_hour,     & ! (out)
   346            & sec_in_min       = sec_in_a_min       & ! (out)
   347            & )
   348          sec_in_a_day  = hour_in_a_day * min_in_a_hour * sec_in_a_min
   349  
   350          ! This is old version to be deleted, yot, 2010/09/23.
   351  !!$        ClockByDay = mod( TimeN / sec_in_a_day, 1.0_DP )
   352          !
   353          ClockByDay = DCCalDateEvalSecOfDay( TimeN, date = InitialDate )
   354          ClockByDay = ClockByDay / sec_in_a_day
   355  
   356  
   357  !!$        write( 6, * ) '###', TimeN, ClockByDay, mod( TimeN / sec_in_a_day, 1.0_DP )
   358  !!$        write( 60, * ) TimeN, ClockByDay, mod( TimeN / sec_in_a_day, 1.0_DP )
   359  !!$        call flush( 60 )
   360  
   361  
   362          do i = 0, imax - 1
   363            do j = 1, jmax
   364  
   365  
   366              if ( FlagDiurnalMean ) then
   367                HourAngle = 0.0_DP
   368              else
   369                HourAngle = ClockByDay * 2.0_DP * PI - PI + x_Lon(i)
   370              end if
   371  
   372              CosZet = sin( y_Lat(j) ) * SinDel &
   373                &  + cos( y_Lat(j) ) * sqrt( 1.0_DP - SinDel**2 ) * cos( HourAngle )
   374  
   375              xy_CosZetLV(i,j) = CosZet
   376  
   377              if ( CosZet > 0.0_DP ) then
   378                xy_InAngleLV(i,j)       = 1.0_DP / CosZet
   379              else
   380                xy_InAngleLV(i,j)       = 0.
   381              end if
   382  
   383            end do
   384          end do
     .  !CDIR NOASSUME                                                          
     .        do j3 = 0, jmax - 1, maxvl()                                      
     .           j4 = min0(jmax - j3,maxvl())                                   
     .           do i = 1, imax                                                 
     .  !CDIR       NODEP                                                       
     .              do j = 1, j4                                                
     .                 if (flagdiurnalmean .ne. 0) then                         
     .                    hourangle = 0.0000000000000000e+000                   
     .                 else                                                     
     .                    hourangle = clockbyday*2.00000000000000e+000*         
     .       1               3.14159265358979e+000 - 3.14159265358979e+000 +    
     .       2               x_lon(i-1)                                         
     .                 endif                                                    
     .                 coszet = dsin(y_lat(j3+j))*sindel + dcos(y_lat(j3+j))*   
     .       1            dsqrt(1.00000000000000e+000 - sindel**2)*dcos(        
     .       2            hourangle)                                            
     .                 xy_coszetlv(i-1,j3+j) = coszet                           
     .                 if (coszet .gt. 0.0000000000000000e+000) then            
     .                    xy_inanglelv(i-1,j3+j) = 1.00000000000000e+000/coszet 
     .                 else                                                     
     .                    xy_inanglelv(i-1,j3+j) = 0.0000000000000000e+000      
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .        end do                                                            
     .        go to 10009                                                       
   385  
   386        else
   387  
   388          ! бƤʤͥ
   389          ! not implemented insolation type
   390          !
   391          call MessageNotify( 'E', module_name, 'This type of insolation is not impremented' )
   392  
   393        end if
   394  
   395      else
   396  
   397        ! û () ׻ޤ.
   398        ! ƱžꤷƤ,
   399        ! ˷ 90 ٤Ǻ,  180-360 ٤ͥȤʤäƤޤ.
   400        !
   401        ! Calculate short wave (insolation) incoming radiation.
   402        ! A planet with synchronized rotation are assumed.
   403        ! Incoming is max at latitude 90 deg., and zero between 180 and 360 deg. constantly.
   404        do i = 0, imax - 1
   405           AngleMaxLon  = - PI / 2.0_DP + x_Lon( i )
   406           do j = 1, jmax
   407              CosZet = cos( y_Lat(j) ) * cos( AngleMaxLon )
   408  
   409              xy_CosZetLV(i,j) = CosZet
   410  
   411              if ( CosZet > 0.0_DP ) then
   412                 xy_InAngleLV(i,j) = 1.0_DP / CosZet
   413              else
   414                 xy_InAngleLV(i,j) = 0.0_DP
   415              end if
   416  
   417              DistFromStarScldLV = 1.0_DP
   418           end do
     .        if (jmax .gt. 0) then                                             
     .  !CDIR    NODEP                                                          
     .           do j = 1, jmax                                                 
     .              coszet = dcos(y_lat(j))*dcos(anglemaxlon)                   
     .              xy_coszetlv(i,j) = coszet                                   
     .              if (coszet .gt. 0.0000000000000000e+000) then               
     .                 xy_inanglelv(i,j) = 1.00000000000000e+000/coszet         
     .              else                                                        
     .                 xy_inanglelv(i,j) = 0.0000000000000000e+000              
     .              endif                                                       
     .           end do                                                         
     .           distfromstarscldlv = 1.00000000000000e+000                     
     .        endif                                                             
   419        end do
   420  
   421      end if
   422  
   423  
   424      if ( present( xy_InAngle ) ) then
   425        xy_InAngle = xy_InAngleLV
     .        if (jmax .gt. 0) then                                             
     .           J5 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t290 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t292 = 1, imax                                           
     .                 xy_inangle(t292-1,t290) = xy_inanglelv(t292-1,t290)      
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t290 = J5 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t292 = 1, imax                                           
     .                 xy_inangle(t292-1,t290) = xy_inanglelv(t292-1,t290)      
     .                 xy_inangle(t292-1,t290+1) = xy_inanglelv(t292-1,t290+1)  
     .                 xy_inangle(t292-1,t290+2) = xy_inanglelv(t292-1,t290+2)  
     .                 xy_inangle(t292-1,t290+3) = xy_inanglelv(t292-1,t290+3)  
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   426      end if
   427      if ( present( xy_CosZet ) ) then
   428        xy_CosZet = xy_CosZetLV
     .        if (jmax .gt. 0) then                                             
     .           J6 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t282 = 1, J6                                                
     .  !CDIR       NODEP                                                       
     .              do t284 = 1, imax                                           
     .                 xy_coszet(t284-1,t282) = xy_coszetlv(t284-1,t282)        
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t282 = J6 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t284 = 1, imax                                           
     .                 xy_coszet(t284-1,t282) = xy_coszetlv(t284-1,t282)        
     .                 xy_coszet(t284-1,t282+1) = xy_coszetlv(t284-1,t282+1)    
     .                 xy_coszet(t284-1,t282+2) = xy_coszetlv(t284-1,t282+2)    
     .                 xy_coszet(t284-1,t282+3) = xy_coszetlv(t284-1,t282+3)    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   429      end if
   430      if ( present( DistFromStarScld ) ) then
   431        DistFromStarScld = DistFromStarScldLV
   432      end if
   433  
   434      ! ҥȥǡ
   435      ! History data output
   436      !
   437      if ( present( FlagOutput ) ) then
   438        if ( FlagOutput ) then
   439          call HistoryAutoPut( TimeN, 'Decl'            , asin(SinDel)*180.0_DP/PI      )
   440          call HistoryAutoPut( TimeN, 'DistFromStarScld', DistFromStarScldLV            )
   441          call HistoryAutoPut( TimeN, 'PlanetLonFromVE' , PlanetLonFromVELV*180.0_DP/PI )
   442        end if
   443      else
   444        call HistoryAutoPut( TimeN, 'Decl'            , asin(SinDel)*180.0_DP/PI      )
   445        call HistoryAutoPut( TimeN, 'DistFromStarScld', DistFromStarScldLV            )
   446        call HistoryAutoPut( TimeN, 'PlanetLonFromVE' , PlanetLonFromVELV*180.0_DP/PI )
   447      end if
   448  
   449  
   450    end subroutine RadShortIncome
   451  
   452    !--------------------------------------------------------------------------------------
   453  
   454    subroutine ShortIncomCalcOrbParam(             &
   455      & SinDel, DistFromStarScld, PlanetLonFromVE  & ! (out)
   456      & )
   457      !
   458      ! û () ׻ޤ.
   459      !
   460      ! Calculate short wave (insolation) incoming radiation.
   461      !
   462  
   463      ! ⥸塼 ; USE statements
   464      !
   465  
   466      ! դӻμ갷
   467      ! Date and time handler
   468      !
   469      use dc_calendar, only: DCCalInquire, DCCalDateChkLeapYear
   470  
   471      ! ʸ ; Declaration statements
   472      !
   473      implicit none
   474      real(DP), intent(out) :: SinDel
   475                                ! ְ
   476                                ! Declination
   477      real(DP), intent(out) :: DistFromStarScld
   478                                ! ƻĹȾ¤ǥ󥰤εΥ
   479                                ! Distance from the star scaled
   480                                ! by semimajor axis of the planet's orbit
   481      real(DP), intent(out) :: PlanetLonFromVE
   482                                ! 濴濴Ȥɸˤʬ¬äη
   483                                ! Longitude of the planet measured from the vernal equinox
   484                                ! in the coordinate that the central star is located on
   485                                ! the origin.
   486  
   487      ! ѿ
   488      ! Work variables
   489      !
   490      integer:: itr              ! ƥ졼˲ DO 롼Ѻѿ
   491                                 ! Work variables for DO loop in iteration direction
   492  
   493      real(DP):: MeanAnomaly     ! ʿѶ
   494                                 ! Mean anomaly
   495      real(DP):: EccAnomaly      ! Υ
   496                                 ! eccentric anomaly
   497      real(DP):: EccAnomalyError ! ˥塼ȥˡˤΥѤθ
   498                                 ! error of eccentric anomaly in Newton method
   499      real(DP):: TrueAnomaly     ! Υ
   500                                 ! true anomaly
   501  
   502      integer         :: hour_in_a_day, min_in_a_hour, day_in_a_year
   503      integer, pointer:: day_in_month_ptr(:) => null()
   504      real(DP)        :: sec_in_a_min, sec_in_a_day, sec_in_a_year
   505  
   506  
   507  
   508      ! ¹ʸ ; Executable statement
   509      !
   510  
   511      ! ǧ
   512      ! Initialization check
   513      !
   514      if ( .not. rad_short_income_inited ) then
   515        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   516      end if
   517  
   518  
   519      ! Ѳ, Ѳη׻
   520      ! Calculate with seasonal change and diurnal change
   521      !
   522      call DCCalInquire( &
   523        & day_in_month_ptr = day_in_month_ptr , & ! (out)
   524        & hour_in_day      = hour_in_a_day,     & ! (out)
   525        & min_in_hour      = min_in_a_hour,     & ! (out)
   526        & sec_in_min       = sec_in_a_min       & ! (out)
   527        & )
   528      ! Add 1 to day_in_month_ptr(2) if it is leap year.
   529      !
   530      if ( DCCalDateChkLeapYear( TimeN, InitialDate ) ) then
   531        day_in_month_ptr(2) = day_in_month_ptr(2) + 1
   532      end if
   533  
   534      day_in_a_year = sum( day_in_month_ptr )
   535      deallocate( day_in_month_ptr )
   536      sec_in_a_day  = hour_in_a_day * min_in_a_hour * sec_in_a_min
   537      sec_in_a_year = day_in_a_year * sec_in_a_day
   538  
   539      MeanAnomaly  =                                               &
   540        &   2.0_DP * PI * ( TimeN - TimeAtEpoch ) / sec_in_a_year  &
   541        & + ( LonFromVEAtEpoch - PerLonFromVE ) * PI / 180.0_DP
   542      MeanAnomaly  = mod( MeanAnomaly, 2.0_DP * PI )
   543  
   544  
   545      ! ˥塼ȥˡѤʿѶѤΥѤ.
   546      ! Calculate eccentric anomaly from mean anomaly by using Newton method.
   547  
   548      EccAnomaly = MeanAnomaly
   549      do itr = 1, MaxItrEccAnomaly
   550        EccAnomalyError = EccAnomaly                                        &
   551          & - Eccentricity * sin(EccAnomaly) - MeanAnomaly
   552        if ( abs(EccAnomalyError) <= ThreEccAnomalyError ) exit
   553        EccAnomaly      = EccAnomaly                                        &
   554          & - EccAnomalyError / ( 1.0_DP - Eccentricity * cos(EccAnomaly) )
   555        EccAnomaly      = mod( EccAnomaly, 2.0 * PI )
   556      end do
   557      if ( itr > MaxItrEccAnomaly ) then
   558        call MessageNotify( 'E', module_name,                        &
   559          & 'Calculation for eccentric anomaly does not converge.' )
   560      end if
   561  
   562      DistFromStarScld = 1.0_DP - Eccentricity * cos( EccAnomaly )
   563  
   564      TrueAnomaly = 2.0_DP                                                    &
   565        & * atan(                                                             &
   566        &         sqrt( ( 1.0d0 + Eccentricity ) / ( 1.0d0 - Eccentricity ) ) &
   567        &           * tan( EccAnomaly / 2.0_DP )                              &
   568        &       )
   569  
   570      PlanetLonFromVE = TrueAnomaly + PerLonFromVE * PI / 180.0_DP
   571      PlanetLonFromVE = mod( PlanetLonFromVE, 2.0_DP * PI )
   572  
   573      SinDel = sin( EpsOrb * PI / 180.0_DP ) * sin( PlanetLonFromVE )
   574  
   575  
   576          ! code for debug
   577  !!$        write( 60, * ) TimeN/sec_in_a_day, DCCalDateChkLeapYear(TimeN,date=InitialDate), day_in_a_year
   578  !!$        write(  6, * ) TimeN/sec_in_a_day, DCCalDateChkLeapYear(TimeN,date=InitialDate), day_in_a_year
   579  !!$        call flush( 60 )
   580  
   581  
   582  !!$        write( 60, * ) TimeN/sec_in_a_day, asin(SinDel)*180.0/PI, DistFromStarScld, PlanetLonFromVE*180.0_DP/PI
   583  !!$        write(  6, * ) TimeN/sec_in_a_day, asin(SinDel)*180.0/PI, DistFromStarScld, PlanetLonFromVE*180.0_DP/PI
   584  !!$        call flush( 60 )
   585  
   586  
   587    end subroutine ShortIncomCalcOrbParam
   588  
   589    !--------------------------------------------------------------------------------------
   590  
   591    subroutine RadShortIncomeInit
   592      !
   593      ! rad_short_income ⥸塼νԤޤ.
   594      ! NAMELIST#rad_short_income_nml ɤ߹ߤϤμ³ǹԤޤ.
   595      !
   596      ! "rad_short_income" module is initialized.
   597      ! "NAMELIST#rad_short_income_nml" is loaded in this procedure.
   598      !
   599  
   600      ! ⥸塼 ; USE statements
   601      !
   602  
   603      ! ̷ѥ᥿
   604      ! Kind type parameter
   605      !
   606      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   607  
   608      ! ե
   609      ! File I/O support
   610      !
   611      use dc_iounit, only: FileOpen
   612  
   613      ! ҥȥǡ
   614      ! History data output
   615      !
   616      use gtool_historyauto, only: HistoryAutoAddVariable
   617  
   618      ! μ갷
   619      ! Calendar and Date handler
   620      !
   621      use dc_calendar, only: &
   622        & DC_CAL_DATE, &          ! ɽǡ.
   623                                  ! Data type for date and time
   624        & DCCalDateInquire, DCCalDateCreate, DCCalDateDifference
   625  
   626      ! NAMELIST եϤ˴ؤ桼ƥƥ
   627      ! Utilities for NAMELIST file input
   628      !
   629      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   630  
   631      ! ʸ ; Declaration statements
   632      !
   633      implicit none
   634  
   635      integer:: EpochYear, EpochMonth, EpochDay, EpochHour, EpochMin
   636                                !  (ǯʬ).
   637                                ! "TimeAtEpoch" ξˤ餬Ѥ.
   638                                !
   639                                ! Date at epoch (year, month, day, hour, minute)
   640                                ! These are used when "TimeAtEpoch" is negative.
   641      real(DP):: EpochSec
   642                                !  ().
   643                                ! "TimeAtEpoch" ξˤ餬Ѥ.
   644                                !
   645                                ! Date at epoch (second)
   646                                ! These are used when "TimeAtEpoch" is negative.
   647  
   648      type(DC_CAL_DATE):: EpochDate
   649                                ! 
   650                                ! Date at epoch
   651  
   652      real(DP)         :: PerpDelDeg
   653                                ! Declination angle in degree used for perpetual experiment
   654  
   655      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   656                                ! Unit number for NAMELIST file open
   657      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   658                                ! IOSTAT of NAMELIST read
   659  
   660      logical         :: FlagUseOfEpochDate
   661      character(TOKEN):: date_print
   662  
   663  
   664      ! NAMELIST ѿ
   665      ! NAMELIST group name
   666      !
   667      namelist /rad_short_income_nml/                                     &
   668        & FlagRadSynchronous,                                             &
   669        & FlagAnnualMean, FlagDiurnalMean, FlagPerpetual,                 &
   670        & PerpDelDeg, PerpDistFromStarScld,                               &
   671        & EpsOrb,                                                         &
   672        & PerLonFromVE,                                                   &
   673        & LonFromVEAtEpoch,                                               &
   674        & Eccentricity,                                                   &
   675        & TimeAtEpoch,                                                    &
   676        & EpochYear, EpochMonth, EpochDay, EpochHour, EpochMin, EpochSec, &
   677        & MaxItrEccAnomaly, ThreEccAnomalyError,                          &
   678        & IncomAIns, IncomBIns, IncomAZet, IncomBZet
   679            !
   680            ! ǥեͤˤĤƤϽ³ "rad_short_income#RadShortIncomeInit"
   681            ! Υɤ򻲾ȤΤ.
   682            !
   683            ! Refer to source codes in the initialization procedure
   684            ! "rad_short_income#RadShortIncomeInit" for the default values.
   685            !
   686  
   687      ! ¹ʸ ; Executable statement
   688      !
   689  
   690      if ( rad_short_income_inited ) return
   691  
   692  
   693      ! ǥեͤ
   694      ! Default values settings
   695      !
   696      FlagRadSynchronous       = .false.
   697      FlagAnnualMean           = .true.
   698      FlagDiurnalMean          = .true.
   699      FlagPerpetual            = .false.
   700  
   701      !---
   702  
   703      PerpDelDeg               = 0.0_DP
   704      PerpDistFromStarScld     = 1.0_DP
   705  
   706      !---
   707  
   708      EpsOrb               =   23.5_DP    ! Earth-like value
   709      PerLonFromVE         =    0.0_DP
   710      LonFromVEAtEpoch     =  280.0_DP    ! This value results in the fact that the planet
   711                                          ! is located at the position of vernal equinox
   712                                          ! at 80 days after calculation with the use of
   713                                          ! "360day" calendar.
   714      Eccentricity         =    0.0_DP
   715      TimeAtEpoch          =    0.0_DP
   716      EpochYear            =   -1
   717      EpochMonth           =   -1
   718      EpochDay             =   -1
   719      EpochHour            =   -1
   720      EpochMin             =   -1
   721      EpochSec             =   -1.0_DP
   722  
   723      !---
   724  
   725      ! Sample values for the Earth
   726      !  References:
   727      !    Duffett-Smith, P., Practical astronomy with your calculator Third Edition,
   728      !    Cambridge University Press, pp.185, 1988.
   729      !
   730  !!$    EpsOrb               =   23.44_DP                ! Rika nenpyo (Chronological
   731  !!$                                                     ! Scientific Tables 2010)
   732  !!$    PerLonFromVE         =  102.768413_DP + 180.0_DP ! Duffett-Smith (1988), p.105
   733  !!$                                                     ! modified (plus 180 degrees)
   734  !!$    LonFromVEAtEpoch     =   99.403308_DP + 180.0_DP ! Duffett-Smith (1988), p.105
   735  !!$                                                     ! modified (plus 180 degrees)
   736  !!$    Eccentricity         =    0.016713_DP            ! Duffett-Smith (1988), p.105
   737  !!$    TimeAtEpoch          =   -1.0_DP                 ! EpochXXX written below are used
   738  !!$                                                     ! because this is negative.
   739  !!$    EpochYear            = 1990                      ! Duffett-Smith (1988), p.105
   740  !!$    EpochMonth           =    1
   741  !!$    EpochDay             =    1
   742  !!$    EpochHour            =    0
   743  !!$    EpochMin             =    0
   744  !!$    EpochSec             =    0.0_DP
   745      !---
   746  
   747      ! Sample values for Mars
   748      !  References:
   749      !    Allison, M., Geophys. Res. Lett., 24, 1967-1970, 1997.
   750      !
   751  !!$    EpsOrb               =   25.19_DP              ! Allison (1997)
   752  !!$    PerLonFromVE         =  250.98_DP              ! Allison (1997) (modified)
   753  !!$    LonFromVEAtEpoch     =  -10.342_DP             ! Arbitrarily set for clarity
   754  !!$                                                   ! This results in Ls ~ 0 at Time = 0
   755  !!$    Eccentricity         =    0.0934_DP            ! Allison (1997), value at epoch J2000
   756  !!$    TimeAtEpoch          =    0.0_DP               ! Arbitrarily set for clarity
   757  !!$    EpochYear            =   -1                    ! not used
   758  !!$    EpochMonth           =   -1
   759  !!$    EpochDay             =   -1
   760  !!$    EpochHour            =   -1
   761  !!$    EpochMin             =   -1
   762  !!$    EpochSec             =   -1.0_DP
   763  
   764      !---
   765  
   766      MaxItrEccAnomaly     = 20
   767      ThreEccAnomalyError  = 1e-6_DP
   768  
   769      IncomAIns            = 0.127_DP   ! Reference of this value is unknown.
   770      IncomBIns            = 0.183_DP   ! Reference of this value is unknown.
   771      IncomAZet            = 0.410_DP   ! Reference of this value is unknown.
   772      IncomBZet            = 0.590_DP   ! Reference of this value is unknown.
   773  
   774      ! NAMELIST ɤ߹
   775      ! NAMELIST is input
   776      !
   777      if ( trim(namelist_filename) /= '' ) then
   778        call FileOpen( unit_nml, &          ! (out)
   779          & namelist_filename, mode = 'r' ) ! (in)
   780  
   781        rewind( unit_nml )
   782        read( unit_nml, &                ! (in)
   783          & nml = rad_short_income_nml, &  ! (out)
   784          & iostat = iostat_nml )        ! (out)
   785        close( unit_nml )
   786  
   787        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   788      end if
   789  
   790  
   791      PerpSinDel = sin( PerpDelDeg * PI / 180.0_DP )
   792  
   793  
   794      FlagUseOfEpochDate = .false.
   795  
   796      if ( TimeAtEpoch < 0.0_DP ) then
   797        call DCCalDateCreate(    &
   798          & year  = EpochYear,   & ! (in)
   799          & month = EpochMonth,  & ! (in)
   800          & day   = EpochDay,    & ! (in)
   801          & hour  = EpochHour,   & ! (in)
   802          & min   = EpochMin,    & ! (in)
   803          & sec   = EpochSec,    & ! (in)
   804          & date  = EpochDate )    ! (out) optional
   805  
   806        TimeAtEpoch = DCCalDateDifference( &
   807          &                                 start_date = InitialDate, &  ! (in)
   808          &                                 end_date   = EpochDate    &  ! (in)
   809          &                              )
   810  
   811        FlagUseOfEpochDate = .true.
   812      end if
   813  
   814      ! ¸Ѥѿγդ
   815      ! Allocate variables for saving
   816      !
   817  
   818      ! ҥȥǡϤΤΤؤѿϿ
   819      ! Register of variables for history data output
   820      !
   821  !!$    call HistoryAutoAddVariable( 'xxxxx' , &
   822  !!$      & (/ 'lon ', 'lat ', 'sig', 'time'/), &
   823  !!$      & 'xxxx', 'W m-2' )
   824  
   825      call HistoryAutoAddVariable( 'ISR' , &
   826        & (/ 'lon ', 'lat ', 'time'/),     &
   827        & 'incoming shortwave', 'W m-2' )
   828  
   829      call HistoryAutoAddVariable( 'Decl' , &
   830        & (/ 'time'/),                      &
   831        & 'declination angle', 'degree' )
   832  
   833      call HistoryAutoAddVariable( 'DistFromStarScld' , &
   834        & (/ 'time'/),                                  &
   835        & 'distance between the central star and the planet', '1' )
   836  
   837      call HistoryAutoAddVariable( 'PlanetLonFromVE' , &
   838        & (/ 'time'/),                                 &
   839        & 'planetary longitude from the vernal equinox', 'degree' )
   840  
   841      !  ; Print
   842      !
   843      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   844      call MessageNotify( 'M', module_name, 'ShortIncomming:' )
   845      call MessageNotify( 'M', module_name, '  FlagRadSynchronous       = %b', l = (/ FlagRadSynchronous /) )
   846      call MessageNotify( 'M', module_name, '  FlagAnnualMean           = %b', l = (/ FlagAnnualMean            /) )
   847      call MessageNotify( 'M', module_name, '  FlagDiurnalMean          = %b', l = (/ FlagDiurnalMean           /) )
   848      call MessageNotify( 'M', module_name, '  FlagPerpetual            = %b', l = (/ FlagPerpetual             /) )
   849      call MessageNotify( 'M', module_name, '  PerpDelDeg               = %f', d = (/ PerpDelDeg                /) )
   850      call MessageNotify( 'M', module_name, '  PerpDistFromStarScld     = %f', d = (/ PerpDistFromStarScld      /) )
   851      call MessageNotify( 'M', module_name, '  EpsOrb                   = %f', d = (/ EpsOrb                   /) )
   852      call MessageNotify( 'M', module_name, '  PerLonFromVE             = %f', d = (/ PerLonFromVE             /) )
   853      call MessageNotify( 'M', module_name, '  Eccentricity             = %f', d = (/ Eccentricity             /) )
   854  
   855      if ( FlagUseOfEpochDate ) then
   856        call DCCalDateInquire( date_print, date = EpochDate )
   857        call MessageNotify( 'M', module_name, '  EpochDate  = %c', &
   858          & c1 = trim(date_print) )
   859      end if
   860      call MessageNotify( 'M', module_name, '  TimeAtEpoch              = %f', d = (/ TimeAtEpoch              /) )
   861      call MessageNotify( 'M', module_name, '  LonFromVEAtEpoch         = %f', d = (/ LonFromVEAtEpoch         /) )
   862  
   863      call MessageNotify( 'M', module_name, '  MaxItrEccAnomaly         = %d', i = (/ MaxItrEccAnomaly         /) )
   864      call MessageNotify( 'M', module_name, '  ThreEccAnomalyError      = %f', d = (/ ThreEccAnomalyError      /) )
   865      call MessageNotify( 'M', module_name, '  IncomAIns                = %f', d = (/ IncomAIns                /) )
   866      call MessageNotify( 'M', module_name, '  IncomBIns                = %f', d = (/ IncomBIns                /) )
   867      call MessageNotify( 'M', module_name, '  IncomAZet                = %f', d = (/ IncomAZet                /) )
   868      call MessageNotify( 'M', module_name, '  IncomBZet                = %f', d = (/ IncomBZet                /) )
   869      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   870  
   871      rad_short_income_inited = .true.
   872  
   873    end subroutine RadShortIncomeInit
   874  
   875    !-------------------------------------------------------------------
   876  
   877  end module rad_short_income
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:10 2012
FILE NAME: rad_short_income.f90
PROGRAM NAME: rad_short_income
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != û ()
     2:            !
     3:            != Short wave (insolation) incoming
     4:            !
     5:            ! Authors::   Satoshi NODA, Yasuhiro MORIKAWA, Yukiko YAMADA, Yoshiyuki O. TAKAHASHI
     6:            ! Version::   $Id: rad_short_income.f90,v 1.5 2012-02-01 05:19:53 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module rad_short_income
    13:              !
    14:              != û ()
    15:              !
    16:              != Short wave (insolation) incoming
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! û () ׻ޤ.
    21:              !
    22:              ! Calculate short wave (insolation) incoming radiation. 
    23:              !
    24:              !== Procedures List
    25:              !
    26:              ! ShortIncoming      :: û () η׻
    27:              ! ------------       :: ------------
    28:              ! ShortIncoming      :: Calculate short wave (insolation) incoming radiation. 
    29:              !
    30:              !== NAMELIST
    31:              !
    32:              ! NAMELIST#rad_short_income_nml
    33:              !
    34:            
    35:              ! ⥸塼 ; USE statements
    36:              !
    37:            
    38:              ! ̷ѥ᥿
    39:              ! Kind type parameter
    40:              !
    41:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    42:                &                 STRING, &  ! ʸ.       Strings. 
    43:                &                 TOKEN      ! .   Keywords.
    44:            
    45:              ! å
    46:              ! Message output
    47:              !
    48:              use dc_message, only: MessageNotify
    49:            
    50:              ! ʪ
    51:              ! Physical and mathematical constants settings
    52:              !
    53:              use constants0, only: &
    54:                & PI                    ! $ \pi $.
    55:                                        ! ߼Ψ. Circular constant
    56:            
    57:              ! ʻ
    58:              ! Grid points settings
    59:              !
    60:              use gridset, only: imax, & ! ٳʻ. 
    61:                                         ! Number of grid points in longitude
    62:                &                jmax, & ! ٳʻ. 
    63:                                         ! Number of grid points in latitude
    64:                &                kmax    ! ľؿ. 
    65:                                         ! Number of vertical level
    66:            
    67:              ! 
    68:              ! Time control
    69:              !
    70:              use timeset, only: &
    71:                & TimeN,                & !
    72:                & InitialDate             ! ׻.
    73:                                          ! Start date of calculation
    74:            
    75:              ! ɸǡ
    76:              ! Axes data settings
    77:              !
    78:              use axesset, only: &
    79:                & y_Lat,   & ! $ \varphi $ [rad.] . . Latitude
    80:                & x_Lon      ! $ \lambda $ [rad.] . . Longitude
    81:            
    82:            
    83:              ! ʸ ; Declaration statements
    84:              !
    85:              implicit none
    86:              private
    87:            
    88:              ! ³
    89:              ! Public procedure
    90:              !
    91:              public:: RadShortIncome
    92:              public:: RadShortIncomeInit
    93:            
    94:              ! ѿ
    95:              ! Public variables
    96:              !
    97:              logical, save :: rad_short_income_inited = .false.
    98:                                          ! ե饰. 
    99:                                          ! Initialization flag.
   100:            
   101:            
   102:              ! ѿ
   103:              ! Private variables
   104:              !
   105:            
   106:              logical,  save:: FlagAnnualMean
   107:                                          ! ǯʿͥե饰.
   108:                                          ! Flag for annual mean incoming radiation. 
   109:              logical,  save:: FlagDiurnalMean
   110:                                          ! ʿͥե饰.
   111:                                          ! Flag for diurnal mean incoming radiation. 
   112:              logical,  save:: FlagPerpetual
   113:                                          ! Ѳʤͥե饰.
   114:                                          ! Flag for perpetual incoming radiation. 
   115:            
   116:              real(DP), save :: PerpSinDel
   117:                                          ! sine of declination angle for perpetual experiments
   118:              real(DP), save :: PerpDistFromStarScld
   119:                                          ! distance between a planet and a central star for 
   120:                                          ! perpetual experiment
   121:            
   122:            
   123:              ! NOTE:
   124:              !   Distance between the central star and the planet, and the declination can be
   125:              !   determined by specifying following three parameters: 
   126:              !     PerLonFromVE     : the longitude of the perihelion measured from the vernal 
   127:              !                        equinox, 
   128:              !     LonFromVEAtEpoch : the longitude of the planet at epoch, 
   129:              !     epoch            : date or time. 
   130:              !
   131:              real(DP), save:: PerLonFromVE
   132:                                          ! ʬ¬äη () (degree)
   133:                                          ! Longitude of the perihelion from vernal equinox (degree)
   134:              real(DP), save:: LonFromVEAtEpoch
   135:                                          ! ˤη () (degree)
   136:                                          ! Longitude of the planet at epoch (degree)
   137:              real(DP), save:: TimeAtEpoch
   138:                                          ! ˤ (sec)
   139:                                          ! Time at epoch (sec)
   140:            
   141:              real(DP), save:: EpsOrb
   142:                                          ! ƻг.
   143:                                          ! Inclination of equator to orbit.
   144:              real(DP), save:: Eccentricity
   145:                                          ! ΥΨ.
   146:                                          ! Eccentricity.
   147:            
   148:              integer,  save:: MaxItrEccAnomaly
   149:                                          ! ΥѤ׻κ緫֤.
   150:                                          ! Maximum iteration number of times
   151:                                          ! to calculate eccentric anomaly.
   152:              real(DP), save:: ThreEccAnomalyError
   153:                                          ! ΥѤ׻θεƤ.
   154:                                          ! Threshold of error
   155:                                          ! to calculate eccentric anomaly.
   156:            
   157:              real(DP), save:: IncomAIns
   158:                                          ! $ A_{ins} $ . ǯʿͤη. 
   159:                                          ! Coefficient of annual mean incoming radiation. 
   160:              real(DP), save:: IncomBIns
   161:                                          ! $ B_{ins} $ . ǯʿͤη. AIns Ʊ. 
   162:                                          ! Coefficient of annual mean incoming radiation. 
   163:                                          ! Same as "AIns". 
   164:              real(DP), save:: IncomAZet
   165:                                          ! $ A_{\zeta} $ . ǯʿͳѤη. AIns Ʊ. 
   166:                                          ! Coefficient of annual mean incoming radiation. 
   167:                                          ! Same as "AIns". 
   168:              real(DP), save:: IncomBZet
   169:                                          ! $ B_{\zeta} $ . ǯʿͳѤη. AIns Ʊ. 
   170:                                          ! Coefficient of annual mean incoming radiation. 
   171:                                          ! Same as "AIns". 
   172:            
   173:            
   174:              real(DP), allocatable, save:: xy_InAngle (:,:)
   175:                                          ! sec (ͳ). 
   176:                                          ! sec (angle of incidence)
   177:            
   178:              logical:: FlagRadSynchronous
   179:                                          ! ƱžͤΥե饰
   180:                                          ! Flag for synchronous rotation
   181:            
   182:              character(*), parameter:: module_name = 'rad_short_income'
   183:                                          ! ⥸塼̾. 
   184:                                          ! Module name
   185:              character(*), parameter:: version = &
   186:                & '$Name: dcpam5-20120921 $' // &
   187:                & '$Id: rad_short_income.f90,v 1.5 2012-02-01 05:19:53 yot Exp $'
   188:                                          ! ⥸塼ΥС
   189:                                          ! Module version
   190:            
   191:            contains
   192:            
   193:              !--------------------------------------------------------------------------------------
   194:            
   195:              subroutine RadShortIncome(                    &
   196:                & xy_InAngle, DistFromStarScld, xy_CosZet,  & ! (out) optional
   197:                & DiurnalMeanFactor, PlanetLonFromVE,       & ! (out) optional
   198:                & FlagOutput                                & ! (in)  optional
   199:                & )
   200:                !
   201:                ! û () ׻ޤ.
   202:                !
   203:                ! Calculate short wave (insolation) incoming radiation. 
   204:                !
   205:            
   206:                ! ⥸塼 ; USE statements
   207:                !
   208:            
   209:                ! դӻμ갷
   210:                ! Date and time handler
   211:                !
   212:                use dc_calendar, only: DCCalInquire, DCCalDateEvalSecOfDay
   213:            
   214:                ! ҥȥǡ
   215:                ! History data output
   216:                !
   217:                use gtool_historyauto, only: HistoryAutoPut
   218:            
   219:            
   220:                ! ʸ ; Declaration statements
   221:                !
   222:                implicit none
   223:                real(DP), intent(out), optional :: xy_InAngle (0:imax-1, 1:jmax)
   224:                                          ! sec ( ͳ ). 
   225:                                          ! sec ( Incident angle )
   226:                real(DP), intent(out), optional :: DistFromStarScld
   227:                                          ! ƻĹȾ¤ǥ󥰤εΥ
   228:                                          ! Distance from the star scaled
   229:                                          ! by semimajor axis of the planet's orbit
   230:                real(DP), intent(out), optional :: xy_CosZet(0:imax-1, 1:jmax)
   231:                                          ! cos( ͳ )
   232:                                          ! cos( Incident angle )
   233:                real(DP), intent(out), optional :: DiurnalMeanFactor
   234:                real(DP), intent(out), optional :: PlanetLonFromVE
   235:                                          ! 濴濴Ȥɸˤʬ¬äη
   236:                                          ! Longitude of the planet measured from the vernal equinox
   237:                                          ! in the coordinate that the central star is located on 
   238:                                          ! the origin.
   239:                logical , intent(in ), optional :: FlagOutput
   240:            
   241:            
   242:                ! ѿ
   243:                ! Work variables
   244:                !
   245:                integer:: i                ! ˲ DO 롼Ѻѿ
   246:                                           ! Work variables for DO loop in longitude
   247:                integer:: j                ! ˲ DO 롼Ѻѿ
   248:                                           ! Work variables for DO loop in latitude
   249:                real(DP):: SinDel          ! ְ
   250:                                           ! Declination
   251:                real(DP):: CosZet          ! ͳ
   252:                                           ! Incidence angle
   253:                real(DP):: AngleMaxLon     ! ͤȤʤ
   254:            
   255:                real(DP):: HourAngle       ! 
   256:                                           ! Hour angle
   257:                real(DP):: ClockByDay      ! ɽ (0.0 - 1.0)
   258:                                           ! Clock expressed by day (0.0 - 1.0)
   259:            
   260:            
   261:                real(DP) :: xy_InAngleLV       (0:imax-1, 1:jmax)
   262:                                           ! sec ( ͳ ). 
   263:                                           ! sec ( Incident angle )
   264:                                           ! (local variable)
   265:                real(DP) :: DistFromStarScldLV
   266:                                           ! Distance between the central star and the planet
   267:                                           ! (local variable)
   268:                real(DP) :: xy_CosZetLV        (0:imax-1, 1:jmax)
   269:                                           ! cos( ͳ )
   270:                                           ! cos( Incident angle )
   271:                                           ! (local variable)
   272:                real(DP) :: PlanetLonFromVELV
   273:            
   274:                integer         :: hour_in_a_day, min_in_a_hour
   275:                real(DP)        :: sec_in_a_min, sec_in_a_day
   276:            
   277:            
   278:                ! ¹ʸ ; Executable statement
   279:                !
   280:            
   281:                ! ǧ
   282:                ! Initialization check
   283:                !
   284:                if ( .not. rad_short_income_inited ) then
   285:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   286:                end if
   287:            
   288:            
   289:                ! Set flag for diurnally averaged insolation : This is temporary one.
   290:                !
   291:                if ( present( DiurnalMeanFactor ) ) then
   292:                  if ( ( .not. FlagAnnualMean ) .and. FlagDiurnalMean ) then
   293:                    DiurnalMeanFactor = 1.0_DP / PI
   294:                  else
   295:                    DiurnalMeanFactor = 1.0_DP
   296:                  end if
   297:                end if
   298:            
   299:            
   300:                ! ƱžͤΥե饰
   301:                ! Flag for synchronous rotation
   302:                if ( .not. FlagRadSynchronous ) then
   303:            
   304:                  ! ǯ, ʿͤη׻
   305:                  ! Calculate annual mean, daily mean insolation
   306:                  !
   307:            
   308:                  if ( FlagAnnualMean .and. FlagDiurnalMean ) then
   309:            
   310: +------>           do i = 0, imax - 1
   311: |V----->             do j = 1, jmax
   312: ||                     xy_CosZetLV(i,j) = IncomAIns + IncomBIns * cos( y_Lat(j) )**2
   313: ||         
   314: ||                     if ( xy_CosZetLV(i,j) > 0.0_DP ) then
   315: ||                       xy_InAngleLV(i,j) = 1.0_DP / xy_CosZetLV(i,j)
   316: ||                     else
   317: ||                       xy_InAngleLV(i,j) = 0.
   318: ||                     end if
   319: ||         
   320: |V-----              end do
   321: +------            end do
   322:            
   323:                    DistFromStarScldLV = 1.0_DP
   324:                    SinDel             = 0.0_DP
   325:                    PlanetLonFromVELV  = 0.0_DP
   326:            
   327:                  else if ( .not. FlagAnnualMean ) then
   328:            
   329:                    ! Set sine of declination and distance between a planet and a central star 
   330:                    ! scaled with semi-major axis
   331:                    !
   332:                    if ( FlagPerpetual ) then
   333:                      SinDel             = PerpSinDel
   334:                      DistFromStarScldLV = PerpDistFromStarScld
   335:                    else
   336:                      call ShortIncomCalcOrbParam(                       &
   337:                        & SinDel, DistFromStarScldLV, PlanetLonFromVELV  & ! (out) optional
   338:                        & )
   339:                      if ( present( PlanetLonFromVE ) ) PlanetLonFromVE = PlanetLonFromVELV
   340:                    end if
   341:            
   342:            
   343:                    call DCCalInquire( &
   344:                      & hour_in_day      = hour_in_a_day,     & ! (out)
   345:                      & min_in_hour      = min_in_a_hour,     & ! (out)
   346:                      & sec_in_min       = sec_in_a_min       & ! (out)
   347:                      & )
   348:                    sec_in_a_day  = hour_in_a_day * min_in_a_hour * sec_in_a_min
   349:            
   350:                    ! This is old version to be deleted, yot, 2010/09/23.
   351:            !!$        ClockByDay = mod( TimeN / sec_in_a_day, 1.0_DP )
   352:                    !
   353:                    ClockByDay = DCCalDateEvalSecOfDay( TimeN, date = InitialDate )
   354:                    ClockByDay = ClockByDay / sec_in_a_day
   355:            
   356:            
   357:            !!$        write( 6, * ) '###', TimeN, ClockByDay, mod( TimeN / sec_in_a_day, 1.0_DP )
   358:            !!$        write( 60, * ) TimeN, ClockByDay, mod( TimeN / sec_in_a_day, 1.0_DP )
   359:            !!$        call flush( 60 )
   360:            
   361:            
   362: +------>           do i = 0, imax - 1
   363: |V----->             do j = 1, jmax
   364: ||         
   365: ||         
   366: ||                     if ( FlagDiurnalMean ) then
   367: ||                       HourAngle = 0.0_DP
   368: ||                     else
   369: ||                       HourAngle = ClockByDay * 2.0_DP * PI - PI + x_Lon(i)
   370: ||                     end if
   371: ||         
   372: ||                     CosZet = sin( y_Lat(j) ) * SinDel &
   373: ||                       &  + cos( y_Lat(j) ) * sqrt( 1.0_DP - SinDel**2 ) * cos( HourAngle )
   374: ||         
   375: ||                     xy_CosZetLV(i,j) = CosZet
   376: ||         
   377: ||                     if ( CosZet > 0.0_DP ) then
   378: ||                       xy_InAngleLV(i,j)       = 1.0_DP / CosZet
   379: ||                     else
   380: ||                       xy_InAngleLV(i,j)       = 0.
   381: ||                     end if
   382: ||         
   383: |V-----              end do
   384: +------            end do
   385:            
   386:                  else
   387:            
   388:                    ! бƤʤͥ
   389:                    ! not implemented insolation type
   390:                    !
   391:                    call MessageNotify( 'E', module_name, 'This type of insolation is not impremented' )
   392:            
   393:                  end if
   394:            
   395:                else
   396:            
   397:                  ! û () ׻ޤ.
   398:                  ! ƱžꤷƤ,
   399:                  ! ˷ 90 ٤Ǻ,  180-360 ٤ͥȤʤäƤޤ.
   400:                  !
   401:                  ! Calculate short wave (insolation) incoming radiation.
   402:                  ! A planet with synchronized rotation are assumed.
   403:                  ! Incoming is max at latitude 90 deg., and zero between 180 and 360 deg. constantly.
   404: +------>         do i = 0, imax - 1
   405: |                   AngleMaxLon  = - PI / 2.0_DP + x_Lon( i )
   406: |V----->            do j = 1, jmax
   407: ||                     CosZet = cos( y_Lat(j) ) * cos( AngleMaxLon )
   408: ||         
   409: ||                     xy_CosZetLV(i,j) = CosZet
   410: ||         
   411: ||                     if ( CosZet > 0.0_DP ) then
   412: ||                        xy_InAngleLV(i,j) = 1.0_DP / CosZet
   413: ||                     else
   414: ||                        xy_InAngleLV(i,j) = 0.0_DP
   415: ||                     end if
   416: ||         
   417: ||                     DistFromStarScldLV = 1.0_DP
   418: |V-----             end do
   419: +------          end do
   420:            
   421:                end if
   422:            
   423:            
   424:                if ( present( xy_InAngle ) ) then
   425: +V=====          xy_InAngle = xy_InAngleLV
   426:                end if
   427:                if ( present( xy_CosZet ) ) then
   428: +V=====          xy_CosZet = xy_CosZetLV
   429:                end if
   430:                if ( present( DistFromStarScld ) ) then
   431:                  DistFromStarScld = DistFromStarScldLV
   432:                end if
   433:            
   434:                ! ҥȥǡ
   435:                ! History data output
   436:                !
   437:                if ( present( FlagOutput ) ) then
   438:                  if ( FlagOutput ) then
   439:                    call HistoryAutoPut( TimeN, 'Decl'            , asin(SinDel)*180.0_DP/PI      )
   440:                    call HistoryAutoPut( TimeN, 'DistFromStarScld', DistFromStarScldLV            )
   441:                    call HistoryAutoPut( TimeN, 'PlanetLonFromVE' , PlanetLonFromVELV*180.0_DP/PI )
   442:                  end if
   443:                else
   444:                  call HistoryAutoPut( TimeN, 'Decl'            , asin(SinDel)*180.0_DP/PI      )
   445:                  call HistoryAutoPut( TimeN, 'DistFromStarScld', DistFromStarScldLV            )
   446:                  call HistoryAutoPut( TimeN, 'PlanetLonFromVE' , PlanetLonFromVELV*180.0_DP/PI )
   447:                end if
   448:            
   449:            
   450:              end subroutine RadShortIncome
   451:            
   452:              !--------------------------------------------------------------------------------------
   453:            
   454:              subroutine ShortIncomCalcOrbParam(             &
   455:                & SinDel, DistFromStarScld, PlanetLonFromVE  & ! (out)
   456:                & )
   457:                !
   458:                ! û () ׻ޤ.
   459:                !
   460:                ! Calculate short wave (insolation) incoming radiation. 
   461:                !
   462:            
   463:                ! ⥸塼 ; USE statements
   464:                !
   465:            
   466:                ! դӻμ갷
   467:                ! Date and time handler
   468:                !
   469:                use dc_calendar, only: DCCalInquire, DCCalDateChkLeapYear
   470:            
   471:                ! ʸ ; Declaration statements
   472:                !
   473:                implicit none
   474:                real(DP), intent(out) :: SinDel
   475:                                          ! ְ
   476:                                          ! Declination
   477:                real(DP), intent(out) :: DistFromStarScld
   478:                                          ! ƻĹȾ¤ǥ󥰤εΥ
   479:                                          ! Distance from the star scaled
   480:                                          ! by semimajor axis of the planet's orbit
   481:                real(DP), intent(out) :: PlanetLonFromVE
   482:                                          ! 濴濴Ȥɸˤʬ¬äη
   483:                                          ! Longitude of the planet measured from the vernal equinox
   484:                                          ! in the coordinate that the central star is located on 
   485:                                          ! the origin.
   486:            
   487:                ! ѿ
   488:                ! Work variables
   489:                !
   490:                integer:: itr              ! ƥ졼˲ DO 롼Ѻѿ
   491:                                           ! Work variables for DO loop in iteration direction
   492:            
   493:                real(DP):: MeanAnomaly     ! ʿѶ
   494:                                           ! Mean anomaly
   495:                real(DP):: EccAnomaly      ! Υ
   496:                                           ! eccentric anomaly
   497:                real(DP):: EccAnomalyError ! ˥塼ȥˡˤΥѤθ
   498:                                           ! error of eccentric anomaly in Newton method
   499:                real(DP):: TrueAnomaly     ! Υ
   500:                                           ! true anomaly
   501:            
   502:                integer         :: hour_in_a_day, min_in_a_hour, day_in_a_year
   503:                integer, pointer:: day_in_month_ptr(:) => null()
   504:                real(DP)        :: sec_in_a_min, sec_in_a_day, sec_in_a_year
   505:            
   506:            
   507:            
   508:                ! ¹ʸ ; Executable statement
   509:                !
   510:            
   511:                ! ǧ
   512:                ! Initialization check
   513:                !
   514:                if ( .not. rad_short_income_inited ) then
   515:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   516:                end if
   517:            
   518:            
   519:                ! Ѳ, Ѳη׻
   520:                ! Calculate with seasonal change and diurnal change
   521:                !
   522:                call DCCalInquire( &
   523:                  & day_in_month_ptr = day_in_month_ptr , & ! (out)
   524:                  & hour_in_day      = hour_in_a_day,     & ! (out)
   525:                  & min_in_hour      = min_in_a_hour,     & ! (out)
   526:                  & sec_in_min       = sec_in_a_min       & ! (out)
   527:                  & )
   528:                ! Add 1 to day_in_month_ptr(2) if it is leap year.
   529:                !
   530:                if ( DCCalDateChkLeapYear( TimeN, InitialDate ) ) then
   531:                  day_in_month_ptr(2) = day_in_month_ptr(2) + 1
   532:                end if
   533:            
   534: V======        day_in_a_year = sum( day_in_month_ptr )
   535:                deallocate( day_in_month_ptr )
   536:                sec_in_a_day  = hour_in_a_day * min_in_a_hour * sec_in_a_min
   537:                sec_in_a_year = day_in_a_year * sec_in_a_day
   538:            
   539:                MeanAnomaly  =                                               &
   540:                  &   2.0_DP * PI * ( TimeN - TimeAtEpoch ) / sec_in_a_year  &
   541:                  & + ( LonFromVEAtEpoch - PerLonFromVE ) * PI / 180.0_DP
   542:                MeanAnomaly  = mod( MeanAnomaly, 2.0_DP * PI )
   543:            
   544:            
   545:                ! ˥塼ȥˡѤʿѶѤΥѤ.
   546:                ! Calculate eccentric anomaly from mean anomaly by using Newton method.
   547:            
   548:                EccAnomaly = MeanAnomaly
   549: +------>       do itr = 1, MaxItrEccAnomaly
   550: |                EccAnomalyError = EccAnomaly                                        &
   551: |                  & - Eccentricity * sin(EccAnomaly) - MeanAnomaly
   552: |                if ( abs(EccAnomalyError) <= ThreEccAnomalyError ) exit
   553: |                EccAnomaly      = EccAnomaly                                        &
   554: |                  & - EccAnomalyError / ( 1.0_DP - Eccentricity * cos(EccAnomaly) )
   555: |                EccAnomaly      = mod( EccAnomaly, 2.0 * PI )
   556: +------        end do
   557:                if ( itr > MaxItrEccAnomaly ) then
   558:                  call MessageNotify( 'E', module_name,                        &
   559:                    & 'Calculation for eccentric anomaly does not converge.' )
   560:                end if
   561:            
   562:                DistFromStarScld = 1.0_DP - Eccentricity * cos( EccAnomaly )
   563:            
   564:                TrueAnomaly = 2.0_DP                                                    &
   565:                  & * atan(                                                             &
   566:                  &         sqrt( ( 1.0d0 + Eccentricity ) / ( 1.0d0 - Eccentricity ) ) &
   567:                  &           * tan( EccAnomaly / 2.0_DP )                              &
   568:                  &       )
   569:            
   570:                PlanetLonFromVE = TrueAnomaly + PerLonFromVE * PI / 180.0_DP
   571:                PlanetLonFromVE = mod( PlanetLonFromVE, 2.0_DP * PI )
   572:            
   573:                SinDel = sin( EpsOrb * PI / 180.0_DP ) * sin( PlanetLonFromVE )
   574:            
   575:            
   576:                    ! code for debug
   577:            !!$        write( 60, * ) TimeN/sec_in_a_day, DCCalDateChkLeapYear(TimeN,date=InitialDate), day_in_a_year
   578:            !!$        write(  6, * ) TimeN/sec_in_a_day, DCCalDateChkLeapYear(TimeN,date=InitialDate), day_in_a_year
   579:            !!$        call flush( 60 )
   580:            
   581:            
   582:            !!$        write( 60, * ) TimeN/sec_in_a_day, asin(SinDel)*180.0/PI, DistFromStarScld, PlanetLonFromVE*180.0_DP/PI
   583:            !!$        write(  6, * ) TimeN/sec_in_a_day, asin(SinDel)*180.0/PI, DistFromStarScld, PlanetLonFromVE*180.0_DP/PI
   584:            !!$        call flush( 60 )
   585:            
   586:            
   587:              end subroutine ShortIncomCalcOrbParam
   588:            
   589:              !--------------------------------------------------------------------------------------
   590:            
   591:              subroutine RadShortIncomeInit
   592:                !
   593:                ! rad_short_income ⥸塼νԤޤ. 
   594:                ! NAMELIST#rad_short_income_nml ɤ߹ߤϤμ³ǹԤޤ. 
   595:                !
   596:                ! "rad_short_income" module is initialized. 
   597:                ! "NAMELIST#rad_short_income_nml" is loaded in this procedure. 
   598:                !
   599:            
   600:                ! ⥸塼 ; USE statements
   601:                !
   602:            
   603:                ! ̷ѥ᥿
   604:                ! Kind type parameter
   605:                !
   606:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   607:            
   608:                ! ե
   609:                ! File I/O support
   610:                !
   611:                use dc_iounit, only: FileOpen
   612:            
   613:                ! ҥȥǡ
   614:                ! History data output
   615:                !
   616:                use gtool_historyauto, only: HistoryAutoAddVariable
   617:            
   618:                ! μ갷
   619:                ! Calendar and Date handler
   620:                !
   621:                use dc_calendar, only: &
   622:                  & DC_CAL_DATE, &          ! ɽǡ.
   623:                                            ! Data type for date and time
   624:                  & DCCalDateInquire, DCCalDateCreate, DCCalDateDifference
   625:            
   626:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   627:                ! Utilities for NAMELIST file input
   628:                !
   629:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   630:            
   631:                ! ʸ ; Declaration statements
   632:                !
   633:                implicit none
   634:            
   635:                integer:: EpochYear, EpochMonth, EpochDay, EpochHour, EpochMin
   636:                                          !  (ǯʬ).
   637:                                          ! "TimeAtEpoch" ξˤ餬Ѥ.
   638:                                          !
   639:                                          ! Date at epoch (year, month, day, hour, minute)
   640:                                          ! These are used when "TimeAtEpoch" is negative.
   641:                real(DP):: EpochSec
   642:                                          !  ().
   643:                                          ! "TimeAtEpoch" ξˤ餬Ѥ.
   644:                                          !
   645:                                          ! Date at epoch (second)
   646:                                          ! These are used when "TimeAtEpoch" is negative.
   647:            
   648:                type(DC_CAL_DATE):: EpochDate
   649:                                          ! 
   650:                                          ! Date at epoch
   651:            
   652:                real(DP)         :: PerpDelDeg
   653:                                          ! Declination angle in degree used for perpetual experiment
   654:            
   655:                integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   656:                                          ! Unit number for NAMELIST file open
   657:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   658:                                          ! IOSTAT of NAMELIST read
   659:            
   660:                logical         :: FlagUseOfEpochDate
   661:                character(TOKEN):: date_print
   662:            
   663:            
   664:                ! NAMELIST ѿ
   665:                ! NAMELIST group name
   666:                !
   667:                namelist /rad_short_income_nml/                                     &
   668:                  & FlagRadSynchronous,                                             &
   669:                  & FlagAnnualMean, FlagDiurnalMean, FlagPerpetual,                 &
   670:                  & PerpDelDeg, PerpDistFromStarScld,                               &
   671:                  & EpsOrb,                                                         &
   672:                  & PerLonFromVE,                                                   &
   673:                  & LonFromVEAtEpoch,                                               &
   674:                  & Eccentricity,                                                   &
   675:                  & TimeAtEpoch,                                                    &
   676:                  & EpochYear, EpochMonth, EpochDay, EpochHour, EpochMin, EpochSec, &
   677:                  & MaxItrEccAnomaly, ThreEccAnomalyError,                          &
   678:                  & IncomAIns, IncomBIns, IncomAZet, IncomBZet
   679:                      !
   680:                      ! ǥեͤˤĤƤϽ³ "rad_short_income#RadShortIncomeInit" 
   681:                      ! Υɤ򻲾ȤΤ. 
   682:                      !
   683:                      ! Refer to source codes in the initialization procedure
   684:                      ! "rad_short_income#RadShortIncomeInit" for the default values. 
   685:                      !
   686:            
   687:                ! ¹ʸ ; Executable statement
   688:                !
   689:            
   690:                if ( rad_short_income_inited ) return
   691:            
   692:            
   693:                ! ǥեͤ
   694:                ! Default values settings
   695:                !
   696:                FlagRadSynchronous       = .false.
   697:                FlagAnnualMean           = .true.
   698:                FlagDiurnalMean          = .true.
   699:                FlagPerpetual            = .false.
   700:            
   701:                !---
   702:            
   703:                PerpDelDeg               = 0.0_DP
   704:                PerpDistFromStarScld     = 1.0_DP
   705:            
   706:                !---
   707:            
   708:                EpsOrb               =   23.5_DP    ! Earth-like value
   709:                PerLonFromVE         =    0.0_DP
   710:                LonFromVEAtEpoch     =  280.0_DP    ! This value results in the fact that the planet
   711:                                                    ! is located at the position of vernal equinox 
   712:                                                    ! at 80 days after calculation with the use of 
   713:                                                    ! "360day" calendar.
   714:                Eccentricity         =    0.0_DP
   715:                TimeAtEpoch          =    0.0_DP
   716:                EpochYear            =   -1
   717:                EpochMonth           =   -1
   718:                EpochDay             =   -1
   719:                EpochHour            =   -1
   720:                EpochMin             =   -1
   721:                EpochSec             =   -1.0_DP
   722:            
   723:                !---
   724:            
   725:                ! Sample values for the Earth
   726:                !  References: 
   727:                !    Duffett-Smith, P., Practical astronomy with your calculator Third Edition, 
   728:                !    Cambridge University Press, pp.185, 1988.
   729:                !
   730:            !!$    EpsOrb               =   23.44_DP                ! Rika nenpyo (Chronological 
   731:            !!$                                                     ! Scientific Tables 2010)
   732:            !!$    PerLonFromVE         =  102.768413_DP + 180.0_DP ! Duffett-Smith (1988), p.105
   733:            !!$                                                     ! modified (plus 180 degrees)
   734:            !!$    LonFromVEAtEpoch     =   99.403308_DP + 180.0_DP ! Duffett-Smith (1988), p.105
   735:            !!$                                                     ! modified (plus 180 degrees)
   736:            !!$    Eccentricity         =    0.016713_DP            ! Duffett-Smith (1988), p.105
   737:            !!$    TimeAtEpoch          =   -1.0_DP                 ! EpochXXX written below are used 
   738:            !!$                                                     ! because this is negative.
   739:            !!$    EpochYear            = 1990                      ! Duffett-Smith (1988), p.105
   740:            !!$    EpochMonth           =    1
   741:            !!$    EpochDay             =    1
   742:            !!$    EpochHour            =    0
   743:            !!$    EpochMin             =    0
   744:            !!$    EpochSec             =    0.0_DP
   745:                !---
   746:            
   747:                ! Sample values for Mars
   748:                !  References: 
   749:                !    Allison, M., Geophys. Res. Lett., 24, 1967-1970, 1997.
   750:                !
   751:            !!$    EpsOrb               =   25.19_DP              ! Allison (1997)
   752:            !!$    PerLonFromVE         =  250.98_DP              ! Allison (1997) (modified)
   753:            !!$    LonFromVEAtEpoch     =  -10.342_DP             ! Arbitrarily set for clarity
   754:            !!$                                                   ! This results in Ls ~ 0 at Time = 0
   755:            !!$    Eccentricity         =    0.0934_DP            ! Allison (1997), value at epoch J2000
   756:            !!$    TimeAtEpoch          =    0.0_DP               ! Arbitrarily set for clarity
   757:            !!$    EpochYear            =   -1                    ! not used
   758:            !!$    EpochMonth           =   -1
   759:            !!$    EpochDay             =   -1
   760:            !!$    EpochHour            =   -1
   761:            !!$    EpochMin             =   -1
   762:            !!$    EpochSec             =   -1.0_DP
   763:            
   764:                !---
   765:            
   766:                MaxItrEccAnomaly     = 20
   767:                ThreEccAnomalyError  = 1e-6_DP
   768:            
   769:                IncomAIns            = 0.127_DP   ! Reference of this value is unknown.
   770:                IncomBIns            = 0.183_DP   ! Reference of this value is unknown.
   771:                IncomAZet            = 0.410_DP   ! Reference of this value is unknown.
   772:                IncomBZet            = 0.590_DP   ! Reference of this value is unknown.
   773:            
   774:                ! NAMELIST ɤ߹
   775:                ! NAMELIST is input
   776:                !
   777:                if ( trim(namelist_filename) /= '' ) then
   778:                  call FileOpen( unit_nml, &          ! (out)
   779:                    & namelist_filename, mode = 'r' ) ! (in)
   780:            
   781:                  rewind( unit_nml )
   782:                  read( unit_nml, &                ! (in)
   783:                    & nml = rad_short_income_nml, &  ! (out)
   784:                    & iostat = iostat_nml )        ! (out)
   785:                  close( unit_nml )
   786:            
   787:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   788:                end if
   789:            
   790:            
   791:                PerpSinDel = sin( PerpDelDeg * PI / 180.0_DP )
   792:            
   793:            
   794:                FlagUseOfEpochDate = .false.
   795:            
   796:                if ( TimeAtEpoch < 0.0_DP ) then
   797:                  call DCCalDateCreate(    &
   798:                    & year  = EpochYear,   & ! (in)
   799:                    & month = EpochMonth,  & ! (in)
   800:                    & day   = EpochDay,    & ! (in)
   801:                    & hour  = EpochHour,   & ! (in)
   802:                    & min   = EpochMin,    & ! (in)
   803:                    & sec   = EpochSec,    & ! (in)
   804:                    & date  = EpochDate )    ! (out) optional
   805:            
   806:                  TimeAtEpoch = DCCalDateDifference( &
   807:                    &                                 start_date = InitialDate, &  ! (in)
   808:                    &                                 end_date   = EpochDate    &  ! (in)
   809:                    &                              )
   810:            
   811:                  FlagUseOfEpochDate = .true.
   812:                end if
   813:            
   814:                ! ¸Ѥѿγդ
   815:                ! Allocate variables for saving
   816:                !
   817:            
   818:                ! ҥȥǡϤΤΤؤѿϿ
   819:                ! Register of variables for history data output
   820:                !
   821:            !!$    call HistoryAutoAddVariable( 'xxxxx' , &
   822:            !!$      & (/ 'lon ', 'lat ', 'sig', 'time'/), &
   823:            !!$      & 'xxxx', 'W m-2' )
   824:            
   825:                call HistoryAutoAddVariable( 'ISR' , &
   826:                  & (/ 'lon ', 'lat ', 'time'/),     &
   827:                  & 'incoming shortwave', 'W m-2' )
   828:            
   829:                call HistoryAutoAddVariable( 'Decl' , &
   830:                  & (/ 'time'/),                      &
   831:                  & 'declination angle', 'degree' )
   832:            
   833:                call HistoryAutoAddVariable( 'DistFromStarScld' , &
   834:                  & (/ 'time'/),                                  &
   835:                  & 'distance between the central star and the planet', '1' )
   836:            
   837:                call HistoryAutoAddVariable( 'PlanetLonFromVE' , &
   838:                  & (/ 'time'/),                                 &
   839:                  & 'planetary longitude from the vernal equinox', 'degree' )
   840:            
   841:                !  ; Print
   842:                !
   843:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   844:                call MessageNotify( 'M', module_name, 'ShortIncomming:' )
   845:                call MessageNotify( 'M', module_name, '  FlagRadSynchronous       = %b', l = (/ FlagRadSynchronous /) )
   846:                call MessageNotify( 'M', module_name, '  FlagAnnualMean           = %b', l = (/ FlagAnnualMean            /) )
   847:                call MessageNotify( 'M', module_name, '  FlagDiurnalMean          = %b', l = (/ FlagDiurnalMean           /) )
   848:                call MessageNotify( 'M', module_name, '  FlagPerpetual            = %b', l = (/ FlagPerpetual             /) )
   849:                call MessageNotify( 'M', module_name, '  PerpDelDeg               = %f', d = (/ PerpDelDeg                /) )
   850:                call MessageNotify( 'M', module_name, '  PerpDistFromStarScld     = %f', d = (/ PerpDistFromStarScld      /) )
   851:                call MessageNotify( 'M', module_name, '  EpsOrb                   = %f', d = (/ EpsOrb                   /) )
   852:                call MessageNotify( 'M', module_name, '  PerLonFromVE             = %f', d = (/ PerLonFromVE             /) )
   853:                call MessageNotify( 'M', module_name, '  Eccentricity             = %f', d = (/ Eccentricity             /) )
   854:            
   855:                if ( FlagUseOfEpochDate ) then
   856:                  call DCCalDateInquire( date_print, date = EpochDate )
   857:                  call MessageNotify( 'M', module_name, '  EpochDate  = %c', &
   858:                    & c1 = trim(date_print) )
   859:                end if
   860:                call MessageNotify( 'M', module_name, '  TimeAtEpoch              = %f', d = (/ TimeAtEpoch              /) )
   861:                call MessageNotify( 'M', module_name, '  LonFromVEAtEpoch         = %f', d = (/ LonFromVEAtEpoch         /) )
   862:            
   863:                call MessageNotify( 'M', module_name, '  MaxItrEccAnomaly         = %d', i = (/ MaxItrEccAnomaly         /) )
   864:                call MessageNotify( 'M', module_name, '  ThreEccAnomalyError      = %f', d = (/ ThreEccAnomalyError      /) )
   865:                call MessageNotify( 'M', module_name, '  IncomAIns                = %f', d = (/ IncomAIns                /) )
   866:                call MessageNotify( 'M', module_name, '  IncomBIns                = %f', d = (/ IncomBIns                /) )
   867:                call MessageNotify( 'M', module_name, '  IncomAZet                = %f', d = (/ IncomAZet                /) )
   868:                call MessageNotify( 'M', module_name, '  IncomBZet                = %f', d = (/ IncomBZet                /) )
   869:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   870:            
   871:                rad_short_income_inited = .true.
   872:            
   873:              end subroutine RadShortIncomeInit
   874:            
   875:              !-------------------------------------------------------------------
   876:            
   877:            end module rad_short_income
