Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:29 2012
FILE NAME: major_comp_phase_change.f90
PROGRAM NAME: major_comp_phase_change
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   236  vec  (   1): Vectorized loop.
   250  opt  (1592): Outer loop unrolled inside inner loop.
   250  vec  (   4): Vectorized array expression.
   250  vec  (   4): Vectorized array expression.
   259  vec  (   3): Unvectorized loop.
   259  vec  (  13): Overhead of loop division is too large.
   260  opt  (1592): Outer loop unrolled inside inner loop.
   260  vec  (   4): Vectorized array expression.
   260  vec  (   4): Vectorized array expression.
   266  vec  (   1): Vectorized loop.
   279  opt  (1592): Outer loop unrolled inside inner loop.
   279  vec  (   4): Vectorized array expression.
   279  vec  (   4): Vectorized array expression.
   281  opt  (1019): Feedback of scalar value from one loop pass to another.
   281  opt  (1592): Outer loop unrolled inside inner loop.
   281  vec  (   4): Vectorized array expression.
   281  vec  (   4): Vectorized array expression.
   283  vec  (   1): Vectorized loop.
   315  opt  (1592): Outer loop unrolled inside inner loop.
   315  vec  (   4): Vectorized array expression.
   315  vec  (   4): Vectorized array expression.
   318  vec  (   1): Vectorized loop.
   367  opt  (1592): Outer loop unrolled inside inner loop.
   367  vec  (   4): Vectorized array expression.
   367  vec  (   4): Vectorized array expression.
   373  opt  (1592): Outer loop unrolled inside inner loop.
   373  vec  (   4): Vectorized array expression.
   373  vec  (   4): Vectorized array expression.
   374  vec  (   3): Unvectorized loop.
   374  vec  (  13): Overhead of loop division is too large.
   375  opt  (1592): Outer loop unrolled inside inner loop.
   375  vec  (   4): Vectorized array expression.
   375  vec  (   4): Vectorized array expression.
   377  opt  (  11): Fused array assignments. :line 377 - 386
   377  vec  (   4): Vectorized array expression.
   377  vec  (   4): Vectorized array expression.
   386  opt  (1592): Outer loop unrolled inside inner loop.
   400  warn (  81): Name "xy_surftempcond" is referenced but not defined.
   520  opt  (1593): Loop nest collapsed into one loop.
   520  vec  (   1): Vectorized loop.
   535  opt  (1592): Outer loop unrolled inside inner loop.
   535  vec  (   4): Vectorized array expression.
   535  vec  (   4): Vectorized array expression.
   546  vec  (   1): Vectorized loop.
   546  vec  (   1): Vectorized loop.
   550  opt  (1592): Outer loop unrolled inside inner loop.
   557  opt  (1592): Outer loop unrolled inside inner loop.
   557  vec  (   4): Vectorized array expression.
   557  vec  (   4): Vectorized array expression.
   563  opt  (1592): Outer loop unrolled inside inner loop.
   563  vec  (   4): Vectorized array expression.
   563  vec  (   4): Vectorized array expression.
   564  vec  (   3): Unvectorized loop.
   564  vec  (  13): Overhead of loop division is too large.
   565  opt  (1592): Outer loop unrolled inside inner loop.
   565  vec  (   4): Vectorized array expression.
   565  vec  (   4): Vectorized array expression.
   570  opt  (  11): Fused array assignments. :line 570 - 576
   570  vec  (   4): Vectorized array expression.
   570  vec  (   4): Vectorized array expression.
   576  opt  (1592): Outer loop unrolled inside inner loop.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:29 2012
FILE NAME: major_comp_phase_change.f90
PROGRAM NAME: major_comp_phase_change
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ʬѲ
     2  !
     3  != Phase change of atmospheric major component
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: major_comp_phase_change.f90,v 1.1 2012-09-08 15:16:39 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module major_comp_phase_change
    13    !
    14    != ʬѲ
    15    !
    16    != Phase change of atmospheric major component
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    !== Procedures List
    21    !
    22  !!$  ! DryConvAdjust :: ήĴ
    23  !!$  ! ------------  :: ------------
    24  !!$  ! DryConvAdjust :: Dry convective adjustment
    25    !
    26    !== NAMELIST
    27    !
    28    ! NAMELIST#major_comp_phase_change_nml
    29    !
    30  
    31    ! ⥸塼 ; USE statements
    32    !
    33  
    34    ! ʻ
    35    ! Grid points settings
    36    !
    37    use gridset, only: imax, & ! ٳʻ.
    38                               ! Number of grid points in longitude
    39      &                jmax, & ! ٳʻ.
    40                               ! Number of grid points in latitude
    41      &                kmax    ! ľؿ.
    42                               ! Number of vertical level
    43  
    44    ! ̷ѥ᥿
    45    ! Kind type parameter
    46    !
    47    use dc_types, only: DP, &      ! ټ¿. Double precision.
    48      &                 STRING     ! ʸ.       Strings.
    49  
    50    ! NAMELIST եϤ˴ؤ桼ƥƥ
    51    ! Utilities for NAMELIST file input
    52    !
    53    use namelist_util, only: MaxNmlArySize
    54                                ! NAMELIST ɤ߹κ祵.
    55                                ! Maximum size of arrays loaded from NAMELIST
    56  
    57    ! å
    58    ! Message output
    59    !
    60    use dc_message, only: MessageNotify
    61  
    62    ! ʸ ; Declaration statements
    63    !
    64    implicit none
    65    private
    66  
    67  
    68    ! ³
    69    ! Public procedure
    70    !
    71    public :: MajorCompPhaseChangeInAtm
    72    public :: MajorCompPhaseChangeInit
    73  
    74  
    75    ! ѿ
    76    ! Public variables
    77    !
    78    logical, save, public:: major_comp_phase_change_inited = .false.
    79                                ! ե饰.
    80                                ! Initialization flag
    81  
    82    ! ѿ
    83    ! Private variables
    84    !
    85    logical, save :: FlagMajCompPhaseChange
    86  
    87  
    88    character(*), parameter:: module_name = 'major_comp_phase_change'
    89                                ! ⥸塼̾.
    90                                ! Module name
    91    character(*), parameter:: version = &
    92      & '$Name: dcpam5-20120921 $' // &
    93      & '$Id: major_comp_phase_change.f90,v 1.1 2012-09-08 15:16:39 yot Exp $'
    94                                ! ⥸塼ΥС
    95                                ! Module version
    96  
    97  
    98  contains
    99  
   100    !-------------------------------------------------------------------
   101  
   102    subroutine MajorCompPhaseChangeInAtmTest(  &
   103      & xyr_Press, xyz_Press, xyz_Height,      &  ! (in)
   104      & xy_Ps, xyz_Temp, xy_SurfMajCompIce     &  ! (inout)
   105      & )
   106      !
   107      ! CO2 Ѳ
   108      !
   109      ! CO2 phase change
   110      !
   111  
   112      ! ⥸塼 ; USE statements
   113      !
   114  
   115      ! 
   116      ! Time control
   117      !
   118      use timeset, only: &
   119        & DelTime, &            ! $ \Delta t $
   120        & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $.
   121        & TimesetClockStart, TimesetClockStop
   122  
   123      ! ҥȥǡ
   124      ! History data output
   125      !
   126      use gtool_historyauto, only: HistoryAutoPut
   127  
   128      ! ʪ
   129      ! Physical constants settings
   130      !
   131      use constants, only: &
   132        & Grav, &               ! $ g $ [m s-2].
   133                                ! ϲ®.
   134                                ! Gravitational acceleration
   135        & CpDry
   136                                ! $ C_p $ [J kg-1 K-1].
   137                                ! 絤갵Ǯ.
   138                                ! Specific heat of air at constant pressure
   139  
   140      ! ʬѲ
   141      ! Phase change of atmospheric major component
   142      !
   143      use major_comp_saturate, only :     &
   144        & MajorCompSaturateCalcCondTemp,  &
   145        & MajorCompSaturateInqLatentHeat
   146  
   147  
   148      ! ʸ ; Declaration statements
   149      !
   150      implicit none
   151  
   152      real(DP), intent(in   ):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
   153                                ! $ \hat{p} $ .  (Ⱦ٥).
   154                                ! Air pressure (half level)
   155      real(DP), intent(in   ):: xyz_Press (0:imax-1, 1:jmax, 1:kmax)
   156                                ! $ p $ .  (٥).
   157                                ! Air pressure (full level)
   158      real(DP), intent(in   ):: xyz_Height(0:imax-1, 1:jmax, 1:kmax)
   159                                !
   160                                !
   161      real(DP), intent(inout):: xy_Ps            (0:imax-1, 1:jmax)
   162                                ! $ T $ .     . Temperature
   163      real(DP), intent(inout):: xyz_Temp         (0:imax-1, 1:jmax, 1:kmax)
   164                                ! $ T $ .     . Temperature
   165      real(DP), intent(inout):: xy_SurfMajCompIce(0:imax-1, 1:jmax)
   166                                !
   167                                ! Surface major component ice amount
   168  
   169      ! ѿ
   170      ! Work variables
   171      !
   172      real(DP):: xyz_TempB           (0:imax-1, 1:jmax, 1:kmax)
   173                                ! Ĵβ.
   174                                ! Temperature before adjustment
   175      real(DP):: xyz_DelAtmMass      (0:imax-1, 1:jmax, 1:kmax)
   176                                !
   177                                ! Atmospheric mass in a layer
   178      real(DP):: xy_FallingIce       (0:imax-1, 1:jmax)
   179                                !
   180                                !
   181      real(DP):: xyz_DelMajCompIce   (0:imax-1, 1:jmax, 1:kmax)
   182                                !
   183                                !
   184      real(DP):: xy_DelSurfMajCompIce(0:imax-1, 1:jmax)
   185                                !
   186                                !
   187      real(DP):: xyz_DTempDt         (0:imax-1, 1:jmax, 1:kmax)
   188                                ! ѲΨ.
   189                                ! Temperature tendency
   190      real(DP):: xy_DSurfMajCompIceDt(0:imax-1, 1:jmax)
   191                                !
   192                                ! Surface major component ice tendency
   193  
   194      real(DP):: xyz_TempCond   (0:imax-1, 1:jmax, 1:kmax)
   195      real(DP):: xy_SurfTempCond(0:imax-1, 1:jmax)
   196      real(DP):: SpecHeatCO2Ice
   197  
   198      real(DP):: LatentHeatMajCompSubl
   199  
   200      integer:: i               ! ˲ DO 롼Ѻѿ
   201                                ! Work variables for DO loop in longitude
   202      integer:: j               ! ˲ DO 롼Ѻѿ
   203                                ! Work variables for DO loop in latitude
   204      integer:: k               ! ľ˲ DO 롼Ѻѿ
   205                                ! Work variables for DO loop in vertical direction
   206  
   207      logical :: FlagCheckPs
   208  
   209  
   210      ! ¹ʸ ; Executable statement
   211      !
   212  
   213      ! 
   214      ! Initialization
   215      !
   216      if ( .not. major_comp_phase_change_inited ) then
   217        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   218      end if
   219  
   220  
   221      if ( .not. FlagMajCompPhaseChange ) return
   222  
   223  
   224      ! ׻ַ¬
   225      ! Start measurement of computation time
   226      !
   227      call TimesetClockStart( module_name )
   228  
   229  
   230      ! Set latent heat
   231      LatentHeatMajCompSubl = MajorCompSaturateInqLatentHeat()
   232  
   233  
   234      FlagCheckPs = .false.
   235      do j = 1, jmax
   236        do i = 0, imax-1
   237          if ( xyr_Press(i,j,0) > 1.0d4 ) then
   238            FlagCheckPs = .true.
   239          end if
   240        end do
     .        i = 0                                                             
     .        if (imax .gt. 0) then                                             
     .  !CDIR    NODEP                                                          
     .           do i = 1, imax                                                 
     .              if (xyr_press(i-1,j,0) .gt. 1.00000000000000e+004) then     
     .                 flagcheckps = 1                                          
     .              endif                                                       
     .           end do                                                         
     .           i = imax                                                       
     .        endif                                                             
   241      end do
   242      if ( FlagCheckPs ) then
   243        call MessageNotify( 'W', module_name, 'Surface pressure is greater than 10000 Pa.' )
   244      end if
   245  
   246  
   247      ! Ĵ "Temp" ¸
   248      ! Store "Temp" before adjustment
   249      !
   250      xyz_TempB    = xyz_Temp
     .        if (xyz_tempb.DSC.U2 .gt. 0) then                                 
     .           J1 = and(xyz_tempb.DSC.U2,3)                                   
     .  !CDIR    NODEP                                                          
     .           do t673 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t675 = 1, xyz_tempb.DSC.U1 + 1                           
     .                 xyz_tempb(t675-1,t673,t671+1) = xyz_temp(t675-1,t673,t671
     .       1            +1)                                                   
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t673 = J1 + 1, xyz_tempb.DSC.U2, 4                          
     .  !CDIR       NODEP                                                       
     .              do t675 = 1, xyz_tempb.DSC.U1 + 1                           
     .                 xyz_tempb(t675-1,t673,t671+1) = xyz_temp(t675-1,t673,t671
     .       1            +1)                                                   
     .                 xyz_tempb(t675-1,t673+1,t671+1) = xyz_temp(t675-1,t673+1,
     .       1            t671+1)                                               
     .                 xyz_tempb(t675-1,t673+2,t671+1) = xyz_temp(t675-1,t673+2,
     .       1            t671+1)                                               
     .                 xyz_tempb(t675-1,t673+3,t671+1) = xyz_temp(t675-1,t673+3,
     .       1            t671+1)                                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   251  
   252  
   253      call MajorCompSaturateCalcCondTemp(  &
   254        & xyz_Press,                       & ! (in)
   255        & xyz_TempCond                     & ! (inout)
   256        & )
   257  
   258  
   259      do k = 1, kmax
   260        xyz_DelAtmMass(:,:,k) = ( xyr_Press(i,j,k-1) - xyr_Press(i,j,k) ) / Grav
     .        if (xyz_delatmmass.DSC.U2 .gt. 0) then                            
     .           J2 = and(xyz_delatmmass.DSC.U2,3)                              
     .  !CDIR    NODEP                                                          
     .           do t683 = 1, J2                                                
     .              D3 = 1.D0/grav                                              
     .  !CDIR       NODEP                                                       
     .              do t685 = 1, xyz_delatmmass.DSC.U1 + 1                      
     .                 xyz_delatmmass(t685-1,t683,k) = (xyr_press(i,j,k-1)-     
     .       1            xyr_press(i,j,k))*D3                                  
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t683 = J2 + 1, xyz_delatmmass.DSC.U2, 4                     
     .              D4 = 1.D0/grav                                              
     .              D5 = 1.D0/grav                                              
     .              D6 = 1.D0/grav                                              
     .              D7 = 1.D0/grav                                              
     .              D2 = xyr_press(i,j,k)                                       
     .              D1 = xyr_press(i,j,k-1)                                     
     .  !CDIR       NODEP                                                       
     .              do t685 = 1, xyz_delatmmass.DSC.U1 + 1                      
     .                 xyz_delatmmass(t685-1,t683,k) = ((D1 - D2)*D4)           
     .                 xyz_delatmmass(t685-1,t683+1,k) = ((D1 - D2)*D5)         
     .                 xyz_delatmmass(t685-1,t683+2,k) = ((D1 - D2)*D6)         
     .                 xyz_delatmmass(t685-1,t683+3,k) = ((D1 - D2)*D7)         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   261      end do
   262  
   263  
   264      k = kmax
   265      do j = 1, jmax
   266        do i = 0, imax-1
   267          if ( xyz_Temp(i,j,k) < xyz_TempCond(i,j,k) ) then
   268            xyz_DelMajCompIce(i,j,k) =                                 &
   269              &   CpDry * ( xyz_TempCond(i,j,k) - xyz_Temp(i,j,k) )    &
   270              &   * xyz_DelAtmMass(i,j,k)                              &
   271              &   / LatentHeatMajCompSubl
   272            xyz_Temp(i,j,k) = xyz_TempCond(i,j,k)
   273          else
   274            xyz_DelMajCompIce(i,j,k) = 0.0_DP
   275          end if
   276        end do
     .        i = 0                                                             
     .        if (imax .gt. 0) then                                             
     .  !CDIR    NODEP                                                          
     .           do i = 1, imax                                                 
     .              if (xyz_temp(i-1,j,k) .lt. xyz_tempcond(i-1,j,k)) then      
     .                 xyz_delmajcompice(i-1,j,k) = cpdry*(xyz_tempcond(i-1,j,k)
     .       1            -xyz_temp(i-1,j,k))*xyz_delatmmass(i-1,j,k)/          
     .       2            latentheatmajcompsubl                                 
     .                 xyz_temp(i-1,j,k) = xyz_tempcond(i-1,j,k)                
     .              else                                                        
     .                 xyz_delmajcompice(i-1,j,k) = 0.0000000000000000e+000     
     .              endif                                                       
     .           end do                                                         
     .           i = imax                                                       
     .        endif                                                             
   277      end do
   278      !
   279      xy_FallingIce = 0.0_DP
     .        if (xy_fallingice.DSC.U2 .gt. 0) then                             
     .           J3 = and(xy_fallingice.DSC.U2,3)                               
     .  !CDIR    NODEP                                                          
     .           do t689 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t691 = 1, xy_fallingice.DSC.U1 + 1                       
     .                 xy_fallingice(t691-1,t689) = 0.0000000000000000e+000     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t689 = J3 + 1, xy_fallingice.DSC.U2, 4                      
     .  !CDIR       NODEP                                                       
     .              do t691 = 1, xy_fallingice.DSC.U1 + 1                       
     .                 xy_fallingice(t691-1,t689) = 0.0000000000000000e+000     
     .                 xy_fallingice(t691-1,t689+1) = 0.0000000000000000e+000   
     .                 xy_fallingice(t691-1,t689+2) = 0.0000000000000000e+000   
     .                 xy_fallingice(t691-1,t689+3) = 0.0000000000000000e+000   
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   280      do k = kmax-1, 1, -1
   281        xy_FallingIce = xy_FallingIce + xyz_DelMajCompIce(:,:,k+1)
     .        if (xy_fallingice.DSC.U2 .gt. 0) then                             
     .           J4 = and(xy_fallingice.DSC.U2,3)                               
     .  !CDIR    NODEP                                                          
     .           do t695 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t697 = 1, xy_fallingice.DSC.U1 + 1                       
     .                 xy_fallingice(t697-1,t695) = xy_fallingice(t697-1,t695)  
     .       1             + xyz_delmajcompice(t697-1,t695,k+1)                 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t695 = J4 + 1, xy_fallingice.DSC.U2, 4                      
     .  !CDIR       NODEP                                                       
     .              do t697 = 1, xy_fallingice.DSC.U1 + 1                       
     .                 xy_fallingice(t697-1,t695) = xy_fallingice(t697-1,t695)  
     .       1             + xyz_delmajcompice(t697-1,t695,k+1)                 
     .                 xy_fallingice(t697-1,t695+1) = xy_fallingice(t697-1,t695+
     .       1            1) + xyz_delmajcompice(t697-1,t695+1,k+1)             
     .                 xy_fallingice(t697-1,t695+2) = xy_fallingice(t697-1,t695+
     .       1            2) + xyz_delmajcompice(t697-1,t695+2,k+1)             
     .                 xy_fallingice(t697-1,t695+3) = xy_fallingice(t697-1,t695+
     .       1            3) + xyz_delmajcompice(t697-1,t695+3,k+1)             
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   282        do j = 1, jmax
   283          do i = 0, imax-1
   284            SpecHeatCO2Ice = 349.0_DP + 4.8_DP * xyz_TempCond(i,j,k)
   285            !                                            Forget et al. (1998)
   286            xyz_DelMajCompIce(i,j,k) =                                     &
   287              &   CpDry * ( xyz_TempCond(i,j,k) - xyz_Temp(i,j,k) )        &
   288              &   * xyz_DelAtmMass(i,j,k)                                  &
   289              &   / LatentHeatMajCompSubl                                  &
   290              & - (   Grav * ( xyz_Height(i,j,k+1) - xyz_Height(i,j,k) )   &
   291              &     + SpecHeatCO2Ice                                       &
   292              &       * ( xyz_TempCond(i,j,k+1) - xyz_TempCond(i,j,k) ) )  &
   293              &   / LatentHeatMajCompSubl                                  &
   294              &   * xy_FallingIce(i,j)
   295            if ( ( xy_FallingIce(i,j) + xyz_DelMajCompIce(i,j,k) ) >= 0.0_DP ) then
   296              xyz_Temp(i,j,k) = xyz_TempCond(i,j,k)
   297            else
   298              xyz_DelMajCompIce(i,j,k) = - xy_FallingIce(i,j)
   299              xyz_Temp(i,j,k) = xyz_Temp(i,j,k)                                &
   300                & + ( - LatentHeatMajCompSubl                                  &
   301                &     + Grav * ( xyz_Height(i,j,k+1) - xyz_Height(i,j,k) )     &
   302                &     + SpecHeatCO2Ice                                         &
   303                &         * ( xyz_TempCond(i,j,k+1) - xyz_TempCond(i,j,k) ) )  &
   304                &     / ( CpDry * xyz_DelAtmMass(i,j,k) )                      &
   305                &     * xy_FallingIce(i,j)
   306            end if
   307          end do
     .        i = 0                                                             
     .        if (imax .gt. 0) then                                             
     .           D8 = 1.D0/latentheatmajcompsubl                                
     .  !CDIR    NODEP                                                          
     .           do i = 1, imax                                                 
     .              specheatco2ice = 3.49000000000000e+002 +                    
     .       1         4.79999999999999e+000*xyz_tempcond(i-1,j,k)              
     .              xyz_delmajcompice1 = cpdry*(xyz_tempcond(i-1,j,k)-xyz_temp(i
     .       1         -1,j,k))*xyz_delatmmass(i-1,j,k)*D8 - ((grav*(xyz_height(
     .       2         i-1,j,k+1)-xyz_height(i-1,j,k)))+(specheatco2ice*(       
     .       3         xyz_tempcond(i-1,j,k+1)-xyz_tempcond(i-1,j,k))))*D8*     
     .       4         xy_fallingice(i-1,j)                                     
     .              if (xy_fallingice(i-1,j) + xyz_delmajcompice1 .ge.          
     .       1         0.0000000000000000e+000) then                            
     .                 xyz_temp(i-1,j,k) = xyz_tempcond(i-1,j,k)                
     .              else                                                        
     .                 xyz_delmajcompice1 = -xy_fallingice(i-1,j)               
     .                 xyz_temp(i-1,j,k) = xyz_temp(i-1,j,k) + ((grav*(         
     .       1            xyz_height(i-1,j,k+1)-xyz_height(i-1,j,k)))-          
     .       2            latentheatmajcompsubl+(specheatco2ice*(xyz_tempcond(i-
     .       3            1,j,k+1)-xyz_tempcond(i-1,j,k))))/(cpdry*             
     .       4            xyz_delatmmass(i-1,j,k))*xy_fallingice(i-1,j)         
     .              endif                                                       
     .              xyz_delmajcompice(i-1,j,k) = xyz_delmajcompice1             
     .           end do                                                         
     .           i = imax                                                       
     .        endif                                                             
   308        end do
   309      end do
   310  
   311  
   312      ! Ice falling on the surface
   313      !   This may result in supersaturation in the lowest level.
   314      !
   315      xy_FallingIce = xy_FallingIce + xyz_DelMajCompIce(:,:,1)
     .        if (xy_fallingice.DSC.U2 .gt. 0) then                             
     .           J5 = and(xy_fallingice.DSC.U2,3)                               
     .  !CDIR    NODEP                                                          
     .           do t705 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t707 = 1, xy_fallingice.DSC.U1 + 1                       
     .                 xy_fallingice(t707-1,t705) = xy_fallingice(t707-1,t705)  
     .       1             + xyz_delmajcompice(t707-1,t705,1)                   
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t705 = J5 + 1, xy_fallingice.DSC.U2, 4                      
     .  !CDIR       NODEP                                                       
     .              do t707 = 1, xy_fallingice.DSC.U1 + 1                       
     .                 xy_fallingice(t707-1,t705) = xy_fallingice(t707-1,t705)  
     .       1             + xyz_delmajcompice(t707-1,t705,1)                   
     .                 xy_fallingice(t707-1,t705+1) = xy_fallingice(t707-1,t705+
     .       1            1) + xyz_delmajcompice(t707-1,t705+1,1)               
     .                 xy_fallingice(t707-1,t705+2) = xy_fallingice(t707-1,t705+
     .       1            2) + xyz_delmajcompice(t707-1,t705+2,1)               
     .                 xy_fallingice(t707-1,t705+3) = xy_fallingice(t707-1,t705+
     .       1            3) + xyz_delmajcompice(t707-1,t705+3,1)               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   316      k = 1
   317      do j = 1, jmax
   318        do i = 0, imax-1
   319          xy_DelSurfMajCompIce(i,j) =                                    &
   320            & - (   Grav * ( xyz_Height(i,j,1) - 0.0_DP ) )              &
   321            &   / LatentHeatMajCompSubl                                  &
   322            &   * xy_FallingIce(i,j)
   323  
   324  
   325  
   326            SpecHeatCO2Ice = 349.0_DP + 4.8_DP * xy_SurfTempCond(i,j)
   327            !                                            Forget et al. (1998)
   328            xy_DelSurfMajCompIce(i,j) =                                    &
   329  !!$            &   CpDry * ( xyz_TempCond(i,j,k) - xyz_Temp(i,j,k) )        &
   330  !!$            &   * xyz_DelAtmMass(i,j,k)                                  &
   331  !!$            &   / LatentHeatMajCompSubl                                  &
   332              & - (   Grav * ( xyz_Height(i,j,1) - 0.0_DP )                &
   333              &     + SpecHeatCO2Ice                                       &
   334              &       * ( xyz_TempCond(i,j,1) - xy_SurfTempCond(i,j) ) )   &
   335              &   / LatentHeatMajCompSubl                                  &
   336              &   * xy_FallingIce(i,j)
   337  
   338  
   339          if ( ( xy_FallingIce(i,j) + xy_DelSurfMajCompIce(i,j) ) >= 0.0_DP ) then
   340            ! Part of ice sublimes.
   341            ! NOTE: In this case, temperature in the lowest layer should be
   342            ! condensation temperature. So, actually, the set of temperature is
   343            ! meaningless.
   344            xyz_Temp(i,j,k) = xyz_TempCond(i,j,k)
   345          else
   346            ! All falling ice sublimes.
   347            ! NOTE: The formulation below is different from that by Forget et al.
   348            ! (1998). The latent heat and heat by potential energy release and
   349            ! heating ice is distributed in the lowest layer in this model, not
   350            ! to the soil.
   351            xy_DelSurfMajCompIce(i,j) = - xy_FallingIce(i,j)
   352            xyz_Temp(i,j,k) = xyz_Temp(i,j,k)                                &
   353              & + ( - LatentHeatMajCompSubl                                  &
   354              &     + Grav * ( xyz_Height(i,j,1) - 0.0_DP )                  &
   355              &     + SpecHeatCO2Ice                                         &
   356              &         * ( xyz_TempCond(i,j,1) - xy_SurfTempCond(i,j) ) )   &
   357              &     / ( CpDry * xyz_DelAtmMass(i,j,k) )                      &
   358              &     * xy_FallingIce(i,j)
   359         end if
   360         end do
     .        i = 0                                                             
     .        if (imax .gt. 0) then                                             
     .           D10 = 1.D0/latentheatmajcompsubl                               
     .           D11 = 1.D0/latentheatmajcompsubl                               
     .  !CDIR    NODEP                                                          
     .           do i = 1, imax                                                 
     .              xy_delsurfmajcompice1 = -(grav*(xyz_height(i-1,j,1)-        
     .       1         0.0000000000000000e+000))*D10*xy_fallingice(i-1,j)       
     .              specheatco2ice = 3.49000000000000e+002 +                    
     .       1         4.79999999999999e+000*xy_surftempcond(i-1,j)             
     .              xy_delsurfmajcompice1 = -((grav*(xyz_height(i-1,j,1)-       
     .       1         0.0000000000000000e+000))+(specheatco2ice*(xyz_tempcond(i
     .       2         -1,j,1)-xy_surftempcond(i-1,j))))*D11*xy_fallingice(i-1,j
     .       3         )                                                        
     .              if (xy_fallingice(i-1,j) + xy_delsurfmajcompice1 .ge.       
     .       1         0.0000000000000000e+000) then                            
     .                 xyz_temp(i-1,j,1) = xyz_tempcond(i-1,j,1)                
     .              else                                                        
     .                 xy_delsurfmajcompice1 = -xy_fallingice(i-1,j)            
     .                 xyz_temp(i-1,j,1) = xyz_temp(i-1,j,1) + ((grav*(         
     .       1            xyz_height(i-1,j,1)-0.0000000000000000e+000))-        
     .       2            latentheatmajcompsubl+(specheatco2ice*(xyz_tempcond(i-
     .       3            1,j,1)-xy_surftempcond(i-1,j))))/(cpdry*xyz_delatmmass
     .       4            (i-1,j,1))*xy_fallingice(i-1,j)                       
     .              endif                                                       
     .              xy_delsurfmajcompice(i-1,j) = xy_delsurfmajcompice1         
     .           end do                                                         
     .           i = imax                                                       
     .        endif                                                             
   361      end do
   362  
   363  
   364      ! ѲΨ
   365      ! Calculate temperature tendency
   366      !
   367      xyz_DTempDt = ( xyz_Temp - xyz_TempB ) / ( 2.0_DP * DelTime )
     .        if (jmax .gt. 0) then                                             
     .           J6 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t717 = 1, J6                                                
     .              D13 = 1.D0/(2.00000000000000e+000*deltime)                  
     .  !CDIR       NODEP                                                       
     .              do t719 = 1, imax                                           
     .                 xyz_dtempdt(t719-1,t717,t715+1) = (xyz_temp(t719-1,t717, 
     .       1            t715+1)-xyz_tempb(t719-1,t717,t715+1))*D13            
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t717 = J6 + 1, jmax, 4                                      
     .              D14 = 1.D0/(2.00000000000000e+000*deltime)                  
     .              D15 = 1.D0/(2.00000000000000e+000*deltime)                  
     .              D16 = 1.D0/(2.00000000000000e+000*deltime)                  
     .              D17 = 1.D0/(2.00000000000000e+000*deltime)                  
     .  !CDIR       NODEP                                                       
     .              do t719 = 1, imax                                           
     .                 xyz_dtempdt(t719-1,t717,t715+1) = (xyz_temp(t719-1,t717, 
     .       1            t715+1)-xyz_tempb(t719-1,t717,t715+1))*D14            
     .                 xyz_dtempdt(t719-1,t717+1,t715+1) = (xyz_temp(t719-1,t717
     .       1            +1,t715+1)-xyz_tempb(t719-1,t717+1,t715+1))*D15       
     .                 xyz_dtempdt(t719-1,t717+2,t715+1) = (xyz_temp(t719-1,t717
     .       1            +2,t715+1)-xyz_tempb(t719-1,t717+2,t715+1))*D16       
     .                 xyz_dtempdt(t719-1,t717+3,t715+1) = (xyz_temp(t719-1,t717
     .       1            +3,t715+1)-xyz_tempb(t719-1,t717+3,t715+1))*D17       
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   368  
   369  
   370      !
   371      ! Surface major component ice adjustment
   372      !
   373      xy_DSurfMajCompIceDt = 0.0_DP
     .        if (xy_dsurfmajcompicedt.DSC.U2 .gt. 0) then                      
     .           J7 = and(xy_dsurfmajcompicedt.DSC.U2,3)                        
     .  !CDIR    NODEP                                                          
     .           do t730 = 1, J7                                                
     .  !CDIR       NODEP                                                       
     .              do t732 = 1, xy_dsurfmajcompicedt.DSC.U1 + 1                
     .                 xy_dsurfmajcompicedt(t732-1,t730) =                      
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t730 = J7 + 1, xy_dsurfmajcompicedt.DSC.U2, 4               
     .  !CDIR       NODEP                                                       
     .              do t732 = 1, xy_dsurfmajcompicedt.DSC.U1 + 1                
     .                 xy_dsurfmajcompicedt(t732-1,t730) =                      
     .       1            0.0000000000000000e+000                               
     .                 xy_dsurfmajcompicedt(t732-1,t730+1) =                    
     .       1            0.0000000000000000e+000                               
     .                 xy_dsurfmajcompicedt(t732-1,t730+2) =                    
     .       1            0.0000000000000000e+000                               
     .                 xy_dsurfmajcompicedt(t732-1,t730+3) =                    
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   374      do k = kmax, 1, -1
   375        xy_DSurfMajCompIceDt = xy_DSurfMajCompIceDt + xyz_DelMajCompIce(:,:,k)
     .        if (xy_dsurfmajcompicedt.DSC.U2 .gt. 0) then                      
     .           J8 = and(xy_dsurfmajcompicedt.DSC.U2,3)                        
     .  !CDIR    NODEP                                                          
     .           do t736 = 1, J8                                                
     .  !CDIR       NODEP                                                       
     .              do t738 = 1, xy_dsurfmajcompicedt.DSC.U1 + 1                
     .                 xy_dsurfmajcompicedt(t738-1,t736) = xy_dsurfmajcompicedt(
     .       1            t738-1,t736) + xyz_delmajcompice(t738-1,t736,k)       
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t736 = J8 + 1, xy_dsurfmajcompicedt.DSC.U2, 4               
     .  !CDIR       NODEP                                                       
     .              do t738 = 1, xy_dsurfmajcompicedt.DSC.U1 + 1                
     .                 xy_dsurfmajcompicedt(t738-1,t736) = xy_dsurfmajcompicedt(
     .       1            t738-1,t736) + xyz_delmajcompice(t738-1,t736,k)       
     .                 xy_dsurfmajcompicedt(t738-1,t736+1) =                    
     .       1            xy_dsurfmajcompicedt(t738-1,t736+1) +                 
     .       2            xyz_delmajcompice(t738-1,t736+1,k)                    
     .                 xy_dsurfmajcompicedt(t738-1,t736+2) =                    
     .       1            xy_dsurfmajcompicedt(t738-1,t736+2) +                 
     .       2            xyz_delmajcompice(t738-1,t736+2,k)                    
     .                 xy_dsurfmajcompicedt(t738-1,t736+3) =                    
     .       1            xy_dsurfmajcompicedt(t738-1,t736+3) +                 
     .       2            xyz_delmajcompice(t738-1,t736+3,k)                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   376      end do
   377      xy_DSurfMajCompIceDt = xy_DSurfMajCompIceDt + xy_DelSurfMajCompIce(i,j)
     .        if (xy_dsurfmajcompicedt.DSC.U2 .gt. 0) then                      
     .           J9 = and(xy_dsurfmajcompicedt.DSC.U2,1)                        
     .  !CDIR    NODEP                                                          
     .           do t746 = 1, J9                                                
     .  !CDIR       NODEP                                                       
     .              do t748 = 1, xy_dsurfmajcompicedt.DSC.U1 + 1                
     .                 xy_dsurfmajcompicedt(t748-1,t746) = xy_dsurfmajcompicedt(
     .       1            t748-1,t746) + xy_delsurfmajcompice(i,j)              
     .                 xy_surfmajcompice(t748-1,t746) = xy_surfmajcompice(t748-1
     .       1            ,t746) + xy_dsurfmajcompicedt(t748-1,t746)*(          
     .       2            2.00000000000000e+000*deltime)                        
     .                 xy_ps(t748-1,t746) = xy_ps(t748-1,t746) -                
     .       1            xy_dsurfmajcompicedt(t748-1,t746)*grav*(              
     .       2            2.00000000000000e+000*deltime)                        
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t746 = J9 + 1, xy_dsurfmajcompicedt.DSC.U2, 2               
     .              D18 = xy_delsurfmajcompice(i,j)                             
     .  !CDIR       NODEP                                                       
     .              do t748 = 1, xy_dsurfmajcompicedt.DSC.U1 + 1                
     .                 xy_dsurfmajcompicedt(t748-1,t746) = xy_dsurfmajcompicedt(
     .       1            t748-1,t746) + D18                                    
     .                 xy_dsurfmajcompicedt(t748-1,t746+1) =                    
     .       1            xy_dsurfmajcompicedt(t748-1,t746+1) + D18             
     .                 xy_surfmajcompice(t748-1,t746) = xy_surfmajcompice(t748-1
     .       1            ,t746) + xy_dsurfmajcompicedt(t748-1,t746)*(          
     .       2            2.00000000000000e+000*deltime)                        
     .                 xy_surfmajcompice(t748-1,t746+1) = xy_surfmajcompice(t748
     .       1            -1,t746+1) + xy_dsurfmajcompicedt(t748-1,t746+1)*(    
     .       2            2.00000000000000e+000*deltime)                        
     .                 xy_ps(t748-1,t746) = xy_ps(t748-1,t746) -                
     .       1            xy_dsurfmajcompicedt(t748-1,t746)*grav*(              
     .       2            2.00000000000000e+000*deltime)                        
     .                 xy_ps(t748-1,t746+1) = xy_ps(t748-1,t746+1) -            
     .       1            xy_dsurfmajcompicedt(t748-1,t746+1)*grav*(            
     .       2            2.00000000000000e+000*deltime)                        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   378      !
   379      xy_SurfMajCompIce = xy_SurfMajCompIce &
   380        & + xy_DSurfMajCompIceDt * ( 2.0_DP * DelTime )
   381  
   382  
   383      !
   384      ! Surface pressure adjustment
   385      !
   386      xy_Ps = xy_Ps - xy_DSurfMajCompIceDt * Grav * ( 2.0_DP * DelTime )
   387  
   388  
   389      ! ҥȥǡ
   390      ! History data output
   391      !
   392      call HistoryAutoPut( TimeN, 'DTempDtMajCompPhaseChange', xyz_DTempDt )
   393  
   394  
   395      ! ׻ַ¬
   396      ! Pause measurement of computation time
   397      !
   398      call TimesetClockStop( module_name )
   399  
   400    end subroutine MajorCompPhaseChangeInAtmTest
   401  
   402    !--------------------------------------------------------------------------------------
   403  
   404    subroutine MajorCompPhaseChangeInAtm(   &
   405      & xyr_Press, xyz_Press,               &  ! (in)
   406      & xy_Ps, xyz_Temp, xy_SurfMajCompIce  &  ! (inout)
   407      & )
   408      !
   409      ! CO2 Ѳ
   410      !
   411      ! CO2 phase change
   412      !
   413  
   414      ! ⥸塼 ; USE statements
   415      !
   416  
   417      ! 
   418      ! Time control
   419      !
   420      use timeset, only: &
   421        & DelTime, &            ! $ \Delta t $
   422        & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $.
   423        & TimesetClockStart, TimesetClockStop
   424  
   425      ! ҥȥǡ
   426      ! History data output
   427      !
   428      use gtool_historyauto, only: HistoryAutoPut
   429  
   430      ! ʪ
   431      ! Physical constants settings
   432      !
   433      use constants, only: &
   434        & Grav, &               ! $ g $ [m s-2].
   435                                ! ϲ®.
   436                                ! Gravitational acceleration
   437        & CpDry
   438                                ! $ C_p $ [J kg-1 K-1].
   439                                ! 絤갵Ǯ.
   440                                ! Specific heat of air at constant pressure
   441  
   442      ! ʬѲ
   443      ! Phase change of atmospheric major component
   444      !
   445      use major_comp_saturate, only :    &
   446        & MajorCompSaturateCalcCondTemp, &
   447        & MajorCompSaturateInqLatentHeat
   448  
   449  
   450      ! ʸ ; Declaration statements
   451      !
   452      implicit none
   453  
   454      real(DP), intent(in   ):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
   455                                ! $ \hat{p} $ .  (Ⱦ٥).
   456                                ! Air pressure (half level)
   457      real(DP), intent(in   ):: xyz_Press (0:imax-1, 1:jmax, 1:kmax)
   458                                ! $ p $ .  (٥).
   459                                ! Air pressure (full level)
   460      real(DP), intent(inout):: xy_Ps            (0:imax-1, 1:jmax)
   461                                ! $ T $ .     . Temperature
   462      real(DP), intent(inout):: xyz_Temp         (0:imax-1, 1:jmax, 1:kmax)
   463                                ! $ T $ .     . Temperature
   464      real(DP), intent(inout):: xy_SurfMajCompIce(0:imax-1, 1:jmax)
   465                                !
   466                                ! Surface major component ice amount
   467  
   468      ! ѿ
   469      ! Work variables
   470      !
   471      real(DP):: xyz_TempB           (0:imax-1, 1:jmax, 1:kmax)
   472                                ! Ĵβ.
   473                                ! Temperature before adjustment
   474      real(DP):: xyz_DTempDt         (0:imax-1, 1:jmax, 1:kmax)
   475                                ! ѲΨ.
   476                                ! Temperature tendency
   477      real(DP):: xy_DSurfMajCompIceDt(0:imax-1, 1:jmax)
   478                                !
   479                                ! Surface major component ice tendency
   480  
   481      real(DP):: xyz_TempCond   (0:imax-1, 1:jmax, 1:kmax)
   482  
   483      real(DP):: LatentHeatMajCompSubl
   484  
   485      integer:: i               ! ˲ DO 롼Ѻѿ
   486                                ! Work variables for DO loop in longitude
   487      integer:: j               ! ˲ DO 롼Ѻѿ
   488                                ! Work variables for DO loop in latitude
   489      integer:: k               ! ľ˲ DO 롼Ѻѿ
   490                                ! Work variables for DO loop in vertical direction
   491  
   492      logical :: FlagCheckPs
   493  
   494  
   495      ! ¹ʸ ; Executable statement
   496      !
   497  
   498      ! 
   499      ! Initialization
   500      !
   501      if ( .not. major_comp_phase_change_inited ) then
   502        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   503      end if
   504  
   505  
   506      if ( .not. FlagMajCompPhaseChange ) return
   507  
   508  
   509      ! ׻ַ¬
   510      ! Start measurement of computation time
   511      !
   512      call TimesetClockStart( module_name )
   513  
   514  
   515      ! Set latent heat
   516      LatentHeatMajCompSubl = MajorCompSaturateInqLatentHeat()
   517  
   518  
   519      FlagCheckPs = .false.
   520      do j = 1, jmax
   521        do i = 0, imax-1
   522          if ( xyr_Press(i,j,0) > 1.0d4 ) then
   523            FlagCheckPs = .true.
   524          end if
   525        end do
   526      end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do j = 1, jmax*imax                                               
     .           if (xyr_press(j-1,1,0) .gt. 1.00000000000000e+004) then        
     .              flagcheckps = 1                                             
     .           endif                                                          
     .        end do                                                            
   527      if ( FlagCheckPs ) then
   528        call MessageNotify( 'W', module_name, 'Surface pressure is greater than 10000 Pa.' )
   529      end if
   530  
   531  
   532      ! Ĵ "Temp" ¸
   533      ! Store "Temp" before adjustment
   534      !
   535      xyz_TempB    = xyz_Temp
     .        if (xyz_tempb.DSC.U2 .gt. 0) then                                 
     .           J1 = and(xyz_tempb.DSC.U2,3)                                   
     .  !CDIR    NODEP                                                          
     .           do t271 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t273 = 1, xyz_tempb.DSC.U1 + 1                           
     .                 xyz_tempb(t273-1,t271,t269+1) = xyz_temp(t273-1,t271,t269
     .       1            +1)                                                   
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t271 = J1 + 1, xyz_tempb.DSC.U2, 4                          
     .  !CDIR       NODEP                                                       
     .              do t273 = 1, xyz_tempb.DSC.U1 + 1                           
     .                 xyz_tempb(t273-1,t271,t269+1) = xyz_temp(t273-1,t271,t269
     .       1            +1)                                                   
     .                 xyz_tempb(t273-1,t271+1,t269+1) = xyz_temp(t273-1,t271+1,
     .       1            t269+1)                                               
     .                 xyz_tempb(t273-1,t271+2,t269+1) = xyz_temp(t273-1,t271+2,
     .       1            t269+1)                                               
     .                 xyz_tempb(t273-1,t271+3,t269+1) = xyz_temp(t273-1,t271+3,
     .       1            t269+1)                                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   536  
   537  
   538      call MajorCompSaturateCalcCondTemp( &
   539        & xyz_Press,                      & ! (in)
   540        & xyz_TempCond                    & ! (inout)
   541        & )
   542  
   543  
   544      do k = 1, kmax
   545        do j = 1, jmax
   546          do i = 0, imax-1
   547            if ( xyz_Temp(i,j,k) < xyz_TempCond(i,j,k) ) then
   548              xyz_Temp(i,j,k) = xyz_TempCond(i,j,k)
   549            end if
   550          end do
   551        end do
     .        if (jmax .gt. 0) then                                             
     .           J2 = and(jmax,1)                                               
     .           do j = 1, J2                                                   
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xyz_temp(i-1,j,k) .lt. xyz_tempcond(i-1,j,k)) then   
     .                    xyz_temp(i-1,j,k) = xyz_tempcond(i-1,j,k)             
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .           do j = J2 + 1, jmax, 2                                         
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xyz_temp(i-1,j,k) .lt. xyz_tempcond(i-1,j,k)) then   
     .                    xyz_temp(i-1,j,k) = xyz_tempcond(i-1,j,k)             
     .                 endif                                                    
     .                 if (xyz_temp(i-1,j+1,k) .lt. xyz_tempcond(i-1,j+1,k))    
     .       1            then                                                  
     .                    xyz_temp(i-1,j+1,k) = xyz_tempcond(i-1,j+1,k)         
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   552      end do
   553  
   554      ! ѲΨ
   555      ! Calculate temperature tendency
   556      !
   557      xyz_DTempDt = ( xyz_Temp - xyz_TempB ) / ( 2.0_DP * DelTime )
     .        if (jmax .gt. 0) then                                             
     .           J3 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t283 = 1, J3                                                
     .              D1 = 1.D0/(2.00000000000000e+000*deltime)                   
     .  !CDIR       NODEP                                                       
     .              do t285 = 1, imax                                           
     .                 xyz_dtempdt(t285-1,t283,t281+1) = (xyz_temp(t285-1,t283, 
     .       1            t281+1)-xyz_tempb(t285-1,t283,t281+1))*D1             
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t283 = J3 + 1, jmax, 4                                      
     .              D2 = 1.D0/(2.00000000000000e+000*deltime)                   
     .              D3 = 1.D0/(2.00000000000000e+000*deltime)                   
     .              D4 = 1.D0/(2.00000000000000e+000*deltime)                   
     .              D5 = 1.D0/(2.00000000000000e+000*deltime)                   
     .  !CDIR       NODEP                                                       
     .              do t285 = 1, imax                                           
     .                 xyz_dtempdt(t285-1,t283,t281+1) = (xyz_temp(t285-1,t283, 
     .       1            t281+1)-xyz_tempb(t285-1,t283,t281+1))*D2             
     .                 xyz_dtempdt(t285-1,t283+1,t281+1) = (xyz_temp(t285-1,t283
     .       1            +1,t281+1)-xyz_tempb(t285-1,t283+1,t281+1))*D3        
     .                 xyz_dtempdt(t285-1,t283+2,t281+1) = (xyz_temp(t285-1,t283
     .       1            +2,t281+1)-xyz_tempb(t285-1,t283+2,t281+1))*D4        
     .                 xyz_dtempdt(t285-1,t283+3,t281+1) = (xyz_temp(t285-1,t283
     .       1            +3,t281+1)-xyz_tempb(t285-1,t283+3,t281+1))*D5        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   558  
   559  
   560      !
   561      ! Surface major component ice adjustment
   562      !
   563      xy_DSurfMajCompIceDt = 0.0_DP
     .        if (xy_dsurfmajcompicedt.DSC.U2 .gt. 0) then                      
     .           J4 = and(xy_dsurfmajcompicedt.DSC.U2,3)                        
     .  !CDIR    NODEP                                                          
     .           do t296 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t298 = 1, xy_dsurfmajcompicedt.DSC.U1 + 1                
     .                 xy_dsurfmajcompicedt(t298-1,t296) =                      
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t296 = J4 + 1, xy_dsurfmajcompicedt.DSC.U2, 4               
     .  !CDIR       NODEP                                                       
     .              do t298 = 1, xy_dsurfmajcompicedt.DSC.U1 + 1                
     .                 xy_dsurfmajcompicedt(t298-1,t296) =                      
     .       1            0.0000000000000000e+000                               
     .                 xy_dsurfmajcompicedt(t298-1,t296+1) =                    
     .       1            0.0000000000000000e+000                               
     .                 xy_dsurfmajcompicedt(t298-1,t296+2) =                    
     .       1            0.0000000000000000e+000                               
     .                 xy_dsurfmajcompicedt(t298-1,t296+3) =                    
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   564      do k = kmax, 1, -1
   565        xy_DSurfMajCompIceDt = xy_DSurfMajCompIceDt                    &
     .        if (xy_dsurfmajcompicedt.DSC.U2 .gt. 0) then                      
     .           J5 = and(xy_dsurfmajcompicedt.DSC.U2,3)                        
     .  !CDIR    NODEP                                                          
     .           do t302 = 1, J5                                                
     .              D6 = 1.D0/grav                                              
     .              D7 = D6/latentheatmajcompsubl                               
     .  !CDIR       NODEP                                                       
     .              do t304 = 1, xy_dsurfmajcompicedt.DSC.U1 + 1                
     .                 xy_dsurfmajcompicedt(t304-1,t302) = xy_dsurfmajcompicedt(
     .       1            t304-1,t302) + cpdry*xyz_dtempdt(t304-1,t302,k)*(     
     .       2            xyr_press(t304-1,t302,k-1)-xyr_press(t304-1,t302,k))* 
     .       3            D7                                                    
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t302 = J5 + 1, xy_dsurfmajcompicedt.DSC.U2, 4               
     .              D8 = 1.D0/grav                                              
     .              D9 = D8/latentheatmajcompsubl                               
     .              D10 = 1.D0/grav                                             
     .              D11 = D10/latentheatmajcompsubl                             
     .              D12 = 1.D0/grav                                             
     .              D13 = D12/latentheatmajcompsubl                             
     .              D14 = 1.D0/grav                                             
     .              D15 = D14/latentheatmajcompsubl                             
     .  !CDIR       NODEP                                                       
     .              do t304 = 1, xy_dsurfmajcompicedt.DSC.U1 + 1                
     .                 xy_dsurfmajcompicedt(t304-1,t302) = xy_dsurfmajcompicedt(
     .       1            t304-1,t302) + cpdry*xyz_dtempdt(t304-1,t302,k)*(     
     .       2            xyr_press(t304-1,t302,k-1)-xyr_press(t304-1,t302,k))* 
     .       3            D9                                                    
     .                 xy_dsurfmajcompicedt(t304-1,t302+1) =                    
     .       1            xy_dsurfmajcompicedt(t304-1,t302+1) + cpdry*          
     .       2            xyz_dtempdt(t304-1,t302+1,k)*(xyr_press(t304-1,t302+1,
     .       3            k-1)-xyr_press(t304-1,t302+1,k))*D11                  
     .                 xy_dsurfmajcompicedt(t304-1,t302+2) =                    
     .       1            xy_dsurfmajcompicedt(t304-1,t302+2) + cpdry*          
     .       2            xyz_dtempdt(t304-1,t302+2,k)*(xyr_press(t304-1,t302+2,
     .       3            k-1)-xyr_press(t304-1,t302+2,k))*D13                  
     .                 xy_dsurfmajcompicedt(t304-1,t302+3) =                    
     .       1            xy_dsurfmajcompicedt(t304-1,t302+3) + cpdry*          
     .       2            xyz_dtempdt(t304-1,t302+3,k)*(xyr_press(t304-1,t302+3,
     .       3            k-1)-xyr_press(t304-1,t302+3,k))*D15                  
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   566          & + CpDry * xyz_DTempDt(:,:,k)                               &
   567          &   * ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav       &
   568          &   / LatentHeatMajCompSubl
   569      end do
   570      xy_SurfMajCompIce = xy_SurfMajCompIce + xy_DSurfMajCompIceDt * ( 2.0_DP * DelTime )
     .        if (jmax .gt. 0) then                                             
     .           J6 = and(jmax,1)                                               
     .  !CDIR    NODEP                                                          
     .           do t316 = 1, J6                                                
     .  !CDIR       NODEP                                                       
     .              do t318 = 1, imax                                           
     .                 xy_surfmajcompice(t318-1,t316) = xy_surfmajcompice(t318-1
     .       1            ,t316) + xy_dsurfmajcompicedt(t318-1,t316)*(          
     .       2            2.00000000000000e+000*deltime)                        
     .                 xy_ps(t318-1,t316) = xy_ps(t318-1,t316) -                
     .       1            xy_dsurfmajcompicedt(t318-1,t316)*grav*(              
     .       2            2.00000000000000e+000*deltime)                        
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t316 = J6 + 1, jmax, 2                                      
     .  !CDIR       NODEP                                                       
     .              do t318 = 1, imax                                           
     .                 xy_surfmajcompice(t318-1,t316) = xy_surfmajcompice(t318-1
     .       1            ,t316) + xy_dsurfmajcompicedt(t318-1,t316)*(          
     .       2            2.00000000000000e+000*deltime)                        
     .                 xy_surfmajcompice(t318-1,t316+1) = xy_surfmajcompice(t318
     .       1            -1,t316+1) + xy_dsurfmajcompicedt(t318-1,t316+1)*(    
     .       2            2.00000000000000e+000*deltime)                        
     .                 xy_ps(t318-1,t316) = xy_ps(t318-1,t316) -                
     .       1            xy_dsurfmajcompicedt(t318-1,t316)*grav*(              
     .       2            2.00000000000000e+000*deltime)                        
     .                 xy_ps(t318-1,t316+1) = xy_ps(t318-1,t316+1) -            
     .       1            xy_dsurfmajcompicedt(t318-1,t316+1)*grav*(            
     .       2            2.00000000000000e+000*deltime)                        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   571  
   572  
   573      !
   574      ! Surface pressure adjustment
   575      !
   576      xy_Ps = xy_Ps - xy_DSurfMajCompIceDt * Grav * ( 2.0_DP * DelTime )
   577  
   578  
   579      ! ҥȥǡ
   580      ! History data output
   581      !
   582      call HistoryAutoPut( TimeN, 'DTempDtMajCompPhaseChange', xyz_DTempDt )
   583  
   584  
   585      ! ׻ַ¬
   586      ! Pause measurement of computation time
   587      !
   588      call TimesetClockStop( module_name )
   589  
   590    end subroutine MajorCompPhaseChangeInAtm
   591  
   592    !--------------------------------------------------------------------------------------
   593  
   594  !!$  subroutine MajorCompPhaseChangeLimitTemp( &
   595  !!$    & xyr_Press, xyz_Press,  &  ! (in)
   596  !!$    & xy_SurfTemp, xyz_Temp  &  ! (inout)
   597  !!$    & )
   598  !!$    !
   599  !!$    ! CO2 Ѳ
   600  !!$    !
   601  !!$    ! CO2 phase change
   602  !!$    !
   603  !!$
   604  !!$    ! ⥸塼 ; USE statements
   605  !!$    !
   606  !!$
   607  !!$    ! 
   608  !!$    ! Time control
   609  !!$    !
   610  !!$    use timeset, only: &
   611  !!$      & DelTime, &            ! $ \Delta t $
   612  !!$      & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $.
   613  !!$      & TimesetClockStart, TimesetClockStop
   614  !!$
   615  !!$    ! ҥȥǡ
   616  !!$    ! History data output
   617  !!$    !
   618  !!$    use gtool_historyauto, only: HistoryAutoPut
   619  !!$
   620  !!$
   621  !!$    ! ʸ ; Declaration statements
   622  !!$    !
   623  !!$    implicit none
   624  !!$
   625  !!$    real(DP), intent(in   ):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
   626  !!$                              ! $ \hat{p} $ .  (Ⱦ٥).
   627  !!$                              ! Air pressure (half level)
   628  !!$    real(DP), intent(in   ):: xyz_Press (0:imax-1, 1:jmax, 1:kmax)
   629  !!$                              ! $ p $ .  (٥).
   630  !!$                              ! Air pressure (full level)
   631  !!$    real(DP), intent(inout):: xy_SurfTemp(0:imax-1, 1:jmax)
   632  !!$                              ! $ T_s $ .   ɽ̲. Surface temperature
   633  !!$    real(DP), intent(inout):: xyz_Temp   (0:imax-1, 1:jmax, 1:kmax)
   634  !!$                              ! $ T $ .     . Temperature
   635  !!$
   636  !!$    ! ѿ
   637  !!$    ! Work variables
   638  !!$    !
   639  !!$    real(DP):: xy_SurfTempB  (0:imax-1, 1:jmax)
   640  !!$                              ! Ĵɽ̲.
   641  !!$                              ! Surface temperature before adjustment
   642  !!$    real(DP):: xyz_TempB     (0:imax-1, 1:jmax, 1:kmax)
   643  !!$                              ! Ĵβ.
   644  !!$                              ! Temperature before adjustment
   645  !!$    real(DP):: xy_DSurfTempDt(0:imax-1, 1:jmax)
   646  !!$                              ! ɽ̲ѲΨ.
   647  !!$                              ! Surface temperature tendency
   648  !!$    real(DP):: xyz_DTempDt   (0:imax-1, 1:jmax, 1:kmax)
   649  !!$                              ! ѲΨ.
   650  !!$                              ! Temperature tendency
   651  !!$
   652  !!$    real(DP):: xy_SurfTempCond(0:imax-1, 1:jmax)
   653  !!$    real(DP):: xyz_TempCond   (0:imax-1, 1:jmax, 1:kmax)
   654  !!$
   655  !!$    integer:: i               ! ˲ DO 롼Ѻѿ
   656  !!$                              ! Work variables for DO loop in longitude
   657  !!$    integer:: j               ! ˲ DO 롼Ѻѿ
   658  !!$                              ! Work variables for DO loop in latitude
   659  !!$    integer:: k               ! ľ˲ DO 롼Ѻѿ
   660  !!$                              ! Work variables for DO loop in vertical direction
   661  !!$
   662  !!$    logical :: FlagCheckPs
   663  !!$
   664  !!$
   665  !!$    ! ¹ʸ ; Executable statement
   666  !!$    !
   667  !!$
   668  !!$    ! ׻ַ¬
   669  !!$    ! Start measurement of computation time
   670  !!$    !
   671  !!$    call TimesetClockStart( module_name )
   672  !!$
   673  !!$    ! 
   674  !!$    ! Initialization
   675  !!$    !
   676  !!$    if ( .not. major_comp_phase_change_inited ) call MajorCompPhaseChangeInit
   677  !!$
   678  !!$    if ( .not. FlagUse ) return
   679  !!$
   680  !!$
   681  !!$    FlagCheckPs = .false.
   682  !!$    do j = 1, jmax
   683  !!$      do i = 0, imax-1
   684  !!$        if ( xyr_Press(i,j,0) > 1.0d4 ) then
   685  !!$          FlagCheckPs = .true.
   686  !!$        end if
   687  !!$      end do
   688  !!$    end do
   689  !!$    if ( FlagCheckPs ) then
   690  !!$      call MessageNotify( 'W', module_name, 'Surface pressure is greater than 10000 Pa.' )
   691  !!$    end if
   692  !!$
   693  !!$
   694  !!$    ! Ĵ "Temp" ¸
   695  !!$    ! Store "Temp" before adjustment
   696  !!$    !
   697  !!$    xy_SurfTempB = xy_SurfTemp
   698  !!$    xyz_TempB    = xyz_Temp
   699  !!$
   700  !!$
   701  !!$    do j = 1, jmax
   702  !!$      do i = 0, imax-1
   703  !!$        xy_SurfTempCond(i,j) = &
   704  !!$          & 149.2d0 + 6.48d0 * log( 0.135d0 * xyr_Press(i,j,0) * 1.0d-2 )
   705  !!$      end do
   706  !!$    end do
   707  !!$    do k = 1, kmax
   708  !!$      do j = 1, jmax
   709  !!$        do i = 0, imax-1
   710  !!$          xyz_TempCond(i,j,k) = &
   711  !!$            & 149.2d0 + 6.48d0 * log( 0.135d0 * xyz_Press(i,j,k) * 1.0d-2 )
   712  !!$        end do
   713  !!$      end do
   714  !!$    end do
   715  !!$
   716  !!$    do j = 1, jmax
   717  !!$      do i = 0, imax-1
   718  !!$        if ( xy_SurfTemp(i,j) < xy_SurfTempCond(i,j) ) then
   719  !!$          xy_SurfTemp(i,j) = xy_SurfTempCond(i,j)
   720  !!$        end if
   721  !!$      end do
   722  !!$    end do
   723  !!$    do k = 1, kmax
   724  !!$      do j = 1, jmax
   725  !!$        do i = 0, imax-1
   726  !!$          if ( xyz_Temp(i,j,k) < xyz_TempCond(i,j,k) ) then
   727  !!$            xyz_Temp(i,j,k) = xyz_TempCond(i,j,k)
   728  !!$          end if
   729  !!$        end do
   730  !!$      end do
   731  !!$    end do
   732  !!$
   733  !!$
   734  !!$    ! ѲΨ
   735  !!$    ! Calculate temperature tendency
   736  !!$    !
   737  !!$    xy_DSurfTempDt = ( xy_SurfTemp - xy_SurfTempB ) / ( 2.0_DP * DelTime )
   738  !!$    xyz_DTempDt    = ( xyz_Temp    - xyz_TempB    ) / ( 2.0_DP * DelTime )
   739  !!$
   740  !!$
   741  !!$    ! ҥȥǡ
   742  !!$    ! History data output
   743  !!$    !
   744  !!$    call HistoryAutoPut( TimeN, 'DSurfTempDtCO2PhaseChange', xy_DSurfTempDt )
   745  !!$    call HistoryAutoPut( TimeN, 'DTempDtCO2PhaseChange'    , xyz_DTempDt    )
   746  !!$
   747  !!$
   748  !!$    ! ׻ַ¬
   749  !!$    ! Pause measurement of computation time
   750  !!$    !
   751  !!$    call TimesetClockStop( module_name )
   752  !!$
   753  !!$  end subroutine MajorCompPhaseChangeLimitTemp
   754  
   755    !--------------------------------------------------------------------------------------
   756  
   757    subroutine MajorCompPhaseChangeInit(             &
   758      & ArgFlagMajCompPhaseChange, CondMajCompName   & ! (in)
   759      & )
   760      !
   761      ! major_comp_phase_change ⥸塼νԤޤ.
   762      ! NAMELIST#major_comp_phase_change_nml ɤ߹ߤϤμ³ǹԤޤ.
   763      !
   764      ! "major_comp_phase_change" module is initialized.
   765      ! "NAMELIST#major_comp_phase_change_nml" is loaded in this procedure.
   766      !
   767  
   768      ! ⥸塼 ; USE statements
   769      !
   770  
   771  !!$    ! NAMELIST եϤ˴ؤ桼ƥƥ
   772  !!$    ! Utilities for NAMELIST file input
   773  !!$    !
   774  !!$    use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   775  !!$
   776  !!$    ! ե
   777  !!$    ! File I/O support
   778  !!$    !
   779  !!$    use dc_iounit, only: FileOpen
   780  !!$
   781  !!$    ! ̷ѥ᥿
   782  !!$    ! Kind type parameter
   783  !!$    !
   784  !!$    use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   785  
   786      ! ʸ
   787      ! Character handling
   788      !
   789      use dc_string, only: StoA
   790  
   791      ! ҥȥǡ
   792      ! History data output
   793      !
   794      use gtool_historyauto, only: HistoryAutoAddVariable
   795  
   796      ! ʬѲ
   797      ! Phase change of atmospheric major component
   798      !
   799      use major_comp_saturate, only : &
   800        & MajorCompSaturateInit
   801  
   802  
   803      ! ʸ ; Declaration statements
   804      !
   805      implicit none
   806  
   807      logical     , intent(in) :: ArgFlagMajCompPhaseChange
   808      character(*), intent(in) :: CondMajCompName
   809  
   810  
   811  !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   812  !!$                              ! Unit number for NAMELIST file open
   813  !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   814  !!$                              ! IOSTAT of NAMELIST read
   815  
   816      ! NAMELIST ѿ
   817      ! NAMELIST group name
   818      !
   819  !!$    namelist /major_comp_phase_change_nml/ &
   820  !!$      & FlagUse
   821  
   822            ! ǥեͤˤĤƤϽ³ "major_comp_phase_change#MajorCompPhaseChangeInit"
   823            ! Υɤ򻲾ȤΤ.
   824            !
   825            ! Refer to source codes in the initialization procedure
   826            ! "major_comp_phase_change#MajorCompPhaseChangeInit" for the default values.
   827            !
   828  
   829      ! ¹ʸ ; Executable statement
   830      !
   831  
   832      if ( major_comp_phase_change_inited ) return
   833  
   834  
   835      FlagMajCompPhaseChange = ArgFlagMajCompPhaseChange
   836  
   837  
   838      ! ǥեͤ
   839      ! Default values settings
   840      !
   841  
   842  
   843      ! NAMELIST ɤ߹
   844      ! NAMELIST is input
   845      !
   846  !!$    if ( trim(namelist_filename) /= '' ) then
   847  !!$      call FileOpen( unit_nml, &          ! (out)
   848  !!$        & namelist_filename, mode = 'r' ) ! (in)
   849  !!$
   850  !!$      rewind( unit_nml )
   851  !!$      read( unit_nml,                        &  ! (in)
   852  !!$        & nml = major_comp_phase_change_nml, &  ! (out)
   853  !!$        & iostat = iostat_nml )                 ! (out)
   854  !!$      close( unit_nml )
   855  !!$
   856  !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   857  !!$!      if ( iostat_nml == 0 ) write( STDOUT, nml = cumulus_adjust_nml )
   858  !!$    end if
   859  
   860  
   861      if ( FlagMajCompPhaseChange ) then
   862        ! ʬѲ
   863        ! Phase change of atmospheric major component
   864        !
   865        call MajorCompSaturateInit(  &
   866          & CondMajCompName          & ! (in)
   867          & )
   868      end if
   869  
   870  
   871      ! ҥȥǡϤΤΤؤѿϿ
   872      ! Register of variables for history data output
   873      !
   874      call HistoryAutoAddVariable( 'DSurfTempDtMajCompPhaseChange', &
   875        & (/ 'lon ', 'lat ', 'time' /),                             &
   876        & 'heating by major component phase change', 'K s-1' )
   877      call HistoryAutoAddVariable( 'DTempDtMajCompPhaseChange',     &
   878        & (/ 'lon ', 'lat ', 'sig ', 'time' /),                 &
   879        & 'heating by major component phase change', 'K s-1' )
   880  
   881      !  ; Print
   882      !
   883      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   884      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   885  
   886      major_comp_phase_change_inited = .true.
   887  
   888    end subroutine MajorCompPhaseChangeInit
   889  
   890    !-------------------------------------------------------------------
   891  
   892  end module major_comp_phase_change
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:29 2012
FILE NAME: major_comp_phase_change.f90
PROGRAM NAME: major_comp_phase_change
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ʬѲ
     2:            !
     3:            != Phase change of atmospheric major component
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: major_comp_phase_change.f90,v 1.1 2012-09-08 15:16:39 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module major_comp_phase_change
    13:              !
    14:              != ʬѲ
    15:              !
    16:              != Phase change of atmospheric major component
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              !== Procedures List
    21:              ! 
    22:            !!$  ! DryConvAdjust :: ήĴ
    23:            !!$  ! ------------  :: ------------
    24:            !!$  ! DryConvAdjust :: Dry convective adjustment
    25:              !
    26:              !== NAMELIST
    27:              !
    28:              ! NAMELIST#major_comp_phase_change_nml
    29:              !
    30:            
    31:              ! ⥸塼 ; USE statements
    32:              !
    33:            
    34:              ! ʻ
    35:              ! Grid points settings
    36:              !
    37:              use gridset, only: imax, & ! ٳʻ. 
    38:                                         ! Number of grid points in longitude
    39:                &                jmax, & ! ٳʻ. 
    40:                                         ! Number of grid points in latitude
    41:                &                kmax    ! ľؿ. 
    42:                                         ! Number of vertical level
    43:            
    44:              ! ̷ѥ᥿
    45:              ! Kind type parameter
    46:              !
    47:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    48:                &                 STRING     ! ʸ.       Strings. 
    49:            
    50:              ! NAMELIST եϤ˴ؤ桼ƥƥ
    51:              ! Utilities for NAMELIST file input
    52:              !
    53:              use namelist_util, only: MaxNmlArySize
    54:                                          ! NAMELIST ɤ߹κ祵. 
    55:                                          ! Maximum size of arrays loaded from NAMELIST
    56:            
    57:              ! å
    58:              ! Message output
    59:              !
    60:              use dc_message, only: MessageNotify
    61:            
    62:              ! ʸ ; Declaration statements
    63:              !
    64:              implicit none
    65:              private
    66:            
    67:            
    68:              ! ³
    69:              ! Public procedure
    70:              !
    71:              public :: MajorCompPhaseChangeInAtm
    72:              public :: MajorCompPhaseChangeInit
    73:            
    74:            
    75:              ! ѿ
    76:              ! Public variables
    77:              !
    78:              logical, save, public:: major_comp_phase_change_inited = .false.
    79:                                          ! ե饰. 
    80:                                          ! Initialization flag
    81:            
    82:              ! ѿ
    83:              ! Private variables
    84:              !
    85:              logical, save :: FlagMajCompPhaseChange
    86:            
    87:            
    88:              character(*), parameter:: module_name = 'major_comp_phase_change'
    89:                                          ! ⥸塼̾. 
    90:                                          ! Module name
    91:              character(*), parameter:: version = &
    92:                & '$Name: dcpam5-20120921 $' // &
    93:                & '$Id: major_comp_phase_change.f90,v 1.1 2012-09-08 15:16:39 yot Exp $'
    94:                                          ! ⥸塼ΥС
    95:                                          ! Module version
    96:            
    97:            
    98:            contains
    99:            
   100:              !-------------------------------------------------------------------
   101:            
   102:              subroutine MajorCompPhaseChangeInAtmTest(  &
   103:                & xyr_Press, xyz_Press, xyz_Height,      &  ! (in)
   104:                & xy_Ps, xyz_Temp, xy_SurfMajCompIce     &  ! (inout)
   105:                & )
   106:                !
   107:                ! CO2 Ѳ
   108:                !
   109:                ! CO2 phase change
   110:                !
   111:            
   112:                ! ⥸塼 ; USE statements
   113:                !
   114:            
   115:                ! 
   116:                ! Time control
   117:                !
   118:                use timeset, only: &
   119:                  & DelTime, &            ! $ \Delta t $
   120:                  & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $. 
   121:                  & TimesetClockStart, TimesetClockStop
   122:            
   123:                ! ҥȥǡ
   124:                ! History data output
   125:                !
   126:                use gtool_historyauto, only: HistoryAutoPut
   127:            
   128:                ! ʪ
   129:                ! Physical constants settings
   130:                !
   131:                use constants, only: &
   132:                  & Grav, &               ! $ g $ [m s-2].
   133:                                          ! ϲ®.
   134:                                          ! Gravitational acceleration
   135:                  & CpDry
   136:                                          ! $ C_p $ [J kg-1 K-1].
   137:                                          ! 絤갵Ǯ.
   138:                                          ! Specific heat of air at constant pressure
   139:            
   140:                ! ʬѲ
   141:                ! Phase change of atmospheric major component
   142:                !
   143:                use major_comp_saturate, only :     &
   144:                  & MajorCompSaturateCalcCondTemp,  &
   145:                  & MajorCompSaturateInqLatentHeat
   146:            
   147:            
   148:                ! ʸ ; Declaration statements
   149:                !
   150:                implicit none
   151:            
   152:                real(DP), intent(in   ):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
   153:                                          ! $ \hat{p} $ .  (Ⱦ٥). 
   154:                                          ! Air pressure (half level)
   155:                real(DP), intent(in   ):: xyz_Press (0:imax-1, 1:jmax, 1:kmax)
   156:                                          ! $ p $ .  (٥). 
   157:                                          ! Air pressure (full level)
   158:                real(DP), intent(in   ):: xyz_Height(0:imax-1, 1:jmax, 1:kmax)
   159:                                          ! 
   160:                                          ! 
   161:                real(DP), intent(inout):: xy_Ps            (0:imax-1, 1:jmax)
   162:                                          ! $ T $ .     . Temperature
   163:                real(DP), intent(inout):: xyz_Temp         (0:imax-1, 1:jmax, 1:kmax)
   164:                                          ! $ T $ .     . Temperature
   165:                real(DP), intent(inout):: xy_SurfMajCompIce(0:imax-1, 1:jmax)
   166:                                          !
   167:                                          ! Surface major component ice amount
   168:            
   169:                ! ѿ
   170:                ! Work variables
   171:                !
   172:                real(DP):: xyz_TempB           (0:imax-1, 1:jmax, 1:kmax)
   173:                                          ! Ĵβ. 
   174:                                          ! Temperature before adjustment
   175:                real(DP):: xyz_DelAtmMass      (0:imax-1, 1:jmax, 1:kmax)
   176:                                          !
   177:                                          ! Atmospheric mass in a layer
   178:                real(DP):: xy_FallingIce       (0:imax-1, 1:jmax)
   179:                                          !
   180:                                          !
   181:                real(DP):: xyz_DelMajCompIce   (0:imax-1, 1:jmax, 1:kmax)
   182:                                          !
   183:                                          !
   184:                real(DP):: xy_DelSurfMajCompIce(0:imax-1, 1:jmax)
   185:                                          !
   186:                                          !
   187:                real(DP):: xyz_DTempDt         (0:imax-1, 1:jmax, 1:kmax)
   188:                                          ! ѲΨ. 
   189:                                          ! Temperature tendency
   190:                real(DP):: xy_DSurfMajCompIceDt(0:imax-1, 1:jmax)
   191:                                          ! 
   192:                                          ! Surface major component ice tendency
   193:            
   194:                real(DP):: xyz_TempCond   (0:imax-1, 1:jmax, 1:kmax)
   195:                real(DP):: xy_SurfTempCond(0:imax-1, 1:jmax)
   196:                real(DP):: SpecHeatCO2Ice
   197:            
   198:                real(DP):: LatentHeatMajCompSubl
   199:            
   200:                integer:: i               ! ˲ DO 롼Ѻѿ
   201:                                          ! Work variables for DO loop in longitude
   202:                integer:: j               ! ˲ DO 롼Ѻѿ
   203:                                          ! Work variables for DO loop in latitude
   204:                integer:: k               ! ľ˲ DO 롼Ѻѿ
   205:                                          ! Work variables for DO loop in vertical direction
   206:            
   207:                logical :: FlagCheckPs
   208:            
   209:            
   210:                ! ¹ʸ ; Executable statement
   211:                !
   212:            
   213:                ! 
   214:                ! Initialization
   215:                !
   216:                if ( .not. major_comp_phase_change_inited ) then
   217:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   218:                end if
   219:            
   220:            
   221:                if ( .not. FlagMajCompPhaseChange ) return
   222:            
   223:            
   224:                ! ׻ַ¬
   225:                ! Start measurement of computation time
   226:                !
   227:                call TimesetClockStart( module_name )
   228:            
   229:            
   230:                ! Set latent heat
   231:                LatentHeatMajCompSubl = MajorCompSaturateInqLatentHeat()
   232:            
   233:            
   234:                FlagCheckPs = .false.
   235: +------>       do j = 1, jmax
   236: |V----->         do i = 0, imax-1
   237: ||                 if ( xyr_Press(i,j,0) > 1.0d4 ) then
   238: ||                   FlagCheckPs = .true.
   239: ||                 end if
   240: |V-----          end do
   241: +------        end do
   242:                if ( FlagCheckPs ) then
   243:                  call MessageNotify( 'W', module_name, 'Surface pressure is greater than 10000 Pa.' )
   244:                end if
   245:            
   246:            
   247:                ! Ĵ "Temp" ¸
   248:                ! Store "Temp" before adjustment
   249:                !
   250: ++V====        xyz_TempB    = xyz_Temp
   251:            
   252:            
   253:                call MajorCompSaturateCalcCondTemp(  &
   254:                  & xyz_Press,                       & ! (in)
   255:                  & xyz_TempCond                     & ! (inout)
   256:                  & )
   257:            
   258:            
   259: +------>       do k = 1, kmax
   260: |+V====          xyz_DelAtmMass(:,:,k) = ( xyr_Press(i,j,k-1) - xyr_Press(i,j,k) ) / Grav
   261: +------        end do
   262:            
   263:            
   264:                k = kmax
   265: +------>       do j = 1, jmax
   266: |V----->         do i = 0, imax-1
   267: ||                 if ( xyz_Temp(i,j,k) < xyz_TempCond(i,j,k) ) then
   268: ||                   xyz_DelMajCompIce(i,j,k) =                                 &
   269: ||                     &   CpDry * ( xyz_TempCond(i,j,k) - xyz_Temp(i,j,k) )    &
   270: ||                     &   * xyz_DelAtmMass(i,j,k)                              &
   271: ||                     &   / LatentHeatMajCompSubl
   272: ||                   xyz_Temp(i,j,k) = xyz_TempCond(i,j,k)
   273: ||                 else
   274: ||                   xyz_DelMajCompIce(i,j,k) = 0.0_DP
   275: ||                 end if
   276: |V-----          end do
   277: +------        end do
   278:                !
   279: +V=====        xy_FallingIce = 0.0_DP
   280: +------>       do k = kmax-1, 1, -1
   281: |+V====          xy_FallingIce = xy_FallingIce + xyz_DelMajCompIce(:,:,k+1)
   282: |+----->         do j = 1, jmax
   283: ||V---->           do i = 0, imax-1
   284: |||                  SpecHeatCO2Ice = 349.0_DP + 4.8_DP * xyz_TempCond(i,j,k)
   285: |||                  !                                            Forget et al. (1998)
   286: |||                  xyz_DelMajCompIce(i,j,k) =                                     &
   287: |||                    &   CpDry * ( xyz_TempCond(i,j,k) - xyz_Temp(i,j,k) )        &
   288: |||                    &   * xyz_DelAtmMass(i,j,k)                                  &
   289: |||                    &   / LatentHeatMajCompSubl                                  &
   290: |||                    & - (   Grav * ( xyz_Height(i,j,k+1) - xyz_Height(i,j,k) )   &
   291: |||                    &     + SpecHeatCO2Ice                                       &
   292: |||                    &       * ( xyz_TempCond(i,j,k+1) - xyz_TempCond(i,j,k) ) )  &
   293: |||                    &   / LatentHeatMajCompSubl                                  &
   294: |||                    &   * xy_FallingIce(i,j)
   295: |||                  if ( ( xy_FallingIce(i,j) + xyz_DelMajCompIce(i,j,k) ) >= 0.0_DP ) then
   296: |||                    xyz_Temp(i,j,k) = xyz_TempCond(i,j,k)
   297: |||                  else
   298: |||                    xyz_DelMajCompIce(i,j,k) = - xy_FallingIce(i,j)
   299: |||                    xyz_Temp(i,j,k) = xyz_Temp(i,j,k)                                &
   300: |||                      & + ( - LatentHeatMajCompSubl                                  &
   301: |||                      &     + Grav * ( xyz_Height(i,j,k+1) - xyz_Height(i,j,k) )     &
   302: |||                      &     + SpecHeatCO2Ice                                         &
   303: |||                      &         * ( xyz_TempCond(i,j,k+1) - xyz_TempCond(i,j,k) ) )  &
   304: |||                      &     / ( CpDry * xyz_DelAtmMass(i,j,k) )                      &
   305: |||                      &     * xy_FallingIce(i,j)
   306: |||                  end if
   307: ||V----            end do
   308: |+-----          end do
   309: +------        end do
   310:            
   311:            
   312:                ! Ice falling on the surface
   313:                !   This may result in supersaturation in the lowest level.
   314:                !
   315: +V=====        xy_FallingIce = xy_FallingIce + xyz_DelMajCompIce(:,:,1)
   316:                k = 1
   317: +------>       do j = 1, jmax
   318: |V----->         do i = 0, imax-1
   319: ||                 xy_DelSurfMajCompIce(i,j) =                                    &
   320: ||                   & - (   Grav * ( xyz_Height(i,j,1) - 0.0_DP ) )              &
   321: ||                   &   / LatentHeatMajCompSubl                                  &
   322: ||                   &   * xy_FallingIce(i,j)
   323: ||         
   324: ||         
   325: ||         
   326: ||                   SpecHeatCO2Ice = 349.0_DP + 4.8_DP * xy_SurfTempCond(i,j)
   327: ||                   !                                            Forget et al. (1998)
   328: ||                   xy_DelSurfMajCompIce(i,j) =                                    &
   329: ||         !!$            &   CpDry * ( xyz_TempCond(i,j,k) - xyz_Temp(i,j,k) )        &
   330: ||         !!$            &   * xyz_DelAtmMass(i,j,k)                                  &
   331: ||         !!$            &   / LatentHeatMajCompSubl                                  &
   332: ||                     & - (   Grav * ( xyz_Height(i,j,1) - 0.0_DP )                &
   333: ||                     &     + SpecHeatCO2Ice                                       &
   334: ||                     &       * ( xyz_TempCond(i,j,1) - xy_SurfTempCond(i,j) ) )   &
   335: ||                     &   / LatentHeatMajCompSubl                                  &
   336: ||                     &   * xy_FallingIce(i,j)
   337: ||         
   338: ||         
   339: ||                 if ( ( xy_FallingIce(i,j) + xy_DelSurfMajCompIce(i,j) ) >= 0.0_DP ) then
   340: ||                   ! Part of ice sublimes.
   341: ||                   ! NOTE: In this case, temperature in the lowest layer should be 
   342: ||                   ! condensation temperature. So, actually, the set of temperature is 
   343: ||                   ! meaningless.
   344: ||                   xyz_Temp(i,j,k) = xyz_TempCond(i,j,k)
   345: ||                 else
   346: ||                   ! All falling ice sublimes.
   347: ||                   ! NOTE: The formulation below is different from that by Forget et al.
   348: ||                   ! (1998). The latent heat and heat by potential energy release and 
   349: ||                   ! heating ice is distributed in the lowest layer in this model, not
   350: ||                   ! to the soil.
   351: ||                   xy_DelSurfMajCompIce(i,j) = - xy_FallingIce(i,j)
   352: ||                   xyz_Temp(i,j,k) = xyz_Temp(i,j,k)                                &
   353: ||                     & + ( - LatentHeatMajCompSubl                                  &
   354: ||                     &     + Grav * ( xyz_Height(i,j,1) - 0.0_DP )                  &
   355: ||                     &     + SpecHeatCO2Ice                                         &
   356: ||                     &         * ( xyz_TempCond(i,j,1) - xy_SurfTempCond(i,j) ) )   &
   357: ||                     &     / ( CpDry * xyz_DelAtmMass(i,j,k) )                      &
   358: ||                     &     * xy_FallingIce(i,j)
   359: ||                end if
   360: |V-----           end do
   361: +------        end do
   362:            
   363:            
   364:                ! ѲΨ
   365:                ! Calculate temperature tendency
   366:                !
   367: ++V====        xyz_DTempDt = ( xyz_Temp - xyz_TempB ) / ( 2.0_DP * DelTime )
   368:            
   369:            
   370:                !
   371:                ! Surface major component ice adjustment
   372:                !
   373: +V=====        xy_DSurfMajCompIceDt = 0.0_DP
   374: +------>       do k = kmax, 1, -1
   375: |+V====          xy_DSurfMajCompIceDt = xy_DSurfMajCompIceDt + xyz_DelMajCompIce(:,:,k)
   376: +------        end do
   377: *V----->       xy_DSurfMajCompIceDt = xy_DSurfMajCompIceDt + xy_DelSurfMajCompIce(i,j)
   378: ||             !
   379: ||             xy_SurfMajCompIce = xy_SurfMajCompIce &
   380: ||               & + xy_DSurfMajCompIceDt * ( 2.0_DP * DelTime )
   381: ||         
   382: ||         
   383: ||             !
   384: ||             ! Surface pressure adjustment
   385: ||             !
   386: *V-----        xy_Ps = xy_Ps - xy_DSurfMajCompIceDt * Grav * ( 2.0_DP * DelTime )
   387:            
   388:            
   389:                ! ҥȥǡ
   390:                ! History data output
   391:                !
   392:                call HistoryAutoPut( TimeN, 'DTempDtMajCompPhaseChange', xyz_DTempDt )
   393:            
   394:            
   395:                ! ׻ַ¬
   396:                ! Pause measurement of computation time
   397:                !
   398:                call TimesetClockStop( module_name )
   399:            
   400:              end subroutine MajorCompPhaseChangeInAtmTest
   401:            
   402:              !--------------------------------------------------------------------------------------
   403:            
   404:              subroutine MajorCompPhaseChangeInAtm(   &
   405:                & xyr_Press, xyz_Press,               &  ! (in)
   406:                & xy_Ps, xyz_Temp, xy_SurfMajCompIce  &  ! (inout)
   407:                & )
   408:                !
   409:                ! CO2 Ѳ
   410:                !
   411:                ! CO2 phase change
   412:                !
   413:            
   414:                ! ⥸塼 ; USE statements
   415:                !
   416:            
   417:                ! 
   418:                ! Time control
   419:                !
   420:                use timeset, only: &
   421:                  & DelTime, &            ! $ \Delta t $
   422:                  & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $. 
   423:                  & TimesetClockStart, TimesetClockStop
   424:            
   425:                ! ҥȥǡ
   426:                ! History data output
   427:                !
   428:                use gtool_historyauto, only: HistoryAutoPut
   429:            
   430:                ! ʪ
   431:                ! Physical constants settings
   432:                !
   433:                use constants, only: &
   434:                  & Grav, &               ! $ g $ [m s-2].
   435:                                          ! ϲ®.
   436:                                          ! Gravitational acceleration
   437:                  & CpDry
   438:                                          ! $ C_p $ [J kg-1 K-1].
   439:                                          ! 絤갵Ǯ.
   440:                                          ! Specific heat of air at constant pressure
   441:            
   442:                ! ʬѲ
   443:                ! Phase change of atmospheric major component
   444:                !
   445:                use major_comp_saturate, only :    &
   446:                  & MajorCompSaturateCalcCondTemp, &
   447:                  & MajorCompSaturateInqLatentHeat
   448:            
   449:            
   450:                ! ʸ ; Declaration statements
   451:                !
   452:                implicit none
   453:            
   454:                real(DP), intent(in   ):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
   455:                                          ! $ \hat{p} $ .  (Ⱦ٥). 
   456:                                          ! Air pressure (half level)
   457:                real(DP), intent(in   ):: xyz_Press (0:imax-1, 1:jmax, 1:kmax)
   458:                                          ! $ p $ .  (٥). 
   459:                                          ! Air pressure (full level)
   460:                real(DP), intent(inout):: xy_Ps            (0:imax-1, 1:jmax)
   461:                                          ! $ T $ .     . Temperature
   462:                real(DP), intent(inout):: xyz_Temp         (0:imax-1, 1:jmax, 1:kmax)
   463:                                          ! $ T $ .     . Temperature
   464:                real(DP), intent(inout):: xy_SurfMajCompIce(0:imax-1, 1:jmax)
   465:                                          !
   466:                                          ! Surface major component ice amount
   467:            
   468:                ! ѿ
   469:                ! Work variables
   470:                !
   471:                real(DP):: xyz_TempB           (0:imax-1, 1:jmax, 1:kmax)
   472:                                          ! Ĵβ. 
   473:                                          ! Temperature before adjustment
   474:                real(DP):: xyz_DTempDt         (0:imax-1, 1:jmax, 1:kmax)
   475:                                          ! ѲΨ. 
   476:                                          ! Temperature tendency
   477:                real(DP):: xy_DSurfMajCompIceDt(0:imax-1, 1:jmax)
   478:                                          ! 
   479:                                          ! Surface major component ice tendency
   480:            
   481:                real(DP):: xyz_TempCond   (0:imax-1, 1:jmax, 1:kmax)
   482:            
   483:                real(DP):: LatentHeatMajCompSubl
   484:            
   485:                integer:: i               ! ˲ DO 롼Ѻѿ
   486:                                          ! Work variables for DO loop in longitude
   487:                integer:: j               ! ˲ DO 롼Ѻѿ
   488:                                          ! Work variables for DO loop in latitude
   489:                integer:: k               ! ľ˲ DO 롼Ѻѿ
   490:                                          ! Work variables for DO loop in vertical direction
   491:            
   492:                logical :: FlagCheckPs
   493:            
   494:            
   495:                ! ¹ʸ ; Executable statement
   496:                !
   497:            
   498:                ! 
   499:                ! Initialization
   500:                !
   501:                if ( .not. major_comp_phase_change_inited ) then
   502:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   503:                end if
   504:            
   505:            
   506:                if ( .not. FlagMajCompPhaseChange ) return
   507:            
   508:            
   509:                ! ׻ַ¬
   510:                ! Start measurement of computation time
   511:                !
   512:                call TimesetClockStart( module_name )
   513:            
   514:            
   515:                ! Set latent heat
   516:                LatentHeatMajCompSubl = MajorCompSaturateInqLatentHeat()
   517:            
   518:            
   519:                FlagCheckPs = .false.
   520: W------>       do j = 1, jmax
   521: |+----->         do i = 0, imax-1
   522: ||                 if ( xyr_Press(i,j,0) > 1.0d4 ) then
   523: ||                   FlagCheckPs = .true.
   524: ||                 end if
   525: |+-----          end do
   526: W------        end do
   527:                if ( FlagCheckPs ) then
   528:                  call MessageNotify( 'W', module_name, 'Surface pressure is greater than 10000 Pa.' )
   529:                end if
   530:            
   531:            
   532:                ! Ĵ "Temp" ¸
   533:                ! Store "Temp" before adjustment
   534:                !
   535: ++V====        xyz_TempB    = xyz_Temp
   536:            
   537:            
   538:                call MajorCompSaturateCalcCondTemp( &
   539:                  & xyz_Press,                      & ! (in)
   540:                  & xyz_TempCond                    & ! (inout)
   541:                  & )
   542:            
   543:            
   544: +------>       do k = 1, kmax
   545: |+----->         do j = 1, jmax
   546: ||V---->           do i = 0, imax-1
   547: |||                  if ( xyz_Temp(i,j,k) < xyz_TempCond(i,j,k) ) then
   548: |||                    xyz_Temp(i,j,k) = xyz_TempCond(i,j,k)
   549: |||                  end if
   550: ||V----            end do
   551: |+-----          end do
   552: +------        end do
   553:            
   554:                ! ѲΨ
   555:                ! Calculate temperature tendency
   556:                !
   557: ++V====        xyz_DTempDt = ( xyz_Temp - xyz_TempB ) / ( 2.0_DP * DelTime )
   558:            
   559:            
   560:                !
   561:                ! Surface major component ice adjustment
   562:                !
   563: +V=====        xy_DSurfMajCompIceDt = 0.0_DP
   564: +------>       do k = kmax, 1, -1
   565: |+V====          xy_DSurfMajCompIceDt = xy_DSurfMajCompIceDt                    &
   566: |                  & + CpDry * xyz_DTempDt(:,:,k)                               &
   567: |                  &   * ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav       &
   568: |                  &   / LatentHeatMajCompSubl
   569: +------        end do
   570: *V----->       xy_SurfMajCompIce = xy_SurfMajCompIce + xy_DSurfMajCompIceDt * ( 2.0_DP * DelTime )
   571: ||         
   572: ||         
   573: ||             !
   574: ||             ! Surface pressure adjustment
   575: ||             !
   576: *V-----        xy_Ps = xy_Ps - xy_DSurfMajCompIceDt * Grav * ( 2.0_DP * DelTime )
   577:            
   578:            
   579:                ! ҥȥǡ
   580:                ! History data output
   581:                !
   582:                call HistoryAutoPut( TimeN, 'DTempDtMajCompPhaseChange', xyz_DTempDt )
   583:            
   584:            
   585:                ! ׻ַ¬
   586:                ! Pause measurement of computation time
   587:                !
   588:                call TimesetClockStop( module_name )
   589:            
   590:              end subroutine MajorCompPhaseChangeInAtm
   591:            
   592:              !--------------------------------------------------------------------------------------
   593:            
   594:            !!$  subroutine MajorCompPhaseChangeLimitTemp( &
   595:            !!$    & xyr_Press, xyz_Press,  &  ! (in)
   596:            !!$    & xy_SurfTemp, xyz_Temp  &  ! (inout)
   597:            !!$    & )
   598:            !!$    !
   599:            !!$    ! CO2 Ѳ
   600:            !!$    !
   601:            !!$    ! CO2 phase change
   602:            !!$    !
   603:            !!$
   604:            !!$    ! ⥸塼 ; USE statements
   605:            !!$    !
   606:            !!$
   607:            !!$    ! 
   608:            !!$    ! Time control
   609:            !!$    !
   610:            !!$    use timeset, only: &
   611:            !!$      & DelTime, &            ! $ \Delta t $
   612:            !!$      & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $. 
   613:            !!$      & TimesetClockStart, TimesetClockStop
   614:            !!$
   615:            !!$    ! ҥȥǡ
   616:            !!$    ! History data output
   617:            !!$    !
   618:            !!$    use gtool_historyauto, only: HistoryAutoPut
   619:            !!$
   620:            !!$
   621:            !!$    ! ʸ ; Declaration statements
   622:            !!$    !
   623:            !!$    implicit none
   624:            !!$
   625:            !!$    real(DP), intent(in   ):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
   626:            !!$                              ! $ \hat{p} $ .  (Ⱦ٥). 
   627:            !!$                              ! Air pressure (half level)
   628:            !!$    real(DP), intent(in   ):: xyz_Press (0:imax-1, 1:jmax, 1:kmax)
   629:            !!$                              ! $ p $ .  (٥). 
   630:            !!$                              ! Air pressure (full level)
   631:            !!$    real(DP), intent(inout):: xy_SurfTemp(0:imax-1, 1:jmax)
   632:            !!$                              ! $ T_s $ .   ɽ̲. Surface temperature
   633:            !!$    real(DP), intent(inout):: xyz_Temp   (0:imax-1, 1:jmax, 1:kmax)
   634:            !!$                              ! $ T $ .     . Temperature
   635:            !!$
   636:            !!$    ! ѿ
   637:            !!$    ! Work variables
   638:            !!$    !
   639:            !!$    real(DP):: xy_SurfTempB  (0:imax-1, 1:jmax)
   640:            !!$                              ! Ĵɽ̲. 
   641:            !!$                              ! Surface temperature before adjustment
   642:            !!$    real(DP):: xyz_TempB     (0:imax-1, 1:jmax, 1:kmax)
   643:            !!$                              ! Ĵβ. 
   644:            !!$                              ! Temperature before adjustment
   645:            !!$    real(DP):: xy_DSurfTempDt(0:imax-1, 1:jmax)
   646:            !!$                              ! ɽ̲ѲΨ. 
   647:            !!$                              ! Surface temperature tendency
   648:            !!$    real(DP):: xyz_DTempDt   (0:imax-1, 1:jmax, 1:kmax)
   649:            !!$                              ! ѲΨ. 
   650:            !!$                              ! Temperature tendency
   651:            !!$
   652:            !!$    real(DP):: xy_SurfTempCond(0:imax-1, 1:jmax)
   653:            !!$    real(DP):: xyz_TempCond   (0:imax-1, 1:jmax, 1:kmax)
   654:            !!$
   655:            !!$    integer:: i               ! ˲ DO 롼Ѻѿ
   656:            !!$                              ! Work variables for DO loop in longitude
   657:            !!$    integer:: j               ! ˲ DO 롼Ѻѿ
   658:            !!$                              ! Work variables for DO loop in latitude
   659:            !!$    integer:: k               ! ľ˲ DO 롼Ѻѿ
   660:            !!$                              ! Work variables for DO loop in vertical direction
   661:            !!$
   662:            !!$    logical :: FlagCheckPs
   663:            !!$
   664:            !!$
   665:            !!$    ! ¹ʸ ; Executable statement
   666:            !!$    !
   667:            !!$
   668:            !!$    ! ׻ַ¬
   669:            !!$    ! Start measurement of computation time
   670:            !!$    !
   671:            !!$    call TimesetClockStart( module_name )
   672:            !!$
   673:            !!$    ! 
   674:            !!$    ! Initialization
   675:            !!$    !
   676:            !!$    if ( .not. major_comp_phase_change_inited ) call MajorCompPhaseChangeInit
   677:            !!$
   678:            !!$    if ( .not. FlagUse ) return
   679:            !!$
   680:            !!$
   681:            !!$    FlagCheckPs = .false.
   682:            !!$    do j = 1, jmax
   683:            !!$      do i = 0, imax-1
   684:            !!$        if ( xyr_Press(i,j,0) > 1.0d4 ) then
   685:            !!$          FlagCheckPs = .true.
   686:            !!$        end if
   687:            !!$      end do
   688:            !!$    end do
   689:            !!$    if ( FlagCheckPs ) then
   690:            !!$      call MessageNotify( 'W', module_name, 'Surface pressure is greater than 10000 Pa.' )
   691:            !!$    end if
   692:            !!$
   693:            !!$
   694:            !!$    ! Ĵ "Temp" ¸
   695:            !!$    ! Store "Temp" before adjustment
   696:            !!$    !
   697:            !!$    xy_SurfTempB = xy_SurfTemp
   698:            !!$    xyz_TempB    = xyz_Temp
   699:            !!$
   700:            !!$
   701:            !!$    do j = 1, jmax
   702:            !!$      do i = 0, imax-1
   703:            !!$        xy_SurfTempCond(i,j) = &
   704:            !!$          & 149.2d0 + 6.48d0 * log( 0.135d0 * xyr_Press(i,j,0) * 1.0d-2 )
   705:            !!$      end do
   706:            !!$    end do
   707:            !!$    do k = 1, kmax
   708:            !!$      do j = 1, jmax
   709:            !!$        do i = 0, imax-1
   710:            !!$          xyz_TempCond(i,j,k) = &
   711:            !!$            & 149.2d0 + 6.48d0 * log( 0.135d0 * xyz_Press(i,j,k) * 1.0d-2 )
   712:            !!$        end do
   713:            !!$      end do
   714:            !!$    end do
   715:            !!$
   716:            !!$    do j = 1, jmax
   717:            !!$      do i = 0, imax-1
   718:            !!$        if ( xy_SurfTemp(i,j) < xy_SurfTempCond(i,j) ) then
   719:            !!$          xy_SurfTemp(i,j) = xy_SurfTempCond(i,j)
   720:            !!$        end if
   721:            !!$      end do
   722:            !!$    end do
   723:            !!$    do k = 1, kmax
   724:            !!$      do j = 1, jmax
   725:            !!$        do i = 0, imax-1
   726:            !!$          if ( xyz_Temp(i,j,k) < xyz_TempCond(i,j,k) ) then
   727:            !!$            xyz_Temp(i,j,k) = xyz_TempCond(i,j,k)
   728:            !!$          end if
   729:            !!$        end do
   730:            !!$      end do
   731:            !!$    end do
   732:            !!$
   733:            !!$
   734:            !!$    ! ѲΨ
   735:            !!$    ! Calculate temperature tendency
   736:            !!$    !
   737:            !!$    xy_DSurfTempDt = ( xy_SurfTemp - xy_SurfTempB ) / ( 2.0_DP * DelTime )
   738:            !!$    xyz_DTempDt    = ( xyz_Temp    - xyz_TempB    ) / ( 2.0_DP * DelTime )
   739:            !!$
   740:            !!$
   741:            !!$    ! ҥȥǡ
   742:            !!$    ! History data output
   743:            !!$    !
   744:            !!$    call HistoryAutoPut( TimeN, 'DSurfTempDtCO2PhaseChange', xy_DSurfTempDt )
   745:            !!$    call HistoryAutoPut( TimeN, 'DTempDtCO2PhaseChange'    , xyz_DTempDt    )
   746:            !!$
   747:            !!$
   748:            !!$    ! ׻ַ¬
   749:            !!$    ! Pause measurement of computation time
   750:            !!$    !
   751:            !!$    call TimesetClockStop( module_name )
   752:            !!$
   753:            !!$  end subroutine MajorCompPhaseChangeLimitTemp
   754:            
   755:              !--------------------------------------------------------------------------------------
   756:            
   757:              subroutine MajorCompPhaseChangeInit(             &
   758:                & ArgFlagMajCompPhaseChange, CondMajCompName   & ! (in)
   759:                & )
   760:                !
   761:                ! major_comp_phase_change ⥸塼νԤޤ. 
   762:                ! NAMELIST#major_comp_phase_change_nml ɤ߹ߤϤμ³ǹԤޤ. 
   763:                !
   764:                ! "major_comp_phase_change" module is initialized. 
   765:                ! "NAMELIST#major_comp_phase_change_nml" is loaded in this procedure. 
   766:                !
   767:            
   768:                ! ⥸塼 ; USE statements
   769:                !
   770:            
   771:            !!$    ! NAMELIST եϤ˴ؤ桼ƥƥ
   772:            !!$    ! Utilities for NAMELIST file input
   773:            !!$    !
   774:            !!$    use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   775:            !!$
   776:            !!$    ! ե
   777:            !!$    ! File I/O support
   778:            !!$    !
   779:            !!$    use dc_iounit, only: FileOpen
   780:            !!$
   781:            !!$    ! ̷ѥ᥿
   782:            !!$    ! Kind type parameter
   783:            !!$    !
   784:            !!$    use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   785:            
   786:                ! ʸ
   787:                ! Character handling
   788:                !
   789:                use dc_string, only: StoA
   790:            
   791:                ! ҥȥǡ
   792:                ! History data output
   793:                !
   794:                use gtool_historyauto, only: HistoryAutoAddVariable
   795:            
   796:                ! ʬѲ
   797:                ! Phase change of atmospheric major component
   798:                !
   799:                use major_comp_saturate, only : &
   800:                  & MajorCompSaturateInit
   801:            
   802:            
   803:                ! ʸ ; Declaration statements
   804:                !
   805:                implicit none
   806:            
   807:                logical     , intent(in) :: ArgFlagMajCompPhaseChange
   808:                character(*), intent(in) :: CondMajCompName
   809:            
   810:            
   811:            !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   812:            !!$                              ! Unit number for NAMELIST file open
   813:            !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   814:            !!$                              ! IOSTAT of NAMELIST read
   815:            
   816:                ! NAMELIST ѿ
   817:                ! NAMELIST group name
   818:                !
   819:            !!$    namelist /major_comp_phase_change_nml/ &
   820:            !!$      & FlagUse
   821:            
   822:                      ! ǥեͤˤĤƤϽ³ "major_comp_phase_change#MajorCompPhaseChangeInit" 
   823:                      ! Υɤ򻲾ȤΤ. 
   824:                      !
   825:                      ! Refer to source codes in the initialization procedure
   826:                      ! "major_comp_phase_change#MajorCompPhaseChangeInit" for the default values. 
   827:                      !
   828:            
   829:                ! ¹ʸ ; Executable statement
   830:                !
   831:            
   832:                if ( major_comp_phase_change_inited ) return
   833:            
   834:            
   835:                FlagMajCompPhaseChange = ArgFlagMajCompPhaseChange
   836:            
   837:            
   838:                ! ǥեͤ
   839:                ! Default values settings
   840:                !
   841:            
   842:            
   843:                ! NAMELIST ɤ߹
   844:                ! NAMELIST is input
   845:                !
   846:            !!$    if ( trim(namelist_filename) /= '' ) then
   847:            !!$      call FileOpen( unit_nml, &          ! (out)
   848:            !!$        & namelist_filename, mode = 'r' ) ! (in)
   849:            !!$
   850:            !!$      rewind( unit_nml )
   851:            !!$      read( unit_nml,                        &  ! (in)
   852:            !!$        & nml = major_comp_phase_change_nml, &  ! (out)
   853:            !!$        & iostat = iostat_nml )                 ! (out)
   854:            !!$      close( unit_nml )
   855:            !!$
   856:            !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   857:            !!$!      if ( iostat_nml == 0 ) write( STDOUT, nml = cumulus_adjust_nml )
   858:            !!$    end if
   859:            
   860:            
   861:                if ( FlagMajCompPhaseChange ) then
   862:                  ! ʬѲ
   863:                  ! Phase change of atmospheric major component
   864:                  !
   865:                  call MajorCompSaturateInit(  &
   866:                    & CondMajCompName          & ! (in)
   867:                    & )
   868:                end if
   869:            
   870:            
   871:                ! ҥȥǡϤΤΤؤѿϿ
   872:                ! Register of variables for history data output
   873:                !
   874:                call HistoryAutoAddVariable( 'DSurfTempDtMajCompPhaseChange', &
   875:                  & (/ 'lon ', 'lat ', 'time' /),                             &
   876:                  & 'heating by major component phase change', 'K s-1' )
   877:                call HistoryAutoAddVariable( 'DTempDtMajCompPhaseChange',     &
   878:                  & (/ 'lon ', 'lat ', 'sig ', 'time' /),                 &
   879:                  & 'heating by major component phase change', 'K s-1' )
   880:            
   881:                !  ; Print
   882:                !
   883:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   884:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   885:            
   886:                major_comp_phase_change_inited = .true.
   887:            
   888:              end subroutine MajorCompPhaseChangeInit
   889:            
   890:              !-------------------------------------------------------------------
   891:            
   892:            end module major_comp_phase_change
