Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:27 2012
FILE NAME: major_comp_saturate.f90
PROGRAM NAME: major_comp_saturate
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   264  opt  (1593): Loop nest collapsed into one loop.
   264  vec  (   4): Vectorized array expression.
   312  opt  (1593): Loop nest collapsed into one loop.
   312  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:27 2012
FILE NAME: major_comp_saturate.f90
PROGRAM NAME: major_comp_saturate
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ʬѲ
     2  !
     3  != Phase change of atmospheric major component
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: major_comp_saturate.f90,v 1.1 2012-09-08 15:16:39 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module major_comp_saturate
    13    !
    14    != ʬѲ
    15    !
    16    != Phase change of atmospheric major component
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    !== Procedures List
    21    !
    22  !!$  ! DryConvAdjust :: ήĴ
    23  !!$  ! ------------  :: ------------
    24  !!$  ! DryConvAdjust :: Dry convective adjustment
    25    !
    26    !== NAMELIST
    27    !
    28    ! NAMELIST#major_comp_saturate_nml
    29    !
    30  
    31    ! ⥸塼 ; USE statements
    32    !
    33  
    34    ! ʻ
    35    ! Grid points settings
    36    !
    37    use gridset, only: imax, & ! ٳʻ.
    38                               ! Number of grid points in longitude
    39      &                jmax, & ! ٳʻ.
    40                               ! Number of grid points in latitude
    41      &                kmax    ! ľؿ.
    42                               ! Number of vertical level
    43  
    44    ! ̷ѥ᥿
    45    ! Kind type parameter
    46    !
    47    use dc_types, only: DP, &      ! ټ¿. Double precision.
    48      &                 STRING     ! ʸ.       Strings.
    49  
    50    ! NAMELIST եϤ˴ؤ桼ƥƥ
    51    ! Utilities for NAMELIST file input
    52    !
    53    use namelist_util, only: MaxNmlArySize
    54                                ! NAMELIST ɤ߹κ祵.
    55                                ! Maximum size of arrays loaded from NAMELIST
    56  
    57    ! å
    58    ! Message output
    59    !
    60    use dc_message, only: MessageNotify
    61  
    62    ! ʸ ; Declaration statements
    63    !
    64    implicit none
    65    private
    66  
    67  
    68    integer, save      :: IndexSpc
    69    integer, parameter :: IndexSpcCO2     = 1
    70  
    71  
    72    real(DP), parameter :: LatentHeatCO2Subl = 5.9d5
    73                                ! Latent heat of CO2 (J kg^{-1})
    74                                ! This value is obtained from Pollack et al.
    75                                ! (1981) and Forget et al. (1998).
    76  
    77    ! ³
    78    ! Public procedure
    79    !
    80    public :: MajorCompSaturateCalcCondTemp
    81    public :: MajorCompSaturateInqLatentHeat
    82    public :: MajorCompSaturateInit
    83  
    84    ! ѿ
    85    ! Public variables
    86    !
    87    logical, save, public:: major_comp_saturate_inited = .false.
    88                                ! ե饰.
    89                                ! Initialization flag
    90  
    91    ! ѿ
    92    ! Private variables
    93    !
    94    character(*), parameter:: module_name = 'major_comp_saturate'
    95                                ! ⥸塼̾.
    96                                ! Module name
    97    character(*), parameter:: version = &
    98      & '$Name: dcpam5-20120921 $' // &
    99      & '$Id: major_comp_saturate.f90,v 1.1 2012-09-08 15:16:39 yot Exp $'
   100                                ! ⥸塼ΥС
   101                                ! Module version
   102  
   103  
   104    interface MajorCompSaturateCalcCondTemp
   105      module procedure &
   106        MajorCompSaturateCalcCondTemp3D, &
   107        MajorCompSaturateCalcCondTemp2D
   108    end interface
   109  
   110  
   111  contains
   112  
   113    !--------------------------------------------------------------------------------------
   114  
   115    subroutine MajorCompSaturateCalcCondTemp3D(  &
   116      & xyz_Press,                               &  ! (in)
   117      & xyz_TempCond                             &  ! (inout)
   118      & )
   119      !
   120      ! ʬѲ
   121      !
   122      ! Major component phase change
   123      !
   124  
   125      ! ⥸塼 ; USE statements
   126      !
   127  
   128  
   129      ! ʸ ; Declaration statements
   130      !
   131      implicit none
   132  
   133      real(DP), intent(in ):: xyz_Press   (0:imax-1, 1:jmax, 1:kmax)
   134                                ! $ p $ .  (٥).
   135                                ! Air pressure (full level)
   136      real(DP), intent(out):: xyz_TempCond(0:imax-1, 1:jmax, 1:kmax)
   137                                !
   138                                ! Condensation temperature
   139  
   140      ! ѿ
   141      ! Work variables
   142      !
   143  
   144      ! ¹ʸ ; Executable statement
   145      !
   146  
   147  
   148      ! 
   149      ! Initialization
   150      !
   151      if ( .not. major_comp_saturate_inited ) then
   152        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   153      end if
   154  
   155  
   156      select case ( IndexSpc )
   157      case ( IndexSpcCO2 )
   158        call CalcCO2CondTemp3D(  &
   159          & xyz_Press,       &  ! (in)
   160          & xyz_TempCond     &  ! (inout)
   161          & )
   162      end select
   163  
   164  
   165    end subroutine MajorCompSaturateCalcCondTemp3D
   166  
   167    !--------------------------------------------------------------------------------------
   168  
   169    subroutine MajorCompSaturateCalcCondTemp2D(  &
   170      & xy_Press,                                &  ! (in)
   171      & xy_TempCond                              &  ! (inout)
   172      & )
   173      !
   174      ! ʬѲ
   175      !
   176      ! Major component phase change
   177      !
   178  
   179      ! ⥸塼 ; USE statements
   180      !
   181  
   182  
   183      ! ʸ ; Declaration statements
   184      !
   185      implicit none
   186  
   187      real(DP), intent(in ):: xy_Press   (0:imax-1, 1:jmax)
   188                                ! $ p $ .  (٥).
   189                                ! Air pressure (full level)
   190      real(DP), intent(out):: xy_TempCond(0:imax-1, 1:jmax)
   191                                !
   192                                ! Condensation temperature
   193  
   194      ! ѿ
   195      ! Work variables
   196      !
   197  
   198      ! ¹ʸ ; Executable statement
   199      !
   200  
   201  
   202      ! 
   203      ! Initialization
   204      !
   205      if ( .not. major_comp_saturate_inited ) then
   206        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   207      end if
   208  
   209  
   210      select case ( IndexSpc )
   211      case ( IndexSpcCO2 )
   212        call CalcCO2CondTemp2D(  &
   213          & xy_Press,            &  ! (in)
   214          & xy_TempCond          &  ! (inout)
   215          & )
   216      end select
   217  
   218  
   219    end subroutine MajorCompSaturateCalcCondTemp2D
   220  
   221    !--------------------------------------------------------------------------------------
   222  
   223    subroutine CalcCO2CondTemp3D(  &
   224      & xyz_Press,                 &  ! (in)
   225      & xyz_TempCond               &  ! (inout)
   226      & )
   227      !
   228      ! CO2 Ѳ
   229      !
   230      ! CO2 phase change
   231      !
   232  
   233      ! ⥸塼 ; USE statements
   234      !
   235  
   236  
   237      ! ʸ ; Declaration statements
   238      !
   239      implicit none
   240  
   241      real(DP), intent(in ):: xyz_Press   (0:imax-1, 1:jmax, 1:kmax)
   242                                ! $ p $ .  (٥).
   243                                ! Air pressure (full level)
   244      real(DP), intent(out):: xyz_TempCond(0:imax-1, 1:jmax, 1:kmax)
   245                                !
   246                                ! Condensation temperature
   247  
   248      ! ѿ
   249      ! Work variables
   250      !
   251  
   252      ! ¹ʸ ; Executable statement
   253      !
   254  
   255  
   256      ! 
   257      ! Initialization
   258      !
   259      if ( .not. major_comp_saturate_inited ) then
   260        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   261      end if
   262  
   263  
   264      xyz_TempCond = 149.2_DP + 6.48_DP * log( 0.135_DP * xyz_Press * 1.0d-2 )
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t42 = 1, kmax*jmax*imax                                        
     .           xyz_tempcond(t42-1,1,1) = 1.49199999999999e+002 +              
     .       1      6.48000000000000e+000*dlog(1.35000000000000e-001*xyz_press( 
     .       2      t42-1,1,1)*1.00000000000000e-002)                           
     .        end do                                                            
   265  
   266  
   267    end subroutine CalcCO2CondTemp3D
   268  
   269    !--------------------------------------------------------------------------------------
   270  
   271    subroutine CalcCO2CondTemp2D(  &
   272      & xy_Press,                  &  ! (in)
   273      & xy_TempCond                &  ! (inout)
   274      & )
   275      !
   276      ! CO2 Ѳ
   277      !
   278      ! CO2 phase change
   279      !
   280  
   281      ! ⥸塼 ; USE statements
   282      !
   283  
   284  
   285      ! ʸ ; Declaration statements
   286      !
   287      implicit none
   288  
   289      real(DP), intent(in ):: xy_Press   (0:imax-1, 1:jmax)
   290                                ! $ p $ .  (٥).
   291                                ! Air pressure (full level)
   292      real(DP), intent(out):: xy_TempCond(0:imax-1, 1:jmax)
   293                                !
   294                                ! Condensation temperature
   295  
   296      ! ѿ
   297      ! Work variables
   298      !
   299  
   300      ! ¹ʸ ; Executable statement
   301      !
   302  
   303  
   304      ! 
   305      ! Initialization
   306      !
   307      if ( .not. major_comp_saturate_inited ) then
   308        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   309      end if
   310  
   311  
   312      xy_TempCond = 149.2_DP + 6.48_DP * log( 0.135_DP * xy_Press * 1.0d-2 )
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t32 = 1, jmax*imax                                             
     .           xy_tempcond(t32-1,1) = 1.49199999999999e+002 +                 
     .       1      6.48000000000000e+000*dlog(1.35000000000000e-001*xy_press(  
     .       2      t32-1,1)*1.00000000000000e-002)                             
     .        end do                                                            
   313  
   314  
   315    end subroutine CalcCO2CondTemp2D
   316  
   317    !--------------------------------------------------------------------------------------
   318  
   319    function MajorCompSaturateInqLatentHeat( ) result( LatentHeat )
   320      !
   321      ! ʬǮ֤ޤ.
   322      !
   323      ! Inquiry of latent heat of major component
   324      !
   325  
   326      ! ⥸塼 ; USE statements
   327      !
   328  
   329      ! å
   330      ! Message output
   331      !
   332      use dc_message, only: MessageNotify
   333  
   334      ! ʸ ; Declaration statements
   335      !
   336      implicit none
   337  
   338      real(DP) :: LatentHeat
   339  
   340  
   341      ! ¹ʸ ; Executable statement
   342      !
   343  
   344      ! 
   345      ! Initialization
   346      !
   347      if ( .not. major_comp_saturate_inited ) then
   348        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   349      end if
   350  
   351  
   352      ! Set latent heat
   353      select case ( IndexSpc )
   354      case ( IndexSpcCO2  )
   355        LatentHeat = LatentHeatCO2Subl
   356      case default
   357        call MessageNotify( 'E', module_name, 'This specice is not supported.' )
   358      end select
   359  
   360  
   361    end function MajorCompSaturateInqLatentHeat
   362  
   363    !--------------------------------------------------------------------------------------
   364  
   365    subroutine MajorCompSaturateInit(  &
   366      & CondMajCompName                & ! (in)
   367      & )
   368      !
   369      ! major_comp_saturate ⥸塼νԤޤ.
   370      ! NAMELIST#major_comp_saturate_nml ɤ߹ߤϤμ³ǹԤޤ.
   371      !
   372      ! "major_comp_saturate" module is initialized.
   373      ! "NAMELIST#major_comp_saturate_nml" is loaded in this procedure.
   374      !
   375  
   376      ! ⥸塼 ; USE statements
   377      !
   378  
   379  !!$    ! NAMELIST եϤ˴ؤ桼ƥƥ
   380  !!$    ! Utilities for NAMELIST file input
   381  !!$    !
   382  !!$    use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   383  !!$
   384  !!$    ! ե
   385  !!$    ! File I/O support
   386  !!$    !
   387  !!$    use dc_iounit, only: FileOpen
   388  !!$
   389  !!$    ! ̷ѥ᥿
   390  !!$    ! Kind type parameter
   391  !!$    !
   392  !!$    use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   393  
   394      ! ʸ
   395      ! Character handling
   396      !
   397      use dc_string, only: StoA
   398  
   399  
   400      ! ʸ ; Declaration statements
   401      !
   402      implicit none
   403  
   404      character(*), intent(in) :: CondMajCompName
   405                                          ! Condensable major component
   406  
   407  
   408  !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   409  !!$                              ! Unit number for NAMELIST file open
   410  !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   411  !!$                              ! IOSTAT of NAMELIST read
   412  
   413      ! NAMELIST ѿ
   414      ! NAMELIST group name
   415      !
   416  !!$    namelist /major_comp_saturate_nml/ &
   417  !!$      & FlagUse
   418  
   419            ! ǥեͤˤĤƤϽ³ "major_comp_saturate#MajorCompSaturateInit"
   420            ! Υɤ򻲾ȤΤ.
   421            !
   422            ! Refer to source codes in the initialization procedure
   423            ! "major_comp_saturate#MajorCompSaturateInit" for the default values.
   424            !
   425  
   426      ! ¹ʸ ; Executable statement
   427      !
   428  
   429      if ( major_comp_saturate_inited ) return
   430  
   431  
   432      ! ǥեͤ
   433      ! Default values settings
   434      !
   435  
   436  
   437      ! NAMELIST ɤ߹
   438      ! NAMELIST is input
   439      !
   440  !!$    if ( trim(namelist_filename) /= '' ) then
   441  !!$      call FileOpen( unit_nml, &          ! (out)
   442  !!$        & namelist_filename, mode = 'r' ) ! (in)
   443  !!$
   444  !!$      rewind( unit_nml )
   445  !!$      read( unit_nml,                    &  ! (in)
   446  !!$        & nml = major_comp_saturate_nml, &  ! (out)
   447  !!$        & iostat = iostat_nml )             ! (out)
   448  !!$      close( unit_nml )
   449  !!$
   450  !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   451  !!$!      if ( iostat_nml == 0 ) write( STDOUT, nml = cumulus_adjust_nml )
   452  !!$    end if
   453  
   454  
   455      ! Set index
   456      select case ( CondMajCompName )
   457      case ( 'CO2' )
   458        IndexSpc = IndexSpcCO2
   459      case default
   460        call MessageNotify( 'E', module_name, 'This specice is not supported.' )
   461      end select
   462  
   463  
   464  
   465      !  ; Print
   466      !
   467      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   468      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   469  
   470  
   471      major_comp_saturate_inited = .true.
   472  
   473    end subroutine MajorCompSaturateInit
   474  
   475    !-------------------------------------------------------------------
   476  
   477  end module major_comp_saturate
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:27 2012
FILE NAME: major_comp_saturate.f90
PROGRAM NAME: major_comp_saturate
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ʬѲ
     2:            !
     3:            != Phase change of atmospheric major component
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: major_comp_saturate.f90,v 1.1 2012-09-08 15:16:39 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module major_comp_saturate
    13:              !
    14:              != ʬѲ
    15:              !
    16:              != Phase change of atmospheric major component
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              !== Procedures List
    21:              ! 
    22:            !!$  ! DryConvAdjust :: ήĴ
    23:            !!$  ! ------------  :: ------------
    24:            !!$  ! DryConvAdjust :: Dry convective adjustment
    25:              !
    26:              !== NAMELIST
    27:              !
    28:              ! NAMELIST#major_comp_saturate_nml
    29:              !
    30:            
    31:              ! ⥸塼 ; USE statements
    32:              !
    33:            
    34:              ! ʻ
    35:              ! Grid points settings
    36:              !
    37:              use gridset, only: imax, & ! ٳʻ. 
    38:                                         ! Number of grid points in longitude
    39:                &                jmax, & ! ٳʻ. 
    40:                                         ! Number of grid points in latitude
    41:                &                kmax    ! ľؿ. 
    42:                                         ! Number of vertical level
    43:            
    44:              ! ̷ѥ᥿
    45:              ! Kind type parameter
    46:              !
    47:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    48:                &                 STRING     ! ʸ.       Strings. 
    49:            
    50:              ! NAMELIST եϤ˴ؤ桼ƥƥ
    51:              ! Utilities for NAMELIST file input
    52:              !
    53:              use namelist_util, only: MaxNmlArySize
    54:                                          ! NAMELIST ɤ߹κ祵. 
    55:                                          ! Maximum size of arrays loaded from NAMELIST
    56:            
    57:              ! å
    58:              ! Message output
    59:              !
    60:              use dc_message, only: MessageNotify
    61:            
    62:              ! ʸ ; Declaration statements
    63:              !
    64:              implicit none
    65:              private
    66:            
    67:            
    68:              integer, save      :: IndexSpc
    69:              integer, parameter :: IndexSpcCO2     = 1
    70:            
    71:            
    72:              real(DP), parameter :: LatentHeatCO2Subl = 5.9d5
    73:                                          ! Latent heat of CO2 (J kg^{-1})
    74:                                          ! This value is obtained from Pollack et al. 
    75:                                          ! (1981) and Forget et al. (1998).
    76:            
    77:              ! ³
    78:              ! Public procedure
    79:              !
    80:              public :: MajorCompSaturateCalcCondTemp
    81:              public :: MajorCompSaturateInqLatentHeat
    82:              public :: MajorCompSaturateInit
    83:            
    84:              ! ѿ
    85:              ! Public variables
    86:              !
    87:              logical, save, public:: major_comp_saturate_inited = .false.
    88:                                          ! ե饰. 
    89:                                          ! Initialization flag
    90:            
    91:              ! ѿ
    92:              ! Private variables
    93:              !
    94:              character(*), parameter:: module_name = 'major_comp_saturate'
    95:                                          ! ⥸塼̾. 
    96:                                          ! Module name
    97:              character(*), parameter:: version = &
    98:                & '$Name: dcpam5-20120921 $' // &
    99:                & '$Id: major_comp_saturate.f90,v 1.1 2012-09-08 15:16:39 yot Exp $'
   100:                                          ! ⥸塼ΥС
   101:                                          ! Module version
   102:            
   103:            
   104:              interface MajorCompSaturateCalcCondTemp
   105:                module procedure &
   106:                  MajorCompSaturateCalcCondTemp3D, &
   107:                  MajorCompSaturateCalcCondTemp2D
   108:              end interface
   109:            
   110:            
   111:            contains
   112:            
   113:              !--------------------------------------------------------------------------------------
   114:            
   115:              subroutine MajorCompSaturateCalcCondTemp3D(  &
   116:                & xyz_Press,                               &  ! (in)
   117:                & xyz_TempCond                             &  ! (inout)
   118:                & )
   119:                !
   120:                ! ʬѲ
   121:                !
   122:                ! Major component phase change
   123:                !
   124:            
   125:                ! ⥸塼 ; USE statements
   126:                !
   127:            
   128:            
   129:                ! ʸ ; Declaration statements
   130:                !
   131:                implicit none
   132:            
   133:                real(DP), intent(in ):: xyz_Press   (0:imax-1, 1:jmax, 1:kmax)
   134:                                          ! $ p $ .  (٥). 
   135:                                          ! Air pressure (full level)
   136:                real(DP), intent(out):: xyz_TempCond(0:imax-1, 1:jmax, 1:kmax)
   137:                                          !
   138:                                          ! Condensation temperature
   139:            
   140:                ! ѿ
   141:                ! Work variables
   142:                !
   143:            
   144:                ! ¹ʸ ; Executable statement
   145:                !
   146:            
   147:            
   148:                ! 
   149:                ! Initialization
   150:                !
   151:                if ( .not. major_comp_saturate_inited ) then
   152:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   153:                end if
   154:            
   155:            
   156:                select case ( IndexSpc )
   157:                case ( IndexSpcCO2 )
   158:                  call CalcCO2CondTemp3D(  &
   159:                    & xyz_Press,       &  ! (in)
   160:                    & xyz_TempCond     &  ! (inout)
   161:                    & )
   162:                end select
   163:            
   164:            
   165:              end subroutine MajorCompSaturateCalcCondTemp3D
   166:            
   167:              !--------------------------------------------------------------------------------------
   168:            
   169:              subroutine MajorCompSaturateCalcCondTemp2D(  &
   170:                & xy_Press,                                &  ! (in)
   171:                & xy_TempCond                              &  ! (inout)
   172:                & )
   173:                !
   174:                ! ʬѲ
   175:                !
   176:                ! Major component phase change
   177:                !
   178:            
   179:                ! ⥸塼 ; USE statements
   180:                !
   181:            
   182:            
   183:                ! ʸ ; Declaration statements
   184:                !
   185:                implicit none
   186:            
   187:                real(DP), intent(in ):: xy_Press   (0:imax-1, 1:jmax)
   188:                                          ! $ p $ .  (٥). 
   189:                                          ! Air pressure (full level)
   190:                real(DP), intent(out):: xy_TempCond(0:imax-1, 1:jmax)
   191:                                          !
   192:                                          ! Condensation temperature
   193:            
   194:                ! ѿ
   195:                ! Work variables
   196:                !
   197:            
   198:                ! ¹ʸ ; Executable statement
   199:                !
   200:            
   201:            
   202:                ! 
   203:                ! Initialization
   204:                !
   205:                if ( .not. major_comp_saturate_inited ) then
   206:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   207:                end if
   208:            
   209:            
   210:                select case ( IndexSpc )
   211:                case ( IndexSpcCO2 )
   212:                  call CalcCO2CondTemp2D(  &
   213:                    & xy_Press,            &  ! (in)
   214:                    & xy_TempCond          &  ! (inout)
   215:                    & )
   216:                end select
   217:            
   218:            
   219:              end subroutine MajorCompSaturateCalcCondTemp2D
   220:            
   221:              !--------------------------------------------------------------------------------------
   222:            
   223:              subroutine CalcCO2CondTemp3D(  &
   224:                & xyz_Press,                 &  ! (in)
   225:                & xyz_TempCond               &  ! (inout)
   226:                & )
   227:                !
   228:                ! CO2 Ѳ
   229:                !
   230:                ! CO2 phase change
   231:                !
   232:            
   233:                ! ⥸塼 ; USE statements
   234:                !
   235:            
   236:            
   237:                ! ʸ ; Declaration statements
   238:                !
   239:                implicit none
   240:            
   241:                real(DP), intent(in ):: xyz_Press   (0:imax-1, 1:jmax, 1:kmax)
   242:                                          ! $ p $ .  (٥). 
   243:                                          ! Air pressure (full level)
   244:                real(DP), intent(out):: xyz_TempCond(0:imax-1, 1:jmax, 1:kmax)
   245:                                          !
   246:                                          ! Condensation temperature
   247:            
   248:                ! ѿ
   249:                ! Work variables
   250:                !
   251:            
   252:                ! ¹ʸ ; Executable statement
   253:                !
   254:            
   255:            
   256:                ! 
   257:                ! Initialization
   258:                !
   259:                if ( .not. major_comp_saturate_inited ) then
   260:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   261:                end if
   262:            
   263:            
   264: WW*====        xyz_TempCond = 149.2_DP + 6.48_DP * log( 0.135_DP * xyz_Press * 1.0d-2 )
   265:            
   266:            
   267:              end subroutine CalcCO2CondTemp3D
   268:            
   269:              !--------------------------------------------------------------------------------------
   270:            
   271:              subroutine CalcCO2CondTemp2D(  &
   272:                & xy_Press,                  &  ! (in)
   273:                & xy_TempCond                &  ! (inout)
   274:                & )
   275:                !
   276:                ! CO2 Ѳ
   277:                !
   278:                ! CO2 phase change
   279:                !
   280:            
   281:                ! ⥸塼 ; USE statements
   282:                !
   283:            
   284:            
   285:                ! ʸ ; Declaration statements
   286:                !
   287:                implicit none
   288:            
   289:                real(DP), intent(in ):: xy_Press   (0:imax-1, 1:jmax)
   290:                                          ! $ p $ .  (٥). 
   291:                                          ! Air pressure (full level)
   292:                real(DP), intent(out):: xy_TempCond(0:imax-1, 1:jmax)
   293:                                          !
   294:                                          ! Condensation temperature
   295:            
   296:                ! ѿ
   297:                ! Work variables
   298:                !
   299:            
   300:                ! ¹ʸ ; Executable statement
   301:                !
   302:            
   303:            
   304:                ! 
   305:                ! Initialization
   306:                !
   307:                if ( .not. major_comp_saturate_inited ) then
   308:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   309:                end if
   310:            
   311:            
   312: **=====        xy_TempCond = 149.2_DP + 6.48_DP * log( 0.135_DP * xy_Press * 1.0d-2 )
   313:            
   314:            
   315:              end subroutine CalcCO2CondTemp2D
   316:            
   317:              !--------------------------------------------------------------------------------------
   318:            
   319:              function MajorCompSaturateInqLatentHeat( ) result( LatentHeat )
   320:                !
   321:                ! ʬǮ֤ޤ. 
   322:                !
   323:                ! Inquiry of latent heat of major component
   324:                !
   325:            
   326:                ! ⥸塼 ; USE statements
   327:                !
   328:            
   329:                ! å
   330:                ! Message output
   331:                !
   332:                use dc_message, only: MessageNotify
   333:            
   334:                ! ʸ ; Declaration statements
   335:                !
   336:                implicit none
   337:            
   338:                real(DP) :: LatentHeat
   339:            
   340:            
   341:                ! ¹ʸ ; Executable statement
   342:                !
   343:            
   344:                ! 
   345:                ! Initialization
   346:                !
   347:                if ( .not. major_comp_saturate_inited ) then
   348:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   349:                end if
   350:            
   351:            
   352:                ! Set latent heat
   353:                select case ( IndexSpc )
   354:                case ( IndexSpcCO2  )
   355:                  LatentHeat = LatentHeatCO2Subl
   356:                case default
   357:                  call MessageNotify( 'E', module_name, 'This specice is not supported.' )
   358:                end select
   359:            
   360:            
   361:              end function MajorCompSaturateInqLatentHeat
   362:            
   363:              !--------------------------------------------------------------------------------------
   364:            
   365:              subroutine MajorCompSaturateInit(  &
   366:                & CondMajCompName                & ! (in)
   367:                & )
   368:                !
   369:                ! major_comp_saturate ⥸塼νԤޤ. 
   370:                ! NAMELIST#major_comp_saturate_nml ɤ߹ߤϤμ³ǹԤޤ. 
   371:                !
   372:                ! "major_comp_saturate" module is initialized. 
   373:                ! "NAMELIST#major_comp_saturate_nml" is loaded in this procedure. 
   374:                !
   375:            
   376:                ! ⥸塼 ; USE statements
   377:                !
   378:            
   379:            !!$    ! NAMELIST եϤ˴ؤ桼ƥƥ
   380:            !!$    ! Utilities for NAMELIST file input
   381:            !!$    !
   382:            !!$    use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   383:            !!$
   384:            !!$    ! ե
   385:            !!$    ! File I/O support
   386:            !!$    !
   387:            !!$    use dc_iounit, only: FileOpen
   388:            !!$
   389:            !!$    ! ̷ѥ᥿
   390:            !!$    ! Kind type parameter
   391:            !!$    !
   392:            !!$    use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   393:            
   394:                ! ʸ
   395:                ! Character handling
   396:                !
   397:                use dc_string, only: StoA
   398:            
   399:            
   400:                ! ʸ ; Declaration statements
   401:                !
   402:                implicit none
   403:            
   404:                character(*), intent(in) :: CondMajCompName
   405:                                                    ! Condensable major component
   406:            
   407:            
   408:            !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   409:            !!$                              ! Unit number for NAMELIST file open
   410:            !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   411:            !!$                              ! IOSTAT of NAMELIST read
   412:            
   413:                ! NAMELIST ѿ
   414:                ! NAMELIST group name
   415:                !
   416:            !!$    namelist /major_comp_saturate_nml/ &
   417:            !!$      & FlagUse
   418:            
   419:                      ! ǥեͤˤĤƤϽ³ "major_comp_saturate#MajorCompSaturateInit" 
   420:                      ! Υɤ򻲾ȤΤ. 
   421:                      !
   422:                      ! Refer to source codes in the initialization procedure
   423:                      ! "major_comp_saturate#MajorCompSaturateInit" for the default values. 
   424:                      !
   425:            
   426:                ! ¹ʸ ; Executable statement
   427:                !
   428:            
   429:                if ( major_comp_saturate_inited ) return
   430:            
   431:            
   432:                ! ǥեͤ
   433:                ! Default values settings
   434:                !
   435:            
   436:            
   437:                ! NAMELIST ɤ߹
   438:                ! NAMELIST is input
   439:                !
   440:            !!$    if ( trim(namelist_filename) /= '' ) then
   441:            !!$      call FileOpen( unit_nml, &          ! (out)
   442:            !!$        & namelist_filename, mode = 'r' ) ! (in)
   443:            !!$
   444:            !!$      rewind( unit_nml )
   445:            !!$      read( unit_nml,                    &  ! (in)
   446:            !!$        & nml = major_comp_saturate_nml, &  ! (out)
   447:            !!$        & iostat = iostat_nml )             ! (out)
   448:            !!$      close( unit_nml )
   449:            !!$
   450:            !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   451:            !!$!      if ( iostat_nml == 0 ) write( STDOUT, nml = cumulus_adjust_nml )
   452:            !!$    end if
   453:            
   454:            
   455:                ! Set index
   456:                select case ( CondMajCompName )
   457:                case ( 'CO2' )
   458:                  IndexSpc = IndexSpcCO2
   459:                case default
   460:                  call MessageNotify( 'E', module_name, 'This specice is not supported.' )
   461:                end select
   462:            
   463:            
   464:            
   465:                !  ; Print
   466:                !
   467:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   468:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   469:            
   470:            
   471:                major_comp_saturate_inited = .true.
   472:            
   473:              end subroutine MajorCompSaturateInit
   474:            
   475:              !-------------------------------------------------------------------
   476:            
   477:            end module major_comp_saturate
