Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:12 2012
FILE NAME: composition.f90
PROGRAM NAME: composition
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   149  vec  (   3): Unvectorized loop.
   150  opt  (1017): Subroutine call prevents optimization.
   150  vec  (   9): Vectorization obstructive statement.
   383  vec  (   3): Unvectorized loop.
   383  vec  (  13): Overhead of loop division is too large.
   384  opt  (1017): Subroutine call prevents optimization.
   384  vec  (  18): Unvectorizable data type.
   385  vec  (  18): Unvectorizable data type.
   388  opt  (  11): Fused array assignments. :line 388 - 392
   388  vec  (   4): Vectorized array expression.
   434  vec  (   3): Unvectorized loop.
   434  vec  (  13): Overhead of loop division is too large.
   435  vec  (  18): Unvectorizable data type.
   436  opt  (1017): Subroutine call prevents optimization.
   436  vec  (  17): Unvectorizable statement.
   438  vec  (  18): Unvectorizable data type.
   440  vec  (  18): Unvectorizable data type.
   441  vec  (  18): Unvectorizable data type.
   443  vec  (  18): Unvectorizable data type.
   445  vec  (  22): Dependency unknown. Unvectorizable dependency is assumed.:n
   448  vec  (   1): Vectorized loop.
   448  vec  (  24): Iteration count is assumed. Iteration count=256
   453  vec  (   1): Vectorized loop.
   453  vec  (  24): Iteration count is assumed. Iteration count=256
   458  vec  (   1): Vectorized loop.
   458  vec  (  24): Iteration count is assumed. Iteration count=256
   463  vec  (   3): Unvectorized loop.
   464  vec  (  18): Unvectorizable data type.
   465  opt  (1084): Branch out of the loop inhibits optimization.
   486  vec  (   3): Unvectorized loop.
   487  opt  (1017): Subroutine call prevents optimization.
   487  vec  (   9): Vectorization obstructive statement.
   487  vec  (  10): Vectorization obstructive procedure reference.:messagenotifyc
   489  vec  (   3): Unvectorized loop.
   490  opt  (1017): Subroutine call prevents optimization.
   490  vec  (   9): Vectorization obstructive statement.
   490  vec  (  10): Vectorization obstructive procedure reference.:messagenotifyc
   492  vec  (   3): Unvectorized loop.
   493  opt  (1017): Subroutine call prevents optimization.
   493  vec  (  10): Vectorization obstructive procedure reference.:messagenotifyc
   495  vec  (   3): Unvectorized loop.
   496  opt  (1017): Subroutine call prevents optimization.
   496  vec  (  10): Vectorization obstructive procedure reference.:messagenotifyc
   498  vec  (   3): Unvectorized loop.
   499  opt  (1017): Subroutine call prevents optimization.
   499  vec  (  10): Vectorization obstructive procedure reference.:messagenotifyc
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:12 2012
FILE NAME: composition.f90
PROGRAM NAME: composition
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ˴ؤ
     2  !
     3  != Settings of array for atmospheric composition
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: composition.f90,v 1.6 2012-09-08 15:25:53 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module composition
    13    !
    14    != ˴ؤ
    15    !
    16    != Settings of array for atmospheric composition
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! ˴ؤ
    21    !
    22    ! Settings of array for atmospheric composition
    23    !
    24    !== Variables List
    25    !
    26    ! ncmax        :: ʬο
    27    ! ------------ :: ------------
    28    ! ncmax        :: Number of minor comstituents
    29    !
    30    !== Procedures List
    31    !
    32    ! CompositionInit :: ˴ؤ
    33    ! --------------  :: ------------
    34    ! CompositionInit :: Settings of parameters for array for composition
    35    !
    36    !
    37    !== NAMELIST
    38    !
    39    ! NAMELIST#composition_nml
    40    !
    41  
    42    ! ⥸塼 ; USE statements
    43    !
    44  
    45    ! ̷ѥ᥿
    46    ! Kind type parameter
    47    !
    48    use dc_types, only: DP,     & ! ټ¿. Double precision.
    49                        STRING    ! ʸ. Strings.
    50  
    51    ! ʸ ; Declaration statements
    52    !
    53    implicit none
    54    private
    55  
    56    ! ³
    57    ! Public procedure
    58    !
    59    public :: CompositionInqIndex
    60    public :: CompositionInqFlagMassFix
    61    public :: CompositionInqFlagAdv
    62    public :: CompositionInqFlagVDiff
    63    public :: CompositionInit
    64  
    65    ! ѿ
    66    ! Public variables
    67    !
    68    logical          , save, public             :: composition_inited = .false.
    69                                ! ե饰.
    70                                ! Initialization flag
    71  
    72    integer          , save, public             :: ncmax
    73                                ! ʬο
    74                                ! Number of composition
    75    character(STRING), save, public, allocatable:: a_QMixName(:)
    76                                ! ʬѿ̾
    77                                ! Name of variables for composition
    78    character(STRING), save, public, allocatable:: a_QMixLongName(:)
    79                                ! ʬĹѿ̾
    80                                ! Long name of variables for composition
    81    logical          , save,         allocatable:: a_FlagMassFix(:)
    82                                ! ¸Υե饰
    83                                ! Flag for mass fix
    84    logical          , save,         allocatable:: a_FlagAdv(:)
    85                                ! ʬΰή׻Υե饰
    86                                ! Flag for advection calculation
    87    logical          , save,         allocatable:: a_FlagVDiff(:)
    88                                ! ľΰή׻Υե饰
    89                                ! Flag for vertical diffusion
    90    integer          , save, public             :: IndexH2OVap
    91                                ! Υǥå
    92                                ! Index for water vapor
    93  
    94    ! ѿ
    95    ! Private variables
    96    !
    97    character(*), parameter:: module_name = 'composition'
    98                                ! ⥸塼̾.
    99                                ! Module name
   100    character(*), parameter:: version = &
   101      & '$Name: dcpam5-20120921 $' // &
   102      & '$Id: composition.f90,v 1.6 2012-09-08 15:25:53 yot Exp $'
   103                                ! ⥸塼ΥС
   104                                ! Module version
   105  
   106  contains
   107  
   108    !-------------------------------------------------------------------
   109  
   110    function CompositionInqIndex( Name ) result( Index )
   111      !
   112      ! Name Ϳ줿̾ʬΥǥ֤ޤ.
   113      !
   114      ! Inquiry of index of constituent
   115      !
   116  
   117      ! ⥸塼 ; USE statements
   118      !
   119  
   120      ! å
   121      ! Message output
   122      !
   123      use dc_message, only: MessageNotify
   124  
   125      ! ʸ ; Declaration statements
   126      !
   127      implicit none
   128  
   129      character(len=*), intent(in ) :: Name
   130  
   131      integer:: Index
   132  
   133      integer:: n               ! ˲ DO 롼Ѻѿ
   134                                ! Work variables for DO loop in dimension of constituents
   135  
   136      ! ¹ʸ ; Executable statement
   137      !
   138  
   139      ! 
   140      ! Initialization
   141      !
   142      if ( .not. composition_inited ) then
   143        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   144      end if
   145  
   146  
   147      Index = -1
   148  
   149      do n = 1, ncmax
   150        if ( a_QMixName(n) == trim( Name ) ) then
   151          Index = n
   152          exit
   153        end if
   154      end do
   155  
   156  !!$    if ( Index == -1 ) then
   157  !!$      call MessageNotify( 'E', module_name, &
   158  !!$        & 'Cannot find %c in a list of constituents.', c1 = trim( Name ) )
   159  !!$    end if
   160  
   161  
   162    end function CompositionInqIndex
   163  
   164    !-------------------------------------------------------------------
   165  
   166    function CompositionInqFlagMassFix( Index ) result( FlagMassFix )
   167      !
   168      ! Name Ϳ줿̾ʬΰήե饰֤ޤ.
   169      !
   170      ! Inquiry of flag for advection of constituent
   171      !
   172  
   173      ! ⥸塼 ; USE statements
   174      !
   175  
   176      ! å
   177      ! Message output
   178      !
   179      use dc_message, only: MessageNotify
   180  
   181      ! ʸ ; Declaration statements
   182      !
   183      implicit none
   184  
   185      integer, intent(in ) :: Index
   186  
   187      logical :: FlagMassFix
   188  
   189  
   190      ! ¹ʸ ; Executable statement
   191      !
   192  
   193      ! 
   194      ! Initialization
   195      !
   196      if ( .not. composition_inited ) then
   197        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   198      end if
   199  
   200  
   201      if ( ( Index < 1 ) .or. ( Index > ncmax ) ) then
   202        call MessageNotify( 'E', module_name, &
   203          & 'Index is inappropriate, Index = %d', i = (/ Index /) )
   204      end if
   205  
   206      FlagMassFix = a_FlagMassFix( Index )
   207  
   208  
   209    end function CompositionInqFlagMassFix
   210  
   211    !-------------------------------------------------------------------
   212  
   213    function CompositionInqFlagAdv( Index ) result( FlagAdv )
   214      !
   215      ! Name Ϳ줿̾ʬΰήե饰֤ޤ.
   216      !
   217      ! Inquiry of flag for advection of constituent
   218      !
   219  
   220      ! ⥸塼 ; USE statements
   221      !
   222  
   223      ! å
   224      ! Message output
   225      !
   226      use dc_message, only: MessageNotify
   227  
   228      ! ʸ ; Declaration statements
   229      !
   230      implicit none
   231  
   232      integer, intent(in ) :: Index
   233  
   234      logical :: FlagAdv
   235  
   236  
   237      ! ¹ʸ ; Executable statement
   238      !
   239  
   240      ! 
   241      ! Initialization
   242      !
   243      if ( .not. composition_inited ) then
   244        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   245      end if
   246  
   247  
   248      if ( ( Index < 1 ) .or. ( Index > ncmax ) ) then
   249        call MessageNotify( 'E', module_name, &
   250          & 'Index is inappropriate, Index = %d', i = (/ Index /) )
   251      end if
   252  
   253      FlagAdv = a_FlagAdv( Index )
   254  
   255  
   256    end function CompositionInqFlagAdv
   257  
   258    !-------------------------------------------------------------------
   259  
   260    function CompositionInqFlagVDiff( Index ) result( FlagVDiff )
   261      !
   262      ! Name Ϳ줿̾ʬΰήե饰֤ޤ.
   263      !
   264      ! Inquiry of flag for advection of constituent
   265      !
   266  
   267      ! ⥸塼 ; USE statements
   268      !
   269  
   270      ! å
   271      ! Message output
   272      !
   273      use dc_message, only: MessageNotify
   274  
   275      ! ʸ ; Declaration statements
   276      !
   277      implicit none
   278  
   279      integer, intent(in ) :: Index
   280  
   281      logical :: FlagVDiff
   282  
   283  
   284      ! ¹ʸ ; Executable statement
   285      !
   286  
   287      ! 
   288      ! Initialization
   289      !
   290      if ( .not. composition_inited ) then
   291        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   292      end if
   293  
   294  
   295      if ( ( Index < 1 ) .or. ( Index > ncmax ) ) then
   296        call MessageNotify( 'E', module_name, &
   297          & 'Index is inappropriate, Index = %d', i = (/ Index /) )
   298      end if
   299  
   300      FlagVDiff = a_FlagVDiff( Index )
   301  
   302  
   303    end function CompositionInqFlagVDiff
   304  
   305    !-------------------------------------------------------------------
   306  
   307    subroutine CompositionInit
   308      !
   309      ! composition ⥸塼νԤޤ.
   310      ! NAMELIST#composition_nml ɤ߹ߤϤμ³ǹԤޤ.
   311      !
   312      ! "composition" module is initialized.
   313      ! NAMELIST#composition_nml is loaded in this procedure.
   314      !
   315  
   316      ! ⥸塼 ; USE statements
   317      !
   318  
   319      ! NAMELIST եϤ˴ؤ桼ƥƥ
   320      ! Utilities for NAMELIST file input
   321      !
   322      use namelist_util, only: namelist_filename, NmlutilMsg, MaxNmlArySize
   323  
   324      ! ե
   325      ! File I/O support
   326      !
   327      use dc_iounit, only: FileOpen
   328  
   329      ! ̷ѥ᥿
   330      ! Kind type parameter
   331      !
   332      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   333  
   334      ! å
   335      ! Message output
   336      !
   337      use dc_message, only: MessageNotify
   338  
   339      ! ʸ ; Declaration statements
   340      !
   341      implicit none
   342  
   343      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   344                                ! Unit number for NAMELIST file open
   345      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   346                                ! IOSTAT of NAMELIST read
   347  
   348      character(len=STRING) :: Names      (1:MaxNmlArySize)
   349      character(len=STRING) :: LongNames  (1:MaxNmlArySize)
   350      logical               :: FlagMassFix(1:MaxNmlArySize)
   351      logical               :: FlagAdv    (1:MaxNmlArySize)
   352      logical               :: FlagVDiff  (1:MaxNmlArySize)
   353  
   354      integer:: n               ! ˲ DO 롼Ѻѿ
   355                                ! Work variables for DO loop in dimension of constituents
   356  
   357      ! NAMELIST ѿ
   358      ! NAMELIST group name
   359      !
   360      namelist /composition_nml/ &
   361        & ncmax, Names, LongNames, FlagMassFix, FlagAdv, FlagVDiff
   362            !
   363            ! ǥեͤˤĤƤϽ³ "composition#CompositionInit"
   364            ! Υɤ򻲾ȤΤ.
   365            !
   366            ! Refer to source codes in the initialization procedure
   367            ! "composition#CompositionInit" for the default values.
   368            !
   369  
   370      ! ¹ʸ ; Executable statement
   371      !
   372  
   373      if ( composition_inited ) return
   374  !!$    call InitCheck
   375  
   376      ! ǥեͤ
   377      ! Default values settings
   378      !
   379      ncmax        = 1
   380  
   381      Names    (1) = 'QVap'
   382      LongNames(1) = 'specific humidity'
   383      do n = 2, MaxNmlArySize
   384        Names    (n) = ''
   385        LongNames(n) = ''
   386      end do
   387  
   388      FlagMassFix = .true.
   389  
   390      FlagAdv     = .true.
   391  
   392      FlagVDiff   = .true.
   393  
   394  
   395      ! NAMELIST ɤ߹
   396      ! NAMELIST is input
   397      !
   398      if ( trim(namelist_filename) /= '' ) then
   399        call FileOpen( unit_nml, &          ! (out)
   400          & namelist_filename, mode = 'r' ) ! (in)
   401  
   402        rewind( unit_nml )
   403        read( unit_nml,            & ! (in)
   404          & nml = composition_nml, & ! (out)
   405          & iostat = iostat_nml    & ! (out)
   406          & )
   407        close( unit_nml )
   408  
   409        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   410        if ( iostat_nml == 0 ) write( STDOUT, nml = composition_nml )
   411      end if
   412  
   413      ! 󥵥Υå
   414      ! Check number of array size
   415      !
   416      if ( ncmax < 1 ) then
   417        call MessageNotify( 'E', module_name, &
   418          & 'number of composition has to be greater than 0. ' // &
   419          & 'ncmax=%d' , &
   420          & i = (/ ncmax /) )
   421      end if
   422  
   423  
   424      ! Set variable name of constituents for ouptut
   425      !
   426      allocate( a_QMixName    ( ncmax ) )
   427      allocate( a_QMixLongName( ncmax ) )
   428      if ( ncmax > 99 ) then
   429        call MessageNotify( 'E', module_name, &
   430          & 'number of composition greater than 99 is inappropriate for current version. ' // &
   431          & 'ncmax=%d' , &
   432          & i = (/ ncmax /) )
   433      end if
   434      do n = 1, ncmax
   435        if ( Names(n) == '' ) then
   436          write( a_QMixName(n), '(a,i3.3)' ) "QMix", n
   437        else
   438          a_QMixName(n) = Names(n)
   439        end if
   440        if ( LongNames(n) == '' ) then
   441          a_QMixLongName(n) = a_QMixName(n)
   442        else
   443          a_QMixLongName(n) = LongNames(n)
   444        end if
   445      end do
   446  
   447      allocate( a_FlagMassFix( ncmax ) )
   448      do n = 1, ncmax
   449        a_FlagMassFix( n ) = FlagMassFix(n)
   450      end do
   451  
   452      allocate( a_FlagAdv( ncmax ) )
   453      do n = 1, ncmax
   454        a_FlagAdv( n ) = FlagAdv(n)
   455      end do
   456  
   457      allocate( a_FlagVDiff( ncmax ) )
   458      do n = 1, ncmax
   459        a_FlagVDiff( n ) = FlagVDiff(n)
   460      end do
   461  
   462      IndexH2OVap = -1
   463      do n = 1, ncmax
   464        if ( a_QMixName(n) == 'QVap' ) then
   465          IndexH2OVap = n
   466          exit
   467        end if
   468      end do
   469  
   470  
   471      ! ΥǥåΥå
   472      ! Check index for water vapor
   473      !
   474      if ( ( IndexH2OVap < 1 ) .or. ( IndexH2OVap > ncmax ) ) then
   475        call MessageNotify( 'E', module_name, &
   476          & 'IndexH2OVap has to be greater than or equal to 1 and less than or equal to ncmax. ' // &
   477          & 'IndexH2OVap=%d' , &
   478          & i = (/ IndexH2OVap /) )
   479      end if
   480  
   481  
   482      !  ; Print
   483      !
   484      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   485      call MessageNotify( 'M', module_name, '    ncmax              = %d', i = (/ ncmax /) )
   486      do n = 1, ncmax
   487        call MessageNotify( 'M', module_name, '    QMixName(%d)     = %c', i = (/ n /), c1 = trim(a_QMixName(n)) )
   488      end do
   489      do n = 1, ncmax
   490        call MessageNotify( 'M', module_name, '    QMixLongName(%d) = %c', i = (/ n /), c1 = trim(a_QMixLongName(n)) )
   491      end do
   492      do n = 1, ncmax
   493        call MessageNotify( 'M', module_name, '    FlagMassFix(%d)  = %b', i = (/ n /), l = (/ a_FlagMassFix(n) /) )
   494      end do
   495      do n = 1, ncmax
   496        call MessageNotify( 'M', module_name, '    FlagAdv(%d)      = %b', i = (/ n /), l = (/ a_FlagAdv(n) /) )
   497      end do
   498      do n = 1, ncmax
   499        call MessageNotify( 'M', module_name, '    FlagVDiff(%d)    = %b', i = (/ n /), l = (/ a_FlagVDiff(n) /) )
   500      end do
   501      call MessageNotify( 'M', module_name, '    IndexH2OVap        = %d', i = (/ IndexH2OVap /) )
   502      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   503  
   504      composition_inited = .true.
   505    end subroutine CompositionInit
   506  
   507    !-------------------------------------------------------------------
   508  
   509  !!$  subroutine InitCheck
   510  !!$    !
   511  !!$    ! ¸⥸塼νå
   512  !!$    !
   513  !!$    ! Check initialization of dependency modules
   514  !!$
   515  !!$    ! ⥸塼 ; USE statements
   516  !!$    !
   517  !!$
   518  !!$    ! NAMELIST եϤ˴ؤ桼ƥƥ
   519  !!$    ! Utilities for NAMELIST file input
   520  !!$    !
   521  !!$    use namelist_util, only: namelist_util_inited
   522  !!$
   523  !!$    ! å
   524  !!$    ! Message output
   525  !!$    !
   526  !!$    use dc_message, only: MessageNotify
   527  !!$
   528  !!$    ! ¹ʸ ; Executable statement
   529  !!$    !
   530  !!$
   531  !!$    if ( .not. namelist_util_inited ) &
   532  !!$      & call MessageNotify( 'E', module_name, '"namelist_util" module is not initialized.' )
   533  !!$
   534  !!$  end subroutine InitCheck
   535  
   536  end module composition
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:12 2012
FILE NAME: composition.f90
PROGRAM NAME: composition
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ˴ؤ
     2:            !
     3:            != Settings of array for atmospheric composition
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: composition.f90,v 1.6 2012-09-08 15:25:53 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module composition
    13:              !
    14:              != ˴ؤ
    15:              !
    16:              != Settings of array for atmospheric composition
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! ˴ؤ
    21:              !
    22:              ! Settings of array for atmospheric composition
    23:              !
    24:              !== Variables List
    25:              !
    26:              ! ncmax        :: ʬο
    27:              ! ------------ :: ------------
    28:              ! ncmax        :: Number of minor comstituents
    29:              !
    30:              !== Procedures List
    31:              !
    32:              ! CompositionInit :: ˴ؤ
    33:              ! --------------  :: ------------
    34:              ! CompositionInit :: Settings of parameters for array for composition
    35:              !
    36:              !
    37:              !== NAMELIST
    38:              !
    39:              ! NAMELIST#composition_nml
    40:              !
    41:            
    42:              ! ⥸塼 ; USE statements
    43:              !
    44:            
    45:              ! ̷ѥ᥿
    46:              ! Kind type parameter
    47:              !
    48:              use dc_types, only: DP,     & ! ټ¿. Double precision. 
    49:                                  STRING    ! ʸ. Strings.
    50:            
    51:              ! ʸ ; Declaration statements
    52:              !
    53:              implicit none
    54:              private
    55:            
    56:              ! ³
    57:              ! Public procedure
    58:              !
    59:              public :: CompositionInqIndex
    60:              public :: CompositionInqFlagMassFix
    61:              public :: CompositionInqFlagAdv
    62:              public :: CompositionInqFlagVDiff
    63:              public :: CompositionInit
    64:            
    65:              ! ѿ
    66:              ! Public variables
    67:              !
    68:              logical          , save, public             :: composition_inited = .false.
    69:                                          ! ե饰. 
    70:                                          ! Initialization flag
    71:            
    72:              integer          , save, public             :: ncmax
    73:                                          ! ʬο
    74:                                          ! Number of composition
    75:              character(STRING), save, public, allocatable:: a_QMixName(:)
    76:                                          ! ʬѿ̾
    77:                                          ! Name of variables for composition
    78:              character(STRING), save, public, allocatable:: a_QMixLongName(:)
    79:                                          ! ʬĹѿ̾
    80:                                          ! Long name of variables for composition
    81:              logical          , save,         allocatable:: a_FlagMassFix(:)
    82:                                          ! ¸Υե饰
    83:                                          ! Flag for mass fix
    84:              logical          , save,         allocatable:: a_FlagAdv(:)
    85:                                          ! ʬΰή׻Υե饰
    86:                                          ! Flag for advection calculation
    87:              logical          , save,         allocatable:: a_FlagVDiff(:)
    88:                                          ! ľΰή׻Υե饰
    89:                                          ! Flag for vertical diffusion
    90:              integer          , save, public             :: IndexH2OVap
    91:                                          ! Υǥå
    92:                                          ! Index for water vapor
    93:            
    94:              ! ѿ
    95:              ! Private variables
    96:              !
    97:              character(*), parameter:: module_name = 'composition'
    98:                                          ! ⥸塼̾. 
    99:                                          ! Module name
   100:              character(*), parameter:: version = &
   101:                & '$Name: dcpam5-20120921 $' // &
   102:                & '$Id: composition.f90,v 1.6 2012-09-08 15:25:53 yot Exp $'
   103:                                          ! ⥸塼ΥС
   104:                                          ! Module version
   105:            
   106:            contains
   107:            
   108:              !-------------------------------------------------------------------
   109:            
   110:              function CompositionInqIndex( Name ) result( Index )
   111:                !
   112:                ! Name Ϳ줿̾ʬΥǥ֤ޤ. 
   113:                !
   114:                ! Inquiry of index of constituent
   115:                !
   116:            
   117:                ! ⥸塼 ; USE statements
   118:                !
   119:            
   120:                ! å
   121:                ! Message output
   122:                !
   123:                use dc_message, only: MessageNotify
   124:            
   125:                ! ʸ ; Declaration statements
   126:                !
   127:                implicit none
   128:            
   129:                character(len=*), intent(in ) :: Name
   130:            
   131:                integer:: Index
   132:            
   133:                integer:: n               ! ˲ DO 롼Ѻѿ
   134:                                          ! Work variables for DO loop in dimension of constituents
   135:            
   136:                ! ¹ʸ ; Executable statement
   137:                !
   138:            
   139:                ! 
   140:                ! Initialization
   141:                !
   142:                if ( .not. composition_inited ) then
   143:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   144:                end if
   145:            
   146:            
   147:                Index = -1
   148:            
   149: +------>       do n = 1, ncmax
   150: |                if ( a_QMixName(n) == trim( Name ) ) then
   151: |                  Index = n
   152: |                  exit
   153: |                end if
   154: +------        end do
   155:            
   156:            !!$    if ( Index == -1 ) then
   157:            !!$      call MessageNotify( 'E', module_name, &
   158:            !!$        & 'Cannot find %c in a list of constituents.', c1 = trim( Name ) )
   159:            !!$    end if
   160:            
   161:            
   162:              end function CompositionInqIndex
   163:            
   164:              !-------------------------------------------------------------------
   165:            
   166:              function CompositionInqFlagMassFix( Index ) result( FlagMassFix )
   167:                !
   168:                ! Name Ϳ줿̾ʬΰήե饰֤ޤ.
   169:                !
   170:                ! Inquiry of flag for advection of constituent
   171:                !
   172:            
   173:                ! ⥸塼 ; USE statements
   174:                !
   175:            
   176:                ! å
   177:                ! Message output
   178:                !
   179:                use dc_message, only: MessageNotify
   180:            
   181:                ! ʸ ; Declaration statements
   182:                !
   183:                implicit none
   184:            
   185:                integer, intent(in ) :: Index
   186:            
   187:                logical :: FlagMassFix
   188:            
   189:            
   190:                ! ¹ʸ ; Executable statement
   191:                !
   192:            
   193:                ! 
   194:                ! Initialization
   195:                !
   196:                if ( .not. composition_inited ) then
   197:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   198:                end if
   199:            
   200:            
   201:                if ( ( Index < 1 ) .or. ( Index > ncmax ) ) then
   202:                  call MessageNotify( 'E', module_name, &
   203:                    & 'Index is inappropriate, Index = %d', i = (/ Index /) )
   204:                end if
   205:            
   206:                FlagMassFix = a_FlagMassFix( Index )
   207:            
   208:            
   209:              end function CompositionInqFlagMassFix
   210:            
   211:              !-------------------------------------------------------------------
   212:            
   213:              function CompositionInqFlagAdv( Index ) result( FlagAdv )
   214:                !
   215:                ! Name Ϳ줿̾ʬΰήե饰֤ޤ. 
   216:                !
   217:                ! Inquiry of flag for advection of constituent
   218:                !
   219:            
   220:                ! ⥸塼 ; USE statements
   221:                !
   222:            
   223:                ! å
   224:                ! Message output
   225:                !
   226:                use dc_message, only: MessageNotify
   227:            
   228:                ! ʸ ; Declaration statements
   229:                !
   230:                implicit none
   231:            
   232:                integer, intent(in ) :: Index
   233:            
   234:                logical :: FlagAdv
   235:            
   236:            
   237:                ! ¹ʸ ; Executable statement
   238:                !
   239:            
   240:                ! 
   241:                ! Initialization
   242:                !
   243:                if ( .not. composition_inited ) then
   244:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   245:                end if
   246:            
   247:            
   248:                if ( ( Index < 1 ) .or. ( Index > ncmax ) ) then
   249:                  call MessageNotify( 'E', module_name, &
   250:                    & 'Index is inappropriate, Index = %d', i = (/ Index /) )
   251:                end if
   252:            
   253:                FlagAdv = a_FlagAdv( Index )
   254:            
   255:            
   256:              end function CompositionInqFlagAdv
   257:            
   258:              !-------------------------------------------------------------------
   259:            
   260:              function CompositionInqFlagVDiff( Index ) result( FlagVDiff )
   261:                !
   262:                ! Name Ϳ줿̾ʬΰήե饰֤ޤ.
   263:                !
   264:                ! Inquiry of flag for advection of constituent
   265:                !
   266:            
   267:                ! ⥸塼 ; USE statements
   268:                !
   269:            
   270:                ! å
   271:                ! Message output
   272:                !
   273:                use dc_message, only: MessageNotify
   274:            
   275:                ! ʸ ; Declaration statements
   276:                !
   277:                implicit none
   278:            
   279:                integer, intent(in ) :: Index
   280:            
   281:                logical :: FlagVDiff
   282:            
   283:            
   284:                ! ¹ʸ ; Executable statement
   285:                !
   286:            
   287:                ! 
   288:                ! Initialization
   289:                !
   290:                if ( .not. composition_inited ) then
   291:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   292:                end if
   293:            
   294:            
   295:                if ( ( Index < 1 ) .or. ( Index > ncmax ) ) then
   296:                  call MessageNotify( 'E', module_name, &
   297:                    & 'Index is inappropriate, Index = %d', i = (/ Index /) )
   298:                end if
   299:            
   300:                FlagVDiff = a_FlagVDiff( Index )
   301:            
   302:            
   303:              end function CompositionInqFlagVDiff
   304:            
   305:              !-------------------------------------------------------------------
   306:            
   307:              subroutine CompositionInit
   308:                !
   309:                ! composition ⥸塼νԤޤ. 
   310:                ! NAMELIST#composition_nml ɤ߹ߤϤμ³ǹԤޤ. 
   311:                !
   312:                ! "composition" module is initialized. 
   313:                ! NAMELIST#composition_nml is loaded in this procedure. 
   314:                !
   315:            
   316:                ! ⥸塼 ; USE statements
   317:                !
   318:            
   319:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   320:                ! Utilities for NAMELIST file input
   321:                !
   322:                use namelist_util, only: namelist_filename, NmlutilMsg, MaxNmlArySize
   323:            
   324:                ! ե
   325:                ! File I/O support
   326:                !
   327:                use dc_iounit, only: FileOpen
   328:            
   329:                ! ̷ѥ᥿
   330:                ! Kind type parameter
   331:                !
   332:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   333:            
   334:                ! å
   335:                ! Message output
   336:                !
   337:                use dc_message, only: MessageNotify
   338:            
   339:                ! ʸ ; Declaration statements
   340:                !
   341:                implicit none
   342:            
   343:                integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   344:                                          ! Unit number for NAMELIST file open
   345:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   346:                                          ! IOSTAT of NAMELIST read
   347:            
   348:                character(len=STRING) :: Names      (1:MaxNmlArySize)
   349:                character(len=STRING) :: LongNames  (1:MaxNmlArySize)
   350:                logical               :: FlagMassFix(1:MaxNmlArySize)
   351:                logical               :: FlagAdv    (1:MaxNmlArySize)
   352:                logical               :: FlagVDiff  (1:MaxNmlArySize)
   353:            
   354:                integer:: n               ! ˲ DO 롼Ѻѿ
   355:                                          ! Work variables for DO loop in dimension of constituents
   356:            
   357:                ! NAMELIST ѿ
   358:                ! NAMELIST group name
   359:                !
   360:                namelist /composition_nml/ &
   361:                  & ncmax, Names, LongNames, FlagMassFix, FlagAdv, FlagVDiff
   362:                      !
   363:                      ! ǥեͤˤĤƤϽ³ "composition#CompositionInit" 
   364:                      ! Υɤ򻲾ȤΤ. 
   365:                      !
   366:                      ! Refer to source codes in the initialization procedure
   367:                      ! "composition#CompositionInit" for the default values. 
   368:                      !
   369:            
   370:                ! ¹ʸ ; Executable statement
   371:                !
   372:            
   373:                if ( composition_inited ) return
   374:            !!$    call InitCheck
   375:            
   376:                ! ǥեͤ
   377:                ! Default values settings
   378:                !
   379:                ncmax        = 1
   380:            
   381:                Names    (1) = 'QVap'
   382:                LongNames(1) = 'specific humidity'
   383: +------>       do n = 2, MaxNmlArySize
   384: |                Names    (n) = ''
   385: |                LongNames(n) = ''
   386: +------        end do
   387:            
   388: V------>       FlagMassFix = .true.
   389: |          
   390: |              FlagAdv     = .true.
   391: |          
   392: V------        FlagVDiff   = .true.
   393:            
   394:            
   395:                ! NAMELIST ɤ߹
   396:                ! NAMELIST is input
   397:                !
   398:                if ( trim(namelist_filename) /= '' ) then
   399:                  call FileOpen( unit_nml, &          ! (out)
   400:                    & namelist_filename, mode = 'r' ) ! (in)
   401:            
   402:                  rewind( unit_nml )
   403:                  read( unit_nml,            & ! (in)
   404:                    & nml = composition_nml, & ! (out)
   405:                    & iostat = iostat_nml    & ! (out)
   406:                    & )
   407:                  close( unit_nml )
   408:            
   409:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   410:                  if ( iostat_nml == 0 ) write( STDOUT, nml = composition_nml )
   411:                end if
   412:            
   413:                ! 󥵥Υå
   414:                ! Check number of array size
   415:                !
   416:                if ( ncmax < 1 ) then
   417:                  call MessageNotify( 'E', module_name, &
   418:                    & 'number of composition has to be greater than 0. ' // &
   419:                    & 'ncmax=%d' , &
   420:                    & i = (/ ncmax /) )
   421:                end if
   422:            
   423:            
   424:                ! Set variable name of constituents for ouptut
   425:                !
   426:                allocate( a_QMixName    ( ncmax ) )
   427:                allocate( a_QMixLongName( ncmax ) )
   428:                if ( ncmax > 99 ) then
   429:                  call MessageNotify( 'E', module_name, &
   430:                    & 'number of composition greater than 99 is inappropriate for current version. ' // &
   431:                    & 'ncmax=%d' , &
   432:                    & i = (/ ncmax /) )
   433:                end if
   434: +------>       do n = 1, ncmax
   435: |                if ( Names(n) == '' ) then
   436: |                  write( a_QMixName(n), '(a,i3.3)' ) "QMix", n
   437: |                else
   438: |                  a_QMixName(n) = Names(n)
   439: |                end if
   440: |                if ( LongNames(n) == '' ) then
   441: |                  a_QMixLongName(n) = a_QMixName(n)
   442: |                else
   443: |                  a_QMixLongName(n) = LongNames(n)
   444: |                end if
   445: +------        end do
   446:            
   447:                allocate( a_FlagMassFix( ncmax ) )
   448: V------>       do n = 1, ncmax
   449: |                a_FlagMassFix( n ) = FlagMassFix(n)
   450: V------        end do
   451:            
   452:                allocate( a_FlagAdv( ncmax ) )
   453: V------>       do n = 1, ncmax
   454: |                a_FlagAdv( n ) = FlagAdv(n)
   455: V------        end do
   456:            
   457:                allocate( a_FlagVDiff( ncmax ) )
   458: V------>       do n = 1, ncmax
   459: |                a_FlagVDiff( n ) = FlagVDiff(n)
   460: V------        end do
   461:            
   462:                IndexH2OVap = -1
   463: +------>       do n = 1, ncmax
   464: |                if ( a_QMixName(n) == 'QVap' ) then
   465: |                  IndexH2OVap = n
   466: |                  exit
   467: |                end if
   468: +------        end do
   469:            
   470:            
   471:                ! ΥǥåΥå
   472:                ! Check index for water vapor
   473:                !
   474:                if ( ( IndexH2OVap < 1 ) .or. ( IndexH2OVap > ncmax ) ) then
   475:                  call MessageNotify( 'E', module_name, &
   476:                    & 'IndexH2OVap has to be greater than or equal to 1 and less than or equal to ncmax. ' // &
   477:                    & 'IndexH2OVap=%d' , &
   478:                    & i = (/ IndexH2OVap /) )
   479:                end if
   480:            
   481:            
   482:                !  ; Print
   483:                !
   484:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   485:                call MessageNotify( 'M', module_name, '    ncmax              = %d', i = (/ ncmax /) )
   486: +------>       do n = 1, ncmax
   487: |                call MessageNotify( 'M', module_name, '    QMixName(%d)     = %c', i = (/ n /), c1 = trim(a_QMixName(n)) )
   488: +------        end do
   489: +------>       do n = 1, ncmax
   490: |                call MessageNotify( 'M', module_name, '    QMixLongName(%d) = %c', i = (/ n /), c1 = trim(a_QMixLongName(n)) )
   491: +------        end do
   492: +------>       do n = 1, ncmax
   493: |                call MessageNotify( 'M', module_name, '    FlagMassFix(%d)  = %b', i = (/ n /), l = (/ a_FlagMassFix(n) /) )
   494: +------        end do
   495: +------>       do n = 1, ncmax
   496: |                call MessageNotify( 'M', module_name, '    FlagAdv(%d)      = %b', i = (/ n /), l = (/ a_FlagAdv(n) /) )
   497: +------        end do
   498: +------>       do n = 1, ncmax
   499: |                call MessageNotify( 'M', module_name, '    FlagVDiff(%d)    = %b', i = (/ n /), l = (/ a_FlagVDiff(n) /) )
   500: +------        end do
   501:                call MessageNotify( 'M', module_name, '    IndexH2OVap        = %d', i = (/ IndexH2OVap /) )
   502:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   503:            
   504:                composition_inited = .true.
   505:              end subroutine CompositionInit
   506:            
   507:              !-------------------------------------------------------------------
   508:            
   509:            !!$  subroutine InitCheck
   510:            !!$    !
   511:            !!$    ! ¸⥸塼νå
   512:            !!$    !
   513:            !!$    ! Check initialization of dependency modules
   514:            !!$
   515:            !!$    ! ⥸塼 ; USE statements
   516:            !!$    !
   517:            !!$
   518:            !!$    ! NAMELIST եϤ˴ؤ桼ƥƥ
   519:            !!$    ! Utilities for NAMELIST file input
   520:            !!$    !
   521:            !!$    use namelist_util, only: namelist_util_inited
   522:            !!$
   523:            !!$    ! å
   524:            !!$    ! Message output
   525:            !!$    !
   526:            !!$    use dc_message, only: MessageNotify
   527:            !!$
   528:            !!$    ! ¹ʸ ; Executable statement
   529:            !!$    !
   530:            !!$
   531:            !!$    if ( .not. namelist_util_inited ) &
   532:            !!$      & call MessageNotify( 'E', module_name, '"namelist_util" module is not initialized.' )
   533:            !!$
   534:            !!$  end subroutine InitCheck
   535:            
   536:            end module composition
