Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:09 2012
FILE NAME: constants.f90
PROGRAM NAME: constants
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ʪ
     2  !
     3  != Physical constants settings
     4  !
     5  ! Authors::   Yasuhiro MORIKAWA
     6  ! Version::   $Id: constants.f90,v 1.8 2011-06-19 11:01:56 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module constants
    13    !
    14    != ʪ
    15    !
    16    != Physical constants settings
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! ʪꤪݴɤԤޤ.
    21    ! ǥեͤϵ絤ꤷͤꤵƤޤ.
    22    ! ͤ NAMELIST ѿ constants_nml ˤäѹ뤳Ȥ
    23    ! ǽǤ.
    24    !
    25    ! Physical constants are set and stored.
    26    ! By default, values on atmosphere of earth are set.
    27    ! These values can be changed by NAMELIST group name
    28    ! "constants_nml".
    29    !
    30    !== Procedures List
    31    !
    32    ! ConstantsInit :: ʪ
    33    ! ------------  :: ------------
    34    ! ConstantsInit :: Settings of physical constants
    35    !
    36    !== NAMELIST
    37    !
    38    ! NAMELIST#constants_nml
    39    !
    40  
    41  
    42    ! ⥸塼 ; USE statements
    43    !
    44  
    45    ! ̷ѥ᥿
    46    ! Kind type parameter
    47    !
    48    use dc_types, only: DP     ! ټ¿. Double precision.
    49  
    50    ! ʸ ; Declaration statements
    51    !
    52    implicit none
    53    private
    54  
    55    ! ³
    56    ! Public procedure
    57    !
    58    public:: ConstantsInit
    59  
    60    ! ѿ
    61    ! Public variables
    62    !
    63    logical, save :: constants_inited = .false.
    64                                ! ե饰.
    65                                ! Initialization flag
    66  
    67    real(DP), save, public:: RPlanet
    68                                ! $ a $ [m].
    69                                ! Ⱦ.
    70                                ! Radius of planet
    71    real(DP), save, public:: Omega
    72                                ! $ \Omega $ [s-1].
    73                                ! ž®.
    74                                ! Angular velocity
    75    real(DP), save, public:: Grav
    76                                ! $ g $ [m s-2].
    77                                ! ϲ®.
    78                                ! Gravitational acceleration
    79    real(DP), save, public:: MolWtDry
    80                                ! $ M $ [kg mol-1].
    81                                ! 絤ʿʬ.
    82                                ! Mean molecular weight of dry air
    83    real(DP), save, public:: CpDry
    84                                ! $ C_p $ [J kg-1 K-1].
    85                                ! 絤갵Ǯ.
    86                                ! Specific heat of air at constant pressure
    87    real(DP), save, public:: MolWtWet
    88                                ! $ M_v $ [kg mol-1].
    89                                ! ŷʬʿʬ.
    90                                ! Mean molecular weight of condensible elements
    91    real(DP), save, public:: CpWet
    92                                ! $ C_v $ [J kg-1 K-1] .
    93                                ! ŷʬ갵Ǯ.
    94                                ! Specific heat of condensible elements at constant pressure
    95    real(DP), save, public:: LatentHeat
    96                                ! $ L $ [J kg-1] .
    97                                ! ŷǮ.
    98                                ! Latent heat of condensation
    99    real(DP), save, public:: LatentHeatFusion
   100                                ! $ L $ [J kg-1] .
   101                                ! ͻǮ.
   102                                ! Latent heat of fusion
   103  
   104    real(DP), save, public:: GasRDry
   105                                ! $ R $ [J kg-1 K-1].
   106                                ! 絤ε.
   107                                ! Gas constant of air
   108    real(DP), save, public:: GasRWet
   109                                ! $ R_v $ [J kg-1 K-1].
   110                                ! ŷʬε.
   111                                ! Gas constant of condensible elements
   112    ! EpsV will be removed.
   113    real(DP), save, public:: EpsV
   114                                ! $ \epsilon_v $ .
   115                                ! ʬ.
   116                                ! Molecular weight of water vapor
   117  
   118    real(DP), parameter, public:: FKarm = 0.4_DP
   119                                ! $ k $ .
   120                                ! ޥ.
   121                                ! Karman constant
   122  
   123  
   124    ! ѿ
   125    ! Private variables
   126    !
   127  
   128    character(*), parameter:: module_name = 'constants'
   129                                ! ⥸塼̾.
   130                                ! Module name
   131    character(*), parameter:: version = &
   132      & '$Name: dcpam5-20120921 $' // &
   133      & '$Id: constants.f90,v 1.8 2011-06-19 11:01:56 yot Exp $'
   134                                ! ⥸塼ΥС
   135                                ! Module version
   136  
   137  contains
   138  
   139    !--------------------------------------------------------------------------------------
   140  
   141    subroutine ConstantsInit
   142      !
   143      ! constants ⥸塼νԤޤ.
   144      ! NAMELIST#constants_nml ɤ߹ߤϤμ³ǹԤޤ.
   145      !
   146      ! "constants" module is initialized.
   147      ! NAMELIST#constants_nml is loaded in this procedure.
   148      !
   149  
   150      ! ⥸塼 ; USE statements
   151      !
   152  
   153      ! NAMELIST եϤ˴ؤ桼ƥƥ
   154      ! Utilities for NAMELIST file input
   155      !
   156      use namelist_util, only: namelist_filename, NmlutilMsg
   157  
   158      ! ե
   159      ! File I/O support
   160      !
   161      use dc_iounit, only: FileOpen
   162  
   163      ! ̷ѥ᥿
   164      ! Kind type parameter
   165      !
   166      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   167  
   168      ! å
   169      ! Message output
   170      !
   171      use dc_message, only: MessageNotify
   172  
   173      ! ʪ
   174      ! Physical and mathematical constants settings
   175      !
   176      use constants0, only: &
   177        & PI,               &
   178        & GasRUniv
   179  
   180      ! ʸ ; Declaration statements
   181      !
   182      implicit none
   183  
   184      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   185                                ! Unit number for NAMELIST file open
   186      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   187                                ! IOSTAT of NAMELIST read
   188  
   189      ! NAMELIST ѿ
   190      ! NAMELIST group name
   191      !
   192      namelist /constants_nml/ &
   193        & RPlanet, Omega, Grav, &
   194        & MolWtDry, CpDry, &
   195        & MolWtWet, CpWet, &
   196        & LatentHeat
   197            !
   198            ! ǥեͤˤĤƤϽ³ "constants#ConstantsInit"
   199            ! Υɤ򻲾ȤΤ.
   200            !
   201            ! Refer to source codes in the initialization procedure
   202            ! "constants#ConstantsInit" for the default values.
   203            !
   204  
   205      ! ¹ʸ ; Executable statement
   206      !
   207  
   208      if ( constants_inited ) return
   209  
   210      ! ǥեͤ
   211      ! Default values settings
   212      !
   213      RPlanet          = 6.371e6_DP
   214      Omega            = 2.0_DP * PI / ( 60.0_DP * 60.0_DP * 23.9345_DP )
   215      Grav             = 9.8_DP
   216  
   217      CpDry            = 1004.6_DP
   218      MolWtDry         = 28.964e-3_DP
   219  
   220      CpWet            = 1810.0_DP
   221      MolWtWet         = 18.01528e-3_DP
   222  
   223      LatentHeat       = 2.5e6_DP
   224      LatentHeatFusion = 334.0d3
   225  
   226      ! NAMELIST 
   227      ! Input from NAMELIST
   228      !
   229      if ( trim(namelist_filename) /= '' ) then
   230        call FileOpen( unit_nml, &          ! (out)
   231          & namelist_filename, mode = 'r' ) ! (in)
   232  
   233        rewind( unit_nml )
   234        read( unit_nml, &           ! (in)
   235          & nml = constants_nml, &  ! (out)
   236          & iostat = iostat_nml )   ! (out)
   237        close( unit_nml )
   238  
   239        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   240        if ( iostat_nml == 0 ) write( STDOUT, nml = constants_nml )
   241      end if
   242  
   243      GasRDry          = GasRUniv / MolWtDry
   244      GasRWet          = GasRUniv / MolWtWet
   245      EpsV             = MolWtWet / MolWtDry
   246  
   247  
   248      !  ; Print
   249      !
   250      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   251      call MessageNotify( 'M', module_name, '  RPlanet          = %f', d = (/ RPlanet          /) )
   252      call MessageNotify( 'M', module_name, '  Omega            = %f', d = (/ Omega            /) )
   253      call MessageNotify( 'M', module_name, '  Grav             = %f', d = (/ Grav             /) )
   254  
   255      call MessageNotify( 'M', module_name, '  CpDry            = %f', d = (/ CpDry            /) )
   256      call MessageNotify( 'M', module_name, '  MolWtDry         = %f', d = (/ MolWtDry         /) )
   257  
   258      call MessageNotify( 'M', module_name, '  CpWet            = %f', d = (/ CpWet            /) )
   259      call MessageNotify( 'M', module_name, '  MolWtWet         = %f', d = (/ MolWtWet         /) )
   260      call MessageNotify( 'M', module_name, '  LatentHeat       = %f', d = (/ LatentHeat       /) )
   261      call MessageNotify( 'M', module_name, '  LatentHeatFusion = %f', d = (/ LatentHeatFusion /) )
   262  
   263      call MessageNotify( 'M', module_name, '  GasRDry          = %f', d = (/ GasRDry          /) )
   264      call MessageNotify( 'M', module_name, '  GasRWet          = %f', d = (/ GasRWet          /) )
   265      call MessageNotify( 'M', module_name, '  EpsV             = %f', d = (/ EpsV             /) )
   266      call MessageNotify( 'M', module_name, '  FKarm            = %f', d = (/ FKarm            /) )
   267      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   268  
   269      constants_inited = .true.
   270  
   271    end subroutine ConstantsInit
   272  
   273    !--------------------------------------------------------------------------------------
   274  
   275  end module constants
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:09 2012
FILE NAME: constants.f90
PROGRAM NAME: constants
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ʪ
     2:            !
     3:            != Physical constants settings
     4:            !
     5:            ! Authors::   Yasuhiro MORIKAWA
     6:            ! Version::   $Id: constants.f90,v 1.8 2011-06-19 11:01:56 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module constants
    13:              !
    14:              != ʪ
    15:              !
    16:              != Physical constants settings
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! ʪꤪݴɤԤޤ. 
    21:              ! ǥեͤϵ絤ꤷͤꤵƤޤ. 
    22:              ! ͤ NAMELIST ѿ constants_nml ˤäѹ뤳Ȥ
    23:              ! ǽǤ. 
    24:              !
    25:              ! Physical constants are set and stored. 
    26:              ! By default, values on atmosphere of earth are set. 
    27:              ! These values can be changed by NAMELIST group name 
    28:              ! "constants_nml". 
    29:              !
    30:              !== Procedures List
    31:              !
    32:              ! ConstantsInit :: ʪ
    33:              ! ------------  :: ------------
    34:              ! ConstantsInit :: Settings of physical constants
    35:              !
    36:              !== NAMELIST
    37:              !
    38:              ! NAMELIST#constants_nml
    39:              !
    40:            
    41:            
    42:              ! ⥸塼 ; USE statements
    43:              !
    44:            
    45:              ! ̷ѥ᥿
    46:              ! Kind type parameter
    47:              !
    48:              use dc_types, only: DP     ! ټ¿. Double precision. 
    49:            
    50:              ! ʸ ; Declaration statements
    51:              !
    52:              implicit none
    53:              private
    54:            
    55:              ! ³
    56:              ! Public procedure
    57:              !
    58:              public:: ConstantsInit
    59:            
    60:              ! ѿ
    61:              ! Public variables
    62:              !
    63:              logical, save :: constants_inited = .false.
    64:                                          ! ե饰. 
    65:                                          ! Initialization flag
    66:            
    67:              real(DP), save, public:: RPlanet
    68:                                          ! $ a $ [m]. 
    69:                                          ! Ⱦ. 
    70:                                          ! Radius of planet
    71:              real(DP), save, public:: Omega
    72:                                          ! $ \Omega $ [s-1]. 
    73:                                          ! ž®. 
    74:                                          ! Angular velocity
    75:              real(DP), save, public:: Grav
    76:                                          ! $ g $ [m s-2]. 
    77:                                          ! ϲ®. 
    78:                                          ! Gravitational acceleration
    79:              real(DP), save, public:: MolWtDry
    80:                                          ! $ M $ [kg mol-1]. 
    81:                                          ! 絤ʿʬ. 
    82:                                          ! Mean molecular weight of dry air
    83:              real(DP), save, public:: CpDry
    84:                                          ! $ C_p $ [J kg-1 K-1]. 
    85:                                          ! 絤갵Ǯ. 
    86:                                          ! Specific heat of air at constant pressure
    87:              real(DP), save, public:: MolWtWet
    88:                                          ! $ M_v $ [kg mol-1]. 
    89:                                          ! ŷʬʿʬ. 
    90:                                          ! Mean molecular weight of condensible elements
    91:              real(DP), save, public:: CpWet
    92:                                          ! $ C_v $ [J kg-1 K-1] . 
    93:                                          ! ŷʬ갵Ǯ. 
    94:                                          ! Specific heat of condensible elements at constant pressure
    95:              real(DP), save, public:: LatentHeat
    96:                                          ! $ L $ [J kg-1] . 
    97:                                          ! ŷǮ. 
    98:                                          ! Latent heat of condensation
    99:              real(DP), save, public:: LatentHeatFusion
   100:                                          ! $ L $ [J kg-1] . 
   101:                                          ! ͻǮ. 
   102:                                          ! Latent heat of fusion
   103:            
   104:              real(DP), save, public:: GasRDry
   105:                                          ! $ R $ [J kg-1 K-1]. 
   106:                                          ! 絤ε. 
   107:                                          ! Gas constant of air
   108:              real(DP), save, public:: GasRWet
   109:                                          ! $ R_v $ [J kg-1 K-1]. 
   110:                                          ! ŷʬε. 
   111:                                          ! Gas constant of condensible elements
   112:              ! EpsV will be removed. 
   113:              real(DP), save, public:: EpsV
   114:                                          ! $ \epsilon_v $ . 
   115:                                          ! ʬ. 
   116:                                          ! Molecular weight of water vapor
   117:            
   118:              real(DP), parameter, public:: FKarm = 0.4_DP
   119:                                          ! $ k $ .
   120:                                          ! ޥ. 
   121:                                          ! Karman constant
   122:            
   123:            
   124:              ! ѿ
   125:              ! Private variables
   126:              !
   127:            
   128:              character(*), parameter:: module_name = 'constants'
   129:                                          ! ⥸塼̾. 
   130:                                          ! Module name
   131:              character(*), parameter:: version = &
   132:                & '$Name: dcpam5-20120921 $' // &
   133:                & '$Id: constants.f90,v 1.8 2011-06-19 11:01:56 yot Exp $'
   134:                                          ! ⥸塼ΥС
   135:                                          ! Module version
   136:            
   137:            contains
   138:            
   139:              !--------------------------------------------------------------------------------------
   140:            
   141:              subroutine ConstantsInit
   142:                !
   143:                ! constants ⥸塼νԤޤ. 
   144:                ! NAMELIST#constants_nml ɤ߹ߤϤμ³ǹԤޤ. 
   145:                !
   146:                ! "constants" module is initialized. 
   147:                ! NAMELIST#constants_nml is loaded in this procedure. 
   148:                !
   149:            
   150:                ! ⥸塼 ; USE statements
   151:                !
   152:            
   153:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   154:                ! Utilities for NAMELIST file input
   155:                !
   156:                use namelist_util, only: namelist_filename, NmlutilMsg
   157:            
   158:                ! ե
   159:                ! File I/O support
   160:                !
   161:                use dc_iounit, only: FileOpen
   162:            
   163:                ! ̷ѥ᥿
   164:                ! Kind type parameter
   165:                !
   166:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   167:            
   168:                ! å
   169:                ! Message output
   170:                !
   171:                use dc_message, only: MessageNotify
   172:            
   173:                ! ʪ
   174:                ! Physical and mathematical constants settings
   175:                !
   176:                use constants0, only: &
   177:                  & PI,               &
   178:                  & GasRUniv
   179:            
   180:                ! ʸ ; Declaration statements
   181:                !
   182:                implicit none
   183:            
   184:                integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   185:                                          ! Unit number for NAMELIST file open
   186:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   187:                                          ! IOSTAT of NAMELIST read
   188:            
   189:                ! NAMELIST ѿ
   190:                ! NAMELIST group name
   191:                !
   192:                namelist /constants_nml/ &
   193:                  & RPlanet, Omega, Grav, &
   194:                  & MolWtDry, CpDry, &
   195:                  & MolWtWet, CpWet, &
   196:                  & LatentHeat
   197:                      !
   198:                      ! ǥեͤˤĤƤϽ³ "constants#ConstantsInit" 
   199:                      ! Υɤ򻲾ȤΤ. 
   200:                      !
   201:                      ! Refer to source codes in the initialization procedure
   202:                      ! "constants#ConstantsInit" for the default values. 
   203:                      !
   204:            
   205:                ! ¹ʸ ; Executable statement
   206:                !
   207:            
   208:                if ( constants_inited ) return
   209:            
   210:                ! ǥեͤ
   211:                ! Default values settings
   212:                !
   213:                RPlanet          = 6.371e6_DP
   214:                Omega            = 2.0_DP * PI / ( 60.0_DP * 60.0_DP * 23.9345_DP )
   215:                Grav             = 9.8_DP
   216:            
   217:                CpDry            = 1004.6_DP
   218:                MolWtDry         = 28.964e-3_DP
   219:            
   220:                CpWet            = 1810.0_DP
   221:                MolWtWet         = 18.01528e-3_DP
   222:            
   223:                LatentHeat       = 2.5e6_DP 
   224:                LatentHeatFusion = 334.0d3
   225:            
   226:                ! NAMELIST 
   227:                ! Input from NAMELIST
   228:                !
   229:                if ( trim(namelist_filename) /= '' ) then
   230:                  call FileOpen( unit_nml, &          ! (out)
   231:                    & namelist_filename, mode = 'r' ) ! (in)
   232:            
   233:                  rewind( unit_nml )
   234:                  read( unit_nml, &           ! (in)
   235:                    & nml = constants_nml, &  ! (out)
   236:                    & iostat = iostat_nml )   ! (out)
   237:                  close( unit_nml )
   238:            
   239:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   240:                  if ( iostat_nml == 0 ) write( STDOUT, nml = constants_nml )
   241:                end if
   242:            
   243:                GasRDry          = GasRUniv / MolWtDry
   244:                GasRWet          = GasRUniv / MolWtWet
   245:                EpsV             = MolWtWet / MolWtDry
   246:            
   247:            
   248:                !  ; Print
   249:                !
   250:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   251:                call MessageNotify( 'M', module_name, '  RPlanet          = %f', d = (/ RPlanet          /) )
   252:                call MessageNotify( 'M', module_name, '  Omega            = %f', d = (/ Omega            /) )
   253:                call MessageNotify( 'M', module_name, '  Grav             = %f', d = (/ Grav             /) )
   254:            
   255:                call MessageNotify( 'M', module_name, '  CpDry            = %f', d = (/ CpDry            /) )
   256:                call MessageNotify( 'M', module_name, '  MolWtDry         = %f', d = (/ MolWtDry         /) )
   257:            
   258:                call MessageNotify( 'M', module_name, '  CpWet            = %f', d = (/ CpWet            /) )
   259:                call MessageNotify( 'M', module_name, '  MolWtWet         = %f', d = (/ MolWtWet         /) )
   260:                call MessageNotify( 'M', module_name, '  LatentHeat       = %f', d = (/ LatentHeat       /) )
   261:                call MessageNotify( 'M', module_name, '  LatentHeatFusion = %f', d = (/ LatentHeatFusion /) )
   262:            
   263:                call MessageNotify( 'M', module_name, '  GasRDry          = %f', d = (/ GasRDry          /) )
   264:                call MessageNotify( 'M', module_name, '  GasRWet          = %f', d = (/ GasRWet          /) )
   265:                call MessageNotify( 'M', module_name, '  EpsV             = %f', d = (/ EpsV             /) )
   266:                call MessageNotify( 'M', module_name, '  FKarm            = %f', d = (/ FKarm            /) )
   267:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   268:            
   269:                constants_inited = .true.
   270:            
   271:              end subroutine ConstantsInit
   272:            
   273:              !--------------------------------------------------------------------------------------
   274:            
   275:            end module constants
