Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:08 2012
FILE NAME: constants0.f90
PROGRAM NAME: constants0
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ʪ
     2  !
     3  != Physical and mathematical constants settings
     4  !
     5  ! Authors::   Yasuhiro MORIKAWA, Yoshiyuki O. Takahashi
     6  ! Version::   $Id: constants0.f90,v 1.1 2011-06-19 11:01:56 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module constants0
    13    !
    14    != ʪ
    15    !
    16    != Physical and mathematical constants settings
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! ʪꤪݴɤԤޤ.
    21    ! ǥեͤϵ絤ꤷͤꤵƤޤ.
    22    !
    23    ! Physical and mathematical constants are set and stored.
    24    ! By default, values on atmosphere of earth are set.
    25    !
    26    !== Procedures List
    27    !
    28    ! Constants0Init :: ʪ
    29    ! ------------  :: ------------
    30    ! Constants0Init :: Settings of physical constants
    31    !
    32    !== NAMELIST
    33    !
    34    ! N/A
    35    !
    36  
    37  
    38    ! ⥸塼 ; USE statements
    39    !
    40  
    41    ! ̷ѥ᥿
    42    ! Kind type parameter
    43    !
    44    use dc_types, only: DP     ! ټ¿. Double precision.
    45  
    46    ! ʸ ; Declaration statements
    47    !
    48    implicit none
    49    private
    50  
    51    ! ³
    52    ! Public procedure
    53    !
    54    public:: Constants0Init
    55  
    56    ! ѿ
    57    ! Public variables
    58    !
    59    logical, save, public:: constants0_inited = .false.
    60                                ! ե饰.
    61                                ! Initialization flag
    62  
    63    real(DP), parameter, public:: PI = 3.1415926535897932_DP
    64                                ! $ \pi $ .
    65                                ! ߼Ψ.  Circular constant
    66    real(DP), parameter, public:: GasRUniv = 8.314_DP
    67                                ! $ R^{*} $ [J K-1 mol-1].
    68                                ! ׵.  Universal gas constant
    69    real(DP), parameter, public:: StB = 5.67e-8_DP
    70                                ! $ \sigma_{SB} $ .
    71                                ! ƥեܥĥޥ.
    72                                ! Stefan-Boltzmann constant
    73  
    74    ! ѿ
    75    ! Private variables
    76    !
    77  
    78    character(*), parameter:: module_name = 'constants0'
    79                                ! ⥸塼̾.
    80                                ! Module name
    81    character(*), parameter:: version = &
    82      & '$Name: dcpam5-20120921 $' // &
    83      & '$Id: constants0.f90,v 1.1 2011-06-19 11:01:56 yot Exp $'
    84                                ! ⥸塼ΥС
    85                                ! Module version
    86  
    87  contains
    88  
    89    !--------------------------------------------------------------------------------------
    90  
    91    subroutine Constants0Init
    92      !
    93      ! constants0 ⥸塼νԤޤ.
    94      !
    95      ! "constants0" module is initialized.
    96      !
    97  
    98      ! ⥸塼 ; USE statements
    99      !
   100  
   101      ! å
   102      ! Message output
   103      !
   104      use dc_message, only: MessageNotify
   105  
   106      ! ʸ ; Declaration statements
   107      !
   108      implicit none
   109  
   110      ! ¹ʸ ; Executable statement
   111      !
   112  
   113      if ( constants0_inited ) return
   114  
   115  
   116      !  ; Print
   117      !
   118      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   119      call MessageNotify( 'M', module_name, '  PI               = %f', d = (/ PI               /) )
   120      call MessageNotify( 'M', module_name, '  GasRUniv         = %f', d = (/ GasRUniv         /) )
   121      call MessageNotify( 'M', module_name, '  StB              = %f', d = (/ StB              /) )
   122      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   123  
   124      constants0_inited = .true.
   125  
   126    end subroutine Constants0Init
   127  
   128    !--------------------------------------------------------------------------------------
   129  
   130  end module constants0
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:08 2012
FILE NAME: constants0.f90
PROGRAM NAME: constants0
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ʪ
     2:            !
     3:            != Physical and mathematical constants settings
     4:            !
     5:            ! Authors::   Yasuhiro MORIKAWA, Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: constants0.f90,v 1.1 2011-06-19 11:01:56 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module constants0
    13:              !
    14:              != ʪ
    15:              !
    16:              != Physical and mathematical constants settings
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! ʪꤪݴɤԤޤ. 
    21:              ! ǥեͤϵ絤ꤷͤꤵƤޤ. 
    22:              !
    23:              ! Physical and mathematical constants are set and stored. 
    24:              ! By default, values on atmosphere of earth are set. 
    25:              !
    26:              !== Procedures List
    27:              !
    28:              ! Constants0Init :: ʪ
    29:              ! ------------  :: ------------
    30:              ! Constants0Init :: Settings of physical constants
    31:              !
    32:              !== NAMELIST
    33:              !
    34:              ! N/A
    35:              !
    36:            
    37:            
    38:              ! ⥸塼 ; USE statements
    39:              !
    40:            
    41:              ! ̷ѥ᥿
    42:              ! Kind type parameter
    43:              !
    44:              use dc_types, only: DP     ! ټ¿. Double precision. 
    45:            
    46:              ! ʸ ; Declaration statements
    47:              !
    48:              implicit none
    49:              private
    50:            
    51:              ! ³
    52:              ! Public procedure
    53:              !
    54:              public:: Constants0Init
    55:            
    56:              ! ѿ
    57:              ! Public variables
    58:              !
    59:              logical, save, public:: constants0_inited = .false.
    60:                                          ! ե饰. 
    61:                                          ! Initialization flag
    62:            
    63:              real(DP), parameter, public:: PI = 3.1415926535897932_DP
    64:                                          ! $ \pi $ .
    65:                                          ! ߼Ψ.  Circular constant
    66:              real(DP), parameter, public:: GasRUniv = 8.314_DP
    67:                                          ! $ R^{*} $ [J K-1 mol-1].
    68:                                          ! ׵.  Universal gas constant
    69:              real(DP), parameter, public:: StB = 5.67e-8_DP
    70:                                          ! $ \sigma_{SB} $ . 
    71:                                          ! ƥեܥĥޥ. 
    72:                                          ! Stefan-Boltzmann constant
    73:            
    74:              ! ѿ
    75:              ! Private variables
    76:              !
    77:            
    78:              character(*), parameter:: module_name = 'constants0'
    79:                                          ! ⥸塼̾. 
    80:                                          ! Module name
    81:              character(*), parameter:: version = &
    82:                & '$Name: dcpam5-20120921 $' // &
    83:                & '$Id: constants0.f90,v 1.1 2011-06-19 11:01:56 yot Exp $'
    84:                                          ! ⥸塼ΥС
    85:                                          ! Module version
    86:            
    87:            contains
    88:            
    89:              !--------------------------------------------------------------------------------------
    90:            
    91:              subroutine Constants0Init
    92:                !
    93:                ! constants0 ⥸塼νԤޤ. 
    94:                !
    95:                ! "constants0" module is initialized. 
    96:                !
    97:            
    98:                ! ⥸塼 ; USE statements
    99:                !
   100:            
   101:                ! å
   102:                ! Message output
   103:                !
   104:                use dc_message, only: MessageNotify
   105:            
   106:                ! ʸ ; Declaration statements
   107:                !
   108:                implicit none
   109:            
   110:                ! ¹ʸ ; Executable statement
   111:                !
   112:            
   113:                if ( constants0_inited ) return
   114:            
   115:            
   116:                !  ; Print
   117:                !
   118:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   119:                call MessageNotify( 'M', module_name, '  PI               = %f', d = (/ PI               /) )
   120:                call MessageNotify( 'M', module_name, '  GasRUniv         = %f', d = (/ GasRUniv         /) )
   121:                call MessageNotify( 'M', module_name, '  StB              = %f', d = (/ StB              /) )
   122:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   123:            
   124:                constants0_inited = .true.
   125:            
   126:              end subroutine Constants0Init
   127:            
   128:              !--------------------------------------------------------------------------------------
   129:            
   130:            end module constants0
