Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:05 2012
FILE NAME: i.mpi_wrapper.F90
PROGRAM NAME: mpi_wrapper
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   177  warn (  83): Dummy argument "ireq" is not used.
   208  warn (  83): Dummy argument "idest" is not used.
   208  warn (  83): Dummy argument "ireq" is not used.
   208  warn (  83): Dummy argument "buf" is not used.
   239  warn (  83): Dummy argument "ireq" is not used.
   239  warn (  83): Dummy argument "buf" is not used.
   239  warn (  83): Dummy argument "idep" is not used.
   270  warn (  83): Dummy argument "idest" is not used.
   270  warn (  83): Dummy argument "ireq" is not used.
   270  warn (  83): Dummy argument "buf" is not used.
   301  warn (  83): Dummy argument "ireq" is not used.
   301  warn (  83): Dummy argument "buf" is not used.
   301  warn (  83): Dummy argument "idep" is not used.
   334  warn (  83): Dummy argument "idest" is not used.
   334  warn (  83): Dummy argument "ireq" is not used.
   334  warn (  83): Dummy argument "buf" is not used.
   367  warn (  83): Dummy argument "ireq" is not used.
   367  warn (  83): Dummy argument "buf" is not used.
   367  warn (  83): Dummy argument "idep" is not used.
   402  warn (  83): Dummy argument "idest" is not used.
   402  warn (  83): Dummy argument "ireq" is not used.
   402  warn (  83): Dummy argument "buf" is not used.
   436  warn (  83): Dummy argument "ireq" is not used.
   436  warn (  83): Dummy argument "buf" is not used.
   436  warn (  83): Dummy argument "idep" is not used.
   473  warn (  83): Dummy argument "idest" is not used.
   473  warn (  83): Dummy argument "ireq" is not used.
   473  warn (  83): Dummy argument "buf" is not used.
   511  warn (  83): Dummy argument "ireq" is not used.
   511  warn (  83): Dummy argument "buf" is not used.
   511  warn (  83): Dummy argument "idep" is not used.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:05 2012
FILE NAME: i.mpi_wrapper.F90
PROGRAM NAME: mpi_wrapper
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != MPI Ϣ롼
     2  !
     3  != MPI related routines
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: mpi_wrapper.F90,v 1.3 2012-01-20 00:18:22 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module mpi_wrapper
    13    !
    14    != MPI Ϣ롼
    15    !
    16    != MPI related routines
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! MPI طѿδ MPI طåѡ롼Υ⥸塼.
    21    !
    22    ! This is a module containing MPI-related variables and wrapper routines.
    23    !
    24    !== Procedures List
    25    !
    26  !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    27  !!$  ! RadiationFinalize       :: λ (⥸塼ѿγդ)
    28  !!$  ! ------------            :: ------------
    29  !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    30  !!$  ! RadiationFinalize       :: Termination (deallocate variables in this module)
    31    !
    32    !== NAMELIST
    33    !
    34  !!$  ! NAMELIST#radiation_DennouAGCM_nml
    35    !
    36  
    37    ! ⥸塼 ; USE statements
    38    !
    39  
    40    ! ̷ѥ᥿
    41    ! Kind type parameter
    42    !
    43    use dc_types, only: DP, &      ! ټ¿. Double precision.
    44      &                 STRING, &  ! ʸ.       Strings.
    45      &                 TOKEN      ! .   Keywords.
    46  
    47  
    48  
    49    ! ʸ ; Declaration statements
    50    !
    51    implicit none
    52    private
    53  
    54    ! ³
    55    ! Public procedure
    56    !
    57    public :: MPIWrapperInit
    58    public :: MPIWrapperFinalize
    59    public :: MPIWrapperISend
    60    public :: MPIWrapperIRecv
    61    public :: MPIWrapperWait
    62  
    63  
    64    ! ѿ
    65    ! Public variables
    66    !
    67    integer, save, public :: nprocs
    68                             ! Number of MPI processes
    69    integer, save, public :: myrank
    70                             ! My rank
    71  
    72    ! ѿ
    73    ! Private variables
    74    !
    75  
    76  
    77    interface MPIWrapperISend
    78      module procedure &
    79        MPIWrapperISend_int_1d , &
    80        MPIWrapperISend_dble_1d, &
    81        MPIWrapperISend_dble_2d, &
    82        MPIWrapperISend_dble_3d, &
    83        MPIWrapperISend_dble_4d
    84    end interface
    85  
    86    interface MPIWrapperIRecv
    87      module procedure &
    88        MPIWrapperIRecv_int_1d , &
    89        MPIWrapperIRecv_dble_1d, &
    90        MPIWrapperIRecv_dble_2d, &
    91        MPIWrapperIRecv_dble_3d, &
    92        MPIWrapperIRecv_dble_4d
    93    end interface
    94  
    95    interface MPIWrapperAbort
    96      module procedure &
    97        MPIWrapperStop
    98    end interface
    99  
   100  
   101  contains
   102  
   103    !--------------------------------------------------------------------------------------
   104  
   105    subroutine MPIWrapperInit
   106      !
   107      ! MPI ν
   108      !
   109      ! Initialization of MPI
   110      !
   111  
   112      ! ⥸塼 ; USE statements
   113      !
   114  
   115  
   116  
   117  
   118      nprocs = 1
   119      myrank = 0
   120  
   121  
   122  
   123    end subroutine MPIWrapperInit
   124  
   125    !--------------------------------------------------------------------------------------
   126  
   127    subroutine MPIWrapperFinalize
   128      !
   129      ! MPI νλ
   130      !
   131      ! Finalization of MPI
   132      !
   133  
   134      ! ⥸塼 ; USE statements
   135      !
   136  
   137  
   138  
   139  
   140    end subroutine MPIWrapperFinalize
   141  
   142    !--------------------------------------------------------------------------------------
   143  
   144    subroutine MPIWrapperStop
   145      !
   146      ! MPI ΰ۾ｪλ
   147      !
   148      ! Abort of MPI
   149      !
   150  
   151      ! ⥸塼 ; USE statements
   152      !
   153  
   154  
   155  
   156    end subroutine MPIWrapperstop
   157  
   158    !--------------------------------------------------------------------------------------
   159  
   160    subroutine MPIWrapperWait( ireq )
   161      !
   162      ! MPI ̿λޤԵ
   163      !
   164      ! Wait finishing MPI transfer
   165      !
   166  
   167      ! ⥸塼 ; USE statements
   168      !
   169  
   170  
   171      integer, intent(inout) :: ireq
   172                                 ! request number
   173  
   174  
   175  
   176  
   177    end subroutine MPIWrapperWait
   178  
   179    !--------------------------------------------------------------------------------------
   180  
   181    subroutine MPIWrapperISend_int_1d(  &
   182      & idest, im,                      & ! (in)
   183      & buf,                            & ! (in)
   184      & ireq                            & ! (out)
   185      & )
   186      !
   187      ! 1D ֥å̿()
   188      !
   189      ! Non-blocking transfer (send) of real(8) 1D array
   190      !
   191  
   192      ! ⥸塼 ; USE statements
   193      !
   194  
   195  
   196      integer , intent(in ) :: idest
   197                                ! Process number of destination
   198      integer , intent(in ) :: im
   199                                ! Size of 1st dimension of sent data
   200      integer , intent(in ) :: buf( im )
   201                                ! Array to be sent
   202      integer , intent(out) :: ireq
   203                                ! Request number
   204  
   205  
   206  
   207  
   208    end subroutine MPIWrapperISend_int_1d
   209  
   210    !--------------------------------------------------------------------------------------
   211  
   212    subroutine MPIWrapperIRecv_int_1d(  &
   213      & idep, im,                       & ! (in)
   214      & buf,                            & ! (out)
   215      & ireq                            & ! (out)
   216      & )
   217      !
   218      ! 1D ֥å̿()
   219      !
   220      ! Non-blocking transfer (receive) of real(8) 1D array
   221      !
   222  
   223      ! ⥸塼 ; USE statements
   224      !
   225  
   226  
   227      integer , intent(in ) :: idep
   228                                ! Process number of departure
   229      integer , intent(in ) :: im
   230                                ! Size of 1st dimension of received data
   231      integer , intent(out) :: buf( im )
   232                                ! Array to be received
   233      integer , intent(out) :: ireq
   234                                ! Request number
   235  
   236  
   237  
   238  
   239    end subroutine MPIWrapperIRecv_int_1d
   240  
   241    !--------------------------------------------------------------------------------------
   242  
   243    subroutine MPIWrapperISend_dble_1d( &
   244      & idest, im,                      & ! (in)
   245      & buf,                            & ! (in)
   246      & ireq                            & ! (out)
   247      & )
   248      !
   249      ! 1D ֥å̿()
   250      !
   251      ! Non-blocking transfer (send) of real(8) 1D array
   252      !
   253  
   254      ! ⥸塼 ; USE statements
   255      !
   256  
   257  
   258      integer , intent(in ) :: idest
   259                                ! Process number of destination
   260      integer , intent(in ) :: im
   261                                ! Size of 1st dimension of sent data
   262      real(DP), intent(in ) :: buf( im )
   263                                ! Array to be sent
   264      integer , intent(out) :: ireq
   265                                ! Request number
   266  
   267  
   268  
   269  
   270    end subroutine MPIWrapperISend_dble_1d
   271  
   272    !--------------------------------------------------------------------------------------
   273  
   274    subroutine MPIWrapperIRecv_dble_1d( &
   275      & idep, im,                       & ! (in)
   276      & buf,                            & ! (out)
   277      & ireq                            & ! (out)
   278      & )
   279      !
   280      ! 1D ֥å̿()
   281      !
   282      ! Non-blocking transfer (receive) of real(8) 1D array
   283      !
   284  
   285      ! ⥸塼 ; USE statements
   286      !
   287  
   288  
   289      integer , intent(in ) :: idep
   290                                ! Process number of departure
   291      integer , intent(in ) :: im
   292                                ! Size of 1st dimension of received data
   293      real(DP), intent(out) :: buf( im )
   294                                ! Array to be received
   295      integer , intent(out) :: ireq
   296                                ! Request number
   297  
   298  
   299  
   300  
   301    end subroutine MPIWrapperIRecv_dble_1d
   302  
   303    !--------------------------------------------------------------------------------------
   304  
   305    subroutine MPIWrapperISend_dble_2d( &
   306      & idest, im, jm,                  & ! (in)
   307      & buf,                            & ! (in)
   308      & ireq                            & ! (out)
   309      & )
   310      !
   311      ! 2D ֥å̿()
   312      !
   313      ! Non-blocking transfer (send) of real(8) 2D array
   314      !
   315  
   316      ! ⥸塼 ; USE statements
   317      !
   318  
   319  
   320      integer , intent(in ) :: idest
   321                                ! Process number of destination
   322      integer , intent(in ) :: im
   323                                ! Size of 1st dimension of sent data
   324      integer , intent(in ) :: jm
   325                                ! Size of 2nd dimension of sent data
   326      real(DP), intent(in ) :: buf( im, jm )
   327                                ! Array to be sent
   328      integer , intent(out) :: ireq
   329                                ! Request number
   330  
   331  
   332  
   333  
   334    end subroutine MPIWrapperISend_dble_2d
   335  
   336    !--------------------------------------------------------------------------------------
   337  
   338    subroutine MPIWrapperIRecv_dble_2d( &
   339      & idep, im, jm,                   & ! (in)
   340      & buf,                            & ! (out)
   341      & ireq                            & ! (out)
   342      & )
   343      !
   344      ! 2D ֥å̿()
   345      !
   346      ! Non-blocking transfer (receive) of real(8) 2D array
   347      !
   348  
   349      ! ⥸塼 ; USE statements
   350      !
   351  
   352  
   353      integer , intent(in ) :: idep
   354                                ! Process number of destination
   355      integer , intent(in ) :: im
   356                                ! Size of 1st dimension of received data
   357      integer , intent(in ) :: jm
   358                                ! Size of 2nd dimension of received data
   359      real(DP), intent(out) :: buf( im, jm )
   360                                ! Array to be received
   361      integer , intent(out) :: ireq
   362                                ! Request number
   363  
   364  
   365  
   366  
   367    end subroutine MPIWrapperIRecv_dble_2d
   368  
   369    !--------------------------------------------------------------------------------------
   370  
   371    subroutine MPIWrapperISend_dble_3d( &
   372      & idest, im, jm, km,              & ! (in)
   373      & buf,                            & ! (in)
   374      & ireq                            & ! (out)
   375      & )
   376      !
   377      ! 3D ֥å̿()
   378      !
   379      ! Non-blocking transfer (send) of real(8) 3D array
   380      !
   381  
   382      ! ⥸塼 ; USE statements
   383      !
   384  
   385  
   386      integer , intent(in ) :: idest
   387                                ! Process number of destination
   388      integer , intent(in ) :: im
   389                                ! Size of 1st dimension of sent data
   390      integer , intent(in ) :: jm
   391                                ! Size of 2nd dimension of sent data
   392      integer , intent(in ) :: km
   393                                ! Size of 3rd dimension of sent data
   394      real(DP), intent(in ) :: buf( im, jm, km )
   395                                ! Array to be sent
   396      integer , intent(out) :: ireq
   397                                ! Request number
   398  
   399  
   400  
   401  
   402    end subroutine MPIWrapperISend_dble_3d
   403  
   404    !--------------------------------------------------------------------------------------
   405  
   406    subroutine MPIWrapperIRecv_dble_3d( &
   407      & idep, im, jm, km,               & ! (in)
   408      & buf,                            & ! (out)
   409      & ireq                            & ! (out)
   410      & )
   411      !
   412      ! 3D ֥å̿()
   413      !
   414      ! Non-blocking transfer (receive) of real(8) 3D array
   415      !
   416  
   417      ! ⥸塼 ; USE statements
   418      !
   419  
   420      integer , intent(in ) :: idep
   421                                ! Process number of departure
   422      integer , intent(in ) :: im
   423                                ! Size of 1st dimension of received data
   424      integer , intent(in ) :: jm
   425                                ! Size of 2nd dimension of received data
   426      integer , intent(in ) :: km
   427                                ! Size of 3rd dimension of received data
   428      real(DP), intent(out) :: buf( im, jm, km )
   429                                ! Array to be received
   430      integer , intent(out) :: ireq
   431                                ! Request number
   432  
   433  
   434  
   435  
   436    end subroutine MPIWrapperIRecv_dble_3d
   437  
   438    !--------------------------------------------------------------------------------------
   439  
   440    subroutine MPIWrapperISend_dble_4d( &
   441      & idest, im, jm, km, lm,          & ! (in)
   442      & buf,                            & ! (in)
   443      & ireq                            & ! (out)
   444      & )
   445      !
   446      ! 4D ֥å̿()
   447      !
   448      ! Non-blocking transfer (send) of real(8) 4D array
   449      !
   450  
   451      ! ⥸塼 ; USE statements
   452      !
   453  
   454  
   455      integer , intent(in ) :: idest
   456                                ! Process number of destination
   457      integer , intent(in ) :: im
   458                                ! Size of 1st dimension of sent data
   459      integer , intent(in ) :: jm
   460                                ! Size of 2nd dimension of sent data
   461      integer , intent(in ) :: km
   462                                ! Size of 3rd dimension of sent data
   463      integer , intent(in ) :: lm
   464                                ! Size of 4th dimension of sent data
   465      real(DP), intent(in ) :: buf( im, jm, km, lm )
   466                                ! Array to be sent
   467      integer , intent(out) :: ireq
   468                                ! Request number
   469  
   470  
   471  
   472  
   473    end subroutine MPIWrapperISend_dble_4d
   474  
   475    !--------------------------------------------------------------------------------------
   476  
   477    subroutine MPIWrapperIRecv_dble_4d( &
   478      & idep, im, jm, km, lm,           & ! (in)
   479      & buf,                            & ! (out)
   480      & ireq                            & ! (out)
   481      & )
   482      !
   483      ! 4D ֥å̿()
   484      !
   485      ! Non-blocking transfer (receive) of real(8) 4D array
   486      !
   487  
   488      ! ⥸塼 ; USE statements
   489      !
   490  
   491  
   492      integer , intent(in ) :: idep
   493                                ! Process number of departure
   494      integer , intent(in ) :: im
   495                                ! Size of 1st dimension of received data
   496      integer , intent(in ) :: jm
   497                                ! Size of 2nd dimension of received data
   498      integer , intent(in ) :: km
   499                                ! Size of 3rd dimension of received data
   500      integer , intent(in ) :: lm
   501                                ! Size of 4th dimension of received data
   502      real(DP), intent(out) :: buf( im, jm, km, lm )
   503                                ! Array to be received
   504      integer , intent(out) :: ireq
   505                                ! Request number
   506  
   507  
   508  
   509  
   510  
   511    end subroutine MPIWrapperIRecv_dble_4d
   512  
   513    !--------------------------------------------------------------------------------------
   514  
   515  end module mpi_wrapper
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:05 2012
FILE NAME: i.mpi_wrapper.F90
PROGRAM NAME: mpi_wrapper
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != MPI Ϣ롼
     2:            !
     3:            != MPI related routines
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: mpi_wrapper.F90,v 1.3 2012-01-20 00:18:22 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module mpi_wrapper
    13:              !
    14:              != MPI Ϣ롼
    15:              !
    16:              != MPI related routines
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! MPI طѿδ MPI طåѡ롼Υ⥸塼. 
    21:              !
    22:              ! This is a module containing MPI-related variables and wrapper routines. 
    23:              !
    24:              !== Procedures List
    25:              !
    26:            !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    27:            !!$  ! RadiationFinalize       :: λ (⥸塼ѿγդ)
    28:            !!$  ! ------------            :: ------------
    29:            !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    30:            !!$  ! RadiationFinalize       :: Termination (deallocate variables in this module)
    31:              !
    32:              !== NAMELIST
    33:              !
    34:            !!$  ! NAMELIST#radiation_DennouAGCM_nml
    35:              !
    36:            
    37:              ! ⥸塼 ; USE statements
    38:              !
    39:            
    40:              ! ̷ѥ᥿
    41:              ! Kind type parameter
    42:              !
    43:              use dc_types, only: DP, &      ! ټ¿. Double precision.
    44:                &                 STRING, &  ! ʸ.       Strings.
    45:                &                 TOKEN      ! .   Keywords.
    46:            
    47:            
    48:            
    49:              ! ʸ ; Declaration statements
    50:              !
    51:              implicit none
    52:              private
    53:            
    54:              ! ³
    55:              ! Public procedure
    56:              !
    57:              public :: MPIWrapperInit
    58:              public :: MPIWrapperFinalize
    59:              public :: MPIWrapperISend
    60:              public :: MPIWrapperIRecv
    61:              public :: MPIWrapperWait
    62:            
    63:            
    64:              ! ѿ
    65:              ! Public variables
    66:              !
    67:              integer, save, public :: nprocs
    68:                                       ! Number of MPI processes
    69:              integer, save, public :: myrank
    70:                                       ! My rank
    71:            
    72:              ! ѿ
    73:              ! Private variables
    74:              !
    75:            
    76:            
    77:              interface MPIWrapperISend
    78:                module procedure &
    79:                  MPIWrapperISend_int_1d , &
    80:                  MPIWrapperISend_dble_1d, &
    81:                  MPIWrapperISend_dble_2d, &
    82:                  MPIWrapperISend_dble_3d, &
    83:                  MPIWrapperISend_dble_4d
    84:              end interface
    85:            
    86:              interface MPIWrapperIRecv
    87:                module procedure &
    88:                  MPIWrapperIRecv_int_1d , &
    89:                  MPIWrapperIRecv_dble_1d, &
    90:                  MPIWrapperIRecv_dble_2d, &
    91:                  MPIWrapperIRecv_dble_3d, &
    92:                  MPIWrapperIRecv_dble_4d
    93:              end interface
    94:            
    95:              interface MPIWrapperAbort
    96:                module procedure &
    97:                  MPIWrapperStop
    98:              end interface
    99:            
   100:            
   101:            contains
   102:            
   103:              !--------------------------------------------------------------------------------------
   104:            
   105:              subroutine MPIWrapperInit
   106:                !
   107:                ! MPI ν
   108:                !
   109:                ! Initialization of MPI
   110:                !
   111:            
   112:                ! ⥸塼 ; USE statements
   113:                !
   114:            
   115:            
   116:            
   117:            
   118:                nprocs = 1
   119:                myrank = 0
   120:            
   121:            
   122:            
   123:              end subroutine MPIWrapperInit
   124:            
   125:              !--------------------------------------------------------------------------------------
   126:            
   127:              subroutine MPIWrapperFinalize
   128:                !
   129:                ! MPI νλ
   130:                !
   131:                ! Finalization of MPI
   132:                !
   133:            
   134:                ! ⥸塼 ; USE statements
   135:                !
   136:            
   137:            
   138:            
   139:            
   140:              end subroutine MPIWrapperFinalize
   141:            
   142:              !--------------------------------------------------------------------------------------
   143:            
   144:              subroutine MPIWrapperStop
   145:                !
   146:                ! MPI ΰ۾ｪλ
   147:                !
   148:                ! Abort of MPI
   149:                !
   150:            
   151:                ! ⥸塼 ; USE statements
   152:                !
   153:            
   154:            
   155:            
   156:              end subroutine MPIWrapperstop
   157:            
   158:              !--------------------------------------------------------------------------------------
   159:            
   160:              subroutine MPIWrapperWait( ireq )
   161:                !
   162:                ! MPI ̿λޤԵ
   163:                !
   164:                ! Wait finishing MPI transfer
   165:                !
   166:            
   167:                ! ⥸塼 ; USE statements
   168:                !
   169:            
   170:            
   171:                integer, intent(inout) :: ireq
   172:                                           ! request number
   173:            
   174:            
   175:            
   176:            
   177:              end subroutine MPIWrapperWait
   178:            
   179:              !--------------------------------------------------------------------------------------
   180:            
   181:              subroutine MPIWrapperISend_int_1d(  &
   182:                & idest, im,                      & ! (in)
   183:                & buf,                            & ! (in)
   184:                & ireq                            & ! (out)
   185:                & )
   186:                !
   187:                ! 1D ֥å̿()
   188:                !
   189:                ! Non-blocking transfer (send) of real(8) 1D array
   190:                !
   191:            
   192:                ! ⥸塼 ; USE statements
   193:                !
   194:            
   195:            
   196:                integer , intent(in ) :: idest
   197:                                          ! Process number of destination
   198:                integer , intent(in ) :: im
   199:                                          ! Size of 1st dimension of sent data
   200:                integer , intent(in ) :: buf( im )
   201:                                          ! Array to be sent
   202:                integer , intent(out) :: ireq
   203:                                          ! Request number
   204:            
   205:            
   206:            
   207:            
   208:              end subroutine MPIWrapperISend_int_1d
   209:            
   210:              !--------------------------------------------------------------------------------------
   211:            
   212:              subroutine MPIWrapperIRecv_int_1d(  &
   213:                & idep, im,                       & ! (in)
   214:                & buf,                            & ! (out)
   215:                & ireq                            & ! (out)
   216:                & )
   217:                !
   218:                ! 1D ֥å̿()
   219:                !
   220:                ! Non-blocking transfer (receive) of real(8) 1D array
   221:                !
   222:            
   223:                ! ⥸塼 ; USE statements
   224:                !
   225:            
   226:            
   227:                integer , intent(in ) :: idep
   228:                                          ! Process number of departure
   229:                integer , intent(in ) :: im
   230:                                          ! Size of 1st dimension of received data
   231:                integer , intent(out) :: buf( im )
   232:                                          ! Array to be received
   233:                integer , intent(out) :: ireq
   234:                                          ! Request number
   235:            
   236:            
   237:            
   238:            
   239:              end subroutine MPIWrapperIRecv_int_1d
   240:            
   241:              !--------------------------------------------------------------------------------------
   242:            
   243:              subroutine MPIWrapperISend_dble_1d( &
   244:                & idest, im,                      & ! (in)
   245:                & buf,                            & ! (in)
   246:                & ireq                            & ! (out)
   247:                & )
   248:                !
   249:                ! 1D ֥å̿()
   250:                !
   251:                ! Non-blocking transfer (send) of real(8) 1D array
   252:                !
   253:            
   254:                ! ⥸塼 ; USE statements
   255:                !
   256:            
   257:            
   258:                integer , intent(in ) :: idest
   259:                                          ! Process number of destination
   260:                integer , intent(in ) :: im
   261:                                          ! Size of 1st dimension of sent data
   262:                real(DP), intent(in ) :: buf( im )
   263:                                          ! Array to be sent
   264:                integer , intent(out) :: ireq
   265:                                          ! Request number
   266:            
   267:            
   268:            
   269:            
   270:              end subroutine MPIWrapperISend_dble_1d
   271:            
   272:              !--------------------------------------------------------------------------------------
   273:            
   274:              subroutine MPIWrapperIRecv_dble_1d( &
   275:                & idep, im,                       & ! (in)
   276:                & buf,                            & ! (out)
   277:                & ireq                            & ! (out)
   278:                & )
   279:                !
   280:                ! 1D ֥å̿()
   281:                !
   282:                ! Non-blocking transfer (receive) of real(8) 1D array
   283:                !
   284:            
   285:                ! ⥸塼 ; USE statements
   286:                !
   287:            
   288:            
   289:                integer , intent(in ) :: idep
   290:                                          ! Process number of departure
   291:                integer , intent(in ) :: im
   292:                                          ! Size of 1st dimension of received data
   293:                real(DP), intent(out) :: buf( im )
   294:                                          ! Array to be received
   295:                integer , intent(out) :: ireq
   296:                                          ! Request number
   297:            
   298:            
   299:            
   300:            
   301:              end subroutine MPIWrapperIRecv_dble_1d
   302:            
   303:              !--------------------------------------------------------------------------------------
   304:            
   305:              subroutine MPIWrapperISend_dble_2d( &
   306:                & idest, im, jm,                  & ! (in)
   307:                & buf,                            & ! (in)
   308:                & ireq                            & ! (out)
   309:                & )
   310:                !
   311:                ! 2D ֥å̿()
   312:                !
   313:                ! Non-blocking transfer (send) of real(8) 2D array
   314:                !
   315:            
   316:                ! ⥸塼 ; USE statements
   317:                !
   318:            
   319:            
   320:                integer , intent(in ) :: idest
   321:                                          ! Process number of destination
   322:                integer , intent(in ) :: im
   323:                                          ! Size of 1st dimension of sent data
   324:                integer , intent(in ) :: jm
   325:                                          ! Size of 2nd dimension of sent data
   326:                real(DP), intent(in ) :: buf( im, jm )
   327:                                          ! Array to be sent
   328:                integer , intent(out) :: ireq
   329:                                          ! Request number
   330:            
   331:            
   332:            
   333:            
   334:              end subroutine MPIWrapperISend_dble_2d
   335:            
   336:              !--------------------------------------------------------------------------------------
   337:            
   338:              subroutine MPIWrapperIRecv_dble_2d( &
   339:                & idep, im, jm,                   & ! (in)
   340:                & buf,                            & ! (out)
   341:                & ireq                            & ! (out)
   342:                & )
   343:                !
   344:                ! 2D ֥å̿()
   345:                !
   346:                ! Non-blocking transfer (receive) of real(8) 2D array
   347:                !
   348:            
   349:                ! ⥸塼 ; USE statements
   350:                !
   351:            
   352:            
   353:                integer , intent(in ) :: idep
   354:                                          ! Process number of destination
   355:                integer , intent(in ) :: im
   356:                                          ! Size of 1st dimension of received data
   357:                integer , intent(in ) :: jm
   358:                                          ! Size of 2nd dimension of received data
   359:                real(DP), intent(out) :: buf( im, jm )
   360:                                          ! Array to be received
   361:                integer , intent(out) :: ireq
   362:                                          ! Request number
   363:            
   364:            
   365:            
   366:            
   367:              end subroutine MPIWrapperIRecv_dble_2d
   368:            
   369:              !--------------------------------------------------------------------------------------
   370:            
   371:              subroutine MPIWrapperISend_dble_3d( &
   372:                & idest, im, jm, km,              & ! (in)
   373:                & buf,                            & ! (in)
   374:                & ireq                            & ! (out)
   375:                & )
   376:                !
   377:                ! 3D ֥å̿()
   378:                !
   379:                ! Non-blocking transfer (send) of real(8) 3D array
   380:                !
   381:            
   382:                ! ⥸塼 ; USE statements
   383:                !
   384:            
   385:            
   386:                integer , intent(in ) :: idest
   387:                                          ! Process number of destination
   388:                integer , intent(in ) :: im
   389:                                          ! Size of 1st dimension of sent data
   390:                integer , intent(in ) :: jm
   391:                                          ! Size of 2nd dimension of sent data
   392:                integer , intent(in ) :: km
   393:                                          ! Size of 3rd dimension of sent data
   394:                real(DP), intent(in ) :: buf( im, jm, km )
   395:                                          ! Array to be sent
   396:                integer , intent(out) :: ireq
   397:                                          ! Request number
   398:            
   399:            
   400:            
   401:            
   402:              end subroutine MPIWrapperISend_dble_3d
   403:            
   404:              !--------------------------------------------------------------------------------------
   405:            
   406:              subroutine MPIWrapperIRecv_dble_3d( &
   407:                & idep, im, jm, km,               & ! (in)
   408:                & buf,                            & ! (out)
   409:                & ireq                            & ! (out)
   410:                & )
   411:                !
   412:                ! 3D ֥å̿()
   413:                !
   414:                ! Non-blocking transfer (receive) of real(8) 3D array
   415:                !
   416:            
   417:                ! ⥸塼 ; USE statements
   418:                !
   419:            
   420:                integer , intent(in ) :: idep
   421:                                          ! Process number of departure
   422:                integer , intent(in ) :: im
   423:                                          ! Size of 1st dimension of received data
   424:                integer , intent(in ) :: jm
   425:                                          ! Size of 2nd dimension of received data
   426:                integer , intent(in ) :: km
   427:                                          ! Size of 3rd dimension of received data
   428:                real(DP), intent(out) :: buf( im, jm, km )
   429:                                          ! Array to be received
   430:                integer , intent(out) :: ireq
   431:                                          ! Request number
   432:            
   433:            
   434:            
   435:            
   436:              end subroutine MPIWrapperIRecv_dble_3d
   437:            
   438:              !--------------------------------------------------------------------------------------
   439:            
   440:              subroutine MPIWrapperISend_dble_4d( &
   441:                & idest, im, jm, km, lm,          & ! (in)
   442:                & buf,                            & ! (in)
   443:                & ireq                            & ! (out)
   444:                & )
   445:                !
   446:                ! 4D ֥å̿()
   447:                !
   448:                ! Non-blocking transfer (send) of real(8) 4D array
   449:                !
   450:            
   451:                ! ⥸塼 ; USE statements
   452:                !
   453:            
   454:            
   455:                integer , intent(in ) :: idest
   456:                                          ! Process number of destination
   457:                integer , intent(in ) :: im
   458:                                          ! Size of 1st dimension of sent data
   459:                integer , intent(in ) :: jm
   460:                                          ! Size of 2nd dimension of sent data
   461:                integer , intent(in ) :: km
   462:                                          ! Size of 3rd dimension of sent data
   463:                integer , intent(in ) :: lm
   464:                                          ! Size of 4th dimension of sent data
   465:                real(DP), intent(in ) :: buf( im, jm, km, lm )
   466:                                          ! Array to be sent
   467:                integer , intent(out) :: ireq
   468:                                          ! Request number
   469:            
   470:            
   471:            
   472:            
   473:              end subroutine MPIWrapperISend_dble_4d
   474:            
   475:              !--------------------------------------------------------------------------------------
   476:            
   477:              subroutine MPIWrapperIRecv_dble_4d( &
   478:                & idep, im, jm, km, lm,           & ! (in)
   479:                & buf,                            & ! (out)
   480:                & ireq                            & ! (out)
   481:                & )
   482:                !
   483:                ! 4D ֥å̿()
   484:                !
   485:                ! Non-blocking transfer (receive) of real(8) 4D array
   486:                !
   487:            
   488:                ! ⥸塼 ; USE statements
   489:                !
   490:            
   491:            
   492:                integer , intent(in ) :: idep
   493:                                          ! Process number of departure
   494:                integer , intent(in ) :: im
   495:                                          ! Size of 1st dimension of received data
   496:                integer , intent(in ) :: jm
   497:                                          ! Size of 2nd dimension of received data
   498:                integer , intent(in ) :: km
   499:                                          ! Size of 3rd dimension of received data
   500:                integer , intent(in ) :: lm
   501:                                          ! Size of 4th dimension of received data
   502:                real(DP), intent(out) :: buf( im, jm, km, lm )
   503:                                          ! Array to be received
   504:                integer , intent(out) :: ireq
   505:                                          ! Request number
   506:            
   507:            
   508:            
   509:            
   510:            
   511:              end subroutine MPIWrapperIRecv_dble_4d
   512:            
   513:              !--------------------------------------------------------------------------------------
   514:            
   515:            end module mpi_wrapper
