Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:20:20 2012
FILE NAME: i.gridset.F90
PROGRAM NAME: gridset
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   308  vec  (   4): Vectorized array expression.
   320  vec  (   1): Vectorized loop.
   410  vec  (   3): Unvectorized loop.
   412  opt  (1017): Subroutine call prevents optimization.
   412  vec  (  10): Vectorization obstructive procedure reference.:mpiwrapperisend_dble_1d
   413  vec  (  10): Vectorization obstructive procedure reference.:mpiwrapperirecv_dble_1d
   416  vec  (   3): Unvectorized loop.
   418  opt  (1017): Subroutine call prevents optimization.
   418  vec  (  10): Vectorization obstructive procedure reference.:mpiwrapperwait
   419  vec  (  10): Vectorization obstructive procedure reference.:mpiwrapperwait
   425  vec  (   1): Vectorized loop.
   425  vec  (   1): Vectorized loop.
   429  vec  (   1): Vectorized loop.
   432  vec  (   3): Unvectorized loop.
   434  opt  (1017): Subroutine call prevents optimization.
   434  vec  (  10): Vectorization obstructive procedure reference.:messagenotifyc
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:20:20 2012
FILE NAME: i.gridset.F90
PROGRAM NAME: gridset
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ʻȿ
     2  !
     3  != Number of grid points and maximum truncated wavenumber settings
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA, Satoshi NODA
     6  ! Version::   $Id: gridset.F90,v 1.4 2012-02-01 12:03:32 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module gridset
    13    !
    14    != ʻȿ
    15    !
    16    != Number of grid points and maximum truncated wavenumber settings
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! ʻꤪݴɤԤޤ.
    21    ! ڥȥˡѤ뤳ȤˤƤ,
    22    ! ȿݴɤԤޤ.
    23    !
    24    ! Number of grid points is set and stored.
    25    ! Maximum truncated wavenumber is set and stored too,
    26    ! because spectral method is expected to be used.
    27    !
    28    !== Variables List
    29    !
    30    ! nmax         :: ȿ
    31    ! lmax         :: ڥȥǡ󥵥
    32    ! imax         :: ٳʻ
    33    ! jmax_global  :: ٳʻ ()
    34    ! jmax         :: ٳʻ
    35    ! kmax         :: ľؿ
    36    ! kslmax       :: ϲľؿ
    37    ! ------------ :: ------------
    38    ! nmax         :: Maximum truncated wavenumber
    39    ! lmax         :: Size of array for spectral data
    40    ! imax         :: Number of grid points in longitude
    41    ! jmax_global  :: Number of grid points in latitude on whole globe
    42    ! jmax         :: Number of grid points in latitude
    43    ! kmax         :: Number of vertical level
    44    ! kslmax       :: Number of subsurface vertical level
    45    !
    46    !== Procedures List
    47    !
    48    ! GridsetInit   :: ʻȺȿ
    49    ! ------------  :: ------------
    50    ! GridsetInit   :: Settings of number of grid points and maximum truncated wavenumber
    51    !
    52    !
    53    !== NAMELIST
    54    !
    55    ! NAMELIST#gridset_nml
    56    !
    57  
    58    ! ⥸塼 ; USE statements
    59    !
    60  
    61    ! ̷ѥ᥿
    62    ! Kind type parameter
    63    !
    64    use dc_types, only: DP     ! ټ¿. Double precision.
    65  
    66    ! ʸ ; Declaration statements
    67    !
    68    implicit none
    69    private
    70  
    71    ! ³
    72    ! Public procedure
    73    !
    74    public :: GridsetInit
    75    public :: GridsetCheckNumberOfLatGrid
    76  
    77  
    78    ! ѿ
    79    ! Public variables
    80    !
    81    logical, save, public:: gridset_inited = .false.
    82                                ! ե饰.
    83                                ! Initialization flag
    84    integer, save, public:: nmax
    85                                ! ȿ.
    86                                ! Maximum truncated wavenumber
    87    integer, save, public:: lmax
    88                                ! ڥȥǡ󥵥
    89                                ! Size of array for spectral data
    90    integer, save, public:: imax
    91                                ! ٳʻ.
    92                                ! Number of grid points in longitude
    93    integer, save, public:: jmax_global
    94                                ! ٳʻ ().
    95                                ! Number of grid points in latitude on whole globe
    96    integer, save, public:: jmax
    97                                ! ٳʻ.
    98                                ! Number of grid points in latitude
    99    integer, save, public:: kmax
   100                                ! ľؿ.
   101                                ! Number of vertical level
   102    integer, save, public:: kslmax
   103                                ! ϲαľؿ.
   104                                ! Number of subsurface vertical level
   105  
   106    integer, save, allocatable, public :: a_jmax(:)
   107                                ! ƥץΰٳʻ.
   108                                ! Number of grid points in latitude of each process
   109    integer, save             , public :: jmax_max
   110                                ! ƥץΰٳʻκ.
   111                                ! Maximum number of grid points in latitude of all processes
   112  
   113  
   114    ! ѿ
   115    ! Private variables
   116    !
   117  
   118    character(*), parameter:: module_name = 'gridset'
   119                                ! ⥸塼̾.
   120                                ! Module name
   121    character(*), parameter:: version = &
   122      & '$Name: dcpam5-20120921 $' // &
   123      & '$Id: gridset.F90,v 1.4 2012-02-01 12:03:32 yot Exp $'
   124                                ! ⥸塼ΥС
   125                                ! Module version
   126  
   127  contains
   128  
   129    subroutine GridsetInit
   130      !
   131      ! gridset ⥸塼νԤޤ.
   132      ! NAMELIST#gridset_nml ɤ߹ߤϤμ³ǹԤޤ.
   133      !
   134      ! "gridset" module is initialized.
   135      ! NAMELIST#gridset_nml is loaded in this procedure.
   136      !
   137  
   138      ! ⥸塼 ; USE statements
   139      !
   140  
   141      ! NAMELIST եϤ˴ؤ桼ƥƥ
   142      ! Utilities for NAMELIST file input
   143      !
   144      use namelist_util, only: namelist_filename, NmlutilMsg
   145  
   146      ! ե
   147      ! File I/O support
   148      !
   149      use dc_iounit, only: FileOpen
   150  
   151      ! ̷ѥ᥿
   152      ! Kind type parameter
   153      !
   154      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   155  
   156      ! å
   157      ! Message output
   158      !
   159      use dc_message, only: MessageNotify
   160  
   161      ! ʸ ; Declaration statements
   162      !
   163      implicit none
   164      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   165                                ! Unit number for NAMELIST file open
   166      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   167                                ! IOSTAT of NAMELIST read
   168  
   169      ! NAMELIST ѿ
   170      ! NAMELIST group name
   171      !
   172      namelist /gridset_nml/ nmax, imax, jmax, kmax, kslmax
   173            !
   174            ! ǥեͤˤĤƤϽ³ "gridset#GridsetInit"
   175            ! Υɤ򻲾ȤΤ.
   176            !
   177            ! Refer to source codes in the initialization procedure
   178            ! "gridset#GridsetInit" for the default values.
   179            !
   180  
   181      ! ¹ʸ ; Executable statement
   182      !
   183  
   184      if ( gridset_inited ) return
   185      call InitCheck
   186  
   187      ! ǥեͤ
   188      ! Default values settings
   189      !
   190  
   191      imax        = 32
   192  
   193      jmax        = imax / 2
   194      kmax        = 5
   195      nmax        = ( imax - 1 ) / 3
   196  
   197      kslmax      = 0
   198  
   199      ! NAMELIST ɤ߹
   200      ! NAMELIST is input
   201      !
   202      if ( trim(namelist_filename) /= '' ) then
   203        call FileOpen( unit_nml, &          ! (out)
   204          & namelist_filename, mode = 'r' ) ! (in)
   205  
   206        rewind( unit_nml )
   207        read( unit_nml, &         ! (in)
   208          & nml = gridset_nml, &  ! (out)
   209          & iostat = iostat_nml ) ! (out)
   210        close( unit_nml )
   211  
   212        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   213        if ( iostat_nml == 0 ) write( STDOUT, nml = gridset_nml )
   214      end if
   215  
   216      ! Check of array size
   217      !
   218  
   219  
   220      if ( imax /= 1 ) then
   221        if ( jmax /= imax / 2 ) then
   222          call MessageNotify( 'E', module_name, &
   223            & 'Number of grid points in latitudinal direction has to be equal to ' &
   224            & // 'number of grid points in longitudinal direction divided by 2.' )
   225        end if
   226      end if
   227  
   228      ! Set number of grid points in latitudinal direction
   229      !
   230      jmax_global = jmax
   231      !
   232      ! Calculate and save jmax in all processes
   233      !   If jmax is 1, the model runs as 1D model. In that case, jmax need not
   234      !   be calculated.
   235      ! Even if jmax has a value, it is overwritten.
   236      !
   237      call GridsetCalcjmax
   238  
   239  
   240      ! Set size of array for spectral data
   241      !
   242  
   243      lmax = (nmax+1)**2
   244  
   245  
   246  
   247      ! ʻΥå
   248      ! Check number of grid points
   249      !
   250      if ( nmax < 1 .or. imax < 1 .or. jmax_global < 1 .or. jmax < 1 .or. kmax < 1 ) then
   251        call MessageNotify( 'E', module_name, &
   252          & 'number of grid points and maximum truncated wavenumber must be more than 0. ' // &
   253          & 'nmax=%d, imax=%d, jmax_global=%d, jmax=%d, kmax=%d' , &
   254          & i = (/ nmax, imax, jmax_global, jmax, kmax /) )
   255      end if
   256  
   257      !  ; Print
   258      !
   259      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   260      call MessageNotify( 'M', module_name, '    nmax        = %d', i = (/   nmax  /) )
   261      call MessageNotify( 'M', module_name, '    imax        = %d', i = (/   imax  /) )
   262      call MessageNotify( 'M', module_name, '    jmax_global = %d', i = (/   jmax_global /) )
   263      call MessageNotify( 'M', module_name, '    jmax        = %d', i = (/   jmax  /) )
   264      call MessageNotify( 'M', module_name, '    kmax        = %d', i = (/   kmax  /) )
   265      call MessageNotify( 'M', module_name, '  kslmax        = %d', i = (/ kslmax  /) )
   266      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   267  
   268      gridset_inited = .true.
   269    end subroutine GridsetInit
   270  
   271    !-------------------------------------------------------------------
   272  
   273    subroutine GridsetCalcjmax
   274      !
   275      ! jmax ׻.
   276      !
   277      ! Calculate jmax
   278      !
   279  
   280      ! ⥸塼 ; USE statements
   281      !
   282  
   283      ! å
   284      ! Message output
   285      !
   286      use dc_message, only: MessageNotify
   287  
   288      ! MPI
   289      !
   290      use mpi_wrapper, only: nprocs, myrank
   291  
   292      ! ʸ ; Declaration statements
   293      !
   294      implicit none
   295  
   296  
   297      ! Local variables
   298      !
   299      integer            :: jh, jph, js, je, jch, jc
   300      integer            :: n
   301  
   302  
   303      allocate( a_jmax(0:nprocs-1) )
   304  
   305      if ( ( imax == 1 ) .and. ( jmax == 1 ) ) then
   306  
   307        jmax_max = 1
   308        a_jmax   = 1
   309  
   310      else
   311  
   312        ! Following calculation is a copy of that in a subroutine SNMINI in snmini.f
   313        ! included in ISPACK.
   314  
   315        jh = jmax_global / 2
   316        jph = ( jh - 1 ) / nprocs + 1
   317  
   318        jmax_max = jph * 2
   319  
   320        do n = 0, nprocs-1
   321  
   322          js = jph * n + 1
   323          je = min( jph * ( n + 1 ), jh )
   324          if ( je >= js ) THEN
   325            jch = je - js + 1
   326            jc  = jch * 2
   327          else
   328            jc = 0
   329            js = 1
   330            je = 1
   331          end if
   332  
   333          a_jmax(n) = jc
   334  
   335        end do
   336  
   337        if ( jmax /= a_jmax( myrank ) ) then
   338          call MessageNotify( 'M', module_name, &
   339            & 'jmax is overwritten, and is %d.', i = (/ a_jmax( myrank ) /) )
   340        end if
   341        jmax = a_jmax( myrank )
   342  
   343      end if
   344  
   345  
   346    end subroutine GridsetCalcjmax
   347  
   348    !-------------------------------------------------------------------
   349  
   350    subroutine GridsetCheckNumberOfLatGrid( jc )
   351      !
   352      ! 줾Υץôٳʻǧ.
   353      !
   354      ! Check number of latitudinal grids on each process.
   355      !
   356  
   357      ! ⥸塼 ; USE statements
   358      !
   359  
   360      ! å
   361      ! Message output
   362      !
   363      use dc_message, only: MessageNotify
   364  
   365      ! MPI
   366      !
   367      use mpi_wrapper, only: nprocs, myrank, &
   368        & MPIWrapperISend, &
   369        & MPIWrapperIRecv, &
   370        & MPIWrapperWait
   371  
   372  
   373      ! ʸ ; Declaration statements
   374      !
   375      implicit none
   376  
   377      integer, intent(in ) :: jc
   378  
   379      ! Local variable
   380      !
   381      integer , allocatable :: a_jmax_tmp(:)
   382      real(DP)              :: a_SendBuf (1)
   383      real(DP), allocatable :: aa_RecvBuf(:,:)
   384      integer , allocatable :: a_iReqSend(:)
   385      integer , allocatable :: a_iReqRecv(:)
   386      integer               :: n
   387  
   388      ! ¹ʸ ; Executable statement
   389      !
   390  
   391  
   392      if ( jmax /= jc ) then
   393        n = myrank
   394        call MessageNotify( 'E', module_name,                                                    &
   395          & 'Saved jmax in myproc=%d is %d, but is not the same as one calculated by spml, %d.', &
   396          & i = (/myrank, jmax, jc/) )
   397      end if
   398  
   399  
   400  
   401      allocate( a_jmax_tmp(0:nprocs-1) )
   402      allocate( aa_RecvBuf(1,0:nprocs-1) )
   403      allocate( a_iReqSend(0:nprocs-1) )
   404      allocate( a_iReqRecv(0:nprocs-1) )
   405  
   406      a_SendBuf(1) = jc
   407  
   408      ! jmax is sent to all nodes, and received by all nodes.
   409  
   410      do n = 0, nprocs-1
   411        if ( n == myrank ) cycle
   412        call MPIWrapperISend( n, 1, a_SendBuf      , a_iReqSend(n) )
   413        call MPIWrapperIRecv( n, 1, aa_RecvBuf(:,n), a_iReqRecv(n) )
   414      end do
   415  
   416      do n = 0, nprocs-1
   417        if ( n == myrank ) cycle
   418        call MPIWrapperWait( a_iReqSend(n) )
   419        call MPIWrapperWait( a_iReqRecv(n) )
   420      end do
   421  
   422  
   423      do n = 0, nprocs-1
   424        if ( n == myrank ) then
   425          a_jmax_tmp(n) = jc
   426        else
   427          a_jmax_tmp(n) = aa_RecvBuf(1,n)
   428        end if
   429      end do
     .           if (myrank.ge.0 .and. myrank.le.nprocs-1) then                 
     .           a_jmax_tmp(myrank) = jc                                        
     .        endif                                                             
     .        if (myrank.ge.0 .and. myrank.le.nprocs-1) then                    
     .  !CDIR    NODEP                                                          
     .           do n = 1, myrank                                               
     .              a_jmax_tmp(n-1) = ifix(aa_recvbuf(1,n-1))                   
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do n = 1, nprocs - 1 - myrank                                  
     .              a_jmax_tmp(myrank+n) = ifix(aa_recvbuf(1,myrank+n))         
     .           end do                                                         
     .        else                                                              
     .  !CDIR    NODEP                                                          
     .           do n = 1, nprocs                                               
     .              a_jmax_tmp(n-1) = ifix(aa_recvbuf(1,n-1))                   
     .           end do                                                         
     .        endif                                                             
   430  
   431      ! Check number of latitudinal grid in each process.
   432      do n = 0, nprocs-1
   433        if ( a_jmax(n) /= a_jmax_tmp(n) ) then
   434          call MessageNotify( 'E', module_name,                               &
   435            & 'jmax in proc=%d is %d, but is not the same as saved one, %d.', &
   436            & i = (/n, a_jmax_tmp(n), a_jmax(n)/) )
   437        end if
   438      end do
   439  
   440  
   441      deallocate( aa_RecvBuf )
   442      deallocate( a_iReqSend )
   443      deallocate( a_iReqRecv )
   444      deallocate( a_jmax_tmp )
   445  
   446  
   447  
   448    end subroutine GridsetCheckNumberOfLatGrid
   449  
   450    !-------------------------------------------------------------------
   451  
   452    subroutine InitCheck
   453      !
   454      ! ¸⥸塼νå
   455      !
   456      ! Check initialization of dependency modules
   457  
   458      ! ⥸塼 ; USE statements
   459      !
   460  
   461      ! NAMELIST եϤ˴ؤ桼ƥƥ
   462      ! Utilities for NAMELIST file input
   463      !
   464      use namelist_util, only: namelist_util_inited
   465  
   466      ! å
   467      ! Message output
   468      !
   469      use dc_message, only: MessageNotify
   470  
   471      ! ¹ʸ ; Executable statement
   472      !
   473  
   474      if ( .not. namelist_util_inited ) &
   475        & call MessageNotify( 'E', module_name, '"namelist_util" module is not initialized.' )
   476  
   477    end subroutine InitCheck
   478  
   479  end module gridset
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:20:20 2012
FILE NAME: i.gridset.F90
PROGRAM NAME: gridset
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ʻȿ
     2:            !
     3:            != Number of grid points and maximum truncated wavenumber settings
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA, Satoshi NODA
     6:            ! Version::   $Id: gridset.F90,v 1.4 2012-02-01 12:03:32 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module gridset
    13:              !
    14:              != ʻȿ
    15:              !
    16:              != Number of grid points and maximum truncated wavenumber settings
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! ʻꤪݴɤԤޤ. 
    21:              ! ڥȥˡѤ뤳ȤˤƤ, 
    22:              ! ȿݴɤԤޤ. 
    23:              !
    24:              ! Number of grid points is set and stored. 
    25:              ! Maximum truncated wavenumber is set and stored too, 
    26:              ! because spectral method is expected to be used. 
    27:              !
    28:              !== Variables List
    29:              !
    30:              ! nmax         :: ȿ
    31:              ! lmax         :: ڥȥǡ󥵥
    32:              ! imax         :: ٳʻ
    33:              ! jmax_global  :: ٳʻ ()
    34:              ! jmax         :: ٳʻ
    35:              ! kmax         :: ľؿ
    36:              ! kslmax       :: ϲľؿ
    37:              ! ------------ :: ------------
    38:              ! nmax         :: Maximum truncated wavenumber
    39:              ! lmax         :: Size of array for spectral data
    40:              ! imax         :: Number of grid points in longitude
    41:              ! jmax_global  :: Number of grid points in latitude on whole globe
    42:              ! jmax         :: Number of grid points in latitude
    43:              ! kmax         :: Number of vertical level
    44:              ! kslmax       :: Number of subsurface vertical level
    45:              !
    46:              !== Procedures List
    47:              !
    48:              ! GridsetInit   :: ʻȺȿ
    49:              ! ------------  :: ------------
    50:              ! GridsetInit   :: Settings of number of grid points and maximum truncated wavenumber
    51:              !
    52:              !
    53:              !== NAMELIST
    54:              !
    55:              ! NAMELIST#gridset_nml
    56:              !
    57:            
    58:              ! ⥸塼 ; USE statements
    59:              !
    60:            
    61:              ! ̷ѥ᥿
    62:              ! Kind type parameter
    63:              !
    64:              use dc_types, only: DP     ! ټ¿. Double precision. 
    65:            
    66:              ! ʸ ; Declaration statements
    67:              !
    68:              implicit none
    69:              private
    70:            
    71:              ! ³
    72:              ! Public procedure
    73:              !
    74:              public :: GridsetInit
    75:              public :: GridsetCheckNumberOfLatGrid
    76:            
    77:            
    78:              ! ѿ
    79:              ! Public variables
    80:              !
    81:              logical, save, public:: gridset_inited = .false.
    82:                                          ! ե饰. 
    83:                                          ! Initialization flag
    84:              integer, save, public:: nmax
    85:                                          ! ȿ. 
    86:                                          ! Maximum truncated wavenumber
    87:              integer, save, public:: lmax
    88:                                          ! ڥȥǡ󥵥
    89:                                          ! Size of array for spectral data
    90:              integer, save, public:: imax
    91:                                          ! ٳʻ. 
    92:                                          ! Number of grid points in longitude
    93:              integer, save, public:: jmax_global
    94:                                          ! ٳʻ (). 
    95:                                          ! Number of grid points in latitude on whole globe
    96:              integer, save, public:: jmax
    97:                                          ! ٳʻ. 
    98:                                          ! Number of grid points in latitude
    99:              integer, save, public:: kmax
   100:                                          ! ľؿ. 
   101:                                          ! Number of vertical level
   102:              integer, save, public:: kslmax
   103:                                          ! ϲαľؿ. 
   104:                                          ! Number of subsurface vertical level
   105:            
   106:              integer, save, allocatable, public :: a_jmax(:)
   107:                                          ! ƥץΰٳʻ. 
   108:                                          ! Number of grid points in latitude of each process
   109:              integer, save             , public :: jmax_max
   110:                                          ! ƥץΰٳʻκ. 
   111:                                          ! Maximum number of grid points in latitude of all processes
   112:            
   113:            
   114:              ! ѿ
   115:              ! Private variables
   116:              !
   117:            
   118:              character(*), parameter:: module_name = 'gridset'
   119:                                          ! ⥸塼̾. 
   120:                                          ! Module name
   121:              character(*), parameter:: version = &
   122:                & '$Name: dcpam5-20120921 $' // &
   123:                & '$Id: gridset.F90,v 1.4 2012-02-01 12:03:32 yot Exp $'
   124:                                          ! ⥸塼ΥС
   125:                                          ! Module version
   126:            
   127:            contains
   128:            
   129:              subroutine GridsetInit
   130:                !
   131:                ! gridset ⥸塼νԤޤ. 
   132:                ! NAMELIST#gridset_nml ɤ߹ߤϤμ³ǹԤޤ. 
   133:                !
   134:                ! "gridset" module is initialized. 
   135:                ! NAMELIST#gridset_nml is loaded in this procedure. 
   136:                !
   137:            
   138:                ! ⥸塼 ; USE statements
   139:                !
   140:            
   141:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   142:                ! Utilities for NAMELIST file input
   143:                !
   144:                use namelist_util, only: namelist_filename, NmlutilMsg
   145:            
   146:                ! ե
   147:                ! File I/O support
   148:                !
   149:                use dc_iounit, only: FileOpen
   150:            
   151:                ! ̷ѥ᥿
   152:                ! Kind type parameter
   153:                !
   154:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   155:            
   156:                ! å
   157:                ! Message output
   158:                !
   159:                use dc_message, only: MessageNotify
   160:            
   161:                ! ʸ ; Declaration statements
   162:                !
   163:                implicit none
   164:                integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   165:                                          ! Unit number for NAMELIST file open
   166:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   167:                                          ! IOSTAT of NAMELIST read
   168:            
   169:                ! NAMELIST ѿ
   170:                ! NAMELIST group name
   171:                !
   172:                namelist /gridset_nml/ nmax, imax, jmax, kmax, kslmax
   173:                      !
   174:                      ! ǥեͤˤĤƤϽ³ "gridset#GridsetInit" 
   175:                      ! Υɤ򻲾ȤΤ. 
   176:                      !
   177:                      ! Refer to source codes in the initialization procedure
   178:                      ! "gridset#GridsetInit" for the default values. 
   179:                      !
   180:            
   181:                ! ¹ʸ ; Executable statement
   182:                !
   183:            
   184:                if ( gridset_inited ) return
   185:                call InitCheck
   186:            
   187:                ! ǥեͤ
   188:                ! Default values settings
   189:                !
   190:            
   191:                imax        = 32
   192:            
   193:                jmax        = imax / 2
   194:                kmax        = 5
   195:                nmax        = ( imax - 1 ) / 3
   196:            
   197:                kslmax      = 0
   198:            
   199:                ! NAMELIST ɤ߹
   200:                ! NAMELIST is input
   201:                !
   202:                if ( trim(namelist_filename) /= '' ) then
   203:                  call FileOpen( unit_nml, &          ! (out)
   204:                    & namelist_filename, mode = 'r' ) ! (in)
   205:            
   206:                  rewind( unit_nml )
   207:                  read( unit_nml, &         ! (in)
   208:                    & nml = gridset_nml, &  ! (out)
   209:                    & iostat = iostat_nml ) ! (out)
   210:                  close( unit_nml )
   211:            
   212:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   213:                  if ( iostat_nml == 0 ) write( STDOUT, nml = gridset_nml )
   214:                end if
   215:            
   216:                ! Check of array size
   217:                !
   218:            
   219:            
   220:                if ( imax /= 1 ) then
   221:                  if ( jmax /= imax / 2 ) then
   222:                    call MessageNotify( 'E', module_name, &
   223:                      & 'Number of grid points in latitudinal direction has to be equal to ' &
   224:                      & // 'number of grid points in longitudinal direction divided by 2.' )
   225:                  end if
   226:                end if
   227:            
   228:                ! Set number of grid points in latitudinal direction
   229:                !
   230:                jmax_global = jmax
   231:                !
   232:                ! Calculate and save jmax in all processes
   233:                !   If jmax is 1, the model runs as 1D model. In that case, jmax need not 
   234:                !   be calculated. 
   235:                ! Even if jmax has a value, it is overwritten. 
   236:                !
   237:                call GridsetCalcjmax
   238:            
   239:            
   240:                ! Set size of array for spectral data
   241:                !
   242:            
   243:                lmax = (nmax+1)**2
   244:            
   245:            
   246:            
   247:                ! ʻΥå
   248:                ! Check number of grid points
   249:                !
   250:                if ( nmax < 1 .or. imax < 1 .or. jmax_global < 1 .or. jmax < 1 .or. kmax < 1 ) then
   251:                  call MessageNotify( 'E', module_name, &
   252:                    & 'number of grid points and maximum truncated wavenumber must be more than 0. ' // &
   253:                    & 'nmax=%d, imax=%d, jmax_global=%d, jmax=%d, kmax=%d' , &
   254:                    & i = (/ nmax, imax, jmax_global, jmax, kmax /) )
   255:                end if
   256:            
   257:                !  ; Print
   258:                !
   259:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   260:                call MessageNotify( 'M', module_name, '    nmax        = %d', i = (/   nmax  /) )
   261:                call MessageNotify( 'M', module_name, '    imax        = %d', i = (/   imax  /) )
   262:                call MessageNotify( 'M', module_name, '    jmax_global = %d', i = (/   jmax_global /) )
   263:                call MessageNotify( 'M', module_name, '    jmax        = %d', i = (/   jmax  /) )
   264:                call MessageNotify( 'M', module_name, '    kmax        = %d', i = (/   kmax  /) )
   265:                call MessageNotify( 'M', module_name, '  kslmax        = %d', i = (/ kslmax  /) )
   266:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   267:            
   268:                gridset_inited = .true.
   269:              end subroutine GridsetInit
   270:            
   271:              !-------------------------------------------------------------------
   272:            
   273:              subroutine GridsetCalcjmax
   274:                !
   275:                ! jmax ׻.
   276:                !
   277:                ! Calculate jmax
   278:                !
   279:            
   280:                ! ⥸塼 ; USE statements
   281:                !
   282:            
   283:                ! å
   284:                ! Message output
   285:                !
   286:                use dc_message, only: MessageNotify
   287:            
   288:                ! MPI
   289:                !
   290:                use mpi_wrapper, only: nprocs, myrank
   291:            
   292:                ! ʸ ; Declaration statements
   293:                !
   294:                implicit none
   295:            
   296:            
   297:                ! Local variables
   298:                !
   299:                integer            :: jh, jph, js, je, jch, jc
   300:                integer            :: n
   301:            
   302:            
   303:                allocate( a_jmax(0:nprocs-1) )
   304:            
   305:                if ( ( imax == 1 ) .and. ( jmax == 1 ) ) then
   306:            
   307:                  jmax_max = 1
   308: V======          a_jmax   = 1
   309:            
   310:                else
   311:            
   312:                  ! Following calculation is a copy of that in a subroutine SNMINI in snmini.f 
   313:                  ! included in ISPACK.
   314:            
   315:                  jh = jmax_global / 2
   316:                  jph = ( jh - 1 ) / nprocs + 1
   317:            
   318:                  jmax_max = jph * 2
   319:            
   320: V------>         do n = 0, nprocs-1
   321: |          
   322: |                  js = jph * n + 1
   323: |                  je = min( jph * ( n + 1 ), jh )
   324: |                  if ( je >= js ) THEN
   325: |                    jch = je - js + 1
   326: |                    jc  = jch * 2
   327: |                  else
   328: |                    jc = 0
   329: |                    js = 1
   330: |                    je = 1
   331: |                  end if
   332: |          
   333: |                  a_jmax(n) = jc
   334: |          
   335: V------          end do
   336:            
   337:                  if ( jmax /= a_jmax( myrank ) ) then
   338:                    call MessageNotify( 'M', module_name, &
   339:                      & 'jmax is overwritten, and is %d.', i = (/ a_jmax( myrank ) /) )
   340:                  end if
   341:                  jmax = a_jmax( myrank )
   342:            
   343:                end if
   344:            
   345:            
   346:              end subroutine GridsetCalcjmax
   347:            
   348:              !-------------------------------------------------------------------
   349:            
   350:              subroutine GridsetCheckNumberOfLatGrid( jc )
   351:                !
   352:                ! 줾Υץôٳʻǧ.
   353:                !
   354:                ! Check number of latitudinal grids on each process.
   355:                !
   356:            
   357:                ! ⥸塼 ; USE statements
   358:                !
   359:            
   360:                ! å
   361:                ! Message output
   362:                !
   363:                use dc_message, only: MessageNotify
   364:            
   365:                ! MPI
   366:                !
   367:                use mpi_wrapper, only: nprocs, myrank, &
   368:                  & MPIWrapperISend, &
   369:                  & MPIWrapperIRecv, &
   370:                  & MPIWrapperWait
   371:            
   372:            
   373:                ! ʸ ; Declaration statements
   374:                !
   375:                implicit none
   376:            
   377:                integer, intent(in ) :: jc
   378:            
   379:                ! Local variable
   380:                !
   381:                integer , allocatable :: a_jmax_tmp(:)
   382:                real(DP)              :: a_SendBuf (1)
   383:                real(DP), allocatable :: aa_RecvBuf(:,:)
   384:                integer , allocatable :: a_iReqSend(:)
   385:                integer , allocatable :: a_iReqRecv(:)
   386:                integer               :: n
   387:            
   388:                ! ¹ʸ ; Executable statement
   389:                !
   390:            
   391:            
   392:                if ( jmax /= jc ) then
   393:                  n = myrank
   394:                  call MessageNotify( 'E', module_name,                                                    &
   395:                    & 'Saved jmax in myproc=%d is %d, but is not the same as one calculated by spml, %d.', &
   396:                    & i = (/myrank, jmax, jc/) )
   397:                end if
   398:            
   399:            
   400:            
   401:                allocate( a_jmax_tmp(0:nprocs-1) )
   402:                allocate( aa_RecvBuf(1,0:nprocs-1) )
   403:                allocate( a_iReqSend(0:nprocs-1) )
   404:                allocate( a_iReqRecv(0:nprocs-1) )
   405:            
   406:                a_SendBuf(1) = jc
   407:            
   408:                ! jmax is sent to all nodes, and received by all nodes.
   409:            
   410: +------>       do n = 0, nprocs-1
   411: |                if ( n == myrank ) cycle
   412: |                call MPIWrapperISend( n, 1, a_SendBuf      , a_iReqSend(n) )
   413: |                call MPIWrapperIRecv( n, 1, aa_RecvBuf(:,n), a_iReqRecv(n) )
   414: +------        end do
   415:            
   416: +------>       do n = 0, nprocs-1
   417: |                if ( n == myrank ) cycle
   418: |                call MPIWrapperWait( a_iReqSend(n) )
   419: |                call MPIWrapperWait( a_iReqRecv(n) )
   420: +------        end do
   421:            
   422:            
   423: V------>       do n = 0, nprocs-1
   424: |                if ( n == myrank ) then
   425: |                  a_jmax_tmp(n) = jc
   426: |                else
   427: |                  a_jmax_tmp(n) = aa_RecvBuf(1,n)
   428: |                end if
   429: V------        end do
   430:            
   431:                ! Check number of latitudinal grid in each process.
   432: +------>       do n = 0, nprocs-1
   433: |                if ( a_jmax(n) /= a_jmax_tmp(n) ) then
   434: |                  call MessageNotify( 'E', module_name,                               &
   435: |                    & 'jmax in proc=%d is %d, but is not the same as saved one, %d.', &
   436: |                    & i = (/n, a_jmax_tmp(n), a_jmax(n)/) )
   437: |                end if
   438: +------        end do
   439:            
   440:            
   441:                deallocate( aa_RecvBuf )
   442:                deallocate( a_iReqSend )
   443:                deallocate( a_iReqRecv )
   444:                deallocate( a_jmax_tmp )
   445:            
   446:            
   447:            
   448:              end subroutine GridsetCheckNumberOfLatGrid
   449:            
   450:              !-------------------------------------------------------------------
   451:            
   452:              subroutine InitCheck
   453:                !
   454:                ! ¸⥸塼νå
   455:                !
   456:                ! Check initialization of dependency modules
   457:            
   458:                ! ⥸塼 ; USE statements
   459:                !
   460:            
   461:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   462:                ! Utilities for NAMELIST file input
   463:                !
   464:                use namelist_util, only: namelist_util_inited
   465:            
   466:                ! å
   467:                ! Message output
   468:                !
   469:                use dc_message, only: MessageNotify
   470:            
   471:                ! ¹ʸ ; Executable statement
   472:                !
   473:            
   474:                if ( .not. namelist_util_inited ) &
   475:                  & call MessageNotify( 'E', module_name, '"namelist_util" module is not initialized.' )
   476:            
   477:              end subroutine InitCheck
   478:            
   479:            end module gridset
