Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:52:10 2012
FILE NAME: mars_dust_lifting.f90
PROGRAM NAME: mars_dust_lifting
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   208  opt  (1592): Outer loop unrolled inside inner loop.
   208  vec  (   4): Vectorized array expression.
   208  vec  (   4): Vectorized array expression.
   229  opt  (1772): Loop nest fused with following nest(s).
   230  vec  (   1): Vectorized loop.
   239  warn (   7): Characters in a line over this form limitation 132.
   278  warn (  15): Embedded blanks exist in free form lexical token.
   357  opt  (  11): Fused array assignments. :line 357 - 358
   357  vec  (   4): Vectorized array expression.
   357  vec  (   4): Vectorized array expression.
   358  opt  (1592): Outer loop unrolled inside inner loop.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:52:10 2012
FILE NAME: mars_dust_lifting.f90
PROGRAM NAME: mars_dust_lifting
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Υȴ夲
     2  !
     3  != Mars Dust Lifting!
     4  
     5  ! Authors::   OGIHARA Hirotaka
     6  ! Version::   $Id: Mars_dust_lifting.f90,v 0.1 2012-10-01 16:18:31 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921$
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008-2009. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module mars_dust_lifting
    13    !
    14    != Υȴ夲
    15    !
    16    != Surface flux
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! Kahre et al (2006) ˴ŤƲΥȴ夲Ψ׻.
    21    !
    22    !
    23    !
    24    !== References
    25    !
    26    ! Melinda A. Kahre, James R. Murphy, and Robert M. Haberle
    27    ! Modeling the Martian dust cycle and surface dust
    28    ! reservoirs with the NASA Ames general circulation
    29    ! model, Journal of Geophysical Research, vol 111, E06008, 2006
    30    !
    31    !== Procedures List
    32    !
    33    ! MarsDustLifting   :: Υȴ夲Ψη׻
    34    ! ------------      :: ------------
    35    !
    36    !== NAMELIST
    37    !
    38    ! NAMELIST#mars_dust_lifting_nml
    39    !
    40  
    41    ! ⥸塼 ; USE statements
    42    !
    43  
    44    ! ʻ
    45    ! Grid points settings
    46    !
    47    use gridset, only: imax, & ! ٳʻ.
    48                               ! Number of grid points in longitude
    49      &                jmax, & ! ٳʻ.
    50                               ! Number of grid points in latitude
    51      &                kmax    ! ľؿ.
    52                               ! Number of vertical level
    53  
    54  
    55    ! ̷ѥ᥿
    56    ! Kind type parameter
    57    !
    58    use dc_types, only: DP, &      ! ټ¿. Double precision.
    59      &                 STRING     ! ʸ.       Strings.
    60  
    61    ! å
    62    ! Message output
    63    !
    64    use dc_message, only: MessageNotify
    65  
    66    ! ʸ ; Declaration statements
    67    !
    68    implicit none
    69    private
    70  
    71    ! ³
    72    ! Public procedure
    73    !
    74    public :: MarsDustLifting
    75    public :: MarsDustLiftingOutput
    76    public :: MarsDustLiftingInit
    77  
    78    ! ѿ
    79    ! Public variables
    80    !
    81  
    82    ! ѿ
    83    ! Private variables
    84    !
    85    logical, save :: mars_dust_lifting_inited = .false.
    86                                ! ե饰
    87                                ! Initialization flag
    88  
    89  
    90    real(DP), save:: StressThreshold
    91                              ! ϥȤ򴬤夲 (N m-2)
    92                              ! Wind stress threshold (N m-2)
    93  
    94    real(DP), save:: KMHEfficiencyFactor
    95                              ! Ψ(m-1)
    96                              ! Efficiency factor (m-1)
    97    real(DP), save:: NewmanEfficiencyFactor
    98                              ! Ψ(m-1)
    99                              ! Efficiency factor (m-1)
   100  
   101    character(*), parameter:: module_name = 'mars_dust_lifting'
   102                                ! ⥸塼̾.
   103                                ! Module name
   104    character(*), parameter:: version = &
   105      & '$Name: dcpam5-20120921 $' // &
   106      & '$Id: mars_dust_lifting.f90,v 0.1 2012-10-01 00:26:41 yot Exp $'
   107                                ! ⥸塼ΥС
   108                                ! Module version
   109  
   110  
   111  contains
   112  
   113    !-------------------------------------------------------------------------------------
   114  
   115    subroutine MarsDustLifting( &
   116      & xyr_MomFluxX, xyr_MomFluxY, xyr_Press, xyr_VirTemp, & ! (in)
   117      & xy_KMHMarsDustLifting, xy_NewmanMarsDustLifting          & ! (out)
   118      & )
   119    !
   120    ! Х륯ˡǵ᤿, ǮեåȤäƲΥȴ夲Ψ
   121    ! ׻ޤ.
   122  
   123      ! ⥸塼 ; USE statements
   124      !
   125  
   126      ! ɸǡ
   127      ! Axes data settings
   128      !
   129      use axesset, only: &
   130        & y_Lat                 ! $ \varphi $ [rad.] . . Latitude
   131  
   132      ! 
   133      ! Time control
   134      !
   135      use timeset, only: &
   136        & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $.
   137        & TimesetClockStart, TimesetClockStop
   138  
   139      ! ǥХåѥ桼ƥƥ
   140      ! Utilities for debug
   141      !
   142      use dc_trace, only: DbgMessage, BeginSub, EndSub
   143  
   144      ! ʪ
   145      ! Physical constants settings
   146      !
   147      use constants, only: &
   148        & Grav, &               ! $ g $ [m s-2].
   149                                ! ϲ®.
   150                                ! Gravitational acceleration
   151        & GasRDry, &
   152                                ! $ R $ [J kg-1 K-1].
   153                                ! 絤ε.
   154                                ! Gas constant of air
   155        & CpDry
   156                                ! $ C_p $ [J kg-1 K-1].
   157                                ! 絤갵Ǯ.
   158                                ! Specific heat of air at constant pressure
   159  
   160      ! ʸ ; Declaration statements
   161      !
   162      implicit none
   163      real(DP), intent(in):: xyr_MomFluxX (0:imax-1, 1:jmax, 0:kmax)
   164                                ! ư̥եå.
   165                                ! Eastward momentum flux
   166      real(DP), intent(in):: xyr_MomFluxY (0:imax-1, 1:jmax, 0:kmax)
   167                                ! ư̥եå.
   168                                ! Northward momentum flux
   169      real(DP), intent(in):: xyr_VirTemp (0:imax-1, 1:jmax, 0:kmax)
   170                                ! $ T_v $ .  (Ⱦ٥).
   171                                ! Virtual temperature (half level)
   172      real(DP), intent(in):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
   173                                ! $ p_s $ . ɽ̵ (Ⱦ٥).
   174                                ! Surface pressure (half level)
   175      real(DP) :: xy_MomFluxSurf (0:imax-1, 1:jmax)
   176                                ! ɽ̱ư̥եå礭.(N m-2)
   177                                ! momentum flux power
   178      real(DP) :: xy_SurfRho (0:imax-1, 1:jmax)
   179                                ! ɽ̩
   180  
   181      real(DP), intent(out):: xy_KMHMarsDustLifting(0:imax-1, 1:jmax)
   182                                !Υȴ夲Ψ
   183      real(DP), intent(out):: xy_NewmanMarsDustLifting(0:imax-1, 1:jmax)
   184                                !Υȴ夲Ψ
   185  
   186      ! ѿ
   187      ! Work variables
   188      !
   189  
   190      integer:: i               ! ˲ DO 롼Ѻѿ
   191                                ! Work variables for DO loop in longitude
   192      integer:: j               ! ˲ DO 롼Ѻѿ
   193                                ! Work variables for DO loop in latitude
   194  !    integer:: k               ! ˲ DO 롼Ѻѿ
   195                                ! Work variables for DO loop in dimension of constituents
   196  
   197      ! ¹ʸ ; Executable statement
   198      ! ǧ
   199      ! Initialization check
   200      !
   201  !    if ( .not. mars_dust_lifting_inited ) call MarsDustLiftingInit
   202      if ( .not. mars_dust_lifting_inited ) then
   203        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   204      end if
   205  
   206  !   ɽ̱Ϥ礭η׻
   207  
   208      xy_MomFluxSurf(:,:) = sqrt( xyr_MomFluxX(:,:,0)**2 + xyr_MomFluxY(:,:,0)**2 )
     .        if (jmax .gt. 0) then                                             
     .           J1 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t259 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t261 = 1, imax                                           
     .                 xy_momfluxsurf(t261-1,t259) = dsqrt(xyr_momfluxx(t261-1, 
     .       1            t259,0)**2+xyr_momfluxy(t261-1,t259,0)**2)            
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t259 = J1 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t261 = 1, imax                                           
     .                 xy_momfluxsurf(t261-1,t259) = dsqrt(xyr_momfluxx(t261-1, 
     .       1            t259,0)**2+xyr_momfluxy(t261-1,t259,0)**2)            
     .                 xy_momfluxsurf(t261-1,t259+1) = dsqrt(xyr_momfluxx(t261-1
     .       1            ,t259+1,0)**2+xyr_momfluxy(t261-1,t259+1,0)**2)       
     .                 xy_momfluxsurf(t261-1,t259+2) = dsqrt(xyr_momfluxx(t261-1
     .       1            ,t259+2,0)**2+xyr_momfluxy(t261-1,t259+2,0)**2)       
     .                 xy_momfluxsurf(t261-1,t259+3) = dsqrt(xyr_momfluxx(t261-1
     .       1            ,t259+3,0)**2+xyr_momfluxy(t261-1,t259+3,0)**2)       
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   209  
   210  !write(10,*) "xyr_MomFluxX", xyr_MomFLuxX(0,1,0)
   211  !write(10,*) "xyr_MomFluxY", xyr_MomFLuxY(0,1,0)
   212  !write(10,*) "xy_MomFluxSurf=", xy_MomFluxSurf(0,1)
   213  !write(10,*) "StressThreshold", StressThreshold
   214      ! ȴ夲(KMH )
   215  !    do i = 0, imax-1
   216  !      do j = 1, jmax
   217  !        if(xy_MomFluxSurf(i,j) < StressThreshold) then
   218  !          xy_MarsDustLifting(i,j) = 0.0_DP
   219  !        else
   220  !          xy_MarsDustLifting(i,j) =                           &
   221  !            & EfficiencyFactor *(( 10.0_DP)**6)                   &
   222  !            & * ( 2.3_DP* 0.001_DP ) * ((xy_MomFluxSurf(i,j))**2) &
   223  !            & * (((xy_MomFluxSurf(i,j)) - StressThreshold)       &
   224  !            & / StressThreshold)
   225  !        end if
   226  !      end do
   227  !    end do
   228  
   229      do i = 0, imax-1
   230        do j = 1, jmax
   231          if(xy_MomFluxSurf(i,j) < StressThreshold) then
   232            xy_KMHMarsDustLifting(i,j) = 0.0_DP
   233          else
   234            xy_KMHMarsDustLifting(i,j) =                                                      &
   235              & ((xy_MomFluxSurf(i,j))**2) * (((xy_MomFluxSurf(i,j)) - StressThreshold)    &
   236              & / StressThreshold) ! KMH αϤι
   237  
   238  
   239            xy_KMHMarsDustLifting(i,j) = (2.3_DP * 0.001_DP) * xy_KMHMarsDustLifting(i,j) ! ϵ¬᤿ 2.3 x 10^-3 ݤ
   240  
   241  !          xy_MarsDustLifting(i,j) = ((10.0_DP)**6) * xy_MarsDustLifting(i,j)      ! ñ̤ kg m-1 s-1 ˤ
   242  
   243            xy_KMHMarsDustLifting(i,j) = KMHEfficiencyFactor * xy_KMHMarsDustLifting(i,j)    ! ΨҤݤ
   244  
   245          end if
   246        end do
   247      end do
   248  
   249  
   250  !    do i = 0, imax-1
   251  !      do j = 1, jmax
   252  !        if((xy_MomFluxSurf(i,j)*1000.0_DP) < StressThreshold) then
   253  !          xy_MarsDustLifting(i,j) = 0.0_DP
   254  !        else
   255  !          xy_MarsDustLifting(i,j) =                           &
   256  !            & EfficiencyFactor                                 &
   257  !            & * ( 2.3_DP* 0.01_DP ) * ((xy_MomFluxSurf(i,j)* 1000.0_DP)**2) &
   258  !            & * (((xy_MomFluxSurfX(i,j)*1000.0_DP) - StressThreshold)       &
   259  !            & / StressThreshold)
   260  !        end if
   261  !      end do
   262  !    end do
   263  
   264  
   265      !ɽ̩٤η׻
   266      do i = 0, imax-1
   267        do j = 1, jmax
   268          xy_SurfRho(i,j) = xyr_Press(i,j,0) /(GasRDry * xyr_VirTemp(i,j,0))
   269        end do
   270      end do
   271      ! Ϥˤȴ夲(Newman )
   272  
   273      do i = 0, imax-1
   274        do j = 1, jmax
   275          if(xy_MomFluxSurf(i,j) < StressThreshold) then
   276            xy_NewmanMarsDustLifting(i,j) = 0.0_DP
   277          else
   278            xy_NewmanMarsDustLifting(i,j) =                                 &
   279              & ((xy_MomFluxSurf(i,j))**1.5)/(Grav*sqrt(xy_SurfRho(i,j))) * &
   280              & * ( 1.0_DP - sqrt(StressThreshold/xy_MomFluxSurf(i,j)))     &
   281              & * ( 1.0_DP + sqrt(StressThreshold/xy_MomFluxSurf(i,j)))**2 ! Newman αϤι
   282  
   283            xy_NewmanMarsDustLifting(i,j) = 2.61_DP * xy_NewmanMarsDustLifting(i,j) ! ƶ¸᤿ 2.61ݤ
   284  
   285            xy_NewmanMarsDustLifting(i,j) = NewmanEfficiencyFactor * xy_NewmanMarsDustLifting(i,j)    ! ΨҤݤ
   286  
   287          end if
   288        end do
   289      end do
     .        do i = 1, imax                                                    
     .  !CDIR    NODEP                                                          
     .           do j = 1, jmax                                                 
     .              if ((xy_momfluxsurf(i-1,j).lt.stressthreshold)) then        
     .                 xy_kmhmarsdustlifting(i-1,j) = 0.0000000000000000e+000   
     .              else                                                        
     .                 xy_kmhmarsdustlifting(i-1,j) = xy_momfluxsurf(i-1,j)**2*(
     .       1            (xy_momfluxsurf(i-1,j)-stressthreshold)/              
     .       2            stressthreshold)                                      
     .                 xy_kmhmarsdustlifting(i-1,j) = 2.30000000000000e-003*    
     .       1            xy_kmhmarsdustlifting(i-1,j)                          
     .                 xy_kmhmarsdustlifting(i-1,j) = kmhefficiencyfactor*      
     .       1            xy_kmhmarsdustlifting(i-1,j)                          
     .              endif                                                       
     .              xy_surfrho1 = xyr_press(i-1,j,0)/(gasrdry*xyr_virtemp(i-1,j,
     .       1         0))                                                      
     .              if ((xy_momfluxsurf(i-1,j).lt.stressthreshold)) then        
     .                 xy_newmanmarsdustlifting(i-1,j) = 0.0000000000000000e+000
     .              else                                                        
     .                 xy_newmanmarsdustlifting(i-1,j) = xy_momfluxsurf(i-1,j)**
     .       1            1.50000000000000e+000/(grav*dsqrt(xy_surfrho1))**(    
     .       2            1.00000000000000e+000 - (dsqrt((stressthreshold/      
     .       3            xy_momfluxsurf(i-1,j)))))*(1.00000000000000e+000 + (  
     .       4            dsqrt((stressthreshold/xy_momfluxsurf(i-1,j)))))**2   
     .                 xy_newmanmarsdustlifting(i-1,j) = 2.60999999999999e+000* 
     .       1            xy_newmanmarsdustlifting(i-1,j)                       
     .                 xy_newmanmarsdustlifting(i-1,j) = newmanefficiencyfactor*
     .       1            xy_newmanmarsdustlifting(i-1,j)                       
     .              endif                                                       
     .           end do                                                         
     .        end do                                                            
   290  
   291    end subroutine MarsDustLifting
   292    !--------------------------------------------------------------------------------------
   293  
   294    subroutine MarsDustLiftingOutput(      &
   295      & xy_KMHMarsDustLifting, xy_NewmanMarsDustLifting                 & ! (in)
   296      & )
   297      !
   298      ! եå (xyr_KMHMarsDustLifting, xyr_NewmanMarsDustLifting).
   299      ! ˤĤƽϤԤ.
   300      !
   301      !
   302  
   303      ! ⥸塼 ; USE statements
   304      !
   305  
   306      ! 
   307      ! Time control
   308      !
   309      use timeset, only: &
   310        & TimeN, &            ! ƥå $ t $ λ. Time of step $ t $.
   311        & TimesetClockStart, TimesetClockStop
   312  
   313      ! ҥȥǡ
   314      ! History data output
   315      !
   316      use gtool_historyauto, only: HistoryAutoPut
   317  
   318      ! ʸ ; Declaration statements
   319      !
   320      implicit none
   321      real(DP), intent(in):: xy_KMHMarsDustLifting (0:imax-1, 1:jmax)
   322                                ! ȴ夲Ψ.
   323                                !  momentum flux
   324      real(DP), intent(in):: xy_NewmanMarsDustLifting (0:imax-1, 1:jmax)
   325                                ! ȴ夲Ψ.
   326                                !  momentum flux
   327  
   328      ! ϤΤκѿ
   329      real(DP):: xy_KMHDustLifting (0:imax-1, 1:jmax)
   330      real(DP):: xy_NewmanDustLifting (0:imax-1, 1:jmax)
   331  
   332      ! ѿ
   333      ! Work variables
   334      !
   335  !    integer:: i               ! ˲ DO 롼Ѻѿ
   336                                ! Work variables for DO loop in longitude
   337  !    integer:: j               ! ˲ DO 롼Ѻѿ
   338                                ! Work variables for DO loop in latitude
   339  
   340  
   341      ! ¹ʸ ; Executable statement
   342      !
   343  
   344      ! ׻ַ¬
   345      ! Start measurement of computation time
   346      !
   347      call TimesetClockStart( module_name )
   348  
   349  
   350      ! 
   351      ! Initialization
   352      !
   353      if ( .not. mars_dust_lifting_inited ) then
   354        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   355      end if
   356  !    if ( .not. mars_dust_lifting_inited ) call MarsDustLiftingInit
   357      xy_KMHDustLifting(:,:) = xy_KMHMarsDustLifting(:,:)
     .        if (xy_kmhdustlifting.DSC.U2 .gt. 0) then                         
     .           J1 = and(xy_kmhdustlifting.DSC.U2,1)                           
     .  !CDIR    NODEP                                                          
     .           do t56 = 1, J1                                                 
     .  !CDIR       NODEP                                                       
     .              do t58 = 1, xy_kmhdustlifting.DSC.U1 + 1                    
     .                 xy_kmhdustlifting(t58-1,t56) = xy_kmhmarsdustlifting(t58-
     .       1            1,t56)                                                
     .                 xy_newmandustlifting(t58-1,t56) =                        
     .       1            xy_newmanmarsdustlifting(t58-1,t56)                   
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t56 = J1 + 1, xy_kmhdustlifting.DSC.U2, 2                   
     .  !CDIR       NODEP                                                       
     .              do t58 = 1, xy_kmhdustlifting.DSC.U1 + 1                    
     .                 xy_kmhdustlifting(t58-1,t56) = xy_kmhmarsdustlifting(t58-
     .       1            1,t56)                                                
     .                 xy_kmhdustlifting(t58-1,t56+1) = xy_kmhmarsdustlifting(  
     .       1            t58-1,t56+1)                                          
     .                 xy_newmandustlifting(t58-1,t56) =                        
     .       1            xy_newmanmarsdustlifting(t58-1,t56)                   
     .                 xy_newmandustlifting(t58-1,t56+1) =                      
     .       1            xy_newmanmarsdustlifting(t58-1,t56+1)                 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   358      xy_NewmanDustLifting(:,:) = xy_NewmanMarsDustLifting(:,:)
   359  
   360  !do i=0, imax-1
   361  !  do j=1, jmax
   362  !    write(10,*) "DustLifting=", xy_DustLifting(i,j)
   363  !  end do
   364  !end do
   365  
   366      ! ҥȥǡ
   367      ! History data output
   368      !
   369      call HistoryAutoPut( TimeN, 'KMHF_d'           , xy_KMHDustLifting(:,:))
   370      call HistoryAutoPut( TimeN, 'NewmanF_d'           , xy_NewmanDustLifting(:,:))
   371  !    call HistoryAutoPut( TimeN, 'F_dX' , xy_MarsDustLiftingX )
   372  !    call HistoryAutoPut( TimeN, 'F_dY' , xy_MarsDustLiftingY )
   373  
   374      ! ׻ַ¬
   375      ! Pause measurement of computation time
   376      !
   377      call TimesetClockStop( module_name )
   378  
   379    end subroutine MarsDustLiftingOutput
   380  
   381    !--------------------------------------------------------------------------------------
   382  
   383    subroutine MarsDustLiftingInit
   384      !
   385      ! Mars_dust_lifting ⥸塼νԤޤ.
   386      ! NAMELIST#surface_flux_bulk_nml ɤ߹ߤϤμ³ǹԤޤ.
   387      !
   388      ! "surface_flux_bulk" module is initialized.
   389      ! "NAMELIST#surface_flux_bulk_nml" is loaded in this procedure.
   390      !
   391  
   392      ! ⥸塼 ; USE statements
   393      !
   394  
   395      ! NAMELIST եϤ˴ؤ桼ƥƥ
   396      ! Utilities for NAMELIST file input
   397      !
   398      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   399  
   400      ! ե
   401      ! File I/O support
   402      !
   403      use dc_iounit, only: FileOpen
   404  
   405      ! ̷ѥ᥿
   406      ! Kind type parameter
   407      !
   408      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   409  
   410      ! ʸ
   411      ! Character handling
   412      !
   413      use dc_string, only: StoA
   414  
   415      ! ҥȥǡ
   416      ! History data output
   417      !
   418      use gtool_historyauto, only: HistoryAutoAddVariable
   419  
   420      ! ʸ ; Declaration statements
   421      !
   422      implicit none
   423  
   424      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   425                                ! Unit number for NAMELIST file open
   426      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   427                                ! IOSTAT of NAMELIST read
   428  
   429      ! NAMELIST ѿ
   430      ! NAMELIST group name
   431      !
   432      namelist /mars_dust_lifting_nml/                                  &
   433        & StressThreshold, KMHEfficiencyFactor, NewmanEfficiencyFactor
   434            !
   435            ! ǥեͤˤĤƤϽ³ "mars_dust_liftingk#MarsDustLiftingInit"
   436            ! Υɤ򻲾ȤΤ.
   437            !
   438            ! Refer to source codes in the initialization procedure
   439            ! "surface_flux_bulk#SurfFluxInit" for the default values.
   440            !
   441  
   442      ! ¹ʸ ; Executable statement
   443      !
   444  
   445      if ( mars_dust_lifting_inited ) return
   446  
   447      ! ǥեͤ
   448      ! Default values settings
   449      !
   450      StressThreshold = 0.0225_DP! 22.5_DP
   451      KMHEfficiencyFactor = 0.1_DP
   452      NewmanEfficiencyFactor = 9.0_DP * 0.000001_DP
   453  
   454      ! NAMELIST ɤ߹
   455      ! NAMELIST is input
   456      !
   457      if ( trim(namelist_filename) /= '' ) then
   458        call FileOpen( unit_nml, &          ! (out)
   459          & namelist_filename, mode = 'r' ) ! (in)
   460  
   461        rewind( unit_nml )
   462        read( unit_nml, &                ! (in)
   463          & nml = mars_dust_lifting_nml, &  ! (out)
   464          & iostat = iostat_nml )        ! (out)
   465        close( unit_nml )
   466  
   467        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   468      end if
   469  
   470      ! ҥȥǡϤΤΤؤѿϿ
   471      ! Register of variables for history data output
   472      !
   473      call HistoryAutoAddVariable( 'KMHF_d', &
   474        & (/ 'lon ', 'lat ', 'time' /), &
   475        & 'mars dust lifting rate  ', 'kg m-2 s-1' )
   476      call HistoryAutoAddVariable( 'NewmanF_d', &
   477        & (/ 'lon ', 'lat ', 'time' /), &
   478        & 'mars dust lifting rate  ', 'kg m-2 s-1' )
   479      !  ; Print
   480      !
   481      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   482  
   483      call MessageNotify( 'M', module_name, '  StressThreshold   = %f', d = (/ StressThreshold   /) )
   484      call MessageNotify( 'M', module_name, '  KMHEfficiencyFactor  = %f', d = (/ KMHEfficiencyFactor  /) )
   485      call MessageNotify( 'M', module_name, '  NewmanEfficiencyFactor  = %f', d = (/ NewmanEfficiencyFactor  /) )
   486      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   487  
   488      mars_dust_lifting_inited = .true.
   489  
   490    end subroutine MarsDustLiftingInit
   491  
   492    !-------------------------------------------------------------------
   493  
   494  end module mars_dust_lifting
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:52:10 2012
FILE NAME: mars_dust_lifting.f90
PROGRAM NAME: mars_dust_lifting
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Υȴ夲
     2:            !
     3:            != Mars Dust Lifting!
     4:            
     5:            ! Authors::   OGIHARA Hirotaka
     6:            ! Version::   $Id: Mars_dust_lifting.f90,v 0.1 2012-10-01 16:18:31 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921$
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008-2009. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module mars_dust_lifting
    13:              !
    14:              != Υȴ夲
    15:              !
    16:              != Surface flux
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! Kahre et al (2006) ˴ŤƲΥȴ夲Ψ׻. 
    21:              !
    22:              ! 
    23:              !
    24:              !== References
    25:              !
    26:              ! Melinda A. Kahre, James R. Murphy, and Robert M. Haberle
    27:              ! Modeling the Martian dust cycle and surface dust
    28:              ! reservoirs with the NASA Ames general circulation
    29:              ! model, Journal of Geophysical Research, vol 111, E06008, 2006 
    30:              !
    31:              !== Procedures List
    32:              !
    33:              ! MarsDustLifting   :: Υȴ夲Ψη׻
    34:              ! ------------      :: ------------
    35:              !
    36:              !== NAMELIST
    37:              !
    38:              ! NAMELIST#mars_dust_lifting_nml
    39:              !
    40:            
    41:              ! ⥸塼 ; USE statements
    42:              !
    43:            
    44:              ! ʻ
    45:              ! Grid points settings
    46:              !
    47:              use gridset, only: imax, & ! ٳʻ. 
    48:                                         ! Number of grid points in longitude
    49:                &                jmax, & ! ٳʻ. 
    50:                                         ! Number of grid points in latitude
    51:                &                kmax    ! ľؿ. 
    52:                                         ! Number of vertical level
    53:            
    54:            
    55:              ! ̷ѥ᥿
    56:              ! Kind type parameter
    57:              !
    58:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    59:                &                 STRING     ! ʸ.       Strings. 
    60:            
    61:              ! å
    62:              ! Message output
    63:              !
    64:              use dc_message, only: MessageNotify
    65:            
    66:              ! ʸ ; Declaration statements
    67:              !
    68:              implicit none
    69:              private
    70:            
    71:              ! ³
    72:              ! Public procedure
    73:              !
    74:              public :: MarsDustLifting
    75:              public :: MarsDustLiftingOutput
    76:              public :: MarsDustLiftingInit
    77:            
    78:              ! ѿ
    79:              ! Public variables
    80:              !
    81:            
    82:              ! ѿ
    83:              ! Private variables
    84:              !
    85:              logical, save :: mars_dust_lifting_inited = .false.
    86:                                          ! ե饰
    87:                                          ! Initialization flag
    88:            
    89:            
    90:              real(DP), save:: StressThreshold
    91:                                        ! ϥȤ򴬤夲 (N m-2)
    92:                                        ! Wind stress threshold (N m-2)
    93:            
    94:              real(DP), save:: KMHEfficiencyFactor
    95:                                        ! Ψ(m-1)
    96:                                        ! Efficiency factor (m-1)
    97:              real(DP), save:: NewmanEfficiencyFactor
    98:                                        ! Ψ(m-1)
    99:                                        ! Efficiency factor (m-1)
   100:            
   101:              character(*), parameter:: module_name = 'mars_dust_lifting'
   102:                                          ! ⥸塼̾. 
   103:                                          ! Module name
   104:              character(*), parameter:: version = &
   105:                & '$Name: dcpam5-20120921 $' // &
   106:                & '$Id: mars_dust_lifting.f90,v 0.1 2012-10-01 00:26:41 yot Exp $'
   107:                                          ! ⥸塼ΥС
   108:                                          ! Module version
   109:            
   110:            
   111:            contains
   112:              
   113:              !-------------------------------------------------------------------------------------
   114:            
   115:              subroutine MarsDustLifting( &
   116:                & xyr_MomFluxX, xyr_MomFluxY, xyr_Press, xyr_VirTemp, & ! (in)
   117:                & xy_KMHMarsDustLifting, xy_NewmanMarsDustLifting          & ! (out)
   118:                & )
   119:              !
   120:              ! Х륯ˡǵ᤿, ǮեåȤäƲΥȴ夲Ψ
   121:              ! ׻ޤ.
   122:            
   123:                ! ⥸塼 ; USE statements
   124:                !
   125:            
   126:                ! ɸǡ
   127:                ! Axes data settings
   128:                !
   129:                use axesset, only: &
   130:                  & y_Lat                 ! $ \varphi $ [rad.] . . Latitude
   131:            
   132:                ! 
   133:                ! Time control
   134:                !
   135:                use timeset, only: &
   136:                  & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $. 
   137:                  & TimesetClockStart, TimesetClockStop
   138:            
   139:                ! ǥХåѥ桼ƥƥ
   140:                ! Utilities for debug
   141:                !
   142:                use dc_trace, only: DbgMessage, BeginSub, EndSub
   143:            
   144:                ! ʪ
   145:                ! Physical constants settings
   146:                !
   147:                use constants, only: &
   148:                  & Grav, &               ! $ g $ [m s-2]. 
   149:                                          ! ϲ®. 
   150:                                          ! Gravitational acceleration
   151:                  & GasRDry, &
   152:                                          ! $ R $ [J kg-1 K-1]. 
   153:                                          ! 絤ε. 
   154:                                          ! Gas constant of air
   155:                  & CpDry
   156:                                          ! $ C_p $ [J kg-1 K-1]. 
   157:                                          ! 絤갵Ǯ. 
   158:                                          ! Specific heat of air at constant pressure
   159:            
   160:                ! ʸ ; Declaration statements
   161:                !
   162:                implicit none
   163:                real(DP), intent(in):: xyr_MomFluxX (0:imax-1, 1:jmax, 0:kmax)
   164:                                          ! ư̥եå. 
   165:                                          ! Eastward momentum flux
   166:                real(DP), intent(in):: xyr_MomFluxY (0:imax-1, 1:jmax, 0:kmax)
   167:                                          ! ư̥եå. 
   168:                                          ! Northward momentum flux
   169:                real(DP), intent(in):: xyr_VirTemp (0:imax-1, 1:jmax, 0:kmax)
   170:                                          ! $ T_v $ .  (Ⱦ٥). 
   171:                                          ! Virtual temperature (half level)
   172:                real(DP), intent(in):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
   173:                                          ! $ p_s $ . ɽ̵ (Ⱦ٥). 
   174:                                          ! Surface pressure (half level)
   175:                real(DP) :: xy_MomFluxSurf (0:imax-1, 1:jmax)
   176:                                          ! ɽ̱ư̥եå礭.(N m-2) 
   177:                                          ! momentum flux power
   178:                real(DP) :: xy_SurfRho (0:imax-1, 1:jmax)
   179:                                          ! ɽ̩
   180:             
   181:                real(DP), intent(out):: xy_KMHMarsDustLifting(0:imax-1, 1:jmax)
   182:                                          !Υȴ夲Ψ
   183:                real(DP), intent(out):: xy_NewmanMarsDustLifting(0:imax-1, 1:jmax)
   184:                                          !Υȴ夲Ψ
   185:                
   186:                ! ѿ
   187:                ! Work variables
   188:                !
   189:            
   190:                integer:: i               ! ˲ DO 롼Ѻѿ
   191:                                          ! Work variables for DO loop in longitude
   192:                integer:: j               ! ˲ DO 롼Ѻѿ
   193:                                          ! Work variables for DO loop in latitude
   194:            !    integer:: k               ! ˲ DO 롼Ѻѿ
   195:                                          ! Work variables for DO loop in dimension of constituents
   196:            
   197:                ! ¹ʸ ; Executable statement
   198:                ! ǧ
   199:                ! Initialization check
   200:                !
   201:            !    if ( .not. mars_dust_lifting_inited ) call MarsDustLiftingInit
   202:                if ( .not. mars_dust_lifting_inited ) then
   203:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   204:                end if
   205:              
   206:            !   ɽ̱Ϥ礭η׻
   207:            
   208: +V=====        xy_MomFluxSurf(:,:) = sqrt( xyr_MomFluxX(:,:,0)**2 + xyr_MomFluxY(:,:,0)**2 )
   209:            
   210:            !write(10,*) "xyr_MomFluxX", xyr_MomFLuxX(0,1,0)
   211:            !write(10,*) "xyr_MomFluxY", xyr_MomFLuxY(0,1,0)
   212:            !write(10,*) "xy_MomFluxSurf=", xy_MomFluxSurf(0,1)
   213:            !write(10,*) "StressThreshold", StressThreshold
   214:                ! ȴ夲(KMH )
   215:            !    do i = 0, imax-1
   216:            !      do j = 1, jmax
   217:            !        if(xy_MomFluxSurf(i,j) < StressThreshold) then
   218:            !          xy_MarsDustLifting(i,j) = 0.0_DP
   219:            !        else
   220:            !          xy_MarsDustLifting(i,j) =                           & 
   221:            !            & EfficiencyFactor *(( 10.0_DP)**6)                   &
   222:            !            & * ( 2.3_DP* 0.001_DP ) * ((xy_MomFluxSurf(i,j))**2) &
   223:            !            & * (((xy_MomFluxSurf(i,j)) - StressThreshold)       &
   224:            !            & / StressThreshold)
   225:            !        end if
   226:            !      end do
   227:            !    end do
   228:            
   229: +------>       do i = 0, imax-1
   230: |V----->         do j = 1, jmax
   231: ||                 if(xy_MomFluxSurf(i,j) < StressThreshold) then
   232: ||                   xy_KMHMarsDustLifting(i,j) = 0.0_DP
   233: ||                 else
   234: ||                   xy_KMHMarsDustLifting(i,j) =                                                      & 
   235: ||                     & ((xy_MomFluxSurf(i,j))**2) * (((xy_MomFluxSurf(i,j)) - StressThreshold)    &
   236: ||                     & / StressThreshold) ! KMH αϤι
   237: ||         
   238: ||         
   239: ||                   xy_KMHMarsDustLifting(i,j) = (2.3_DP * 0.001_DP) * xy_KMHMarsDustLifting(i,j) ! ϵ¬᤿ 2.3 x 10^-3 ݤ
   240: ||         
   241: ||         !          xy_MarsDustLifting(i,j) = ((10.0_DP)**6) * xy_MarsDustLifting(i,j)      ! ñ̤ kg m-1 s-1 ˤ
   242: ||         
   243: ||                   xy_KMHMarsDustLifting(i,j) = KMHEfficiencyFactor * xy_KMHMarsDustLifting(i,j)    ! ΨҤݤ
   244: ||                    
   245: ||                 end if
   246: ||               end do
   247: ||             end do
   248: ||         
   249: ||         
   250: ||         !    do i = 0, imax-1
   251: ||         !      do j = 1, jmax
   252: ||         !        if((xy_MomFluxSurf(i,j)*1000.0_DP) < StressThreshold) then
   253: ||         !          xy_MarsDustLifting(i,j) = 0.0_DP
   254: ||         !        else
   255: ||         !          xy_MarsDustLifting(i,j) =                           & 
   256: ||         !            & EfficiencyFactor                                 &
   257: ||         !            & * ( 2.3_DP* 0.01_DP ) * ((xy_MomFluxSurf(i,j)* 1000.0_DP)**2) &
   258: ||         !            & * (((xy_MomFluxSurfX(i,j)*1000.0_DP) - StressThreshold)       &
   259: ||         !            & / StressThreshold)
   260: ||         !        end if
   261: ||         !      end do
   262: ||         !    end do
   263: ||         
   264: ||         
   265: ||             !ɽ̩٤η׻
   266: ||             do i = 0, imax-1
   267: ||               do j = 1, jmax
   268: ||                 xy_SurfRho(i,j) = xyr_Press(i,j,0) /(GasRDry * xyr_VirTemp(i,j,0))
   269: ||               end do
   270: ||             end do
   271: ||             ! Ϥˤȴ夲(Newman )
   272: ||         
   273: ||             do i = 0, imax-1
   274: ||               do j = 1, jmax
   275: ||                 if(xy_MomFluxSurf(i,j) < StressThreshold) then
   276: ||                   xy_NewmanMarsDustLifting(i,j) = 0.0_DP
   277: ||                 else
   278: ||                   xy_NewmanMarsDustLifting(i,j) =                                 & 
   279: ||                     & ((xy_MomFluxSurf(i,j))**1.5)/(Grav*sqrt(xy_SurfRho(i,j))) * &
   280: ||                     & * ( 1.0_DP - sqrt(StressThreshold/xy_MomFluxSurf(i,j)))     &
   281: ||                     & * ( 1.0_DP + sqrt(StressThreshold/xy_MomFluxSurf(i,j)))**2 ! Newman αϤι
   282: ||         
   283: ||                   xy_NewmanMarsDustLifting(i,j) = 2.61_DP * xy_NewmanMarsDustLifting(i,j) ! ƶ¸᤿ 2.61ݤ
   284: ||         
   285: ||                   xy_NewmanMarsDustLifting(i,j) = NewmanEfficiencyFactor * xy_NewmanMarsDustLifting(i,j)    ! ΨҤݤ
   286: ||                    
   287: ||                 end if
   288: |V-----          end do
   289: +------        end do
   290:              
   291:              end subroutine MarsDustLifting
   292:              !--------------------------------------------------------------------------------------
   293:            
   294:              subroutine MarsDustLiftingOutput(      &
   295:                & xy_KMHMarsDustLifting, xy_NewmanMarsDustLifting                 & ! (in)
   296:                & )
   297:                !
   298:                ! եå (xyr_KMHMarsDustLifting, xyr_NewmanMarsDustLifting). 
   299:                ! ˤĤƽϤԤ. 
   300:                !
   301:                !
   302:            
   303:                ! ⥸塼 ; USE statements
   304:                !
   305:            
   306:                ! 
   307:                ! Time control
   308:                !
   309:                use timeset, only: &
   310:                  & TimeN, &            ! ƥå $ t $ λ. Time of step $ t $.
   311:                  & TimesetClockStart, TimesetClockStop
   312:            
   313:                ! ҥȥǡ
   314:                ! History data output
   315:                !
   316:                use gtool_historyauto, only: HistoryAutoPut
   317:            
   318:                ! ʸ ; Declaration statements
   319:                !
   320:                implicit none
   321:                real(DP), intent(in):: xy_KMHMarsDustLifting (0:imax-1, 1:jmax)
   322:                                          ! ȴ夲Ψ. 
   323:                                          !  momentum flux
   324:                real(DP), intent(in):: xy_NewmanMarsDustLifting (0:imax-1, 1:jmax)
   325:                                          ! ȴ夲Ψ. 
   326:                                          !  momentum flux
   327:            
   328:                ! ϤΤκѿ
   329:                real(DP):: xy_KMHDustLifting (0:imax-1, 1:jmax)
   330:                real(DP):: xy_NewmanDustLifting (0:imax-1, 1:jmax)
   331:                
   332:                ! ѿ
   333:                ! Work variables
   334:                !
   335:            !    integer:: i               ! ˲ DO 롼Ѻѿ
   336:                                          ! Work variables for DO loop in longitude
   337:            !    integer:: j               ! ˲ DO 롼Ѻѿ
   338:                                          ! Work variables for DO loop in latitude
   339:            
   340:            
   341:                ! ¹ʸ ; Executable statement
   342:                !
   343:            
   344:                ! ׻ַ¬
   345:                ! Start measurement of computation time
   346:                !
   347:                call TimesetClockStart( module_name )
   348:            
   349:            
   350:                ! 
   351:                ! Initialization
   352:                !
   353:                if ( .not. mars_dust_lifting_inited ) then
   354:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   355:                end if
   356:            !    if ( .not. mars_dust_lifting_inited ) call MarsDustLiftingInit
   357: *V----->       xy_KMHDustLifting(:,:) = xy_KMHMarsDustLifting(:,:)
   358: *V-----        xy_NewmanDustLifting(:,:) = xy_NewmanMarsDustLifting(:,:)
   359:                
   360:            !do i=0, imax-1
   361:            !  do j=1, jmax
   362:            !    write(10,*) "DustLifting=", xy_DustLifting(i,j)
   363:            !  end do
   364:            !end do
   365:            
   366:                ! ҥȥǡ
   367:                ! History data output
   368:                !
   369:                call HistoryAutoPut( TimeN, 'KMHF_d'           , xy_KMHDustLifting(:,:))
   370:                call HistoryAutoPut( TimeN, 'NewmanF_d'           , xy_NewmanDustLifting(:,:))
   371:            !    call HistoryAutoPut( TimeN, 'F_dX' , xy_MarsDustLiftingX )
   372:            !    call HistoryAutoPut( TimeN, 'F_dY' , xy_MarsDustLiftingY )
   373:            
   374:                ! ׻ַ¬
   375:                ! Pause measurement of computation time
   376:                !
   377:                call TimesetClockStop( module_name )
   378:            
   379:              end subroutine MarsDustLiftingOutput
   380:            
   381:              !--------------------------------------------------------------------------------------
   382:            
   383:              subroutine MarsDustLiftingInit
   384:                !
   385:                ! Mars_dust_lifting ⥸塼νԤޤ. 
   386:                ! NAMELIST#surface_flux_bulk_nml ɤ߹ߤϤμ³ǹԤޤ. 
   387:                !
   388:                ! "surface_flux_bulk" module is initialized. 
   389:                ! "NAMELIST#surface_flux_bulk_nml" is loaded in this procedure. 
   390:                !
   391:            
   392:                ! ⥸塼 ; USE statements
   393:                !
   394:            
   395:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   396:                ! Utilities for NAMELIST file input
   397:                !
   398:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   399:            
   400:                ! ե
   401:                ! File I/O support
   402:                !
   403:                use dc_iounit, only: FileOpen
   404:            
   405:                ! ̷ѥ᥿
   406:                ! Kind type parameter
   407:                !
   408:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   409:            
   410:                ! ʸ
   411:                ! Character handling
   412:                !
   413:                use dc_string, only: StoA
   414:            
   415:                ! ҥȥǡ
   416:                ! History data output
   417:                !
   418:                use gtool_historyauto, only: HistoryAutoAddVariable
   419:            
   420:                ! ʸ ; Declaration statements
   421:                !
   422:                implicit none
   423:            
   424:                integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   425:                                          ! Unit number for NAMELIST file open
   426:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   427:                                          ! IOSTAT of NAMELIST read
   428:            
   429:                ! NAMELIST ѿ
   430:                ! NAMELIST group name
   431:                !
   432:                namelist /mars_dust_lifting_nml/                                  &
   433:                  & StressThreshold, KMHEfficiencyFactor, NewmanEfficiencyFactor                             
   434:                      !
   435:                      ! ǥեͤˤĤƤϽ³ "mars_dust_liftingk#MarsDustLiftingInit" 
   436:                      ! Υɤ򻲾ȤΤ. 
   437:                      !
   438:                      ! Refer to source codes in the initialization procedure
   439:                      ! "surface_flux_bulk#SurfFluxInit" for the default values. 
   440:                      !
   441:            
   442:                ! ¹ʸ ; Executable statement
   443:                !
   444:            
   445:                if ( mars_dust_lifting_inited ) return
   446:            
   447:                ! ǥեͤ
   448:                ! Default values settings
   449:                !
   450:                StressThreshold = 0.0225_DP! 22.5_DP
   451:                KMHEfficiencyFactor = 0.1_DP
   452:                NewmanEfficiencyFactor = 9.0_DP * 0.000001_DP
   453:            
   454:                ! NAMELIST ɤ߹
   455:                ! NAMELIST is input
   456:                !
   457:                if ( trim(namelist_filename) /= '' ) then
   458:                  call FileOpen( unit_nml, &          ! (out)
   459:                    & namelist_filename, mode = 'r' ) ! (in)
   460:            
   461:                  rewind( unit_nml )
   462:                  read( unit_nml, &                ! (in)
   463:                    & nml = mars_dust_lifting_nml, &  ! (out)
   464:                    & iostat = iostat_nml )        ! (out)
   465:                  close( unit_nml )
   466:            
   467:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   468:                end if
   469:            
   470:                ! ҥȥǡϤΤΤؤѿϿ
   471:                ! Register of variables for history data output
   472:                !
   473:                call HistoryAutoAddVariable( 'KMHF_d', &
   474:                  & (/ 'lon ', 'lat ', 'time' /), &
   475:                  & 'mars dust lifting rate  ', 'kg m-2 s-1' )
   476:                call HistoryAutoAddVariable( 'NewmanF_d', &
   477:                  & (/ 'lon ', 'lat ', 'time' /), &
   478:                  & 'mars dust lifting rate  ', 'kg m-2 s-1' )
   479:                !  ; Print
   480:                !
   481:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   482:            
   483:                call MessageNotify( 'M', module_name, '  StressThreshold   = %f', d = (/ StressThreshold   /) )
   484:                call MessageNotify( 'M', module_name, '  KMHEfficiencyFactor  = %f', d = (/ KMHEfficiencyFactor  /) )
   485:                call MessageNotify( 'M', module_name, '  NewmanEfficiencyFactor  = %f', d = (/ NewmanEfficiencyFactor  /) )
   486:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   487:            
   488:                mars_dust_lifting_inited = .true.
   489:            
   490:              end subroutine MarsDustLiftingInit
   491:            
   492:              !-------------------------------------------------------------------
   493:            
   494:            end module mars_dust_lifting
