Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:52:09 2012
FILE NAME: subsurface_diffusion_heat.f90
PROGRAM NAME: subsurface_diffusion_heat
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   180  opt  (1592): Outer loop unrolled inside inner loop.
   180  vec  (   4): Vectorized array expression.
   180  vec  (   4): Vectorized array expression.
   182  opt  (1593): Loop nest collapsed into one loop.
   182  vec  (   4): Vectorized array expression.
   185  vec  (   3): Unvectorized loop.
   185  vec  (  13): Overhead of loop division is too large.
   186  opt  (1593): Loop nest collapsed into one loop.
   186  vec  (   4): Vectorized array expression.
   190  opt  (1593): Loop nest collapsed into one loop.
   190  vec  (   4): Vectorized array expression.
   199  opt  (1592): Outer loop unrolled inside inner loop.
   199  vec  (   4): Vectorized array expression.
   199  vec  (   4): Vectorized array expression.
   201  opt  (1593): Loop nest collapsed into one loop.
   201  vec  (   4): Vectorized array expression.
   204  opt  (1593): Loop nest collapsed into one loop.
   204  vec  (   1): Vectorized loop.
   210  opt  (1593): Loop nest collapsed into one loop.
   210  vec  (   4): Vectorized array expression.
   218  warn (  83): Dummy argument "xy_soilheatcap" is not used.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:52:09 2012
FILE NAME: subsurface_diffusion_heat.f90
PROGRAM NAME: subsurface_diffusion_heat
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ϲˤǮαľȻ
     2  !
     3  != Vertical diffusion of heat under the ground
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: subsurface_diffusion_heat.f90,v 1.8 2011-07-08 03:55:19 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008-2009. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module subsurface_diffusion_heat
    13    !
    14    != ϲαľȻ
    15    !
    16    != Vertical diffusion under the ground
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    !== Procedures List
    21    !
    22    ! SubsurfaceDiffusion     :: ǮƳեåη׻
    23    ! SubsurfaceDiffusionInit :: ֥롼
    24    ! ----------------------- :: ------------
    25    ! SubsurfaceDiffusion     :: Calculate thermal conduction flux
    26    ! SubsurfaceDiffusionInit :: Initialization
    27    !
    28    !--
    29    !== NAMELIST
    30    !
    31    ! NAMELIST#subsurface_diffusion_heat_nml
    32    !++
    33  
    34    ! ⥸塼 ; USE statements
    35    !
    36  
    37    ! ʻ
    38    ! Grid points settings
    39    !
    40    use gridset, only:   imax, & ! ٳʻ.
    41                                 ! Number of grid points in longitude
    42      &                  jmax, & ! ٳʻ.
    43                                 ! Number of grid points in latitude
    44      &                  kmax, & ! ľؿ.
    45                                 ! Number of vertical level
    46      &                  kslmax  ! ϲαľؿ.
    47                                 ! Number of subsurface vertical level
    48  
    49    ! ̷ѥ᥿
    50    ! Kind type parameter
    51    !
    52    use dc_types, only: DP, &      ! ټ¿. Double precision.
    53      &                 STRING     ! ʸ.       Strings.
    54  
    55    ! å
    56    ! Message output
    57    !
    58    use dc_message, only: MessageNotify
    59  
    60    ! ʸ ; Declaration statements
    61    !
    62    implicit none
    63    private
    64  
    65    ! ³
    66    ! Public procedure
    67    !
    68    public:: SubsurfaceDiffusion
    69    public:: SubsurfaceDiffusionInit
    70  
    71    ! ѿ
    72    ! Public variables
    73    !
    74  
    75    ! ѿ
    76    ! Private variables
    77    !
    78    logical, save :: subsurface_diffusion_inited = .false.
    79                                ! ե饰.
    80                                ! Initialization flag
    81  
    82    character(*), parameter:: module_name = 'subsurface_diffusion_heat'
    83                                ! ⥸塼̾.
    84                                ! Module name
    85    character(*), parameter:: version = &
    86      & '$Name: dcpam5-20120921 $' // &
    87      & '$Id: subsurface_diffusion_heat.f90,v 1.8 2011-07-08 03:55:19 yot Exp $'
    88                                ! ⥸塼ΥС
    89                                ! Module version
    90  
    91  contains
    92  
    93    subroutine SubsurfaceDiffusion(              &
    94      & xy_DeepSubSurfHeatFlux,                  &          ! (in )
    95      & xy_SoilHeatCap, xy_SoilHeatDiffCoef,     &          ! (in )
    96      & xy_SurfTemp, xyz_SoilTemp,               &          ! (in )
    97      & xyr_SoilTempTransCoef, xyr_SoilHeatFlux  &          ! (out)
    98      & )
    99      !
   100      ! ѲΨη׻Ԥޤ.
   101      !
   102      ! Calculate tendencies.
   103      !
   104  
   105      ! ⥸塼 ; USE statements
   106      !
   107  
   108      ! 
   109      ! Time control
   110      !
   111      use timeset, only: &
   112        & TimesetClockStart, TimesetClockStop
   113  
   114      ! ɸǡ
   115      ! Axes data settings
   116      !
   117      use axesset, only: &
   118        r_SSDepth, & ! subsurface grid on interface of layer
   119        z_SSDepth    ! subsurface grid at midpoint of layer
   120  
   121      ! ʸ ; Declaration statements
   122      !
   123      implicit none
   124  
   125      real(DP), intent(in ):: xy_DeepSubSurfHeatFlux (0:imax-1, 1:jmax)
   126                                ! Ǯեå.
   127                                ! "Deep subsurface heat flux"
   128                                ! Heat flux at the bottom of surface/soil layer.
   129      real(DP), intent(in ):: xy_SoilHeatCap (0:imax-1, 1:jmax)
   130                                ! ھǮ (J K-1 kg-1)
   131                                ! Specific heat of soil (J K-1 kg-1)
   132      real(DP), intent(in ):: xy_SoilHeatDiffCoef (0:imax-1, 1:jmax)
   133                                ! ھǮƳ (J m-3 K-1)
   134                                ! Heat conduction coefficient of soil (J m-3 K-1)
   135      real(DP), intent(in ):: xy_SurfTemp (0:imax-1, 1:jmax)
   136                                ! ɽ̲.
   137                                ! Surface temperature
   138      real(DP), intent(in ):: xyz_SoilTemp (0:imax-1, 1:jmax, 1:kslmax)
   139                                ! ھ (K)
   140                                ! Soil temperature (K)
   141      real(DP), intent(out):: xyr_SoilTempTransCoef (0:imax-1, 1:jmax, 0:kslmax)
   142                                ! ͢ھ.
   143                                ! Transfer coefficient: soil temperature
   144      real(DP), intent(out):: xyr_SoilHeatFlux (0:imax-1, 1:jmax, 0:kslmax)
   145                                ! ھǮեå.
   146                                ! Heat flux in sub-surface soil
   147  
   148  
   149  
   150      ! ѿ
   151      ! Work variables
   152      !
   153      integer:: k               ! ľ˲ DO 롼Ѻѿ
   154                                ! Work variables for DO loop in vertical direction
   155  
   156      ! ¹ʸ ; Executable statement
   157      !
   158  
   159      ! ǧ
   160      ! Initialization check
   161      !
   162      if ( .not. subsurface_diffusion_inited ) then
   163        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   164      end if
   165  
   166  
   167      ! ׻ַ¬
   168      ! Start measurement of computation time
   169      !
   170      call TimesetClockStart( module_name )
   171  
   172  
   173  
   174      ! ھٷ׻Ѥ͢η׻
   175      ! Calculate transfer coefficient for heat diffusion in the soil
   176      !
   177      k = 0
   178      if ( kslmax == 0 ) then
   179        ! This line is used when kslmax == 0, because z_SSDepth(k+1) does not exist.
   180        xyr_SoilTempTransCoef(:,:,k) = 0.0d0
     .        if (jmax .gt. 0) then                                             
     .           J1 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t230 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t232 = 1, imax + 1 - min0(1,imax)                        
     .                 xyr_soiltemptranscoef(t232-1,t230,0) =                   
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t230 = J1 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t232 = 1, imax + 1 - min0(1,imax)                        
     .                 xyr_soiltemptranscoef(t232-1,t230,0) =                   
     .       1            0.0000000000000000e+000                               
     .                 xyr_soiltemptranscoef(t232-1,t230+1,0) =                 
     .       1            0.0000000000000000e+000                               
     .                 xyr_soiltemptranscoef(t232-1,t230+2,0) =                 
     .       1            0.0000000000000000e+000                               
     .                 xyr_soiltemptranscoef(t232-1,t230+3,0) =                 
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10009                                                       
   181      else
   182        xyr_SoilTempTransCoef(:,:,k) = &
     .        D1 = 1.D0/(z_ssdepth(1)-0.0000000000000000e+000)                  
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t170 = 1, jmax*imax                                            
     .           xyr_soiltemptranscoef(t170-1,1,0) = xy_soilheatdiffcoef(t170-1,
     .       1      1)*D1                                                       
     .        end do                                                            
   183          & xy_SoilHeatDiffCoef(:,:) / ( z_SSDepth(k+1) - 0.0d0 )
   184      end if
   185      do k = 1, kslmax-1
   186        xyr_SoilTempTransCoef(:,:,k) = &
     .        D2 = 1.D0/(z_ssdepth(k+1)-z_ssdepth(k))                           
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t178 = 1, jmax*imax                                            
     .           xyr_soiltemptranscoef(t178-1,1,k) = xy_soilheatdiffcoef(t178-1,
     .       1      1)*D2                                                       
     .        end do                                                            
   187          & xy_SoilHeatDiffCoef(:,:) / ( z_SSDepth(k+1) - z_SSDepth(k) )
   188      end do
   189      k = kslmax
   190      xyr_SoilTempTransCoef(:,:,k) = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t186 = 1, jmax*imax                                            
     .           xyr_soiltemptranscoef(t186-1,1,k) = 0.0000000000000000e+000    
     .        end do                                                            
   191  
   192  
   193      ! ھǮեåη׻
   194      ! Calculate heat flux in sub-surface soil
   195      !
   196      k = 0
   197      if ( kslmax == 0 ) then
   198        ! This line is used when kslmax == 0, because xyz_SoilTemp(:,:,k+1) does not exist.
   199        xyr_SoilHeatFlux(:,:,k) = 0.0d0
     .        if (jmax .gt. 0) then                                             
     .           J2 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t224 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t226 = 1, imax + 1 - min0(1,imax)                        
     .                 xyr_soilheatflux(t226-1,t224,0) = 0.0000000000000000e+000
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t224 = J2 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t226 = 1, imax + 1 - min0(1,imax)                        
     .                 xyr_soilheatflux(t226-1,t224,0) = 0.0000000000000000e+000
     .                 xyr_soilheatflux(t226-1,t224+1,0) =                      
     .       1            0.0000000000000000e+000                               
     .                 xyr_soilheatflux(t226-1,t224+2,0) =                      
     .       1            0.0000000000000000e+000                               
     .                 xyr_soilheatflux(t226-1,t224+3,0) =                      
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10030                                                       
   200      else
   201        xyr_SoilHeatFlux(:,:,k) = &
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t192 = 1, jmax*imax                                            
     .           xyr_soilheatflux(t192-1,1,0) = -xyr_soiltemptranscoef(t192-1,1,
     .       1      0)*(xyz_soiltemp(t192-1,1,1)-xy_surftemp(t192-1,1))         
     .        end do                                                            
   202          & - xyr_SoilTempTransCoef(:,:,k) * ( xyz_SoilTemp(:,:,1) - xy_SurfTemp(:,:) )
   203      end if
   204      do k = 1, kslmax-1
   205        xyr_SoilHeatFlux(:,:,k) =                               &
   206          & - xyr_SoilTempTransCoef(:,:,k)                      &
   207          &   * ( xyz_SoilTemp(:,:,k+1) - xyz_SoilTemp(:,:,k) )
   208      end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do k = 1, jmax*(kslmax - 1)*imax                                  
     .           xyr_soilheatflux(k-1,1,1) = -xyr_soiltemptranscoef(k-1,1,1)*(  
     .       1      xyz_soiltemp(k-1,1,2)-xyz_soiltemp(k-1,1,1))                
     .        end do                                                            
   209      k = kslmax
   210      xyr_SoilHeatFlux(:,:,k) = xy_DeepSubSurfHeatFlux
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t216 = 1, jmax*imax                                            
     .           xyr_soilheatflux(t216-1,1,k) = xy_deepsubsurfheatflux(t216-1,1)
     .        end do                                                            
   211  
   212  
   213      ! ׻ַ¬
   214      ! Pause measurement of computation time
   215      !
   216      call TimesetClockStop( module_name )
   217  
   218    end subroutine SubsurfaceDiffusion
   219  
   220    !-------------------------------------------------------------------
   221  
   222    subroutine SubsurfaceDiffusionInit
   223      !
   224      ! subsurface_diffusion_heat ⥸塼νԤޤ.
   225      ! NAMELIST#subsurface_diffusion_heat_nml ɤ߹ߤϤμ³ǹԤޤ.
   226      !
   227      ! "subsurface_diffusion_heat" module is initialized.
   228      ! "NAMELIST#subsurface_diffusion_heat_nml" is loaded in this procedure.
   229      !
   230  
   231      ! ⥸塼 ; USE statements
   232      !
   233  
   234      ! NAMELIST եϤ˴ؤ桼ƥƥ
   235      ! Utilities for NAMELIST file input
   236      !
   237      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   238  
   239      ! ե
   240      ! File I/O support
   241      !
   242      use dc_iounit, only: FileOpen
   243  
   244      ! ̷ѥ᥿
   245      ! Kind type parameter
   246      !
   247      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   248  
   249      ! ʸ
   250      ! Character handling
   251      !
   252      use dc_string, only: StoA
   253  
   254      ! ҥȥǡ
   255      ! History data output
   256      !
   257      use gtool_historyauto, only: HistoryAutoAddVariable
   258  
   259      ! å
   260      ! Message output
   261      !
   262      use dc_message, only: MessageNotify
   263  
   264      ! ʸ ; Declaration statements
   265      !
   266      implicit none
   267  
   268      ! ѿ
   269      ! Work variables
   270      !
   271  !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   272  !!$                              ! Unit number for NAMELIST file open
   273  !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   274  !!$                              ! IOSTAT of NAMELIST read
   275  
   276  !!$    real(DP) :: SoilHeatCap
   277  !!$    real(DP) :: SoilHeatDiffCoef
   278  
   279      ! NAMELIST ѿ
   280      ! NAMELIST group name
   281      !
   282  !!$    namelist /subsurface_diffusion_heat_nml/ &
   283  !!$      & SoilHeatCap, SoilHeatDiffCoef
   284  !!$          !
   285  !!$          ! ǥեͤˤĤƤϽ³ "subsurface_diffusion_heat#SubSurfaceDiffusionInit"
   286  !!$          ! Υɤ򻲾ȤΤ.
   287  !!$          !
   288  !!$          ! Refer to source codes in the initialization procedure
   289  !!$          ! "subsurface_diffusion_heat#SubsurfaceDiffusionInit" for the default values.
   290  !!$          !
   291  
   292      ! ¹ʸ ; Executable statement
   293      !
   294  
   295      if ( subsurface_diffusion_inited ) return
   296  
   297      ! ǥեͤ
   298      ! Default values settings
   299      !
   300  
   301  
   302      ! NAMELIST ɤ߹
   303      ! NAMELIST is input
   304      !
   305  !!$    if ( trim(namelist_filename) /= '' ) then
   306  !!$      call FileOpen( unit_nml, &          ! (out)
   307  !!$        & namelist_filename, mode = 'r' ) ! (in)
   308  !!$
   309  !!$      rewind( unit_nml )
   310  !!$      read( unit_nml, &           ! (in)
   311  !!$        & nml = subsurface_diffusion_heat_nml, &  ! (out)
   312  !!$        & iostat = iostat_nml )   ! (out)
   313  !!$      close( unit_nml )
   314  !!$
   315  !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   316  !!$    end if
   317  
   318  
   319      !  ; Print
   320      !
   321      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   322      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   323  
   324      subsurface_diffusion_inited = .true.
   325  
   326    end subroutine SubsurfaceDiffusionInit
   327  
   328    !-------------------------------------------------------------------
   329  
   330  end module subsurface_diffusion_heat
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:52:09 2012
FILE NAME: subsurface_diffusion_heat.f90
PROGRAM NAME: subsurface_diffusion_heat
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ϲˤǮαľȻ
     2:            !
     3:            != Vertical diffusion of heat under the ground
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: subsurface_diffusion_heat.f90,v 1.8 2011-07-08 03:55:19 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008-2009. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module subsurface_diffusion_heat
    13:              !
    14:              != ϲαľȻ
    15:              !
    16:              != Vertical diffusion under the ground
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              !== Procedures List
    21:              !
    22:              ! SubsurfaceDiffusion     :: ǮƳեåη׻
    23:              ! SubsurfaceDiffusionInit :: ֥롼
    24:              ! ----------------------- :: ------------
    25:              ! SubsurfaceDiffusion     :: Calculate thermal conduction flux
    26:              ! SubsurfaceDiffusionInit :: Initialization
    27:              !
    28:              !--
    29:              !== NAMELIST
    30:              !
    31:              ! NAMELIST#subsurface_diffusion_heat_nml
    32:              !++
    33:            
    34:              ! ⥸塼 ; USE statements
    35:              !
    36:            
    37:              ! ʻ
    38:              ! Grid points settings
    39:              !
    40:              use gridset, only:   imax, & ! ٳʻ. 
    41:                                           ! Number of grid points in longitude
    42:                &                  jmax, & ! ٳʻ. 
    43:                                           ! Number of grid points in latitude
    44:                &                  kmax, & ! ľؿ. 
    45:                                           ! Number of vertical level
    46:                &                  kslmax  ! ϲαľؿ. 
    47:                                           ! Number of subsurface vertical level
    48:            
    49:              ! ̷ѥ᥿
    50:              ! Kind type parameter
    51:              !
    52:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    53:                &                 STRING     ! ʸ.       Strings. 
    54:            
    55:              ! å
    56:              ! Message output
    57:              !
    58:              use dc_message, only: MessageNotify
    59:            
    60:              ! ʸ ; Declaration statements
    61:              !
    62:              implicit none
    63:              private
    64:            
    65:              ! ³
    66:              ! Public procedure
    67:              !
    68:              public:: SubsurfaceDiffusion
    69:              public:: SubsurfaceDiffusionInit
    70:            
    71:              ! ѿ
    72:              ! Public variables
    73:              !
    74:            
    75:              ! ѿ
    76:              ! Private variables
    77:              !
    78:              logical, save :: subsurface_diffusion_inited = .false.
    79:                                          ! ե饰. 
    80:                                          ! Initialization flag
    81:            
    82:              character(*), parameter:: module_name = 'subsurface_diffusion_heat'
    83:                                          ! ⥸塼̾. 
    84:                                          ! Module name
    85:              character(*), parameter:: version = &
    86:                & '$Name: dcpam5-20120921 $' // &
    87:                & '$Id: subsurface_diffusion_heat.f90,v 1.8 2011-07-08 03:55:19 yot Exp $'
    88:                                          ! ⥸塼ΥС
    89:                                          ! Module version
    90:            
    91:            contains
    92:            
    93:              subroutine SubsurfaceDiffusion(              &
    94:                & xy_DeepSubSurfHeatFlux,                  &          ! (in )
    95:                & xy_SoilHeatCap, xy_SoilHeatDiffCoef,     &          ! (in )
    96:                & xy_SurfTemp, xyz_SoilTemp,               &          ! (in )
    97:                & xyr_SoilTempTransCoef, xyr_SoilHeatFlux  &          ! (out)
    98:                & )
    99:                !
   100:                ! ѲΨη׻Ԥޤ. 
   101:                !
   102:                ! Calculate tendencies. 
   103:                !
   104:            
   105:                ! ⥸塼 ; USE statements
   106:                !
   107:            
   108:                ! 
   109:                ! Time control
   110:                !
   111:                use timeset, only: &
   112:                  & TimesetClockStart, TimesetClockStop
   113:            
   114:                ! ɸǡ
   115:                ! Axes data settings
   116:                !
   117:                use axesset, only: &
   118:                  r_SSDepth, & ! subsurface grid on interface of layer
   119:                  z_SSDepth    ! subsurface grid at midpoint of layer
   120:            
   121:                ! ʸ ; Declaration statements
   122:                !
   123:                implicit none
   124:            
   125:                real(DP), intent(in ):: xy_DeepSubSurfHeatFlux (0:imax-1, 1:jmax)
   126:                                          ! Ǯեå. 
   127:                                          ! "Deep subsurface heat flux"
   128:                                          ! Heat flux at the bottom of surface/soil layer.
   129:                real(DP), intent(in ):: xy_SoilHeatCap (0:imax-1, 1:jmax)
   130:                                          ! ھǮ (J K-1 kg-1)
   131:                                          ! Specific heat of soil (J K-1 kg-1)
   132:                real(DP), intent(in ):: xy_SoilHeatDiffCoef (0:imax-1, 1:jmax)
   133:                                          ! ھǮƳ (J m-3 K-1)
   134:                                          ! Heat conduction coefficient of soil (J m-3 K-1)
   135:                real(DP), intent(in ):: xy_SurfTemp (0:imax-1, 1:jmax)
   136:                                          ! ɽ̲. 
   137:                                          ! Surface temperature
   138:                real(DP), intent(in ):: xyz_SoilTemp (0:imax-1, 1:jmax, 1:kslmax)
   139:                                          ! ھ (K)
   140:                                          ! Soil temperature (K)
   141:                real(DP), intent(out):: xyr_SoilTempTransCoef (0:imax-1, 1:jmax, 0:kslmax)
   142:                                          ! ͢ھ.
   143:                                          ! Transfer coefficient: soil temperature
   144:                real(DP), intent(out):: xyr_SoilHeatFlux (0:imax-1, 1:jmax, 0:kslmax)
   145:                                          ! ھǮեå. 
   146:                                          ! Heat flux in sub-surface soil
   147:            
   148:            
   149:            
   150:                ! ѿ
   151:                ! Work variables
   152:                !
   153:                integer:: k               ! ľ˲ DO 롼Ѻѿ
   154:                                          ! Work variables for DO loop in vertical direction
   155:            
   156:                ! ¹ʸ ; Executable statement
   157:                !
   158:            
   159:                ! ǧ
   160:                ! Initialization check
   161:                !
   162:                if ( .not. subsurface_diffusion_inited ) then
   163:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   164:                end if
   165:            
   166:            
   167:                ! ׻ַ¬
   168:                ! Start measurement of computation time
   169:                !
   170:                call TimesetClockStart( module_name )
   171:            
   172:            
   173:            
   174:                ! ھٷ׻Ѥ͢η׻
   175:                ! Calculate transfer coefficient for heat diffusion in the soil
   176:                !
   177:                k = 0
   178:                if ( kslmax == 0 ) then
   179:                  ! This line is used when kslmax == 0, because z_SSDepth(k+1) does not exist. 
   180: +V=====          xyr_SoilTempTransCoef(:,:,k) = 0.0d0
   181:                else
   182: W*=====          xyr_SoilTempTransCoef(:,:,k) = &
   183:                    & xy_SoilHeatDiffCoef(:,:) / ( z_SSDepth(k+1) - 0.0d0 )
   184:                end if
   185: +------>       do k = 1, kslmax-1
   186: |WW====          xyr_SoilTempTransCoef(:,:,k) = &
   187: |                  & xy_SoilHeatDiffCoef(:,:) / ( z_SSDepth(k+1) - z_SSDepth(k) )
   188: +------        end do
   189:                k = kslmax
   190: ++=====        xyr_SoilTempTransCoef(:,:,k) = 0.0d0
   191:            
   192:            
   193:                ! ھǮեåη׻
   194:                ! Calculate heat flux in sub-surface soil
   195:                !
   196:                k = 0
   197:                if ( kslmax == 0 ) then
   198:                  ! This line is used when kslmax == 0, because xyz_SoilTemp(:,:,k+1) does not exist. 
   199: +V=====          xyr_SoilHeatFlux(:,:,k) = 0.0d0
   200:                else
   201: W*=====          xyr_SoilHeatFlux(:,:,k) = &
   202:                    & - xyr_SoilTempTransCoef(:,:,k) * ( xyz_SoilTemp(:,:,1) - xy_SurfTemp(:,:) )
   203:                end if
   204: W------>       do k = 1, kslmax-1
   205: |W*====          xyr_SoilHeatFlux(:,:,k) =                               &
   206: |                  & - xyr_SoilTempTransCoef(:,:,k)                      &
   207: |                  &   * ( xyz_SoilTemp(:,:,k+1) - xyz_SoilTemp(:,:,k) )
   208: W------        end do
   209:                k = kslmax
   210: **=====        xyr_SoilHeatFlux(:,:,k) = xy_DeepSubSurfHeatFlux
   211:            
   212:            
   213:                ! ׻ַ¬
   214:                ! Pause measurement of computation time
   215:                !
   216:                call TimesetClockStop( module_name )
   217:            
   218:              end subroutine SubsurfaceDiffusion
   219:            
   220:              !-------------------------------------------------------------------
   221:            
   222:              subroutine SubsurfaceDiffusionInit
   223:                !
   224:                ! subsurface_diffusion_heat ⥸塼νԤޤ. 
   225:                ! NAMELIST#subsurface_diffusion_heat_nml ɤ߹ߤϤμ³ǹԤޤ. 
   226:                !
   227:                ! "subsurface_diffusion_heat" module is initialized. 
   228:                ! "NAMELIST#subsurface_diffusion_heat_nml" is loaded in this procedure. 
   229:                !
   230:            
   231:                ! ⥸塼 ; USE statements
   232:                !
   233:            
   234:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   235:                ! Utilities for NAMELIST file input
   236:                !
   237:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   238:            
   239:                ! ե
   240:                ! File I/O support
   241:                !
   242:                use dc_iounit, only: FileOpen
   243:            
   244:                ! ̷ѥ᥿
   245:                ! Kind type parameter
   246:                !
   247:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   248:            
   249:                ! ʸ
   250:                ! Character handling
   251:                !
   252:                use dc_string, only: StoA
   253:            
   254:                ! ҥȥǡ
   255:                ! History data output
   256:                !
   257:                use gtool_historyauto, only: HistoryAutoAddVariable
   258:            
   259:                ! å
   260:                ! Message output
   261:                !
   262:                use dc_message, only: MessageNotify
   263:            
   264:                ! ʸ ; Declaration statements
   265:                !
   266:                implicit none
   267:            
   268:                ! ѿ
   269:                ! Work variables
   270:                !
   271:            !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   272:            !!$                              ! Unit number for NAMELIST file open
   273:            !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   274:            !!$                              ! IOSTAT of NAMELIST read
   275:            
   276:            !!$    real(DP) :: SoilHeatCap
   277:            !!$    real(DP) :: SoilHeatDiffCoef
   278:            
   279:                ! NAMELIST ѿ
   280:                ! NAMELIST group name
   281:                !
   282:            !!$    namelist /subsurface_diffusion_heat_nml/ &
   283:            !!$      & SoilHeatCap, SoilHeatDiffCoef
   284:            !!$          !
   285:            !!$          ! ǥեͤˤĤƤϽ³ "subsurface_diffusion_heat#SubSurfaceDiffusionInit" 
   286:            !!$          ! Υɤ򻲾ȤΤ. 
   287:            !!$          !
   288:            !!$          ! Refer to source codes in the initialization procedure
   289:            !!$          ! "subsurface_diffusion_heat#SubsurfaceDiffusionInit" for the default values. 
   290:            !!$          !
   291:            
   292:                ! ¹ʸ ; Executable statement
   293:                !
   294:            
   295:                if ( subsurface_diffusion_inited ) return
   296:            
   297:                ! ǥեͤ
   298:                ! Default values settings
   299:                !
   300:            
   301:            
   302:                ! NAMELIST ɤ߹
   303:                ! NAMELIST is input
   304:                !
   305:            !!$    if ( trim(namelist_filename) /= '' ) then
   306:            !!$      call FileOpen( unit_nml, &          ! (out)
   307:            !!$        & namelist_filename, mode = 'r' ) ! (in)
   308:            !!$
   309:            !!$      rewind( unit_nml )
   310:            !!$      read( unit_nml, &           ! (in)
   311:            !!$        & nml = subsurface_diffusion_heat_nml, &  ! (out)
   312:            !!$        & iostat = iostat_nml )   ! (out)
   313:            !!$      close( unit_nml )
   314:            !!$
   315:            !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   316:            !!$    end if
   317:            
   318:            
   319:                !  ; Print
   320:                !
   321:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   322:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   323:            
   324:                subsurface_diffusion_inited = .true.
   325:            
   326:              end subroutine SubsurfaceDiffusionInit
   327:            
   328:              !-------------------------------------------------------------------
   329:            
   330:            end module subsurface_diffusion_heat
